require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_IMMINTRIN_H_INCLUDED)) {
    die("Never use <avx512vldqintrin.h> directly; include <immintrin.h> instead.");
}
unless(defined(&_AVX512VLDQINTRIN_H_INCLUDED)) {
    eval 'sub _AVX512VLDQINTRIN_H_INCLUDED () {1;}' unless defined(&_AVX512VLDQINTRIN_H_INCLUDED);
    if(!defined(&__AVX512VL__) || !defined(&__AVX512DQ__)) {
	eval 'sub __DISABLE_AVX512VLDQ__ () {1;}' unless defined(&__DISABLE_AVX512VLDQ__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_cvttpd_epi64 ( &__m256d  &__A) { ( &__m256i)  &__builtin_ia32_cvttpd2qq256_mask (( &__v4df)  &__A, ( &__v4di)  &_mm256_setzero_si256 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_cvttpd_epi64 ( &__m256i  &__W,  &__mmask8  &__U,  &__m256d  &__A) { ( &__m256i)  &__builtin_ia32_cvttpd2qq256_mask (( &__v4df)  &__A, ( &__v4di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_cvttpd_epi64 ( &__mmask8  &__U,  &__m256d  &__A) { ( &__m256i)  &__builtin_ia32_cvttpd2qq256_mask (( &__v4df)  &__A, ( &__v4di)  &_mm256_setzero_si256 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvttpd_epi64 ( &__m128d  &__A) { ( &__m128i)  &__builtin_ia32_cvttpd2qq128_mask (( &__v2df)  &__A, ( &__v2di)  &_mm_setzero_si128 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_cvttpd_epi64 ( &__m128i  &__W,  &__mmask8  &__U,  &__m128d  &__A) { ( &__m128i)  &__builtin_ia32_cvttpd2qq128_mask (( &__v2df)  &__A, ( &__v2di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_cvttpd_epi64 ( &__mmask8  &__U,  &__m128d  &__A) { ( &__m128i)  &__builtin_ia32_cvttpd2qq128_mask (( &__v2df)  &__A, ( &__v2di)  &_mm_setzero_si128 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_cvttpd_epu64 ( &__m256d  &__A) { ( &__m256i)  &__builtin_ia32_cvttpd2uqq256_mask (( &__v4df)  &__A, ( &__v4di)  &_mm256_setzero_si256 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_cvttpd_epu64 ( &__m256i  &__W,  &__mmask8  &__U,  &__m256d  &__A) { ( &__m256i)  &__builtin_ia32_cvttpd2uqq256_mask (( &__v4df)  &__A, ( &__v4di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_cvttpd_epu64 ( &__mmask8  &__U,  &__m256d  &__A) { ( &__m256i)  &__builtin_ia32_cvttpd2uqq256_mask (( &__v4df)  &__A, ( &__v4di)  &_mm256_setzero_si256 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvttpd_epu64 ( &__m128d  &__A) { ( &__m128i)  &__builtin_ia32_cvttpd2uqq128_mask (( &__v2df)  &__A, ( &__v2di)  &_mm_setzero_si128 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_cvttpd_epu64 ( &__m128i  &__W,  &__mmask8  &__U,  &__m128d  &__A) { ( &__m128i)  &__builtin_ia32_cvttpd2uqq128_mask (( &__v2df)  &__A, ( &__v2di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_cvttpd_epu64 ( &__mmask8  &__U,  &__m128d  &__A) { ( &__m128i)  &__builtin_ia32_cvttpd2uqq128_mask (( &__v2df)  &__A, ( &__v2di)  &_mm_setzero_si128 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_cvtpd_epi64 ( &__m256d  &__A) { ( &__m256i)  &__builtin_ia32_cvtpd2qq256_mask (( &__v4df)  &__A, ( &__v4di)  &_mm256_setzero_si256 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_cvtpd_epi64 ( &__m256i  &__W,  &__mmask8  &__U,  &__m256d  &__A) { ( &__m256i)  &__builtin_ia32_cvtpd2qq256_mask (( &__v4df)  &__A, ( &__v4di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_cvtpd_epi64 ( &__mmask8  &__U,  &__m256d  &__A) { ( &__m256i)  &__builtin_ia32_cvtpd2qq256_mask (( &__v4df)  &__A, ( &__v4di)  &_mm256_setzero_si256 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtpd_epi64 ( &__m128d  &__A) { ( &__m128i)  &__builtin_ia32_cvtpd2qq128_mask (( &__v2df)  &__A, ( &__v2di)  &_mm_setzero_si128 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_cvtpd_epi64 ( &__m128i  &__W,  &__mmask8  &__U,  &__m128d  &__A) { ( &__m128i)  &__builtin_ia32_cvtpd2qq128_mask (( &__v2df)  &__A, ( &__v2di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_cvtpd_epi64 ( &__mmask8  &__U,  &__m128d  &__A) { ( &__m128i)  &__builtin_ia32_cvtpd2qq128_mask (( &__v2df)  &__A, ( &__v2di)  &_mm_setzero_si128 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_cvtpd_epu64 ( &__m256d  &__A) { ( &__m256i)  &__builtin_ia32_cvtpd2uqq256_mask (( &__v4df)  &__A, ( &__v4di)  &_mm256_setzero_si256 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_cvtpd_epu64 ( &__m256i  &__W,  &__mmask8  &__U,  &__m256d  &__A) { ( &__m256i)  &__builtin_ia32_cvtpd2uqq256_mask (( &__v4df)  &__A, ( &__v4di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_cvtpd_epu64 ( &__mmask8  &__U,  &__m256d  &__A) { ( &__m256i)  &__builtin_ia32_cvtpd2uqq256_mask (( &__v4df)  &__A, ( &__v4di)  &_mm256_setzero_si256 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtpd_epu64 ( &__m128d  &__A) { ( &__m128i)  &__builtin_ia32_cvtpd2uqq128_mask (( &__v2df)  &__A, ( &__v2di)  &_mm_setzero_si128 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_cvtpd_epu64 ( &__m128i  &__W,  &__mmask8  &__U,  &__m128d  &__A) { ( &__m128i)  &__builtin_ia32_cvtpd2uqq128_mask (( &__v2df)  &__A, ( &__v2di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_cvtpd_epu64 ( &__mmask8  &__U,  &__m128d  &__A) { ( &__m128i)  &__builtin_ia32_cvtpd2uqq128_mask (( &__v2df)  &__A, ( &__v2di)  &_mm_setzero_si128 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_cvttps_epi64 ( &__m128  &__A) { ( &__m256i)  &__builtin_ia32_cvttps2qq256_mask (( &__v4sf)  &__A, ( &__v4di)  &_mm256_setzero_si256 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_cvttps_epi64 ( &__m256i  &__W,  &__mmask8  &__U,  &__m128  &__A) { ( &__m256i)  &__builtin_ia32_cvttps2qq256_mask (( &__v4sf)  &__A, ( &__v4di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_cvttps_epi64 ( &__mmask8  &__U,  &__m128  &__A) { ( &__m256i)  &__builtin_ia32_cvttps2qq256_mask (( &__v4sf)  &__A, ( &__v4di)  &_mm256_setzero_si256 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvttps_epi64 ( &__m128  &__A) { ( &__m128i)  &__builtin_ia32_cvttps2qq128_mask (( &__v4sf)  &__A, ( &__v2di)  &_mm_setzero_si128 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_cvttps_epi64 ( &__m128i  &__W,  &__mmask8  &__U,  &__m128  &__A) { ( &__m128i)  &__builtin_ia32_cvttps2qq128_mask (( &__v4sf)  &__A, ( &__v2di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_cvttps_epi64 ( &__mmask8  &__U,  &__m128  &__A) { ( &__m128i)  &__builtin_ia32_cvttps2qq128_mask (( &__v4sf)  &__A, ( &__v2di)  &_mm_setzero_si128 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_cvttps_epu64 ( &__m128  &__A) { ( &__m256i)  &__builtin_ia32_cvttps2uqq256_mask (( &__v4sf)  &__A, ( &__v4di)  &_mm256_setzero_si256 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_cvttps_epu64 ( &__m256i  &__W,  &__mmask8  &__U,  &__m128  &__A) { ( &__m256i)  &__builtin_ia32_cvttps2uqq256_mask (( &__v4sf)  &__A, ( &__v4di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_cvttps_epu64 ( &__mmask8  &__U,  &__m128  &__A) { ( &__m256i)  &__builtin_ia32_cvttps2uqq256_mask (( &__v4sf)  &__A, ( &__v4di)  &_mm256_setzero_si256 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvttps_epu64 ( &__m128  &__A) { ( &__m128i)  &__builtin_ia32_cvttps2uqq128_mask (( &__v4sf)  &__A, ( &__v2di)  &_mm_setzero_si128 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_cvttps_epu64 ( &__m128i  &__W,  &__mmask8  &__U,  &__m128  &__A) { ( &__m128i)  &__builtin_ia32_cvttps2uqq128_mask (( &__v4sf)  &__A, ( &__v2di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_cvttps_epu64 ( &__mmask8  &__U,  &__m128  &__A) { ( &__m128i)  &__builtin_ia32_cvttps2uqq128_mask (( &__v4sf)  &__A, ( &__v2di)  &_mm_setzero_si128 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_broadcast_f64x2 ( &__m128d  &__A) { ( &__m256d)  &__builtin_ia32_broadcastf64x2_256_mask (( &__v2df)  &__A, ( &__v4df) &_mm256_undefined_pd(), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_broadcast_f64x2 ( &__m256d  &__O,  &__mmask8  &__M,  &__m128d  &__A) { ( &__m256d)  &__builtin_ia32_broadcastf64x2_256_mask (( &__v2df)  &__A, ( &__v4df)  &__O,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_broadcast_f64x2 ( &__mmask8  &__M,  &__m128d  &__A) { ( &__m256d)  &__builtin_ia32_broadcastf64x2_256_mask (( &__v2df)  &__A, ( &__v4df)  &_mm256_setzero_ps (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_broadcast_i64x2 ( &__m128i  &__A) { ( &__m256i)  &__builtin_ia32_broadcasti64x2_256_mask (( &__v2di)  &__A, ( &__v4di) &_mm256_undefined_si256(), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_broadcast_i64x2 ( &__m256i  &__O,  &__mmask8  &__M,  &__m128i  &__A) { ( &__m256i)  &__builtin_ia32_broadcasti64x2_256_mask (( &__v2di)  &__A, ( &__v4di)  &__O,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_broadcast_i64x2 ( &__mmask8  &__M,  &__m128i  &__A) { ( &__m256i)  &__builtin_ia32_broadcasti64x2_256_mask (( &__v2di)  &__A, ( &__v4di)  &_mm256_setzero_si256 (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_broadcast_f32x2 ( &__m128  &__A) { ( &__m256)  &__builtin_ia32_broadcastf32x2_256_mask (( &__v4sf)  &__A, ( &__v8sf) &_mm256_undefined_ps(), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_broadcast_f32x2 ( &__m256  &__O,  &__mmask8  &__M,  &__m128  &__A) { ( &__m256)  &__builtin_ia32_broadcastf32x2_256_mask (( &__v4sf)  &__A, ( &__v8sf)  &__O,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_broadcast_f32x2 ( &__mmask8  &__M,  &__m128  &__A) { ( &__m256)  &__builtin_ia32_broadcastf32x2_256_mask (( &__v4sf)  &__A, ( &__v8sf)  &_mm256_setzero_ps (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_broadcast_i32x2 ( &__m128i  &__A) { ( &__m256i)  &__builtin_ia32_broadcasti32x2_256_mask (( &__v4si)  &__A, ( &__v8si) &_mm256_undefined_si256(), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_broadcast_i32x2 ( &__m256i  &__O,  &__mmask8  &__M,  &__m128i  &__A) { ( &__m256i)  &__builtin_ia32_broadcasti32x2_256_mask (( &__v4si)  &__A, ( &__v8si)  &__O,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_broadcast_i32x2 ( &__mmask8  &__M,  &__m128i  &__A) { ( &__m256i)  &__builtin_ia32_broadcasti32x2_256_mask (( &__v4si)  &__A, ( &__v8si)  &_mm256_setzero_si256 (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_broadcast_i32x2 ( &__m128i  &__A) { ( &__m128i)  &__builtin_ia32_broadcasti32x2_128_mask (( &__v4si)  &__A, ( &__v4si) &_mm_undefined_si128(), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_broadcast_i32x2 ( &__m128i  &__O,  &__mmask8  &__M,  &__m128i  &__A) { ( &__m128i)  &__builtin_ia32_broadcasti32x2_128_mask (( &__v4si)  &__A, ( &__v4si)  &__O,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_broadcast_i32x2 ( &__mmask8  &__M,  &__m128i  &__A) { ( &__m128i)  &__builtin_ia32_broadcasti32x2_128_mask (( &__v4si)  &__A, ( &__v4si)  &_mm_setzero_si128 (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mullo_epi64 ( &__m256i  &__A,  &__m256i  &__B) { ( &__m256i) (( &__v4du)  &__A * ( &__v4du)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_mullo_epi64 ( &__m256i  &__W,  &__mmask8  &__U,  &__m256i  &__A,  &__m256i  &__B) { ( &__m256i)  &__builtin_ia32_pmullq256_mask (( &__v4di)  &__A, ( &__v4di)  &__B, ( &__v4di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_mullo_epi64 ( &__mmask8  &__U,  &__m256i  &__A,  &__m256i  &__B) { ( &__m256i)  &__builtin_ia32_pmullq256_mask (( &__v4di)  &__A, ( &__v4di)  &__B, ( &__v4di)  &_mm256_setzero_si256 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mullo_epi64 ( &__m128i  &__A,  &__m128i  &__B) { ( &__m128i) (( &__v2du)  &__A * ( &__v2du)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_mullo_epi64 ( &__m128i  &__W,  &__mmask8  &__U,  &__m128i  &__A,  &__m128i  &__B) { ( &__m128i)  &__builtin_ia32_pmullq128_mask (( &__v2di)  &__A, ( &__v2di)  &__B, ( &__v2di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_mullo_epi64 ( &__mmask8  &__U,  &__m128i  &__A,  &__m128i  &__B) { ( &__m128i)  &__builtin_ia32_pmullq128_mask (( &__v2di)  &__A, ( &__v2di)  &__B, ( &__v2di)  &_mm_setzero_si128 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_andnot_pd ( &__m256d  &__W,  &__mmask8  &__U,  &__m256d  &__A,  &__m256d  &__B) { ( &__m256d)  &__builtin_ia32_andnpd256_mask (( &__v4df)  &__A, ( &__v4df)  &__B, ( &__v4df)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_andnot_pd ( &__mmask8  &__U,  &__m256d  &__A,  &__m256d  &__B) { ( &__m256d)  &__builtin_ia32_andnpd256_mask (( &__v4df)  &__A, ( &__v4df)  &__B, ( &__v4df)  &_mm256_setzero_pd (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_andnot_pd ( &__m128d  &__W,  &__mmask8  &__U,  &__m128d  &__A,  &__m128d  &__B) { ( &__m128d)  &__builtin_ia32_andnpd128_mask (( &__v2df)  &__A, ( &__v2df)  &__B, ( &__v2df)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_andnot_pd ( &__mmask8  &__U,  &__m128d  &__A,  &__m128d  &__B) { ( &__m128d)  &__builtin_ia32_andnpd128_mask (( &__v2df)  &__A, ( &__v2df)  &__B, ( &__v2df)  &_mm_setzero_pd (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_andnot_ps ( &__m256  &__W,  &__mmask8  &__U,  &__m256  &__A,  &__m256  &__B) { ( &__m256)  &__builtin_ia32_andnps256_mask (( &__v8sf)  &__A, ( &__v8sf)  &__B, ( &__v8sf)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_andnot_ps ( &__mmask8  &__U,  &__m256  &__A,  &__m256  &__B) { ( &__m256)  &__builtin_ia32_andnps256_mask (( &__v8sf)  &__A, ( &__v8sf)  &__B, ( &__v8sf)  &_mm256_setzero_ps (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_andnot_ps ( &__m128  &__W,  &__mmask8  &__U,  &__m128  &__A,  &__m128  &__B) { ( &__m128)  &__builtin_ia32_andnps128_mask (( &__v4sf)  &__A, ( &__v4sf)  &__B, ( &__v4sf)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_andnot_ps ( &__mmask8  &__U,  &__m128  &__A,  &__m128  &__B) { ( &__m128)  &__builtin_ia32_andnps128_mask (( &__v4sf)  &__A, ( &__v4sf)  &__B, ( &__v4sf)  &_mm_setzero_ps (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_cvtps_epi64 ( &__m128  &__A) { ( &__m256i)  &__builtin_ia32_cvtps2qq256_mask (( &__v4sf)  &__A, ( &__v4di)  &_mm256_setzero_si256 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_cvtps_epi64 ( &__m256i  &__W,  &__mmask8  &__U,  &__m128  &__A) { ( &__m256i)  &__builtin_ia32_cvtps2qq256_mask (( &__v4sf)  &__A, ( &__v4di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_cvtps_epi64 ( &__mmask8  &__U,  &__m128  &__A) { ( &__m256i)  &__builtin_ia32_cvtps2qq256_mask (( &__v4sf)  &__A, ( &__v4di)  &_mm256_setzero_si256 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtps_epi64 ( &__m128  &__A) { ( &__m128i)  &__builtin_ia32_cvtps2qq128_mask (( &__v4sf)  &__A, ( &__v2di)  &_mm_setzero_si128 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_cvtps_epi64 ( &__m128i  &__W,  &__mmask8  &__U,  &__m128  &__A) { ( &__m128i)  &__builtin_ia32_cvtps2qq128_mask (( &__v4sf)  &__A, ( &__v2di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_cvtps_epi64 ( &__mmask8  &__U,  &__m128  &__A) { ( &__m128i)  &__builtin_ia32_cvtps2qq128_mask (( &__v4sf)  &__A, ( &__v2di)  &_mm_setzero_si128 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_cvtps_epu64 ( &__m128  &__A) { ( &__m256i)  &__builtin_ia32_cvtps2uqq256_mask (( &__v4sf)  &__A, ( &__v4di)  &_mm256_setzero_si256 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_cvtps_epu64 ( &__m256i  &__W,  &__mmask8  &__U,  &__m128  &__A) { ( &__m256i)  &__builtin_ia32_cvtps2uqq256_mask (( &__v4sf)  &__A, ( &__v4di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_cvtps_epu64 ( &__mmask8  &__U,  &__m128  &__A) { ( &__m256i)  &__builtin_ia32_cvtps2uqq256_mask (( &__v4sf)  &__A, ( &__v4di)  &_mm256_setzero_si256 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtps_epu64 ( &__m128  &__A) { ( &__m128i)  &__builtin_ia32_cvtps2uqq128_mask (( &__v4sf)  &__A, ( &__v2di)  &_mm_setzero_si128 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_cvtps_epu64 ( &__m128i  &__W,  &__mmask8  &__U,  &__m128  &__A) { ( &__m128i)  &__builtin_ia32_cvtps2uqq128_mask (( &__v4sf)  &__A, ( &__v2di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_cvtps_epu64 ( &__mmask8  &__U,  &__m128  &__A) { ( &__m128i)  &__builtin_ia32_cvtps2uqq128_mask (( &__v4sf)  &__A, ( &__v2di)  &_mm_setzero_si128 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_cvtepi64_ps ( &__m256i  &__A) { ( &__m128)  &__builtin_ia32_cvtqq2ps256_mask (( &__v4di)  &__A, ( &__v4sf)  &_mm_setzero_ps (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_cvtepi64_ps ( &__m128  &__W,  &__mmask8  &__U,  &__m256i  &__A) { ( &__m128)  &__builtin_ia32_cvtqq2ps256_mask (( &__v4di)  &__A, ( &__v4sf)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_cvtepi64_ps ( &__mmask8  &__U,  &__m256i  &__A) { ( &__m128)  &__builtin_ia32_cvtqq2ps256_mask (( &__v4di)  &__A, ( &__v4sf)  &_mm_setzero_ps (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtepi64_ps ( &__m128i  &__A) { ( &__m128)  &__builtin_ia32_cvtqq2ps128_mask (( &__v2di)  &__A, ( &__v4sf)  &_mm_setzero_ps (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_cvtepi64_ps ( &__m128  &__W,  &__mmask8  &__U,  &__m128i  &__A) { ( &__m128)  &__builtin_ia32_cvtqq2ps128_mask (( &__v2di)  &__A, ( &__v4sf)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_cvtepi64_ps ( &__mmask8  &__U,  &__m128i  &__A) { ( &__m128)  &__builtin_ia32_cvtqq2ps128_mask (( &__v2di)  &__A, ( &__v4sf)  &_mm_setzero_ps (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_cvtepu64_ps ( &__m256i  &__A) { ( &__m128)  &__builtin_ia32_cvtuqq2ps256_mask (( &__v4di)  &__A, ( &__v4sf)  &_mm_setzero_ps (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_cvtepu64_ps ( &__m128  &__W,  &__mmask8  &__U,  &__m256i  &__A) { ( &__m128)  &__builtin_ia32_cvtuqq2ps256_mask (( &__v4di)  &__A, ( &__v4sf)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_cvtepu64_ps ( &__mmask8  &__U,  &__m256i  &__A) { ( &__m128)  &__builtin_ia32_cvtuqq2ps256_mask (( &__v4di)  &__A, ( &__v4sf)  &_mm_setzero_ps (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtepu64_ps ( &__m128i  &__A) { ( &__m128)  &__builtin_ia32_cvtuqq2ps128_mask (( &__v2di)  &__A, ( &__v4sf)  &_mm_setzero_ps (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_cvtepu64_ps ( &__m128  &__W,  &__mmask8  &__U,  &__m128i  &__A) { ( &__m128)  &__builtin_ia32_cvtuqq2ps128_mask (( &__v2di)  &__A, ( &__v4sf)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_cvtepu64_ps ( &__mmask8  &__U,  &__m128i  &__A) { ( &__m128)  &__builtin_ia32_cvtuqq2ps128_mask (( &__v2di)  &__A, ( &__v4sf)  &_mm_setzero_ps (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_cvtepi64_pd ( &__m256i  &__A) { ( &__m256d)  &__builtin_ia32_cvtqq2pd256_mask (( &__v4di)  &__A, ( &__v4df)  &_mm256_setzero_pd (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_cvtepi64_pd ( &__m256d  &__W,  &__mmask8  &__U,  &__m256i  &__A) { ( &__m256d)  &__builtin_ia32_cvtqq2pd256_mask (( &__v4di)  &__A, ( &__v4df)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_cvtepi64_pd ( &__mmask8  &__U,  &__m256i  &__A) { ( &__m256d)  &__builtin_ia32_cvtqq2pd256_mask (( &__v4di)  &__A, ( &__v4df)  &_mm256_setzero_pd (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtepi64_pd ( &__m128i  &__A) { ( &__m128d)  &__builtin_ia32_cvtqq2pd128_mask (( &__v2di)  &__A, ( &__v2df)  &_mm_setzero_pd (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_cvtepi64_pd ( &__m128d  &__W,  &__mmask8  &__U,  &__m128i  &__A) { ( &__m128d)  &__builtin_ia32_cvtqq2pd128_mask (( &__v2di)  &__A, ( &__v2df)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_cvtepi64_pd ( &__mmask8  &__U,  &__m128i  &__A) { ( &__m128d)  &__builtin_ia32_cvtqq2pd128_mask (( &__v2di)  &__A, ( &__v2df)  &_mm_setzero_pd (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_cvtepu64_pd ( &__m256i  &__A) { ( &__m256d)  &__builtin_ia32_cvtuqq2pd256_mask (( &__v4di)  &__A, ( &__v4df)  &_mm256_setzero_pd (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_cvtepu64_pd ( &__m256d  &__W,  &__mmask8  &__U,  &__m256i  &__A) { ( &__m256d)  &__builtin_ia32_cvtuqq2pd256_mask (( &__v4di)  &__A, ( &__v4df)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_cvtepu64_pd ( &__mmask8  &__U,  &__m256i  &__A) { ( &__m256d)  &__builtin_ia32_cvtuqq2pd256_mask (( &__v4di)  &__A, ( &__v4df)  &_mm256_setzero_pd (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_and_pd ( &__m256d  &__W,  &__mmask8  &__U,  &__m256d  &__A,  &__m256d  &__B) { ( &__m256d)  &__builtin_ia32_andpd256_mask (( &__v4df)  &__A, ( &__v4df)  &__B, ( &__v4df)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_and_pd ( &__mmask8  &__U,  &__m256d  &__A,  &__m256d  &__B) { ( &__m256d)  &__builtin_ia32_andpd256_mask (( &__v4df)  &__A, ( &__v4df)  &__B, ( &__v4df)  &_mm256_setzero_pd (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_and_pd ( &__m128d  &__W,  &__mmask8  &__U,  &__m128d  &__A,  &__m128d  &__B) { ( &__m128d)  &__builtin_ia32_andpd128_mask (( &__v2df)  &__A, ( &__v2df)  &__B, ( &__v2df)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_and_pd ( &__mmask8  &__U,  &__m128d  &__A,  &__m128d  &__B) { ( &__m128d)  &__builtin_ia32_andpd128_mask (( &__v2df)  &__A, ( &__v2df)  &__B, ( &__v2df)  &_mm_setzero_pd (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_and_ps ( &__m256  &__W,  &__mmask8  &__U,  &__m256  &__A,  &__m256  &__B) { ( &__m256)  &__builtin_ia32_andps256_mask (( &__v8sf)  &__A, ( &__v8sf)  &__B, ( &__v8sf)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_and_ps ( &__mmask8  &__U,  &__m256  &__A,  &__m256  &__B) { ( &__m256)  &__builtin_ia32_andps256_mask (( &__v8sf)  &__A, ( &__v8sf)  &__B, ( &__v8sf)  &_mm256_setzero_ps (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_and_ps ( &__m128  &__W,  &__mmask8  &__U,  &__m128  &__A,  &__m128  &__B) { ( &__m128)  &__builtin_ia32_andps128_mask (( &__v4sf)  &__A, ( &__v4sf)  &__B, ( &__v4sf)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_and_ps ( &__mmask8  &__U,  &__m128  &__A,  &__m128  &__B) { ( &__m128)  &__builtin_ia32_andps128_mask (( &__v4sf)  &__A, ( &__v4sf)  &__B, ( &__v4sf)  &_mm_setzero_ps (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtepu64_pd ( &__m128i  &__A) { ( &__m128d)  &__builtin_ia32_cvtuqq2pd128_mask (( &__v2di)  &__A, ( &__v2df)  &_mm_setzero_pd (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_cvtepu64_pd ( &__m128d  &__W,  &__mmask8  &__U,  &__m128i  &__A) { ( &__m128d)  &__builtin_ia32_cvtuqq2pd128_mask (( &__v2di)  &__A, ( &__v2df)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_cvtepu64_pd ( &__mmask8  &__U,  &__m128i  &__A) { ( &__m128d)  &__builtin_ia32_cvtuqq2pd128_mask (( &__v2di)  &__A, ( &__v2df)  &_mm_setzero_pd (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_xor_pd ( &__m256d  &__W,  &__mmask8  &__U,  &__m256d  &__A,  &__m256d  &__B) { ( &__m256d)  &__builtin_ia32_xorpd256_mask (( &__v4df)  &__A, ( &__v4df)  &__B, ( &__v4df)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_xor_pd ( &__mmask8  &__U,  &__m256d  &__A,  &__m256d  &__B) { ( &__m256d)  &__builtin_ia32_xorpd256_mask (( &__v4df)  &__A, ( &__v4df)  &__B, ( &__v4df)  &_mm256_setzero_pd (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_xor_pd ( &__m128d  &__W,  &__mmask8  &__U,  &__m128d  &__A,  &__m128d  &__B) { ( &__m128d)  &__builtin_ia32_xorpd128_mask (( &__v2df)  &__A, ( &__v2df)  &__B, ( &__v2df)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_xor_pd ( &__mmask8  &__U,  &__m128d  &__A,  &__m128d  &__B) { ( &__m128d)  &__builtin_ia32_xorpd128_mask (( &__v2df)  &__A, ( &__v2df)  &__B, ( &__v2df)  &_mm_setzero_pd (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_xor_ps ( &__m256  &__W,  &__mmask8  &__U,  &__m256  &__A,  &__m256  &__B) { ( &__m256)  &__builtin_ia32_xorps256_mask (( &__v8sf)  &__A, ( &__v8sf)  &__B, ( &__v8sf)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_xor_ps ( &__mmask8  &__U,  &__m256  &__A,  &__m256  &__B) { ( &__m256)  &__builtin_ia32_xorps256_mask (( &__v8sf)  &__A, ( &__v8sf)  &__B, ( &__v8sf)  &_mm256_setzero_ps (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_xor_ps ( &__m128  &__W,  &__mmask8  &__U,  &__m128  &__A,  &__m128  &__B) { ( &__m128)  &__builtin_ia32_xorps128_mask (( &__v4sf)  &__A, ( &__v4sf)  &__B, ( &__v4sf)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_xor_ps ( &__mmask8  &__U,  &__m128  &__A,  &__m128  &__B) { ( &__m128)  &__builtin_ia32_xorps128_mask (( &__v4sf)  &__A, ( &__v4sf)  &__B, ( &__v4sf)  &_mm_setzero_ps (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_or_pd ( &__m256d  &__W,  &__mmask8  &__U,  &__m256d  &__A,  &__m256d  &__B) { ( &__m256d)  &__builtin_ia32_orpd256_mask (( &__v4df)  &__A, ( &__v4df)  &__B, ( &__v4df)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_or_pd ( &__mmask8  &__U,  &__m256d  &__A,  &__m256d  &__B) { ( &__m256d)  &__builtin_ia32_orpd256_mask (( &__v4df)  &__A, ( &__v4df)  &__B, ( &__v4df)  &_mm256_setzero_pd (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_or_pd ( &__m128d  &__W,  &__mmask8  &__U,  &__m128d  &__A,  &__m128d  &__B) { ( &__m128d)  &__builtin_ia32_orpd128_mask (( &__v2df)  &__A, ( &__v2df)  &__B, ( &__v2df)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_or_pd ( &__mmask8  &__U,  &__m128d  &__A,  &__m128d  &__B) { ( &__m128d)  &__builtin_ia32_orpd128_mask (( &__v2df)  &__A, ( &__v2df)  &__B, ( &__v2df)  &_mm_setzero_pd (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_or_ps ( &__m256  &__W,  &__mmask8  &__U,  &__m256  &__A,  &__m256  &__B) { ( &__m256)  &__builtin_ia32_orps256_mask (( &__v8sf)  &__A, ( &__v8sf)  &__B, ( &__v8sf)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_or_ps ( &__mmask8  &__U,  &__m256  &__A,  &__m256  &__B) { ( &__m256)  &__builtin_ia32_orps256_mask (( &__v8sf)  &__A, ( &__v8sf)  &__B, ( &__v8sf)  &_mm256_setzero_ps (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_or_ps ( &__m128  &__W,  &__mmask8  &__U,  &__m128  &__A,  &__m128  &__B) { ( &__m128)  &__builtin_ia32_orps128_mask (( &__v4sf)  &__A, ( &__v4sf)  &__B, ( &__v4sf)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_or_ps ( &__mmask8  &__U,  &__m128  &__A,  &__m128  &__B) { ( &__m128)  &__builtin_ia32_orps128_mask (( &__v4sf)  &__A, ( &__v4sf)  &__B, ( &__v4sf)  &_mm_setzero_ps (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_movm_epi32 ( &__mmask8  &__A) { ( &__m128i)  &__builtin_ia32_cvtmask2d128 ( &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_movm_epi32 ( &__mmask8  &__A) { ( &__m256i)  &__builtin_ia32_cvtmask2d256 ( &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_movm_epi64 ( &__mmask8  &__A) { ( &__m128i)  &__builtin_ia32_cvtmask2q128 ( &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_movm_epi64 ( &__mmask8  &__A) { ( &__m256i)  &__builtin_ia32_cvtmask2q256 ( &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_movepi32_mask ( &__m128i  &__A) { ( &__mmask8)  &__builtin_ia32_cvtd2mask128 (( &__v4si)  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_movepi32_mask ( &__m256i  &__A) { ( &__mmask8)  &__builtin_ia32_cvtd2mask256 (( &__v8si)  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_movepi64_mask ( &__m128i  &__A) { ( &__mmask8)  &__builtin_ia32_cvtq2mask128 (( &__v2di)  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_movepi64_mask ( &__m256i  &__A) { ( &__mmask8)  &__builtin_ia32_cvtq2mask256 (( &__v4di)  &__A); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_extractf64x2_pd ( &__m256d  &__A,  &const \'int\'  &__imm) { ( &__m128d)  &__builtin_ia32_extractf64x2_256_mask (( &__v4df)  &__A,  &__imm, ( &__v2df)  &_mm_setzero_pd (), ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_extractf64x2_pd ( &__m128d  &__W,  &__mmask8  &__U,  &__m256d  &__A,  &const \'int\'  &__imm) { ( &__m128d)  &__builtin_ia32_extractf64x2_256_mask (( &__v4df)  &__A,  &__imm, ( &__v2df)  &__W, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_extractf64x2_pd ( &__mmask8  &__U,  &__m256d  &__A,  &const \'int\'  &__imm) { ( &__m128d)  &__builtin_ia32_extractf64x2_256_mask (( &__v4df)  &__A,  &__imm, ( &__v2df)  &_mm_setzero_pd (), ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_extracti64x2_epi64 ( &__m256i  &__A,  &const \'int\'  &__imm) { ( &__m128i)  &__builtin_ia32_extracti64x2_256_mask (( &__v4di)  &__A,  &__imm, ( &__v2di)  &_mm_setzero_si128 (), ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_extracti64x2_epi64 ( &__m128i  &__W,  &__mmask8  &__U,  &__m256i  &__A,  &const \'int\'  &__imm) { ( &__m128i)  &__builtin_ia32_extracti64x2_256_mask (( &__v4di)  &__A,  &__imm, ( &__v2di)  &__W, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_extracti64x2_epi64 ( &__mmask8  &__U,  &__m256i  &__A,  &const \'int\'  &__imm) { ( &__m128i)  &__builtin_ia32_extracti64x2_256_mask (( &__v4di)  &__A,  &__imm, ( &__v2di)  &_mm_setzero_si128 (), ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_reduce_pd ( &__m256d  &__A, \'int\'  &__B) { ( &__m256d)  &__builtin_ia32_reducepd256_mask (( &__v4df)  &__A,  &__B, ( &__v4df)  &_mm256_setzero_pd (), ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_reduce_pd ( &__m256d  &__W,  &__mmask8  &__U,  &__m256d  &__A, \'int\'  &__B) { ( &__m256d)  &__builtin_ia32_reducepd256_mask (( &__v4df)  &__A,  &__B, ( &__v4df)  &__W, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_reduce_pd ( &__mmask8  &__U,  &__m256d  &__A, \'int\'  &__B) { ( &__m256d)  &__builtin_ia32_reducepd256_mask (( &__v4df)  &__A,  &__B, ( &__v4df)  &_mm256_setzero_pd (), ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_reduce_pd ( &__m128d  &__A, \'int\'  &__B) { ( &__m128d)  &__builtin_ia32_reducepd128_mask (( &__v2df)  &__A,  &__B, ( &__v2df)  &_mm_setzero_pd (), ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_reduce_pd ( &__m128d  &__W,  &__mmask8  &__U,  &__m128d  &__A, \'int\'  &__B) { ( &__m128d)  &__builtin_ia32_reducepd128_mask (( &__v2df)  &__A,  &__B, ( &__v2df)  &__W, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_reduce_pd ( &__mmask8  &__U,  &__m128d  &__A, \'int\'  &__B) { ( &__m128d)  &__builtin_ia32_reducepd128_mask (( &__v2df)  &__A,  &__B, ( &__v2df)  &_mm_setzero_pd (), ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_reduce_ps ( &__m256  &__A, \'int\'  &__B) { ( &__m256)  &__builtin_ia32_reduceps256_mask (( &__v8sf)  &__A,  &__B, ( &__v8sf)  &_mm256_setzero_ps (), ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_reduce_ps ( &__m256  &__W,  &__mmask8  &__U,  &__m256  &__A, \'int\'  &__B) { ( &__m256)  &__builtin_ia32_reduceps256_mask (( &__v8sf)  &__A,  &__B, ( &__v8sf)  &__W, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_reduce_ps ( &__mmask8  &__U,  &__m256  &__A, \'int\'  &__B) { ( &__m256)  &__builtin_ia32_reduceps256_mask (( &__v8sf)  &__A,  &__B, ( &__v8sf)  &_mm256_setzero_ps (), ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_reduce_ps ( &__m128  &__A, \'int\'  &__B) { ( &__m128)  &__builtin_ia32_reduceps128_mask (( &__v4sf)  &__A,  &__B, ( &__v4sf)  &_mm_setzero_ps (), ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_reduce_ps ( &__m128  &__W,  &__mmask8  &__U,  &__m128  &__A, \'int\'  &__B) { ( &__m128)  &__builtin_ia32_reduceps128_mask (( &__v4sf)  &__A,  &__B, ( &__v4sf)  &__W, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_reduce_ps ( &__mmask8  &__U,  &__m128  &__A, \'int\'  &__B) { ( &__m128)  &__builtin_ia32_reduceps128_mask (( &__v4sf)  &__A,  &__B, ( &__v4sf)  &_mm_setzero_ps (), ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_range_pd ( &__m256d  &__A,  &__m256d  &__B, \'int\'  &__C) { ( &__m256d)  &__builtin_ia32_rangepd256_mask (( &__v4df)  &__A, ( &__v4df)  &__B,  &__C, ( &__v4df)  &_mm256_setzero_pd (), ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_range_pd ( &__m256d  &__W,  &__mmask8  &__U,  &__m256d  &__A,  &__m256d  &__B, \'int\'  &__C) { ( &__m256d)  &__builtin_ia32_rangepd256_mask (( &__v4df)  &__A, ( &__v4df)  &__B,  &__C, ( &__v4df)  &__W, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_range_pd ( &__mmask8  &__U,  &__m256d  &__A,  &__m256d  &__B, \'int\'  &__C) { ( &__m256d)  &__builtin_ia32_rangepd256_mask (( &__v4df)  &__A, ( &__v4df)  &__B,  &__C, ( &__v4df)  &_mm256_setzero_pd (), ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_range_pd ( &__m128d  &__A,  &__m128d  &__B, \'int\'  &__C) { ( &__m128d)  &__builtin_ia32_rangepd128_mask (( &__v2df)  &__A, ( &__v2df)  &__B,  &__C, ( &__v2df)  &_mm_setzero_pd (), ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_range_pd ( &__m128d  &__W,  &__mmask8  &__U,  &__m128d  &__A,  &__m128d  &__B, \'int\'  &__C) { ( &__m128d)  &__builtin_ia32_rangepd128_mask (( &__v2df)  &__A, ( &__v2df)  &__B,  &__C, ( &__v2df)  &__W, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_range_pd ( &__mmask8  &__U,  &__m128d  &__A,  &__m128d  &__B, \'int\'  &__C) { ( &__m128d)  &__builtin_ia32_rangepd128_mask (( &__v2df)  &__A, ( &__v2df)  &__B,  &__C, ( &__v2df)  &_mm_setzero_pd (), ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_range_ps ( &__m256  &__A,  &__m256  &__B, \'int\'  &__C) { ( &__m256)  &__builtin_ia32_rangeps256_mask (( &__v8sf)  &__A, ( &__v8sf)  &__B,  &__C, ( &__v8sf)  &_mm256_setzero_ps (), ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_range_ps ( &__m256  &__W,  &__mmask8  &__U,  &__m256  &__A,  &__m256  &__B, \'int\'  &__C) { ( &__m256)  &__builtin_ia32_rangeps256_mask (( &__v8sf)  &__A, ( &__v8sf)  &__B,  &__C, ( &__v8sf)  &__W, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_range_ps ( &__mmask8  &__U,  &__m256  &__A,  &__m256  &__B, \'int\'  &__C) { ( &__m256)  &__builtin_ia32_rangeps256_mask (( &__v8sf)  &__A, ( &__v8sf)  &__B,  &__C, ( &__v8sf)  &_mm256_setzero_ps (), ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_range_ps ( &__m128  &__A,  &__m128  &__B, \'int\'  &__C) { ( &__m128)  &__builtin_ia32_rangeps128_mask (( &__v4sf)  &__A, ( &__v4sf)  &__B,  &__C, ( &__v4sf)  &_mm_setzero_ps (), ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_range_ps ( &__m128  &__W,  &__mmask8  &__U,  &__m128  &__A,  &__m128  &__B, \'int\'  &__C) { ( &__m128)  &__builtin_ia32_rangeps128_mask (( &__v4sf)  &__A, ( &__v4sf)  &__B,  &__C, ( &__v4sf)  &__W, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_range_ps ( &__mmask8  &__U,  &__m128  &__A,  &__m128  &__B, \'int\'  &__C) { ( &__m128)  &__builtin_ia32_rangeps128_mask (( &__v4sf)  &__A, ( &__v4sf)  &__B,  &__C, ( &__v4sf)  &_mm_setzero_ps (), ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_fpclass_pd_mask ( &__mmask8  &__U,  &__m256d  &__A,  &const \'int\'  &__imm) { ( &__mmask8)  &__builtin_ia32_fpclasspd256_mask (( &__v4df)  &__A,  &__imm,  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_fpclass_pd_mask ( &__m256d  &__A,  &const \'int\'  &__imm) { ( &__mmask8)  &__builtin_ia32_fpclasspd256_mask (( &__v4df)  &__A,  &__imm, ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_fpclass_ps_mask ( &__mmask8  &__U,  &__m256  &__A,  &const \'int\'  &__imm) { ( &__mmask8)  &__builtin_ia32_fpclassps256_mask (( &__v8sf)  &__A,  &__imm,  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_fpclass_ps_mask ( &__m256  &__A,  &const \'int\'  &__imm) { ( &__mmask8)  &__builtin_ia32_fpclassps256_mask (( &__v8sf)  &__A,  &__imm, ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_fpclass_pd_mask ( &__mmask8  &__U,  &__m128d  &__A,  &const \'int\'  &__imm) { ( &__mmask8)  &__builtin_ia32_fpclasspd128_mask (( &__v2df)  &__A,  &__imm,  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_fpclass_pd_mask ( &__m128d  &__A,  &const \'int\'  &__imm) { ( &__mmask8)  &__builtin_ia32_fpclasspd128_mask (( &__v2df)  &__A,  &__imm, ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_fpclass_ps_mask ( &__mmask8  &__U,  &__m128  &__A,  &const \'int\'  &__imm) { ( &__mmask8)  &__builtin_ia32_fpclassps128_mask (( &__v4sf)  &__A,  &__imm,  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_fpclass_ps_mask ( &__m128  &__A,  &const \'int\'  &__imm) { ( &__mmask8)  &__builtin_ia32_fpclassps128_mask (( &__v4sf)  &__A,  &__imm, ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_inserti64x2 ( &__m256i  &__A,  &__m128i  &__B,  &const \'int\'  &__imm) { ( &__m256i)  &__builtin_ia32_inserti64x2_256_mask (( &__v4di)  &__A, ( &__v2di)  &__B,  &__imm, ( &__v4di)  &_mm256_setzero_si256 (), ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_inserti64x2 ( &__m256i  &__W,  &__mmask8  &__U,  &__m256i  &__A,  &__m128i  &__B,  &const \'int\'  &__imm) { ( &__m256i)  &__builtin_ia32_inserti64x2_256_mask (( &__v4di)  &__A, ( &__v2di)  &__B,  &__imm, ( &__v4di)  &__W, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_inserti64x2 ( &__mmask8  &__U,  &__m256i  &__A,  &__m128i  &__B,  &const \'int\'  &__imm) { ( &__m256i)  &__builtin_ia32_inserti64x2_256_mask (( &__v4di)  &__A, ( &__v2di)  &__B,  &__imm, ( &__v4di)  &_mm256_setzero_si256 (), ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_insertf64x2 ( &__m256d  &__A,  &__m128d  &__B,  &const \'int\'  &__imm) { ( &__m256d)  &__builtin_ia32_insertf64x2_256_mask (( &__v4df)  &__A, ( &__v2df)  &__B,  &__imm, ( &__v4df)  &_mm256_setzero_pd (), ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_insertf64x2 ( &__m256d  &__W,  &__mmask8  &__U,  &__m256d  &__A,  &__m128d  &__B,  &const \'int\'  &__imm) { ( &__m256d)  &__builtin_ia32_insertf64x2_256_mask (( &__v4df)  &__A, ( &__v2df)  &__B,  &__imm, ( &__v4df)  &__W, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_insertf64x2 ( &__mmask8  &__U,  &__m256d  &__A,  &__m128d  &__B,  &const \'int\'  &__imm) { ( &__m256d)  &__builtin_ia32_insertf64x2_256_mask (( &__v4df)  &__A, ( &__v2df)  &__B,  &__imm, ( &__v4df)  &_mm256_setzero_pd (), ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm256_insertf64x2 {
	    my($X, $Y, $C) = @_;
    	    eval q((( &__m256d)  &__builtin_ia32_insertf64x2_256_mask (( &__v4df)( &__m256d) ($X), ( &__v2df)( &__m128d) , ($C), ( &__v4df)( &__m256d) &_mm256_setzero_pd(), ( &__mmask8)-1)));
	}' unless defined(&_mm256_insertf64x2);
	eval 'sub _mm256_mask_insertf64x2 {
	    my($W, $U, $X, $Y, $C) = @_;
    	    eval q((( &__m256d)  &__builtin_ia32_insertf64x2_256_mask (( &__v4df)( &__m256d) ($X), ( &__v2df)( &__m128d) , ($C), ( &__v4df)( &__m256d)($W), ( &__mmask8)($U))));
	}' unless defined(&_mm256_mask_insertf64x2);
	eval 'sub _mm256_maskz_insertf64x2 {
	    my($U, $X, $Y, $C) = @_;
    	    eval q((( &__m256d)  &__builtin_ia32_insertf64x2_256_mask (( &__v4df)( &__m256d) ($X), ( &__v2df)( &__m128d) , ($C), ( &__v4df)( &__m256d) &_mm256_setzero_pd(), ( &__mmask8)($U))));
	}' unless defined(&_mm256_maskz_insertf64x2);
	eval 'sub _mm256_inserti64x2 {
	    my($X, $Y, $C) = @_;
    	    eval q((( &__m256i)  &__builtin_ia32_inserti64x2_256_mask (( &__v4di)( &__m256i) ($X), ( &__v2di)( &__m128i) , ($C), ( &__v4di)( &__m256i) &_mm256_setzero_si256 (), ( &__mmask8)-1)));
	}' unless defined(&_mm256_inserti64x2);
	eval 'sub _mm256_mask_inserti64x2 {
	    my($W, $U, $X, $Y, $C) = @_;
    	    eval q((( &__m256i)  &__builtin_ia32_inserti64x2_256_mask (( &__v4di)( &__m256i) ($X), ( &__v2di)( &__m128i) , ($C), ( &__v4di)( &__m256i)($W), ( &__mmask8)($U))));
	}' unless defined(&_mm256_mask_inserti64x2);
	eval 'sub _mm256_maskz_inserti64x2 {
	    my($U, $X, $Y, $C) = @_;
    	    eval q((( &__m256i)  &__builtin_ia32_inserti64x2_256_mask (( &__v4di)( &__m256i) ($X), ( &__v2di)( &__m128i) , ($C), ( &__v4di)( &__m256i) &_mm256_setzero_si256 (), ( &__mmask8)($U))));
	}' unless defined(&_mm256_maskz_inserti64x2);
	eval 'sub _mm256_extractf64x2_pd {
	    my($X, $C) = @_;
    	    eval q((( &__m128d)  &__builtin_ia32_extractf64x2_256_mask (( &__v4df)( &__m256d) , ($C), ( &__v2df)( &__m128d)  &_mm_setzero_pd(), ( &__mmask8)-1)));
	}' unless defined(&_mm256_extractf64x2_pd);
	eval 'sub _mm256_mask_extractf64x2_pd {
	    my($W, $U, $X, $C) = @_;
    	    eval q((( &__m128d)  &__builtin_ia32_extractf64x2_256_mask (( &__v4df)( &__m256d) , ($C), ( &__v2df)( &__m128d) ($W), ( &__mmask8) ($U))));
	}' unless defined(&_mm256_mask_extractf64x2_pd);
	eval 'sub _mm256_maskz_extractf64x2_pd {
	    my($U, $X, $C) = @_;
    	    eval q((( &__m128d)  &__builtin_ia32_extractf64x2_256_mask (( &__v4df)( &__m256d) , ($C), ( &__v2df)( &__m128d)  &_mm_setzero_pd(), ( &__mmask8) ($U))));
	}' unless defined(&_mm256_maskz_extractf64x2_pd);
	eval 'sub _mm256_extracti64x2_epi64 {
	    my($X, $C) = @_;
    	    eval q((( &__m128i)  &__builtin_ia32_extracti64x2_256_mask (( &__v4di)( &__m256i) , ($C), ( &__v2di)( &__m128i)  &_mm_setzero_si128 (), ( &__mmask8)-1)));
	}' unless defined(&_mm256_extracti64x2_epi64);
	eval 'sub _mm256_mask_extracti64x2_epi64 {
	    my($W, $U, $X, $C) = @_;
    	    eval q((( &__m128i)  &__builtin_ia32_extracti64x2_256_mask (( &__v4di)( &__m256i) , ($C), ( &__v2di)( &__m128i) ($W), ( &__mmask8) ($U))));
	}' unless defined(&_mm256_mask_extracti64x2_epi64);
	eval 'sub _mm256_maskz_extracti64x2_epi64 {
	    my($U, $X, $C) = @_;
    	    eval q((( &__m128i)  &__builtin_ia32_extracti64x2_256_mask (( &__v4di)( &__m256i) , ($C), ( &__v2di)( &__m128i)  &_mm_setzero_si128 (), ( &__mmask8) ($U))));
	}' unless defined(&_mm256_maskz_extracti64x2_epi64);
	eval 'sub _mm256_reduce_pd {
	    my($A, $B) = @_;
    	    eval q((( &__m256d)  &__builtin_ia32_reducepd256_mask (( &__v4df)( &__m256d), ($B), ( &__v4df) &_mm256_setzero_pd(), ( &__mmask8)-1)));
	}' unless defined(&_mm256_reduce_pd);
	eval 'sub _mm256_mask_reduce_pd {
	    my($W, $U, $A, $B) = @_;
    	    eval q((( &__m256d)  &__builtin_ia32_reducepd256_mask (( &__v4df)( &__m256d), ($B), ( &__v4df)( &__m256d)($W), ( &__mmask8)($U))));
	}' unless defined(&_mm256_mask_reduce_pd);
	eval 'sub _mm256_maskz_reduce_pd {
	    my($U, $A, $B) = @_;
    	    eval q((( &__m256d)  &__builtin_ia32_reducepd256_mask (( &__v4df)( &__m256d), ($B), ( &__v4df) &_mm256_setzero_pd(), ( &__mmask8)($U))));
	}' unless defined(&_mm256_maskz_reduce_pd);
	eval 'sub _mm_reduce_pd {
	    my($A, $B) = @_;
    	    eval q((( &__m128d)  &__builtin_ia32_reducepd128_mask (( &__v2df)( &__m128d), ($B), ( &__v2df) &_mm_setzero_pd(), ( &__mmask8)-1)));
	}' unless defined(&_mm_reduce_pd);
	eval 'sub _mm_mask_reduce_pd {
	    my($W, $U, $A, $B) = @_;
    	    eval q((( &__m128d)  &__builtin_ia32_reducepd128_mask (( &__v2df)( &__m128d), ($B), ( &__v2df)( &__m128d)($W), ( &__mmask8)($U))));
	}' unless defined(&_mm_mask_reduce_pd);
	eval 'sub _mm_maskz_reduce_pd {
	    my($U, $A, $B) = @_;
    	    eval q((( &__m128d)  &__builtin_ia32_reducepd128_mask (( &__v2df)( &__m128d), ($B), ( &__v2df) &_mm_setzero_pd(), ( &__mmask8)($U))));
	}' unless defined(&_mm_maskz_reduce_pd);
	eval 'sub _mm256_reduce_ps {
	    my($A, $B) = @_;
    	    eval q((( &__m256)  &__builtin_ia32_reduceps256_mask (( &__v8sf)( &__m256), ($B), ( &__v8sf) &_mm256_setzero_ps(), ( &__mmask8)-1)));
	}' unless defined(&_mm256_reduce_ps);
	eval 'sub _mm256_mask_reduce_ps {
	    my($W, $U, $A, $B) = @_;
    	    eval q((( &__m256)  &__builtin_ia32_reduceps256_mask (( &__v8sf)( &__m256), ($B), ( &__v8sf)( &__m256)($W), ( &__mmask8)($U))));
	}' unless defined(&_mm256_mask_reduce_ps);
	eval 'sub _mm256_maskz_reduce_ps {
	    my($U, $A, $B) = @_;
    	    eval q((( &__m256)  &__builtin_ia32_reduceps256_mask (( &__v8sf)( &__m256), ($B), ( &__v8sf) &_mm256_setzero_ps(), ( &__mmask8)($U))));
	}' unless defined(&_mm256_maskz_reduce_ps);
	eval 'sub _mm_reduce_ps {
	    my($A, $B) = @_;
    	    eval q((( &__m128)  &__builtin_ia32_reduceps128_mask (( &__v4sf)( &__m128), ($B), ( &__v4sf) &_mm_setzero_ps(), ( &__mmask8)-1)));
	}' unless defined(&_mm_reduce_ps);
	eval 'sub _mm_mask_reduce_ps {
	    my($W, $U, $A, $B) = @_;
    	    eval q((( &__m128)  &__builtin_ia32_reduceps128_mask (( &__v4sf)( &__m128), ($B), ( &__v4sf)( &__m128)($W), ( &__mmask8)($U))));
	}' unless defined(&_mm_mask_reduce_ps);
	eval 'sub _mm_maskz_reduce_ps {
	    my($U, $A, $B) = @_;
    	    eval q((( &__m128)  &__builtin_ia32_reduceps128_mask (( &__v4sf)( &__m128), ($B), ( &__v4sf) &_mm_setzero_ps(), ( &__mmask8)($U))));
	}' unless defined(&_mm_maskz_reduce_ps);
	eval 'sub _mm256_range_pd {
	    my($A, $B, $C) = @_;
    	    eval q((( &__m256d)  &__builtin_ia32_rangepd256_mask (( &__v4df)( &__m256d)($A), ( &__v4df)( &__m256d), ($C), ( &__v4df) &_mm256_setzero_pd(), ( &__mmask8)-1)));
	}' unless defined(&_mm256_range_pd);
	eval 'sub _mm256_maskz_range_pd {
	    my($U, $A, $B, $C) = @_;
    	    eval q((( &__m256d)  &__builtin_ia32_rangepd256_mask (( &__v4df)( &__m256d)($A), ( &__v4df)( &__m256d), ($C), ( &__v4df) &_mm256_setzero_pd(), ( &__mmask8)($U))));
	}' unless defined(&_mm256_maskz_range_pd);
	eval 'sub _mm_range_pd {
	    my($A, $B, $C) = @_;
    	    eval q((( &__m128d)  &__builtin_ia32_rangepd128_mask (( &__v2df)( &__m128d)($A), ( &__v2df)( &__m128d), ($C), ( &__v2df) &_mm_setzero_pd(), ( &__mmask8)-1)));
	}' unless defined(&_mm_range_pd);
	eval 'sub _mm256_range_ps {
	    my($A, $B, $C) = @_;
    	    eval q((( &__m256)  &__builtin_ia32_rangeps256_mask (( &__v8sf)( &__m256)($A), ( &__v8sf)( &__m256), ($C), ( &__v8sf) &_mm256_setzero_ps(), ( &__mmask8)-1)));
	}' unless defined(&_mm256_range_ps);
	eval 'sub _mm256_mask_range_ps {
	    my($W, $U, $A, $B, $C) = @_;
    	    eval q((( &__m256)  &__builtin_ia32_rangeps256_mask (( &__v8sf)( &__m256)($A), ( &__v8sf)( &__m256), ($C), ( &__v8sf)( &__m256)($W), ( &__mmask8)($U))));
	}' unless defined(&_mm256_mask_range_ps);
	eval 'sub _mm256_maskz_range_ps {
	    my($U, $A, $B, $C) = @_;
    	    eval q((( &__m256)  &__builtin_ia32_rangeps256_mask (( &__v8sf)( &__m256)($A), ( &__v8sf)( &__m256), ($C), ( &__v8sf) &_mm256_setzero_ps(), ( &__mmask8)($U))));
	}' unless defined(&_mm256_maskz_range_ps);
	eval 'sub _mm_range_ps {
	    my($A, $B, $C) = @_;
    	    eval q((( &__m128)  &__builtin_ia32_rangeps128_mask (( &__v4sf)( &__m128)($A), ( &__v4sf)( &__m128), ($C), ( &__v4sf) &_mm_setzero_ps(), ( &__mmask8)-1)));
	}' unless defined(&_mm_range_ps);
	eval 'sub _mm_mask_range_ps {
	    my($W, $U, $A, $B, $C) = @_;
    	    eval q((( &__m128)  &__builtin_ia32_rangeps128_mask (( &__v4sf)( &__m128)($A), ( &__v4sf)( &__m128), ($C), ( &__v4sf)( &__m128)($W), ( &__mmask8)($U))));
	}' unless defined(&_mm_mask_range_ps);
	eval 'sub _mm_maskz_range_ps {
	    my($U, $A, $B, $C) = @_;
    	    eval q((( &__m128)  &__builtin_ia32_rangeps128_mask (( &__v4sf)( &__m128)($A), ( &__v4sf)( &__m128), ($C), ( &__v4sf) &_mm_setzero_ps(), ( &__mmask8)($U))));
	}' unless defined(&_mm_maskz_range_ps);
	eval 'sub _mm256_mask_range_pd {
	    my($W, $U, $A, $B, $C) = @_;
    	    eval q((( &__m256d)  &__builtin_ia32_rangepd256_mask (( &__v4df)( &__m256d)($A), ( &__v4df)( &__m256d), ($C), ( &__v4df)( &__m256d)($W), ( &__mmask8)($U))));
	}' unless defined(&_mm256_mask_range_pd);
	eval 'sub _mm_mask_range_pd {
	    my($W, $U, $A, $B, $C) = @_;
    	    eval q((( &__m128d)  &__builtin_ia32_rangepd128_mask (( &__v2df)( &__m128d)($A), ( &__v2df)( &__m128d), ($C), ( &__v2df)( &__m128d)($W), ( &__mmask8)($U))));
	}' unless defined(&_mm_mask_range_pd);
	eval 'sub _mm_maskz_range_pd {
	    my($U, $A, $B, $C) = @_;
    	    eval q((( &__m128d)  &__builtin_ia32_rangepd128_mask (( &__v2df)( &__m128d)($A), ( &__v2df)( &__m128d), ($C), ( &__v2df) &_mm_setzero_pd(), ( &__mmask8)($U))));
	}' unless defined(&_mm_maskz_range_pd);
	eval 'sub _mm256_mask_fpclass_pd_mask {
	    my($u, $X, $C) = @_;
    	    eval q((( &__mmask8)  &__builtin_ia32_fpclasspd256_mask (( &__v4df) ( &__m256d) , ($C),( &__mmask8)($u))));
	}' unless defined(&_mm256_mask_fpclass_pd_mask);
	eval 'sub _mm256_mask_fpclass_ps_mask {
	    my($u, $X, $C) = @_;
    	    eval q((( &__mmask8)  &__builtin_ia32_fpclassps256_mask (( &__v8sf) ( &__m256) , ($C),( &__mmask8)($u))));
	}' unless defined(&_mm256_mask_fpclass_ps_mask);
	eval 'sub _mm_mask_fpclass_pd_mask {
	    my($u, $X, $C) = @_;
    	    eval q((( &__mmask8)  &__builtin_ia32_fpclasspd128_mask (( &__v2df) ( &__m128d) , ($C),( &__mmask8)($u))));
	}' unless defined(&_mm_mask_fpclass_pd_mask);
	eval 'sub _mm_mask_fpclass_ps_mask {
	    my($u, $X, $C) = @_;
    	    eval q((( &__mmask8)  &__builtin_ia32_fpclassps128_mask (( &__v4sf) ( &__m128) , ($C),( &__mmask8)($u))));
	}' unless defined(&_mm_mask_fpclass_ps_mask);
	eval 'sub _mm256_fpclass_pd_mask {
	    my($X, $C) = @_;
    	    eval q((( &__mmask8)  &__builtin_ia32_fpclasspd256_mask (( &__v4df) ( &__m256d) , ($C),( &__mmask8)-1)));
	}' unless defined(&_mm256_fpclass_pd_mask);
	eval 'sub _mm256_fpclass_ps_mask {
	    my($X, $C) = @_;
    	    eval q((( &__mmask8)  &__builtin_ia32_fpclassps256_mask (( &__v8sf) ( &__m256) , ($C),( &__mmask8)-1)));
	}' unless defined(&_mm256_fpclass_ps_mask);
	eval 'sub _mm_fpclass_pd_mask {
	    my($X, $C) = @_;
    	    eval q((( &__mmask8)  &__builtin_ia32_fpclasspd128_mask (( &__v2df) ( &__m128d) , ($C),( &__mmask8)-1)));
	}' unless defined(&_mm_fpclass_pd_mask);
	eval 'sub _mm_fpclass_ps_mask {
	    my($X, $C) = @_;
    	    eval q((( &__mmask8)  &__builtin_ia32_fpclassps128_mask (( &__v4sf) ( &__m128) , ($C),( &__mmask8)-1)));
	}' unless defined(&_mm_fpclass_ps_mask);
    }
    if(defined(&__DISABLE_AVX512VLDQ__)) {
	undef(&__DISABLE_AVX512VLDQ__) if defined(&__DISABLE_AVX512VLDQ__);
    }
}
1;
