require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(!defined (&_X86INTRIN_H_INCLUDED)  && !defined (&_IMMINTRIN_H_INCLUDED)) {
    die("Never use <f16intrin.h> directly; include <x86intrin.h> or <immintrin.h> instead.");
}
unless(defined(&_F16CINTRIN_H_INCLUDED)) {
    eval 'sub _F16CINTRIN_H_INCLUDED () {1;}' unless defined(&_F16CINTRIN_H_INCLUDED);
    unless(defined(&__F16C__)) {
	eval 'sub __DISABLE_F16C__ () {1;}' unless defined(&__DISABLE_F16C__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_cvtsh_ss {  &__v8hi  &__H = {  &__S, 0, 0, 0, 0, 0, 0, 0};  &__v4sf  &__A =  &__builtin_ia32_vcvtph2ps ( &__H);  &__builtin_ia32_vec_ext_v4sf ( &__A, 0); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtph_ps ( &__m128i  &__A) { ( &__m128)  &__builtin_ia32_vcvtph2ps (( &__v8hi)  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_cvtph_ps ( &__m128i  &__A) { ( &__m256)  &__builtin_ia32_vcvtph2ps256 (( &__v8hi)  &__A); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_cvtss_sh (\'float\'  &__F,  &const \'int\'  &__I) {  &__v4sf  &__A = {  &__F, 0, 0, 0};  &__v8hi  &__H =  &__builtin_ia32_vcvtps2ph ( &__A,  &__I);  &__builtin_ia32_vec_ext_v8hi ( &__H, 0); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtps_ph ( &__m128  &__A,  &const \'int\'  &__I) { ( &__m128i)  &__builtin_ia32_vcvtps2ph (( &__v4sf)  &__A,  &__I); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_cvtps_ph ( &__m256  &__A,  &const \'int\'  &__I) { ( &__m128i)  &__builtin_ia32_vcvtps2ph256 (( &__v8sf)  &__A,  &__I); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _cvtss_sh {
	    my($__F, $__I) = @_;
    	    eval q(( &__extension__ ({  &__v4sf  &__A =  &__extension__ { $__F, 0, 0, 0};  &__v8hi  &__H =  &__builtin_ia32_vcvtps2ph ( &__A, $__I);  &__builtin_ia32_vec_ext_v8hi ( &__H, 0); })));
	}' unless defined(&_cvtss_sh);
	eval 'sub _mm_cvtps_ph {
	    my($A, $I) = @_;
    	    eval q((( &__m128i)  &__builtin_ia32_vcvtps2ph (( &__v4sf)( &__m128) $A, ($I))));
	}' unless defined(&_mm_cvtps_ph);
	eval 'sub _mm256_cvtps_ph {
	    my($A, $I) = @_;
    	    eval q((( &__m128i)  &__builtin_ia32_vcvtps2ph256 (( &__v8sf)( &__m256) $A, ($I))));
	}' unless defined(&_mm256_cvtps_ph);
    }
    if(defined(&__DISABLE_F16C__)) {
	undef(&__DISABLE_F16C__) if defined(&__DISABLE_F16C__);
    }
}
1;
