require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_IMMINTRIN_H_INCLUDED)) {
    die("Never use <fmaintrin.h> directly; include <immintrin.h> instead.");
}
unless(defined(&_FMAINTRIN_H_INCLUDED)) {
    eval 'sub _FMAINTRIN_H_INCLUDED () {1;}' unless defined(&_FMAINTRIN_H_INCLUDED);
    unless(defined(&__FMA__)) {
	eval 'sub __DISABLE_FMA__ () {1;}' unless defined(&__DISABLE_FMA__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_fmadd_pd ( &__m128d  &__A,  &__m128d  &__B,  &__m128d  &__C) { ( &__m128d) &__builtin_ia32_vfmaddpd (( &__v2df) &__A, ( &__v2df) &__B, ( &__v2df) &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_fmadd_pd ( &__m256d  &__A,  &__m256d  &__B,  &__m256d  &__C) { ( &__m256d) &__builtin_ia32_vfmaddpd256 (( &__v4df) &__A, ( &__v4df) &__B, ( &__v4df) &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_fmadd_ps ( &__m128  &__A,  &__m128  &__B,  &__m128  &__C) { ( &__m128) &__builtin_ia32_vfmaddps (( &__v4sf) &__A, ( &__v4sf) &__B, ( &__v4sf) &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_fmadd_ps ( &__m256  &__A,  &__m256  &__B,  &__m256  &__C) { ( &__m256) &__builtin_ia32_vfmaddps256 (( &__v8sf) &__A, ( &__v8sf) &__B, ( &__v8sf) &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_fmadd_sd ( &__m128d  &__A,  &__m128d  &__B,  &__m128d  &__C) { ( &__m128d)  &__builtin_ia32_vfmaddsd3 (( &__v2df) &__A, ( &__v2df) &__B, ( &__v2df) &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_fmadd_ss ( &__m128  &__A,  &__m128  &__B,  &__m128  &__C) { ( &__m128)  &__builtin_ia32_vfmaddss3 (( &__v4sf) &__A, ( &__v4sf) &__B, ( &__v4sf) &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_fmsub_pd ( &__m128d  &__A,  &__m128d  &__B,  &__m128d  &__C) { ( &__m128d) &__builtin_ia32_vfmaddpd (( &__v2df) &__A, ( &__v2df) &__B, -( &__v2df) &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_fmsub_pd ( &__m256d  &__A,  &__m256d  &__B,  &__m256d  &__C) { ( &__m256d) &__builtin_ia32_vfmaddpd256 (( &__v4df) &__A, ( &__v4df) &__B, -( &__v4df) &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_fmsub_ps ( &__m128  &__A,  &__m128  &__B,  &__m128  &__C) { ( &__m128) &__builtin_ia32_vfmaddps (( &__v4sf) &__A, ( &__v4sf) &__B, -( &__v4sf) &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_fmsub_ps ( &__m256  &__A,  &__m256  &__B,  &__m256  &__C) { ( &__m256) &__builtin_ia32_vfmaddps256 (( &__v8sf) &__A, ( &__v8sf) &__B, -( &__v8sf) &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_fmsub_sd ( &__m128d  &__A,  &__m128d  &__B,  &__m128d  &__C) { ( &__m128d) &__builtin_ia32_vfmaddsd3 (( &__v2df) &__A, ( &__v2df) &__B, -( &__v2df) &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_fmsub_ss ( &__m128  &__A,  &__m128  &__B,  &__m128  &__C) { ( &__m128) &__builtin_ia32_vfmaddss3 (( &__v4sf) &__A, ( &__v4sf) &__B, -( &__v4sf) &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_fnmadd_pd ( &__m128d  &__A,  &__m128d  &__B,  &__m128d  &__C) { ( &__m128d) &__builtin_ia32_vfmaddpd (-( &__v2df) &__A, ( &__v2df) &__B, ( &__v2df) &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_fnmadd_pd ( &__m256d  &__A,  &__m256d  &__B,  &__m256d  &__C) { ( &__m256d) &__builtin_ia32_vfmaddpd256 (-( &__v4df) &__A, ( &__v4df) &__B, ( &__v4df) &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_fnmadd_ps ( &__m128  &__A,  &__m128  &__B,  &__m128  &__C) { ( &__m128) &__builtin_ia32_vfmaddps (-( &__v4sf) &__A, ( &__v4sf) &__B, ( &__v4sf) &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_fnmadd_ps ( &__m256  &__A,  &__m256  &__B,  &__m256  &__C) { ( &__m256) &__builtin_ia32_vfmaddps256 (-( &__v8sf) &__A, ( &__v8sf) &__B, ( &__v8sf) &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_fnmadd_sd ( &__m128d  &__A,  &__m128d  &__B,  &__m128d  &__C) { ( &__m128d) &__builtin_ia32_vfmaddsd3 (( &__v2df) &__A, -( &__v2df) &__B, ( &__v2df) &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_fnmadd_ss ( &__m128  &__A,  &__m128  &__B,  &__m128  &__C) { ( &__m128) &__builtin_ia32_vfmaddss3 (( &__v4sf) &__A, -( &__v4sf) &__B, ( &__v4sf) &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_fnmsub_pd ( &__m128d  &__A,  &__m128d  &__B,  &__m128d  &__C) { ( &__m128d) &__builtin_ia32_vfmaddpd (-( &__v2df) &__A, ( &__v2df) &__B, -( &__v2df) &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_fnmsub_pd ( &__m256d  &__A,  &__m256d  &__B,  &__m256d  &__C) { ( &__m256d) &__builtin_ia32_vfmaddpd256 (-( &__v4df) &__A, ( &__v4df) &__B, -( &__v4df) &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_fnmsub_ps ( &__m128  &__A,  &__m128  &__B,  &__m128  &__C) { ( &__m128) &__builtin_ia32_vfmaddps (-( &__v4sf) &__A, ( &__v4sf) &__B, -( &__v4sf) &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_fnmsub_ps ( &__m256  &__A,  &__m256  &__B,  &__m256  &__C) { ( &__m256) &__builtin_ia32_vfmaddps256 (-( &__v8sf) &__A, ( &__v8sf) &__B, -( &__v8sf) &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_fnmsub_sd ( &__m128d  &__A,  &__m128d  &__B,  &__m128d  &__C) { ( &__m128d) &__builtin_ia32_vfmaddsd3 (( &__v2df) &__A, -( &__v2df) &__B, -( &__v2df) &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_fnmsub_ss ( &__m128  &__A,  &__m128  &__B,  &__m128  &__C) { ( &__m128) &__builtin_ia32_vfmaddss3 (( &__v4sf) &__A, -( &__v4sf) &__B, -( &__v4sf) &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_fmaddsub_pd ( &__m128d  &__A,  &__m128d  &__B,  &__m128d  &__C) { ( &__m128d) &__builtin_ia32_vfmaddsubpd (( &__v2df) &__A, ( &__v2df) &__B, ( &__v2df) &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_fmaddsub_pd ( &__m256d  &__A,  &__m256d  &__B,  &__m256d  &__C) { ( &__m256d) &__builtin_ia32_vfmaddsubpd256 (( &__v4df) &__A, ( &__v4df) &__B, ( &__v4df) &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_fmaddsub_ps ( &__m128  &__A,  &__m128  &__B,  &__m128  &__C) { ( &__m128) &__builtin_ia32_vfmaddsubps (( &__v4sf) &__A, ( &__v4sf) &__B, ( &__v4sf) &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_fmaddsub_ps ( &__m256  &__A,  &__m256  &__B,  &__m256  &__C) { ( &__m256) &__builtin_ia32_vfmaddsubps256 (( &__v8sf) &__A, ( &__v8sf) &__B, ( &__v8sf) &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_fmsubadd_pd ( &__m128d  &__A,  &__m128d  &__B,  &__m128d  &__C) { ( &__m128d) &__builtin_ia32_vfmaddsubpd (( &__v2df) &__A, ( &__v2df) &__B, -( &__v2df) &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_fmsubadd_pd ( &__m256d  &__A,  &__m256d  &__B,  &__m256d  &__C) { ( &__m256d) &__builtin_ia32_vfmaddsubpd256 (( &__v4df) &__A, ( &__v4df) &__B, -( &__v4df) &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_fmsubadd_ps ( &__m128  &__A,  &__m128  &__B,  &__m128  &__C) { ( &__m128) &__builtin_ia32_vfmaddsubps (( &__v4sf) &__A, ( &__v4sf) &__B, -( &__v4sf) &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_fmsubadd_ps ( &__m256  &__A,  &__m256  &__B,  &__m256  &__C) { ( &__m256) &__builtin_ia32_vfmaddsubps256 (( &__v8sf) &__A, ( &__v8sf) &__B, -( &__v8sf) &__C); });
    }' unless defined(&__attribute__);
    if(defined(&__DISABLE_FMA__)) {
	undef(&__DISABLE_FMA__) if defined(&__DISABLE_FMA__);
    }
}
1;
