require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_X86INTRIN_H_INCLUDED)) {
    die("Never use <tbmintrin.h> directly; include <x86intrin.h> instead.");
}
unless(defined(&_TBMINTRIN_H_INCLUDED)) {
    eval 'sub _TBMINTRIN_H_INCLUDED () {1;}' unless defined(&_TBMINTRIN_H_INCLUDED);
    unless(defined(&__TBM__)) {
	eval 'sub __DISABLE_TBM__ () {1;}' unless defined(&__DISABLE_TBM__);
    }
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__bextri_u32 (my $__X,  &const my $__I) {  &__builtin_ia32_bextri_u32 ( $__X,  $__I); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub __bextri_u32 {
	    my($X, $I) = @_;
    	    eval q(( &__builtin_ia32_bextri_u32 (, ($I))));
	}' unless defined(&__bextri_u32);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__blcfill_u32  {  &__X & ( &__X + 1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__blci_u32  {  &__X | ~( &__X + 1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__blcic_u32  { ~ &__X & ( &__X + 1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__blcmsk_u32  {  &__X ^ ( &__X + 1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__blcs_u32  {  &__X | ( &__X + 1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__blsfill_u32  {  &__X | ( &__X - 1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__blsic_u32  { ~ &__X | ( &__X - 1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__t1mskc_u32  { ~ &__X | ( &__X + 1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__tzmsk_u32  { ~ &__X & ( &__X - 1); });
    }' unless defined(&__attribute__);
    if(defined(&__x86_64__)) {
	if(defined(&__OPTIMIZE__)) {
	    eval 'sub __attribute__ () {
	        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__bextri_u64 (my $__X,  &const my $__I) {  &__builtin_ia32_bextri_u64 ( $__X,  $__I); });
	    }' unless defined(&__attribute__);
	} else {
	    eval 'sub __bextri_u64 {
	        my($X, $I) = @_;
    		eval q(( &__builtin_ia32_bextri_u64 (, ($I))));
	    }' unless defined(&__bextri_u64);
	}
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__blcfill_u64  {  &__X & ( &__X + 1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__blci_u64  {  &__X | ~( &__X + 1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__blcic_u64  { ~ &__X & ( &__X + 1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__blcmsk_u64  {  &__X ^ ( &__X + 1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__blcs_u64  {  &__X | ( &__X + 1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__blsfill_u64  {  &__X | ( &__X - 1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__blsic_u64  { ~ &__X | ( &__X - 1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__t1mskc_u64  { ~ &__X | ( &__X + 1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__tzmsk_u64  { ~ &__X & ( &__X - 1); });
	}' unless defined(&__attribute__);
    }
    if(defined(&__DISABLE_TBM__)) {
	undef(&__DISABLE_TBM__) if defined(&__DISABLE_TBM__);
    }
}
1;
