require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_I386_PARAM_H_)) {
    eval 'sub _I386_PARAM_H_ () {1;}' unless defined(&_I386_PARAM_H_);
    eval 'sub MAXCPUS () {32;}' unless defined(&MAXCPUS);
    if(defined(&_KERNEL)) {
	require 'machine/cpu.ph';
    }
    eval 'sub _MACHINE () { &i386;}' unless defined(&_MACHINE);
    eval 'sub MACHINE () {"i386";}' unless defined(&MACHINE);
    eval 'sub _MACHINE_ARCH () { &i386;}' unless defined(&_MACHINE_ARCH);
    eval 'sub MACHINE_ARCH () {"i386";}' unless defined(&MACHINE_ARCH);
    eval 'sub MID_MACHINE () { &MID_I386;}' unless defined(&MID_MACHINE);
    eval 'sub ALIGNED_POINTER {
        my($p,$t) = @_;
	    eval q(1);
    }' unless defined(&ALIGNED_POINTER);
    eval 'sub ALIGNED_POINTER_LOAD {
        my($q,$p,$t) = @_;
	    eval q( &memcpy(($q), ($p), $sizeof{$t}));
    }' unless defined(&ALIGNED_POINTER_LOAD);
    eval 'sub PGSHIFT () {12;}' unless defined(&PGSHIFT);
    eval 'sub NBPG () {(1<<  &PGSHIFT);}' unless defined(&NBPG);
    eval 'sub PGOFSET () {( &NBPG-1);}' unless defined(&PGOFSET);
    eval 'sub NPTEPG () {( &NBPG/($sizeof{ &pt_entry_t}));}' unless defined(&NPTEPG);
    eval 'sub MAXIOMEM () {0xffffffff;}' unless defined(&MAXIOMEM);
    if(defined(&PAE)) {
	eval 'sub MAXPHYSMEM () {68719476736;}' unless defined(&MAXPHYSMEM);
    } else {
	eval 'sub MAXPHYSMEM () {4294967296;}' unless defined(&MAXPHYSMEM);
    }
    if(defined(&_KERNEL_OPT)) {
	require './i386/opt_kernbase.ph';
    }
    unless(defined(&KERNBASE)) {
	eval 'sub KERNBASE () {0xc0000000;}' unless defined(&KERNBASE);
    }
    eval 'sub KERNTEXTOFF () {( &KERNBASE + 0x100000);}' unless defined(&KERNTEXTOFF);
    eval 'sub BTOPKERNBASE () {( &KERNBASE >>  &PGSHIFT);}' unless defined(&BTOPKERNBASE);
    eval 'sub SSIZE () {1;}' unless defined(&SSIZE);
    eval 'sub SINCR () {1;}' unless defined(&SINCR);
    unless(defined(&UPAGES)) {
	if(defined(&DIAGNOSTIC)) {
	    eval 'sub UPAGES () {3;}' unless defined(&UPAGES);
	} else {
	    eval 'sub UPAGES () {2;}' unless defined(&UPAGES);
	}
    }
    eval 'sub USPACE () {( &UPAGES *  &NBPG);}' unless defined(&USPACE);
    eval 'sub INTRSTACKSIZE () {8192;}' unless defined(&INTRSTACKSIZE);
    unless(defined(&MSGBUFSIZE)) {
	eval 'sub MSGBUFSIZE () {(16* &NBPG);}' unless defined(&MSGBUFSIZE);
    }
    eval 'sub MSIZE () {256;}' unless defined(&MSIZE);
    unless(defined(&MCLSHIFT)) {
	eval 'sub MCLSHIFT () {11;}' unless defined(&MCLSHIFT);
    }
    eval 'sub MCLBYTES () {(1<<  &MCLSHIFT);}' unless defined(&MCLBYTES);
    unless(defined(&NMBCLUSTERS_MAX)) {
	eval 'sub NMBCLUSTERS_MAX () {(0x4000000 /  &MCLBYTES);}' unless defined(&NMBCLUSTERS_MAX);
    }
    unless(defined(&NFS_RSIZE)) {
	eval 'sub NFS_RSIZE () {32768;}' unless defined(&NFS_RSIZE);
    }
    unless(defined(&NFS_WSIZE)) {
	eval 'sub NFS_WSIZE () {32768;}' unless defined(&NFS_WSIZE);
    }
    eval 'sub NKMEMPAGES_MIN_DEFAULT () {((16* 1024* 1024) >>  &PAGE_SHIFT);}' unless defined(&NKMEMPAGES_MIN_DEFAULT);
    eval 'sub NKMEMPAGES_MAX_DEFAULT () {((360* 1024* 1024) >>  &PAGE_SHIFT);}' unless defined(&NKMEMPAGES_MAX_DEFAULT);
    eval 'sub x86_round_pdr {
        my($x) = @_;
	    eval q((((($x)) + ( &NBPD_L2 - 1)) & ~( &NBPD_L2 - 1)));
    }' unless defined(&x86_round_pdr);
    eval 'sub x86_trunc_pdr {
        my($x) = @_;
	    eval q((($x) & ~( &NBPD_L2 - 1)));
    }' unless defined(&x86_trunc_pdr);
    eval 'sub x86_btod {
        my($x) = @_;
	    eval q((($x) >>  &L2_SHIFT));
    }' unless defined(&x86_btod);
    eval 'sub x86_dtob {
        my($x) = @_;
	    eval q((($x) <<  &L2_SHIFT));
    }' unless defined(&x86_dtob);
    eval 'sub x86_round_page {
        my($x) = @_;
	    eval q((((( &paddr_t)($x)) +  &PGOFSET) & ~ &PGOFSET));
    }' unless defined(&x86_round_page);
    eval 'sub x86_trunc_page {
        my($x) = @_;
	    eval q((( &paddr_t)($x) & ~ &PGOFSET));
    }' unless defined(&x86_trunc_page);
    eval 'sub x86_btop {
        my($x) = @_;
	    eval q((( &paddr_t)($x) >>  &PGSHIFT));
    }' unless defined(&x86_btop);
    eval 'sub x86_ptob {
        my($x) = @_;
	    eval q((( &paddr_t)($x) <<  &PGSHIFT));
    }' unless defined(&x86_ptob);
}
1;
