require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_I386_SEGMENTS_H_)) {
    eval 'sub _I386_SEGMENTS_H_ () {1;}' unless defined(&_I386_SEGMENTS_H_);
    if(defined(&_KERNEL_OPT)) {
	require './i386/opt_xen.ph';
    }
    eval 'sub ISPL {
        my($s) = @_;
	    eval q((($s) &  &SEL_RPL));
    }' unless defined(&ISPL);
    unless(defined(&XENPV)) {
	eval 'sub SEL_KPL () {0;}' unless defined(&SEL_KPL);
    } else {
	eval 'sub SEL_XEN () {0;}' unless defined(&SEL_XEN);
	eval 'sub SEL_KPL () {1;}' unless defined(&SEL_KPL);
    }
    eval 'sub SEL_UPL () {3;}' unless defined(&SEL_UPL);
    eval 'sub SEL_RPL () {3;}' unless defined(&SEL_RPL);
    if(defined(&XENPV)) {
	eval 'sub CHK_UPL () {2;}' unless defined(&CHK_UPL);
    } else {
	eval 'sub CHK_UPL () { &SEL_RPL;}' unless defined(&CHK_UPL);
    }
    eval 'sub ISLDT {
        my($s) = @_;
	    eval q((($s) &  &SEL_LDT));
    }' unless defined(&ISLDT);
    eval 'sub SEL_LDT () {4;}' unless defined(&SEL_LDT);
    eval 'sub IOPL_KPL () { &SEL_KPL;}' unless defined(&IOPL_KPL);
    eval 'sub DYNSEL_START () {( &NGDT << 3);}' unless defined(&DYNSEL_START);
    eval 'sub IDXSEL {
        my($s) = @_;
	    eval q(((($s) >> 3) & 0x1fff));
    }' unless defined(&IDXSEL);
    eval 'sub IDXSELN {
        my($s) = @_;
	    eval q(((($s) >> 3)));
    }' unless defined(&IDXSELN);
    eval 'sub IDXDYNSEL {
        my($s) = @_;
	    eval q((((($s) & ~ &SEL_RPL) -  &DYNSEL_START) >> 3));
    }' unless defined(&IDXDYNSEL);
    eval 'sub GSEL {
        my($s,$r) = @_;
	    eval q(((($s) << 3) | $r));
    }' unless defined(&GSEL);
    eval 'sub GSYSSEL {
        my($s,$r) = @_;
	    eval q( &GSEL($s,$r));
    }' unless defined(&GSYSSEL);
    eval 'sub GDYNSEL {
        my($s,$r) = @_;
	    eval q((((($s) << 3) +  &DYNSEL_START) | $r |  &SEL_KPL));
    }' unless defined(&GDYNSEL);
    eval 'sub LSEL {
        my($s,$r) = @_;
	    eval q(((($s) << 3) | $r |  &SEL_LDT));
    }' unless defined(&LSEL);
    eval 'sub USERMODE {
        my($c) = @_;
	    eval q(( &ISPL($c) ==  &SEL_UPL));
    }' unless defined(&USERMODE);
    eval 'sub KERNELMODE {
        my($c) = @_;
	    eval q(( &ISPL($c) ==  &SEL_KPL));
    }' unless defined(&KERNELMODE);
    unless(defined(&_LOCORE)) {
	if((defined(&__GNUC__) ? &__GNUC__ : undef) == 2 && (defined(&__GNUC_MINOR__) ? &__GNUC_MINOR__ : undef) < 7) {
	}
	if((defined(&__GNUC__) ? &__GNUC__ : undef) == 2 && (defined(&__GNUC_MINOR__) ? &__GNUC_MINOR__ : undef) < 7) {
	}
	if(defined(&_KERNEL)) {
	    if(defined(&XENPV)) {
	    } else {
	    }
	}
    }
    eval 'sub SDT_SYSNULL () {0;}' unless defined(&SDT_SYSNULL);
    eval 'sub SDT_SYS286TSS () {1;}' unless defined(&SDT_SYS286TSS);
    eval 'sub SDT_SYSLDT () {2;}' unless defined(&SDT_SYSLDT);
    eval 'sub SDT_SYS286BSY () {3;}' unless defined(&SDT_SYS286BSY);
    eval 'sub SDT_SYS286CGT () {4;}' unless defined(&SDT_SYS286CGT);
    eval 'sub SDT_SYSTASKGT () {5;}' unless defined(&SDT_SYSTASKGT);
    eval 'sub SDT_SYS286IGT () {6;}' unless defined(&SDT_SYS286IGT);
    eval 'sub SDT_SYS286TGT () {7;}' unless defined(&SDT_SYS286TGT);
    eval 'sub SDT_SYSNULL2 () {8;}' unless defined(&SDT_SYSNULL2);
    eval 'sub SDT_SYS386TSS () {9;}' unless defined(&SDT_SYS386TSS);
    eval 'sub SDT_SYSNULL3 () {10;}' unless defined(&SDT_SYSNULL3);
    eval 'sub SDT_SYS386BSY () {11;}' unless defined(&SDT_SYS386BSY);
    eval 'sub SDT_SYS386CGT () {12;}' unless defined(&SDT_SYS386CGT);
    eval 'sub SDT_SYSNULL4 () {13;}' unless defined(&SDT_SYSNULL4);
    eval 'sub SDT_SYS386IGT () {14;}' unless defined(&SDT_SYS386IGT);
    eval 'sub SDT_SYS386TGT () {15;}' unless defined(&SDT_SYS386TGT);
    eval 'sub SDT_MEMRO () {16;}' unless defined(&SDT_MEMRO);
    eval 'sub SDT_MEMROA () {17;}' unless defined(&SDT_MEMROA);
    eval 'sub SDT_MEMRW () {18;}' unless defined(&SDT_MEMRW);
    eval 'sub SDT_MEMRWA () {19;}' unless defined(&SDT_MEMRWA);
    eval 'sub SDT_MEMROD () {20;}' unless defined(&SDT_MEMROD);
    eval 'sub SDT_MEMRODA () {21;}' unless defined(&SDT_MEMRODA);
    eval 'sub SDT_MEMRWD () {22;}' unless defined(&SDT_MEMRWD);
    eval 'sub SDT_MEMRWDA () {23;}' unless defined(&SDT_MEMRWDA);
    eval 'sub SDT_MEME () {24;}' unless defined(&SDT_MEME);
    eval 'sub SDT_MEMEA () {25;}' unless defined(&SDT_MEMEA);
    eval 'sub SDT_MEMER () {26;}' unless defined(&SDT_MEMER);
    eval 'sub SDT_MEMERA () {27;}' unless defined(&SDT_MEMERA);
    eval 'sub SDT_MEMEC () {28;}' unless defined(&SDT_MEMEC);
    eval 'sub SDT_MEMEAC () {29;}' unless defined(&SDT_MEMEAC);
    eval 'sub SDT_MEMERC () {30;}' unless defined(&SDT_MEMERC);
    eval 'sub SDT_MEMERAC () {31;}' unless defined(&SDT_MEMERAC);
    eval 'sub SDTYPE {
        my($p) = @_;
	    eval q(((( &const \'struct segment_descriptor\' *)($p))-> &sd_type));
    }' unless defined(&SDTYPE);
    eval 'sub ISMEMSDP {
        my($s) = @_;
	    eval q(( &SDTYPE($s) >=  &SDT_MEMRO  &&  &SDTYPE($s) <=  &SDT_MEMERAC));
    }' unless defined(&ISMEMSDP);
    eval 'sub IS286GDP {
        my($s) = @_;
	    eval q(( &SDTYPE($s) >=  &SDT_SYS286CGT  &&  &SDTYPE($s) <  &SDT_SYS286TGT));
    }' unless defined(&IS286GDP);
    eval 'sub IS386GDP {
        my($s) = @_;
	    eval q(( &SDTYPE($s) >=  &SDT_SYS386CGT  &&  &SDTYPE($s) <  &SDT_SYS386TGT));
    }' unless defined(&IS386GDP);
    eval 'sub ISGDP {
        my($s) = @_;
	    eval q(( &IS286GDP($s) ||  &IS386GDP($s)));
    }' unless defined(&ISGDP);
    eval 'sub ISSDP {
        my($s) = @_;
	    eval q(( &ISMEMSDP($s) || ! &ISGDP($s)));
    }' unless defined(&ISSDP);
    eval 'sub ISSYSSDP {
        my($s) = @_;
	    eval q((! &ISMEMSDP($s)  && ! &ISGDP($s)));
    }' unless defined(&ISSYSSDP);
    eval 'sub SEGEX_EXT () {0x1;}' unless defined(&SEGEX_EXT);
    eval 'sub SEGEX_IDT () {0x2;}' unless defined(&SEGEX_IDT);
    eval 'sub SEGEX_TI () {0x4;}' unless defined(&SEGEX_TI);
    eval 'sub NIDT () {256;}' unless defined(&NIDT);
    eval 'sub NRSVIDT () {32;}' unless defined(&NRSVIDT);
    eval 'sub GNULL_SEL () {0;}' unless defined(&GNULL_SEL);
    eval 'sub GCODE_SEL () {1;}' unless defined(&GCODE_SEL);
    eval 'sub GDATA_SEL () {2;}' unless defined(&GDATA_SEL);
    eval 'sub GUCODE_SEL () {3;}' unless defined(&GUCODE_SEL);
    eval 'sub GUDATA_SEL () {4;}' unless defined(&GUDATA_SEL);
    eval 'sub GLDT_SEL () {5;}' unless defined(&GLDT_SEL);
    eval 'sub GCPU_SEL () {6;}' unless defined(&GCPU_SEL);
    eval 'sub GEXTBIOSDATA_SEL () {8;}' unless defined(&GEXTBIOSDATA_SEL);
    eval 'sub GAPM32CODE_SEL () {9;}' unless defined(&GAPM32CODE_SEL);
    eval 'sub GAPM16CODE_SEL () {10;}' unless defined(&GAPM16CODE_SEL);
    eval 'sub GAPMDATA_SEL () {11;}' unless defined(&GAPMDATA_SEL);
    eval 'sub GBIOSCODE_SEL () {12;}' unless defined(&GBIOSCODE_SEL);
    eval 'sub GBIOSDATA_SEL () {13;}' unless defined(&GBIOSDATA_SEL);
    eval 'sub GPNPBIOSCODE_SEL () {14;}' unless defined(&GPNPBIOSCODE_SEL);
    eval 'sub GPNPBIOSDATA_SEL () {15;}' unless defined(&GPNPBIOSDATA_SEL);
    eval 'sub GPNPBIOSSCRATCH_SEL () {16;}' unless defined(&GPNPBIOSSCRATCH_SEL);
    eval 'sub GPNPBIOSTRAMP_SEL () {17;}' unless defined(&GPNPBIOSTRAMP_SEL);
    eval 'sub GTRAPTSS_SEL () {18;}' unless defined(&GTRAPTSS_SEL);
    eval 'sub GIPITSS_SEL () {19;}' unless defined(&GIPITSS_SEL);
    eval 'sub GUCODEBIG_SEL () {20;}' unless defined(&GUCODEBIG_SEL);
    eval 'sub GUFS_SEL () {21;}' unless defined(&GUFS_SEL);
    eval 'sub GUGS_SEL () {22;}' unless defined(&GUGS_SEL);
    eval 'sub NGDT () {23;}' unless defined(&NGDT);
    eval 'sub LSYS5CALLS_SEL () {0;}' unless defined(&LSYS5CALLS_SEL);
    eval 'sub LSYS5SIGR_SEL () {1;}' unless defined(&LSYS5SIGR_SEL);
    eval 'sub LUCODE_SEL () {2;}' unless defined(&LUCODE_SEL);
    eval 'sub LUDATA_SEL () {3;}' unless defined(&LUDATA_SEL);
    eval 'sub LSOL26CALLS_SEL () {4;}' unless defined(&LSOL26CALLS_SEL);
    eval 'sub LUCODEBIG_SEL () {5;}' unless defined(&LUCODEBIG_SEL);
    eval 'sub LBSDICALLS_SEL () {16;}' unless defined(&LBSDICALLS_SEL);
    eval 'sub NLDT () {17;}' unless defined(&NLDT);
}
1;
