require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_IMMINTRIN_H_INCLUDED)) {
    die("Never use <avx512fintrin.h> directly; include <immintrin.h> instead.");
}
unless(defined(&_AVX512FINTRIN_H_INCLUDED)) {
    eval 'sub _AVX512FINTRIN_H_INCLUDED () {1;}' unless defined(&_AVX512FINTRIN_H_INCLUDED);
    unless(defined(&__AVX512F__)) {
	eval 'sub __DISABLE_AVX512F__ () {1;}' unless defined(&__DISABLE_AVX512F__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_int2mask (\'int\'  &__M) { ( &__mmask16)  &__M; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask2int {  &__M; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_set_epi64 (my $__A, my $__B, my $__C, my $__D, my $__E, my $__F, my $__G, my $__H) { ( &__m512i) ( &__v8di) {  $__H,  $__G,  $__F,  $__E,  $__D,  $__C,  $__B,  $__A }; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_set_pd (\'double\'  &__A, \'double\'  &__B, \'double\'  &__C, \'double\'  &__D, \'double\'  &__E, \'double\'  &__F, \'double\'  &__G, \'double\'  &__H) { ( &__m512d) {  &__H,  &__G,  &__F,  &__E,  &__D,  &__C,  &__B,  &__A }; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_set_ps (\'float\'  &__A, \'float\'  &__B, \'float\'  &__C, \'float\'  &__D, \'float\'  &__E, \'float\'  &__F, \'float\'  &__G, \'float\'  &__H, \'float\'  &__I, \'float\'  &__J, \'float\'  &__K, \'float\'  &__L, \'float\'  &__M, \'float\'  &__N, \'float\'  &__O, \'float\'  &__P) { ( &__m512) {  &__P,  &__O,  &__N,  &__M,  &__L,  &__K,  &__J,  &__I,  &__H,  &__G,  &__F,  &__E,  &__D,  &__C,  &__B,  &__A }; });
    }' unless defined(&__attribute__);
    eval 'sub _mm512_setr_epi64 {
        my($e0,$e1,$e2,$e3,$e4,$e5,$e6,$e7) = @_;
	    eval q( &_mm512_set_epi64($e7,$e6,$e5,$e4,$e3,$e2,$e1,$e0));
    }' unless defined(&_mm512_setr_epi64);
    eval 'sub _mm512_setr_epi32 {
        my($e0,$e1,$e2,$e3,$e4,$e5,$e6,$e7,			      			  $e8,$e9,$e10,$e11,$e12,$e13,$e14,$e15) = @_;
	    eval q( &_mm512_set_epi32($e15,$e14,$e13,$e12,$e11,$e10,$e9,$e8,$e7,$e6,$e5,$e4,$e3,$e2,$e1,$e0));
    }' unless defined(&_mm512_setr_epi32);
    eval 'sub _mm512_setr_pd {
        my($e0,$e1,$e2,$e3,$e4,$e5,$e6,$e7) = @_;
	    eval q( &_mm512_set_pd($e7,$e6,$e5,$e4,$e3,$e2,$e1,$e0));
    }' unless defined(&_mm512_setr_pd);
    eval 'sub _mm512_setr_ps {
        my($e0,$e1,$e2,$e3,$e4,$e5,$e6,$e7,$e8,$e9,$e10,$e11,$e12,$e13,$e14,$e15) = @_;
	    eval q( &_mm512_set_ps($e15,$e14,$e13,$e12,$e11,$e10,$e9,$e8,$e7,$e6,$e5,$e4,$e3,$e2,$e1,$e0));
    }' unless defined(&_mm512_setr_ps);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_undefined_ps ( &void) {  &__m512  &__Y =  &__Y;  &__Y; });
    }' unless defined(&__attribute__);
    eval 'sub _mm512_undefined () { &_mm512_undefined_ps;}' unless defined(&_mm512_undefined);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_undefined_pd ( &void) {  &__m512d  &__Y =  &__Y;  &__Y; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_undefined_epi32 ( &void) {  &__m512i  &__Y =  &__Y;  &__Y; });
    }' unless defined(&__attribute__);
    eval 'sub _mm512_undefined_si512 () { &_mm512_undefined_epi32;}' unless defined(&_mm512_undefined_si512);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_set1_epi8 (\'char\'  &__A) { ( &__m512i)( &__v64qi) {  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A }; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_set1_epi16  { ( &__m512i)( &__v32hi) {  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A }; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_set1_pd (\'double\'  &__A) { ( &__m512d)  &__builtin_ia32_broadcastsd512 ( ( &__v2df) {  &__A, }, ( &__v8df)  &_mm512_undefined_pd (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_set1_ps (\'float\'  &__A) { ( &__m512)  &__builtin_ia32_broadcastss512 ( ( &__v4sf) {  &__A, }, ( &__v16sf)  &_mm512_undefined_ps (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_set4_epi64 (my $__A, my $__B, my $__C, my $__D) { ( &__m512i) ( &__v8di) {  $__D,  $__C,  $__B,  $__A,  $__D,  $__C,  $__B,  $__A }; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_set4_pd (\'double\'  &__A, \'double\'  &__B, \'double\'  &__C, \'double\'  &__D) { ( &__m512d) {  &__D,  &__C,  &__B,  &__A,  &__D,  &__C,  &__B,  &__A }; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_set4_ps (\'float\'  &__A, \'float\'  &__B, \'float\'  &__C, \'float\'  &__D) { ( &__m512) {  &__D,  &__C,  &__B,  &__A,  &__D,  &__C,  &__B,  &__A,  &__D,  &__C,  &__B,  &__A,  &__D,  &__C,  &__B,  &__A }; });
    }' unless defined(&__attribute__);
    eval 'sub _mm512_setr4_epi64 {
        my($e0,$e1,$e2,$e3) = @_;
	    eval q( &_mm512_set4_epi64($e3,$e2,$e1,$e0));
    }' unless defined(&_mm512_setr4_epi64);
    eval 'sub _mm512_setr4_epi32 {
        my($e0,$e1,$e2,$e3) = @_;
	    eval q( &_mm512_set4_epi32($e3,$e2,$e1,$e0));
    }' unless defined(&_mm512_setr4_epi32);
    eval 'sub _mm512_setr4_pd {
        my($e0,$e1,$e2,$e3) = @_;
	    eval q( &_mm512_set4_pd($e3,$e2,$e1,$e0));
    }' unless defined(&_mm512_setr4_pd);
    eval 'sub _mm512_setr4_ps {
        my($e0,$e1,$e2,$e3) = @_;
	    eval q( &_mm512_set4_ps($e3,$e2,$e1,$e0));
    }' unless defined(&_mm512_setr4_ps);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_setzero_ps ( &void) { ( &__m512){ 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_setzero_pd ( &void) { ( &__m512d) { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_setzero_epi32 ( &void) { ( &__m512i)( &__v8di){ 0, 0, 0, 0, 0, 0, 0, 0}; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_setzero_si512 ( &void) { ( &__m512i)( &__v8di){ 0, 0, 0, 0, 0, 0, 0, 0}; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_mov_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A) { ( &__m512d)  &__builtin_ia32_movapd512_mask (( &__v8df)  &__A, ( &__v8df)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_mov_pd ( &__mmask8  &__U,  &__m512d  &__A) { ( &__m512d)  &__builtin_ia32_movapd512_mask (( &__v8df)  &__A, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_mov_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A) { ( &__m512)  &__builtin_ia32_movaps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_mov_ps ( &__mmask16  &__U,  &__m512  &__A) { ( &__m512)  &__builtin_ia32_movaps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_load_pd ( &void  &const * &__P) { *( &__m512d *)  &__P; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_load_pd ( &__m512d  &__W,  &__mmask8  &__U,  &void  &const * &__P) { ( &__m512d)  &__builtin_ia32_loadapd512_mask (( &const  &__v8df *)  &__P, ( &__v8df)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_load_pd ( &__mmask8  &__U,  &void  &const * &__P) { ( &__m512d)  &__builtin_ia32_loadapd512_mask (( &const  &__v8df *)  &__P, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_store_pd ( &void * &__P,  &__m512d  &__A) { *( &__m512d *)  &__P =  &__A; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_store_pd ( &void * &__P,  &__mmask8  &__U,  &__m512d  &__A) {  &__builtin_ia32_storeapd512_mask (( &__v8df *)  &__P, ( &__v8df)  &__A, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_load_ps ( &void  &const * &__P) { *( &__m512 *)  &__P; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_load_ps ( &__m512  &__W,  &__mmask16  &__U,  &void  &const * &__P) { ( &__m512)  &__builtin_ia32_loadaps512_mask (( &const  &__v16sf *)  &__P, ( &__v16sf)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_load_ps ( &__mmask16  &__U,  &void  &const * &__P) { ( &__m512)  &__builtin_ia32_loadaps512_mask (( &const  &__v16sf *)  &__P, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_store_ps ( &void * &__P,  &__m512  &__A) { *( &__m512 *)  &__P =  &__A; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_store_ps ( &void * &__P,  &__mmask16  &__U,  &__m512  &__A) {  &__builtin_ia32_storeaps512_mask (( &__v16sf *)  &__P, ( &__v16sf)  &__A, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_mov_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m512i  &__A) { ( &__m512i)  &__builtin_ia32_movdqa64_512_mask (( &__v8di)  &__A, ( &__v8di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_mov_epi64 ( &__mmask8  &__U,  &__m512i  &__A) { ( &__m512i)  &__builtin_ia32_movdqa64_512_mask (( &__v8di)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_load_epi64 ( &void  &const * &__P) { *( &__m512i *)  &__P; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_load_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &void  &const * &__P) { ( &__m512i)  &__builtin_ia32_movdqa64load512_mask (( &const  &__v8di *)  &__P, ( &__v8di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_load_epi64 ( &__mmask8  &__U,  &void  &const * &__P) { ( &__m512i)  &__builtin_ia32_movdqa64load512_mask (( &const  &__v8di *)  &__P, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_store_epi64 ( &void * &__P,  &__m512i  &__A) { *( &__m512i *)  &__P =  &__A; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_store_epi64 ( &void * &__P,  &__mmask8  &__U,  &__m512i  &__A) {  &__builtin_ia32_movdqa64store512_mask (( &__v8di *)  &__P, ( &__v8di)  &__A, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_mov_epi32 ( &__m512i  &__W,  &__mmask16  &__U,  &__m512i  &__A) { ( &__m512i)  &__builtin_ia32_movdqa32_512_mask (( &__v16si)  &__A, ( &__v16si)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_mov_epi32 ( &__mmask16  &__U,  &__m512i  &__A) { ( &__m512i)  &__builtin_ia32_movdqa32_512_mask (( &__v16si)  &__A, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_load_si512 ( &void  &const * &__P) { *( &__m512i *)  &__P; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_load_epi32 ( &void  &const * &__P) { *( &__m512i *)  &__P; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_load_epi32 ( &__m512i  &__W,  &__mmask16  &__U,  &void  &const * &__P) { ( &__m512i)  &__builtin_ia32_movdqa32load512_mask (( &const  &__v16si *)  &__P, ( &__v16si)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_load_epi32 ( &__mmask16  &__U,  &void  &const * &__P) { ( &__m512i)  &__builtin_ia32_movdqa32load512_mask (( &const  &__v16si *)  &__P, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_store_si512 ( &void * &__P,  &__m512i  &__A) { *( &__m512i *)  &__P =  &__A; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_store_epi32 ( &void * &__P,  &__m512i  &__A) { *( &__m512i *)  &__P =  &__A; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_store_epi32 ( &void * &__P,  &__mmask16  &__U,  &__m512i  &__A) {  &__builtin_ia32_movdqa32store512_mask (( &__v16si *)  &__P, ( &__v16si)  &__A, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mullo_epi32 ( &__m512i  &__A,  &__m512i  &__B) { ( &__m512i) (( &__v16su)  &__A * ( &__v16su)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_mullo_epi32 ( &__mmask16  &__M,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pmulld512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &_mm512_setzero_si512 (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_mullo_epi32 ( &__m512i  &__W,  &__mmask16  &__M,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pmulld512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &__W,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_sllv_epi32 ( &__m512i  &__X,  &__m512i  &__Y) { ( &__m512i)  &__builtin_ia32_psllv16si_mask (( &__v16si)  &__X, ( &__v16si)  &__Y, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_sllv_epi32 ( &__m512i  &__W,  &__mmask16  &__U,  &__m512i  &__X,  &__m512i  &__Y) { ( &__m512i)  &__builtin_ia32_psllv16si_mask (( &__v16si)  &__X, ( &__v16si)  &__Y, ( &__v16si)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_sllv_epi32 ( &__mmask16  &__U,  &__m512i  &__X,  &__m512i  &__Y) { ( &__m512i)  &__builtin_ia32_psllv16si_mask (( &__v16si)  &__X, ( &__v16si)  &__Y, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_srav_epi32 ( &__m512i  &__X,  &__m512i  &__Y) { ( &__m512i)  &__builtin_ia32_psrav16si_mask (( &__v16si)  &__X, ( &__v16si)  &__Y, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_srav_epi32 ( &__m512i  &__W,  &__mmask16  &__U,  &__m512i  &__X,  &__m512i  &__Y) { ( &__m512i)  &__builtin_ia32_psrav16si_mask (( &__v16si)  &__X, ( &__v16si)  &__Y, ( &__v16si)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_srav_epi32 ( &__mmask16  &__U,  &__m512i  &__X,  &__m512i  &__Y) { ( &__m512i)  &__builtin_ia32_psrav16si_mask (( &__v16si)  &__X, ( &__v16si)  &__Y, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_srlv_epi32 ( &__m512i  &__X,  &__m512i  &__Y) { ( &__m512i)  &__builtin_ia32_psrlv16si_mask (( &__v16si)  &__X, ( &__v16si)  &__Y, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_srlv_epi32 ( &__m512i  &__W,  &__mmask16  &__U,  &__m512i  &__X,  &__m512i  &__Y) { ( &__m512i)  &__builtin_ia32_psrlv16si_mask (( &__v16si)  &__X, ( &__v16si)  &__Y, ( &__v16si)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_srlv_epi32 ( &__mmask16  &__U,  &__m512i  &__X,  &__m512i  &__Y) { ( &__m512i)  &__builtin_ia32_psrlv16si_mask (( &__v16si)  &__X, ( &__v16si)  &__Y, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_add_epi64 ( &__m512i  &__A,  &__m512i  &__B) { ( &__m512i) (( &__v8du)  &__A + ( &__v8du)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_add_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_paddq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_add_epi64 ( &__mmask8  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_paddq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_sub_epi64 ( &__m512i  &__A,  &__m512i  &__B) { ( &__m512i) (( &__v8du)  &__A - ( &__v8du)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_sub_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_psubq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_sub_epi64 ( &__mmask8  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_psubq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_sllv_epi64 ( &__m512i  &__X,  &__m512i  &__Y) { ( &__m512i)  &__builtin_ia32_psllv8di_mask (( &__v8di)  &__X, ( &__v8di)  &__Y, ( &__v8di)  &_mm512_undefined_pd (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_sllv_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m512i  &__X,  &__m512i  &__Y) { ( &__m512i)  &__builtin_ia32_psllv8di_mask (( &__v8di)  &__X, ( &__v8di)  &__Y, ( &__v8di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_sllv_epi64 ( &__mmask8  &__U,  &__m512i  &__X,  &__m512i  &__Y) { ( &__m512i)  &__builtin_ia32_psllv8di_mask (( &__v8di)  &__X, ( &__v8di)  &__Y, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_srav_epi64 ( &__m512i  &__X,  &__m512i  &__Y) { ( &__m512i)  &__builtin_ia32_psrav8di_mask (( &__v8di)  &__X, ( &__v8di)  &__Y, ( &__v8di)  &_mm512_undefined_epi32 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_srav_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m512i  &__X,  &__m512i  &__Y) { ( &__m512i)  &__builtin_ia32_psrav8di_mask (( &__v8di)  &__X, ( &__v8di)  &__Y, ( &__v8di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_srav_epi64 ( &__mmask8  &__U,  &__m512i  &__X,  &__m512i  &__Y) { ( &__m512i)  &__builtin_ia32_psrav8di_mask (( &__v8di)  &__X, ( &__v8di)  &__Y, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_srlv_epi64 ( &__m512i  &__X,  &__m512i  &__Y) { ( &__m512i)  &__builtin_ia32_psrlv8di_mask (( &__v8di)  &__X, ( &__v8di)  &__Y, ( &__v8di)  &_mm512_undefined_epi32 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_srlv_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m512i  &__X,  &__m512i  &__Y) { ( &__m512i)  &__builtin_ia32_psrlv8di_mask (( &__v8di)  &__X, ( &__v8di)  &__Y, ( &__v8di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_srlv_epi64 ( &__mmask8  &__U,  &__m512i  &__X,  &__m512i  &__Y) { ( &__m512i)  &__builtin_ia32_psrlv8di_mask (( &__v8di)  &__X, ( &__v8di)  &__Y, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_add_epi32 ( &__m512i  &__A,  &__m512i  &__B) { ( &__m512i) (( &__v16su)  &__A + ( &__v16su)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_add_epi32 ( &__m512i  &__W,  &__mmask16  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_paddd512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_add_epi32 ( &__mmask16  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_paddd512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mul_epi32 ( &__m512i  &__X,  &__m512i  &__Y) { ( &__m512i)  &__builtin_ia32_pmuldq512_mask (( &__v16si)  &__X, ( &__v16si)  &__Y, ( &__v8di)  &_mm512_undefined_epi32 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_mul_epi32 ( &__m512i  &__W,  &__mmask8  &__M,  &__m512i  &__X,  &__m512i  &__Y) { ( &__m512i)  &__builtin_ia32_pmuldq512_mask (( &__v16si)  &__X, ( &__v16si)  &__Y, ( &__v8di)  &__W,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_mul_epi32 ( &__mmask8  &__M,  &__m512i  &__X,  &__m512i  &__Y) { ( &__m512i)  &__builtin_ia32_pmuldq512_mask (( &__v16si)  &__X, ( &__v16si)  &__Y, ( &__v8di)  &_mm512_setzero_si512 (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_sub_epi32 ( &__m512i  &__A,  &__m512i  &__B) { ( &__m512i) (( &__v16su)  &__A - ( &__v16su)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_sub_epi32 ( &__m512i  &__W,  &__mmask16  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_psubd512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_sub_epi32 ( &__mmask16  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_psubd512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mul_epu32 ( &__m512i  &__X,  &__m512i  &__Y) { ( &__m512i)  &__builtin_ia32_pmuludq512_mask (( &__v16si)  &__X, ( &__v16si)  &__Y, ( &__v8di)  &_mm512_undefined_epi32 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_mul_epu32 ( &__m512i  &__W,  &__mmask8  &__M,  &__m512i  &__X,  &__m512i  &__Y) { ( &__m512i)  &__builtin_ia32_pmuludq512_mask (( &__v16si)  &__X, ( &__v16si)  &__Y, ( &__v8di)  &__W,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_mul_epu32 ( &__mmask8  &__M,  &__m512i  &__X,  &__m512i  &__Y) { ( &__m512i)  &__builtin_ia32_pmuludq512_mask (( &__v16si)  &__X, ( &__v16si)  &__Y, ( &__v8di)  &_mm512_setzero_si512 (),  &__M); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_slli_epi64 ( &__m512i  &__A, my $__B) { ( &__m512i)  &__builtin_ia32_psllqi512_mask (( &__v8di)  &__A,  $__B, ( &__v8di)  &_mm512_undefined_epi32 (), ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_slli_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m512i  &__A, my $__B) { ( &__m512i)  &__builtin_ia32_psllqi512_mask (( &__v8di)  &__A,  $__B, ( &__v8di)  &__W, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_slli_epi64 ( &__mmask8  &__U,  &__m512i  &__A, my $__B) { ( &__m512i)  &__builtin_ia32_psllqi512_mask (( &__v8di)  &__A,  $__B, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm512_slli_epi64 {
	    my($X, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_psllqi512_mask (( &__v8di)( &__m512i), ($C), ( &__v8di)( &__m512i) &_mm512_undefined_epi32 (), ( &__mmask8)-1)));
	}' unless defined(&_mm512_slli_epi64);
	eval 'sub _mm512_mask_slli_epi64 {
	    my($W, $U, $X, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_psllqi512_mask (( &__v8di)( &__m512i), ($C), ( &__v8di)( &__m512i)($W), ( &__mmask8)($U))));
	}' unless defined(&_mm512_mask_slli_epi64);
	eval 'sub _mm512_maskz_slli_epi64 {
	    my($U, $X, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_psllqi512_mask (( &__v8di)( &__m512i), ($C), ( &__v8di)( &__m512i) &_mm512_setzero_si512 (), ( &__mmask8)($U))));
	}' unless defined(&_mm512_maskz_slli_epi64);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_sll_epi64 ( &__m512i  &__A,  &__m128i  &__B) { ( &__m512i)  &__builtin_ia32_psllq512_mask (( &__v8di)  &__A, ( &__v2di)  &__B, ( &__v8di)  &_mm512_undefined_epi32 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_sll_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m512i  &__A,  &__m128i  &__B) { ( &__m512i)  &__builtin_ia32_psllq512_mask (( &__v8di)  &__A, ( &__v2di)  &__B, ( &__v8di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_sll_epi64 ( &__mmask8  &__U,  &__m512i  &__A,  &__m128i  &__B) { ( &__m512i)  &__builtin_ia32_psllq512_mask (( &__v8di)  &__A, ( &__v2di)  &__B, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_srli_epi64 ( &__m512i  &__A, my $__B) { ( &__m512i)  &__builtin_ia32_psrlqi512_mask (( &__v8di)  &__A,  $__B, ( &__v8di)  &_mm512_undefined_epi32 (), ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_srli_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m512i  &__A, my $__B) { ( &__m512i)  &__builtin_ia32_psrlqi512_mask (( &__v8di)  &__A,  $__B, ( &__v8di)  &__W, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_srli_epi64 ( &__mmask8  &__U,  &__m512i  &__A, my $__B) { ( &__m512i)  &__builtin_ia32_psrlqi512_mask (( &__v8di)  &__A,  $__B, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm512_srli_epi64 {
	    my($X, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_psrlqi512_mask (( &__v8di)( &__m512i), ($C), ( &__v8di)( &__m512i) &_mm512_undefined_epi32 (), ( &__mmask8)-1)));
	}' unless defined(&_mm512_srli_epi64);
	eval 'sub _mm512_mask_srli_epi64 {
	    my($W, $U, $X, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_psrlqi512_mask (( &__v8di)( &__m512i), ($C), ( &__v8di)( &__m512i)($W), ( &__mmask8)($U))));
	}' unless defined(&_mm512_mask_srli_epi64);
	eval 'sub _mm512_maskz_srli_epi64 {
	    my($U, $X, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_psrlqi512_mask (( &__v8di)( &__m512i), ($C), ( &__v8di)( &__m512i) &_mm512_setzero_si512 (), ( &__mmask8)($U))));
	}' unless defined(&_mm512_maskz_srli_epi64);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_srl_epi64 ( &__m512i  &__A,  &__m128i  &__B) { ( &__m512i)  &__builtin_ia32_psrlq512_mask (( &__v8di)  &__A, ( &__v2di)  &__B, ( &__v8di)  &_mm512_undefined_epi32 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_srl_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m512i  &__A,  &__m128i  &__B) { ( &__m512i)  &__builtin_ia32_psrlq512_mask (( &__v8di)  &__A, ( &__v2di)  &__B, ( &__v8di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_srl_epi64 ( &__mmask8  &__U,  &__m512i  &__A,  &__m128i  &__B) { ( &__m512i)  &__builtin_ia32_psrlq512_mask (( &__v8di)  &__A, ( &__v2di)  &__B, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_srai_epi64 ( &__m512i  &__A, my $__B) { ( &__m512i)  &__builtin_ia32_psraqi512_mask (( &__v8di)  &__A,  $__B, ( &__v8di)  &_mm512_undefined_epi32 (), ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_srai_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m512i  &__A, my $__B) { ( &__m512i)  &__builtin_ia32_psraqi512_mask (( &__v8di)  &__A,  $__B, ( &__v8di)  &__W, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_srai_epi64 ( &__mmask8  &__U,  &__m512i  &__A, my $__B) { ( &__m512i)  &__builtin_ia32_psraqi512_mask (( &__v8di)  &__A,  $__B, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm512_srai_epi64 {
	    my($X, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_psraqi512_mask (( &__v8di)( &__m512i), ($C), ( &__v8di)( &__m512i) &_mm512_undefined_epi32 (), ( &__mmask8)-1)));
	}' unless defined(&_mm512_srai_epi64);
	eval 'sub _mm512_mask_srai_epi64 {
	    my($W, $U, $X, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_psraqi512_mask (( &__v8di)( &__m512i), ($C), ( &__v8di)( &__m512i)($W), ( &__mmask8)($U))));
	}' unless defined(&_mm512_mask_srai_epi64);
	eval 'sub _mm512_maskz_srai_epi64 {
	    my($U, $X, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_psraqi512_mask (( &__v8di)( &__m512i), ($C), ( &__v8di)( &__m512i) &_mm512_setzero_si512 (), ( &__mmask8)($U))));
	}' unless defined(&_mm512_maskz_srai_epi64);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_sra_epi64 ( &__m512i  &__A,  &__m128i  &__B) { ( &__m512i)  &__builtin_ia32_psraq512_mask (( &__v8di)  &__A, ( &__v2di)  &__B, ( &__v8di)  &_mm512_undefined_epi32 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_sra_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m512i  &__A,  &__m128i  &__B) { ( &__m512i)  &__builtin_ia32_psraq512_mask (( &__v8di)  &__A, ( &__v2di)  &__B, ( &__v8di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_sra_epi64 ( &__mmask8  &__U,  &__m512i  &__A,  &__m128i  &__B) { ( &__m512i)  &__builtin_ia32_psraq512_mask (( &__v8di)  &__A, ( &__v2di)  &__B, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_slli_epi32 ( &__m512i  &__A, my $__B) { ( &__m512i)  &__builtin_ia32_pslldi512_mask (( &__v16si)  &__A,  $__B, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_slli_epi32 ( &__m512i  &__W,  &__mmask16  &__U,  &__m512i  &__A, my $__B) { ( &__m512i)  &__builtin_ia32_pslldi512_mask (( &__v16si)  &__A,  $__B, ( &__v16si)  &__W, ( &__mmask16)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_slli_epi32 ( &__mmask16  &__U,  &__m512i  &__A, my $__B) { ( &__m512i)  &__builtin_ia32_pslldi512_mask (( &__v16si)  &__A,  $__B, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm512_slli_epi32 {
	    my($X, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_pslldi512_mask (( &__v16si)( &__m512i), ($C), ( &__v16si)( &__m512i) &_mm512_undefined_epi32 (), ( &__mmask16)-1)));
	}' unless defined(&_mm512_slli_epi32);
	eval 'sub _mm512_mask_slli_epi32 {
	    my($W, $U, $X, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_pslldi512_mask (( &__v16si)( &__m512i), ($C), ( &__v16si)( &__m512i)($W), ( &__mmask16)($U))));
	}' unless defined(&_mm512_mask_slli_epi32);
	eval 'sub _mm512_maskz_slli_epi32 {
	    my($U, $X, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_pslldi512_mask (( &__v16si)( &__m512i), ($C), ( &__v16si)( &__m512i) &_mm512_setzero_si512 (), ( &__mmask16)($U))));
	}' unless defined(&_mm512_maskz_slli_epi32);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_sll_epi32 ( &__m512i  &__A,  &__m128i  &__B) { ( &__m512i)  &__builtin_ia32_pslld512_mask (( &__v16si)  &__A, ( &__v4si)  &__B, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_sll_epi32 ( &__m512i  &__W,  &__mmask16  &__U,  &__m512i  &__A,  &__m128i  &__B) { ( &__m512i)  &__builtin_ia32_pslld512_mask (( &__v16si)  &__A, ( &__v4si)  &__B, ( &__v16si)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_sll_epi32 ( &__mmask16  &__U,  &__m512i  &__A,  &__m128i  &__B) { ( &__m512i)  &__builtin_ia32_pslld512_mask (( &__v16si)  &__A, ( &__v4si)  &__B, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_srli_epi32 ( &__m512i  &__A, my $__B) { ( &__m512i)  &__builtin_ia32_psrldi512_mask (( &__v16si)  &__A,  $__B, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_srli_epi32 ( &__m512i  &__W,  &__mmask16  &__U,  &__m512i  &__A, my $__B) { ( &__m512i)  &__builtin_ia32_psrldi512_mask (( &__v16si)  &__A,  $__B, ( &__v16si)  &__W, ( &__mmask16)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_srli_epi32 ( &__mmask16  &__U,  &__m512i  &__A, my $__B) { ( &__m512i)  &__builtin_ia32_psrldi512_mask (( &__v16si)  &__A,  $__B, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm512_srli_epi32 {
	    my($X, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_psrldi512_mask (( &__v16si)( &__m512i), ($C), ( &__v16si)( &__m512i) &_mm512_undefined_epi32 (), ( &__mmask16)-1)));
	}' unless defined(&_mm512_srli_epi32);
	eval 'sub _mm512_mask_srli_epi32 {
	    my($W, $U, $X, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_psrldi512_mask (( &__v16si)( &__m512i), ($C), ( &__v16si)( &__m512i)($W), ( &__mmask16)($U))));
	}' unless defined(&_mm512_mask_srli_epi32);
	eval 'sub _mm512_maskz_srli_epi32 {
	    my($U, $X, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_psrldi512_mask (( &__v16si)( &__m512i), ($C), ( &__v16si)( &__m512i) &_mm512_setzero_si512 (), ( &__mmask16)($U))));
	}' unless defined(&_mm512_maskz_srli_epi32);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_srl_epi32 ( &__m512i  &__A,  &__m128i  &__B) { ( &__m512i)  &__builtin_ia32_psrld512_mask (( &__v16si)  &__A, ( &__v4si)  &__B, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_srl_epi32 ( &__m512i  &__W,  &__mmask16  &__U,  &__m512i  &__A,  &__m128i  &__B) { ( &__m512i)  &__builtin_ia32_psrld512_mask (( &__v16si)  &__A, ( &__v4si)  &__B, ( &__v16si)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_srl_epi32 ( &__mmask16  &__U,  &__m512i  &__A,  &__m128i  &__B) { ( &__m512i)  &__builtin_ia32_psrld512_mask (( &__v16si)  &__A, ( &__v4si)  &__B, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_srai_epi32 ( &__m512i  &__A, my $__B) { ( &__m512i)  &__builtin_ia32_psradi512_mask (( &__v16si)  &__A,  $__B, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_srai_epi32 ( &__m512i  &__W,  &__mmask16  &__U,  &__m512i  &__A, my $__B) { ( &__m512i)  &__builtin_ia32_psradi512_mask (( &__v16si)  &__A,  $__B, ( &__v16si)  &__W, ( &__mmask16)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_srai_epi32 ( &__mmask16  &__U,  &__m512i  &__A, my $__B) { ( &__m512i)  &__builtin_ia32_psradi512_mask (( &__v16si)  &__A,  $__B, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm512_srai_epi32 {
	    my($X, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_psradi512_mask (( &__v16si)( &__m512i), ($C), ( &__v16si)( &__m512i) &_mm512_undefined_epi32 (), ( &__mmask16)-1)));
	}' unless defined(&_mm512_srai_epi32);
	eval 'sub _mm512_mask_srai_epi32 {
	    my($W, $U, $X, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_psradi512_mask (( &__v16si)( &__m512i), ($C), ( &__v16si)( &__m512i)($W), ( &__mmask16)($U))));
	}' unless defined(&_mm512_mask_srai_epi32);
	eval 'sub _mm512_maskz_srai_epi32 {
	    my($U, $X, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_psradi512_mask (( &__v16si)( &__m512i), ($C), ( &__v16si)( &__m512i) &_mm512_setzero_si512 (), ( &__mmask16)($U))));
	}' unless defined(&_mm512_maskz_srai_epi32);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_sra_epi32 ( &__m512i  &__A,  &__m128i  &__B) { ( &__m512i)  &__builtin_ia32_psrad512_mask (( &__v16si)  &__A, ( &__v4si)  &__B, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_sra_epi32 ( &__m512i  &__W,  &__mmask16  &__U,  &__m512i  &__A,  &__m128i  &__B) { ( &__m512i)  &__builtin_ia32_psrad512_mask (( &__v16si)  &__A, ( &__v4si)  &__B, ( &__v16si)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_sra_epi32 ( &__mmask16  &__U,  &__m512i  &__A,  &__m128i  &__B) { ( &__m512i)  &__builtin_ia32_psrad512_mask (( &__v16si)  &__A, ( &__v4si)  &__B, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_add_round_sd ( &__m128d  &__A,  &__m128d  &__B,  &const \'int\'  &__R) { ( &__m128d)  &__builtin_ia32_addsd_round (( &__v2df)  &__A, ( &__v2df)  &__B,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_add_round_ss ( &__m128  &__A,  &__m128  &__B,  &const \'int\'  &__R) { ( &__m128)  &__builtin_ia32_addss_round (( &__v4sf)  &__A, ( &__v4sf)  &__B,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_sub_round_sd ( &__m128d  &__A,  &__m128d  &__B,  &const \'int\'  &__R) { ( &__m128d)  &__builtin_ia32_subsd_round (( &__v2df)  &__A, ( &__v2df)  &__B,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_sub_round_ss ( &__m128  &__A,  &__m128  &__B,  &const \'int\'  &__R) { ( &__m128)  &__builtin_ia32_subss_round (( &__v4sf)  &__A, ( &__v4sf)  &__B,  &__R); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm_add_round_sd {
	    my($A, $B, $C) = @_;
    	    eval q(( &__m128d) &__builtin_ia32_addsd_round($A, $B, $C));
	}' unless defined(&_mm_add_round_sd);
	eval 'sub _mm_add_round_ss {
	    my($A, $B, $C) = @_;
    	    eval q(( &__m128) &__builtin_ia32_addss_round($A, $B, $C));
	}' unless defined(&_mm_add_round_ss);
	eval 'sub _mm_sub_round_sd {
	    my($A, $B, $C) = @_;
    	    eval q(( &__m128d) &__builtin_ia32_subsd_round($A, $B, $C));
	}' unless defined(&_mm_sub_round_sd);
	eval 'sub _mm_sub_round_ss {
	    my($A, $B, $C) = @_;
    	    eval q(( &__m128) &__builtin_ia32_subss_round($A, $B, $C));
	}' unless defined(&_mm_sub_round_ss);
    }
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_ternarylogic_epi64 ( &__m512i  &__A,  &__m512i  &__B,  &__m512i  &__C,  &const \'int\'  &__imm) { ( &__m512i)  &__builtin_ia32_pternlogq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &__C,  &__imm, ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_ternarylogic_epi64 ( &__m512i  &__A,  &__mmask8  &__U,  &__m512i  &__B,  &__m512i  &__C,  &const \'int\'  &__imm) { ( &__m512i)  &__builtin_ia32_pternlogq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &__C,  &__imm, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_ternarylogic_epi64 ( &__mmask8  &__U,  &__m512i  &__A,  &__m512i  &__B,  &__m512i  &__C,  &const \'int\'  &__imm) { ( &__m512i)  &__builtin_ia32_pternlogq512_maskz (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &__C,  &__imm, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_ternarylogic_epi32 ( &__m512i  &__A,  &__m512i  &__B,  &__m512i  &__C,  &const \'int\'  &__imm) { ( &__m512i)  &__builtin_ia32_pternlogd512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &__C,  &__imm, ( &__mmask16) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_ternarylogic_epi32 ( &__m512i  &__A,  &__mmask16  &__U,  &__m512i  &__B,  &__m512i  &__C,  &const \'int\'  &__imm) { ( &__m512i)  &__builtin_ia32_pternlogd512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &__C,  &__imm, ( &__mmask16)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_ternarylogic_epi32 ( &__mmask16  &__U,  &__m512i  &__A,  &__m512i  &__B,  &__m512i  &__C,  &const \'int\'  &__imm) { ( &__m512i)  &__builtin_ia32_pternlogd512_maskz (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &__C,  &__imm, ( &__mmask16)  &__U); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm512_ternarylogic_epi64 {
	    my($A, $B, $C, $I) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_pternlogq512_mask (( &__v8di)( &__m512i)($A), ( &__v8di)( &__m512i)($B), ( &__v8di)( &__m512i), ($I), ( &__mmask8)-1)));
	}' unless defined(&_mm512_ternarylogic_epi64);
	eval 'sub _mm512_mask_ternarylogic_epi64 {
	    my($A, $U, $B, $C, $I) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_pternlogq512_mask (( &__v8di)( &__m512i)($A), ( &__v8di)( &__m512i)($B), ( &__v8di)( &__m512i), ($I), ( &__mmask8)($U))));
	}' unless defined(&_mm512_mask_ternarylogic_epi64);
	eval 'sub _mm512_maskz_ternarylogic_epi64 {
	    my($U, $A, $B, $C, $I) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_pternlogq512_maskz (( &__v8di)( &__m512i)($A), ( &__v8di)( &__m512i)($B), ( &__v8di)( &__m512i), ($I), ( &__mmask8)($U))));
	}' unless defined(&_mm512_maskz_ternarylogic_epi64);
	eval 'sub _mm512_ternarylogic_epi32 {
	    my($A, $B, $C, $I) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_pternlogd512_mask (( &__v16si)( &__m512i)($A), ( &__v16si)( &__m512i)($B), ( &__v16si)( &__m512i), ($I), ( &__mmask16)-1)));
	}' unless defined(&_mm512_ternarylogic_epi32);
	eval 'sub _mm512_mask_ternarylogic_epi32 {
	    my($A, $U, $B, $C, $I) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_pternlogd512_mask (( &__v16si)( &__m512i)($A), ( &__v16si)( &__m512i)($B), ( &__v16si)( &__m512i), ($I), ( &__mmask16)($U))));
	}' unless defined(&_mm512_mask_ternarylogic_epi32);
	eval 'sub _mm512_maskz_ternarylogic_epi32 {
	    my($U, $A, $B, $C, $I) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_pternlogd512_maskz (( &__v16si)( &__m512i)($A), ( &__v16si)( &__m512i)($B), ( &__v16si)( &__m512i), ($I), ( &__mmask16)($U))));
	}' unless defined(&_mm512_maskz_ternarylogic_epi32);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_rcp14_pd ( &__m512d  &__A) { ( &__m512d)  &__builtin_ia32_rcp14pd512_mask (( &__v8df)  &__A, ( &__v8df)  &_mm512_undefined_pd (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_rcp14_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A) { ( &__m512d)  &__builtin_ia32_rcp14pd512_mask (( &__v8df)  &__A, ( &__v8df)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_rcp14_pd ( &__mmask8  &__U,  &__m512d  &__A) { ( &__m512d)  &__builtin_ia32_rcp14pd512_mask (( &__v8df)  &__A, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_rcp14_ps ( &__m512  &__A) { ( &__m512)  &__builtin_ia32_rcp14ps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &_mm512_undefined_ps (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_rcp14_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A) { ( &__m512)  &__builtin_ia32_rcp14ps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_rcp14_ps ( &__mmask16  &__U,  &__m512  &__A) { ( &__m512)  &__builtin_ia32_rcp14ps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_rcp14_sd ( &__m128d  &__A,  &__m128d  &__B) { ( &__m128d)  &__builtin_ia32_rcp14sd (( &__v2df)  &__B, ( &__v2df)  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_rcp14_ss ( &__m128  &__A,  &__m128  &__B) { ( &__m128)  &__builtin_ia32_rcp14ss (( &__v4sf)  &__B, ( &__v4sf)  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_rsqrt14_pd ( &__m512d  &__A) { ( &__m512d)  &__builtin_ia32_rsqrt14pd512_mask (( &__v8df)  &__A, ( &__v8df)  &_mm512_undefined_pd (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_rsqrt14_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A) { ( &__m512d)  &__builtin_ia32_rsqrt14pd512_mask (( &__v8df)  &__A, ( &__v8df)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_rsqrt14_pd ( &__mmask8  &__U,  &__m512d  &__A) { ( &__m512d)  &__builtin_ia32_rsqrt14pd512_mask (( &__v8df)  &__A, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_rsqrt14_ps ( &__m512  &__A) { ( &__m512)  &__builtin_ia32_rsqrt14ps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &_mm512_undefined_ps (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_rsqrt14_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A) { ( &__m512)  &__builtin_ia32_rsqrt14ps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_rsqrt14_ps ( &__mmask16  &__U,  &__m512  &__A) { ( &__m512)  &__builtin_ia32_rsqrt14ps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_rsqrt14_sd ( &__m128d  &__A,  &__m128d  &__B) { ( &__m128d)  &__builtin_ia32_rsqrt14sd (( &__v2df)  &__B, ( &__v2df)  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_rsqrt14_ss ( &__m128  &__A,  &__m128  &__B) { ( &__m128)  &__builtin_ia32_rsqrt14ss (( &__v4sf)  &__B, ( &__v4sf)  &__A); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_sqrt_round_pd ( &__m512d  &__A,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_sqrtpd512_mask (( &__v8df)  &__A, ( &__v8df)  &_mm512_undefined_pd (), ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_sqrt_round_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_sqrtpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__W, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_sqrt_round_pd ( &__mmask8  &__U,  &__m512d  &__A,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_sqrtpd512_mask (( &__v8df)  &__A, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_sqrt_round_ps ( &__m512  &__A,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_sqrtps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &_mm512_undefined_ps (), ( &__mmask16) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_sqrt_round_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_sqrtps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__W, ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_sqrt_round_ps ( &__mmask16  &__U,  &__m512  &__A,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_sqrtps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_sqrt_round_sd ( &__m128d  &__A,  &__m128d  &__B,  &const \'int\'  &__R) { ( &__m128d)  &__builtin_ia32_sqrtsd_round (( &__v2df)  &__B, ( &__v2df)  &__A,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_sqrt_round_ss ( &__m128  &__A,  &__m128  &__B,  &const \'int\'  &__R) { ( &__m128)  &__builtin_ia32_sqrtss_round (( &__v4sf)  &__B, ( &__v4sf)  &__A,  &__R); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm512_sqrt_round_pd {
	    my($A, $C) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_sqrtpd512_mask($A, ( &__v8df) &_mm512_undefined_pd(), -1, $C));
	}' unless defined(&_mm512_sqrt_round_pd);
	eval 'sub _mm512_mask_sqrt_round_pd {
	    my($W, $U, $A, $C) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_sqrtpd512_mask($A, $W, $U, $C));
	}' unless defined(&_mm512_mask_sqrt_round_pd);
	eval 'sub _mm512_maskz_sqrt_round_pd {
	    my($U, $A, $C) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_sqrtpd512_mask($A, ( &__v8df) &_mm512_setzero_pd(), $U, $C));
	}' unless defined(&_mm512_maskz_sqrt_round_pd);
	eval 'sub _mm512_sqrt_round_ps {
	    my($A, $C) = @_;
    	    eval q(( &__m512) &__builtin_ia32_sqrtps512_mask($A, ( &__v16sf) &_mm512_undefined_ps(), -1, $C));
	}' unless defined(&_mm512_sqrt_round_ps);
	eval 'sub _mm512_mask_sqrt_round_ps {
	    my($W, $U, $A, $C) = @_;
    	    eval q(( &__m512) &__builtin_ia32_sqrtps512_mask($A, $W, $U, $C));
	}' unless defined(&_mm512_mask_sqrt_round_ps);
	eval 'sub _mm512_maskz_sqrt_round_ps {
	    my($U, $A, $C) = @_;
    	    eval q(( &__m512) &__builtin_ia32_sqrtps512_mask($A, ( &__v16sf) &_mm512_setzero_ps(), $U, $C));
	}' unless defined(&_mm512_maskz_sqrt_round_ps);
	eval 'sub _mm_sqrt_round_sd {
	    my($A, $B, $C) = @_;
    	    eval q(( &__m128d) &__builtin_ia32_sqrtsd_round($A, $B, $C));
	}' unless defined(&_mm_sqrt_round_sd);
	eval 'sub _mm_sqrt_round_ss {
	    my($A, $B, $C) = @_;
    	    eval q(( &__m128) &__builtin_ia32_sqrtss_round($A, $B, $C));
	}' unless defined(&_mm_sqrt_round_ss);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtepi8_epi32 ( &__m128i  &__A) { ( &__m512i)  &__builtin_ia32_pmovsxbd512_mask (( &__v16qi)  &__A, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtepi8_epi32 ( &__m512i  &__W,  &__mmask16  &__U,  &__m128i  &__A) { ( &__m512i)  &__builtin_ia32_pmovsxbd512_mask (( &__v16qi)  &__A, ( &__v16si)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtepi8_epi32 ( &__mmask16  &__U,  &__m128i  &__A) { ( &__m512i)  &__builtin_ia32_pmovsxbd512_mask (( &__v16qi)  &__A, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtepi8_epi64 ( &__m128i  &__A) { ( &__m512i)  &__builtin_ia32_pmovsxbq512_mask (( &__v16qi)  &__A, ( &__v8di)  &_mm512_undefined_epi32 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtepi8_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m128i  &__A) { ( &__m512i)  &__builtin_ia32_pmovsxbq512_mask (( &__v16qi)  &__A, ( &__v8di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtepi8_epi64 ( &__mmask8  &__U,  &__m128i  &__A) { ( &__m512i)  &__builtin_ia32_pmovsxbq512_mask (( &__v16qi)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtepi16_epi32 ( &__m256i  &__A) { ( &__m512i)  &__builtin_ia32_pmovsxwd512_mask (( &__v16hi)  &__A, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtepi16_epi32 ( &__m512i  &__W,  &__mmask16  &__U,  &__m256i  &__A) { ( &__m512i)  &__builtin_ia32_pmovsxwd512_mask (( &__v16hi)  &__A, ( &__v16si)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtepi16_epi32 ( &__mmask16  &__U,  &__m256i  &__A) { ( &__m512i)  &__builtin_ia32_pmovsxwd512_mask (( &__v16hi)  &__A, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtepi16_epi64 ( &__m128i  &__A) { ( &__m512i)  &__builtin_ia32_pmovsxwq512_mask (( &__v8hi)  &__A, ( &__v8di)  &_mm512_undefined_epi32 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtepi16_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m128i  &__A) { ( &__m512i)  &__builtin_ia32_pmovsxwq512_mask (( &__v8hi)  &__A, ( &__v8di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtepi16_epi64 ( &__mmask8  &__U,  &__m128i  &__A) { ( &__m512i)  &__builtin_ia32_pmovsxwq512_mask (( &__v8hi)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtepi32_epi64 ( &__m256i  &__X) { ( &__m512i)  &__builtin_ia32_pmovsxdq512_mask (( &__v8si)  &__X, ( &__v8di)  &_mm512_undefined_epi32 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtepi32_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m256i  &__X) { ( &__m512i)  &__builtin_ia32_pmovsxdq512_mask (( &__v8si)  &__X, ( &__v8di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtepi32_epi64 ( &__mmask8  &__U,  &__m256i  &__X) { ( &__m512i)  &__builtin_ia32_pmovsxdq512_mask (( &__v8si)  &__X, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtepu8_epi32 ( &__m128i  &__A) { ( &__m512i)  &__builtin_ia32_pmovzxbd512_mask (( &__v16qi)  &__A, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtepu8_epi32 ( &__m512i  &__W,  &__mmask16  &__U,  &__m128i  &__A) { ( &__m512i)  &__builtin_ia32_pmovzxbd512_mask (( &__v16qi)  &__A, ( &__v16si)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtepu8_epi32 ( &__mmask16  &__U,  &__m128i  &__A) { ( &__m512i)  &__builtin_ia32_pmovzxbd512_mask (( &__v16qi)  &__A, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtepu8_epi64 ( &__m128i  &__A) { ( &__m512i)  &__builtin_ia32_pmovzxbq512_mask (( &__v16qi)  &__A, ( &__v8di)  &_mm512_undefined_epi32 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtepu8_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m128i  &__A) { ( &__m512i)  &__builtin_ia32_pmovzxbq512_mask (( &__v16qi)  &__A, ( &__v8di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtepu8_epi64 ( &__mmask8  &__U,  &__m128i  &__A) { ( &__m512i)  &__builtin_ia32_pmovzxbq512_mask (( &__v16qi)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtepu16_epi32 ( &__m256i  &__A) { ( &__m512i)  &__builtin_ia32_pmovzxwd512_mask (( &__v16hi)  &__A, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtepu16_epi32 ( &__m512i  &__W,  &__mmask16  &__U,  &__m256i  &__A) { ( &__m512i)  &__builtin_ia32_pmovzxwd512_mask (( &__v16hi)  &__A, ( &__v16si)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtepu16_epi32 ( &__mmask16  &__U,  &__m256i  &__A) { ( &__m512i)  &__builtin_ia32_pmovzxwd512_mask (( &__v16hi)  &__A, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtepu16_epi64 ( &__m128i  &__A) { ( &__m512i)  &__builtin_ia32_pmovzxwq512_mask (( &__v8hi)  &__A, ( &__v8di)  &_mm512_undefined_epi32 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtepu16_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m128i  &__A) { ( &__m512i)  &__builtin_ia32_pmovzxwq512_mask (( &__v8hi)  &__A, ( &__v8di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtepu16_epi64 ( &__mmask8  &__U,  &__m128i  &__A) { ( &__m512i)  &__builtin_ia32_pmovzxwq512_mask (( &__v8hi)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtepu32_epi64 ( &__m256i  &__X) { ( &__m512i)  &__builtin_ia32_pmovzxdq512_mask (( &__v8si)  &__X, ( &__v8di)  &_mm512_undefined_epi32 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtepu32_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m256i  &__X) { ( &__m512i)  &__builtin_ia32_pmovzxdq512_mask (( &__v8si)  &__X, ( &__v8di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtepu32_epi64 ( &__mmask8  &__U,  &__m256i  &__X) { ( &__m512i)  &__builtin_ia32_pmovzxdq512_mask (( &__v8si)  &__X, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_add_round_pd ( &__m512d  &__A,  &__m512d  &__B,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_addpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &_mm512_undefined_pd (), ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_add_round_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_addpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__W, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_add_round_pd ( &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_addpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_add_round_ps ( &__m512  &__A,  &__m512  &__B,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_addps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &_mm512_undefined_ps (), ( &__mmask16) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_add_round_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_addps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__W, ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_add_round_ps ( &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_addps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_sub_round_pd ( &__m512d  &__A,  &__m512d  &__B,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_subpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &_mm512_undefined_pd (), ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_sub_round_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_subpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__W, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_sub_round_pd ( &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_subpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_sub_round_ps ( &__m512  &__A,  &__m512  &__B,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_subps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &_mm512_undefined_ps (), ( &__mmask16) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_sub_round_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_subps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__W, ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_sub_round_ps ( &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_subps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm512_add_round_pd {
	    my($A, $B, $C) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_addpd512_mask($A, $B, ( &__v8df) &_mm512_undefined_pd(), -1, $C));
	}' unless defined(&_mm512_add_round_pd);
	eval 'sub _mm512_mask_add_round_pd {
	    my($W, $U, $A, $B, $C) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_addpd512_mask($A, $B, $W, $U, $C));
	}' unless defined(&_mm512_mask_add_round_pd);
	eval 'sub _mm512_maskz_add_round_pd {
	    my($U, $A, $B, $C) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_addpd512_mask($A, $B, ( &__v8df) &_mm512_setzero_pd(), $U, $C));
	}' unless defined(&_mm512_maskz_add_round_pd);
	eval 'sub _mm512_add_round_ps {
	    my($A, $B, $C) = @_;
    	    eval q(( &__m512) &__builtin_ia32_addps512_mask($A, $B, ( &__v16sf) &_mm512_undefined_ps(), -1, $C));
	}' unless defined(&_mm512_add_round_ps);
	eval 'sub _mm512_mask_add_round_ps {
	    my($W, $U, $A, $B, $C) = @_;
    	    eval q(( &__m512) &__builtin_ia32_addps512_mask($A, $B, $W, $U, $C));
	}' unless defined(&_mm512_mask_add_round_ps);
	eval 'sub _mm512_maskz_add_round_ps {
	    my($U, $A, $B, $C) = @_;
    	    eval q(( &__m512) &__builtin_ia32_addps512_mask($A, $B, ( &__v16sf) &_mm512_setzero_ps(), $U, $C));
	}' unless defined(&_mm512_maskz_add_round_ps);
	eval 'sub _mm512_sub_round_pd {
	    my($A, $B, $C) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_subpd512_mask($A, $B, ( &__v8df) &_mm512_undefined_pd(), -1, $C));
	}' unless defined(&_mm512_sub_round_pd);
	eval 'sub _mm512_mask_sub_round_pd {
	    my($W, $U, $A, $B, $C) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_subpd512_mask($A, $B, $W, $U, $C));
	}' unless defined(&_mm512_mask_sub_round_pd);
	eval 'sub _mm512_maskz_sub_round_pd {
	    my($U, $A, $B, $C) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_subpd512_mask($A, $B, ( &__v8df) &_mm512_setzero_pd(), $U, $C));
	}' unless defined(&_mm512_maskz_sub_round_pd);
	eval 'sub _mm512_sub_round_ps {
	    my($A, $B, $C) = @_;
    	    eval q(( &__m512) &__builtin_ia32_subps512_mask($A, $B, ( &__v16sf) &_mm512_undefined_ps(), -1, $C));
	}' unless defined(&_mm512_sub_round_ps);
	eval 'sub _mm512_mask_sub_round_ps {
	    my($W, $U, $A, $B, $C) = @_;
    	    eval q(( &__m512) &__builtin_ia32_subps512_mask($A, $B, $W, $U, $C));
	}' unless defined(&_mm512_mask_sub_round_ps);
	eval 'sub _mm512_maskz_sub_round_ps {
	    my($U, $A, $B, $C) = @_;
    	    eval q(( &__m512) &__builtin_ia32_subps512_mask($A, $B, ( &__v16sf) &_mm512_setzero_ps(), $U, $C));
	}' unless defined(&_mm512_maskz_sub_round_ps);
    }
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mul_round_pd ( &__m512d  &__A,  &__m512d  &__B,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_mulpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &_mm512_undefined_pd (), ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_mul_round_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_mulpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__W, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_mul_round_pd ( &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_mulpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mul_round_ps ( &__m512  &__A,  &__m512  &__B,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_mulps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &_mm512_undefined_ps (), ( &__mmask16) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_mul_round_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_mulps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__W, ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_mul_round_ps ( &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_mulps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_div_round_pd ( &__m512d  &__M,  &__m512d  &__V,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_divpd512_mask (( &__v8df)  &__M, ( &__v8df)  &__V, ( &__v8df)  &_mm512_undefined_pd (), ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_div_round_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__M,  &__m512d  &__V,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_divpd512_mask (( &__v8df)  &__M, ( &__v8df)  &__V, ( &__v8df)  &__W, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_div_round_pd ( &__mmask8  &__U,  &__m512d  &__M,  &__m512d  &__V,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_divpd512_mask (( &__v8df)  &__M, ( &__v8df)  &__V, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_div_round_ps ( &__m512  &__A,  &__m512  &__B,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_divps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &_mm512_undefined_ps (), ( &__mmask16) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_div_round_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_divps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__W, ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_div_round_ps ( &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_divps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mul_round_sd ( &__m128d  &__A,  &__m128d  &__B,  &const \'int\'  &__R) { ( &__m128d)  &__builtin_ia32_mulsd_round (( &__v2df)  &__A, ( &__v2df)  &__B,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mul_round_ss ( &__m128  &__A,  &__m128  &__B,  &const \'int\'  &__R) { ( &__m128)  &__builtin_ia32_mulss_round (( &__v4sf)  &__A, ( &__v4sf)  &__B,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_div_round_sd ( &__m128d  &__A,  &__m128d  &__B,  &const \'int\'  &__R) { ( &__m128d)  &__builtin_ia32_divsd_round (( &__v2df)  &__A, ( &__v2df)  &__B,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_div_round_ss ( &__m128  &__A,  &__m128  &__B,  &const \'int\'  &__R) { ( &__m128)  &__builtin_ia32_divss_round (( &__v4sf)  &__A, ( &__v4sf)  &__B,  &__R); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm512_mul_round_pd {
	    my($A, $B, $C) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_mulpd512_mask($A, $B, ( &__v8df) &_mm512_undefined_pd(), -1, $C));
	}' unless defined(&_mm512_mul_round_pd);
	eval 'sub _mm512_mask_mul_round_pd {
	    my($W, $U, $A, $B, $C) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_mulpd512_mask($A, $B, $W, $U, $C));
	}' unless defined(&_mm512_mask_mul_round_pd);
	eval 'sub _mm512_maskz_mul_round_pd {
	    my($U, $A, $B, $C) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_mulpd512_mask($A, $B, ( &__v8df) &_mm512_setzero_pd(), $U, $C));
	}' unless defined(&_mm512_maskz_mul_round_pd);
	eval 'sub _mm512_mul_round_ps {
	    my($A, $B, $C) = @_;
    	    eval q(( &__m512) &__builtin_ia32_mulps512_mask($A, $B, ( &__v16sf) &_mm512_undefined_ps(), -1, $C));
	}' unless defined(&_mm512_mul_round_ps);
	eval 'sub _mm512_mask_mul_round_ps {
	    my($W, $U, $A, $B, $C) = @_;
    	    eval q(( &__m512) &__builtin_ia32_mulps512_mask($A, $B, $W, $U, $C));
	}' unless defined(&_mm512_mask_mul_round_ps);
	eval 'sub _mm512_maskz_mul_round_ps {
	    my($U, $A, $B, $C) = @_;
    	    eval q(( &__m512) &__builtin_ia32_mulps512_mask($A, $B, ( &__v16sf) &_mm512_setzero_ps(), $U, $C));
	}' unless defined(&_mm512_maskz_mul_round_ps);
	eval 'sub _mm512_div_round_pd {
	    my($A, $B, $C) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_divpd512_mask($A, $B, ( &__v8df) &_mm512_undefined_pd(), -1, $C));
	}' unless defined(&_mm512_div_round_pd);
	eval 'sub _mm512_mask_div_round_pd {
	    my($W, $U, $A, $B, $C) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_divpd512_mask($A, $B, $W, $U, $C));
	}' unless defined(&_mm512_mask_div_round_pd);
	eval 'sub _mm512_maskz_div_round_pd {
	    my($U, $A, $B, $C) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_divpd512_mask($A, $B, ( &__v8df) &_mm512_setzero_pd(), $U, $C));
	}' unless defined(&_mm512_maskz_div_round_pd);
	eval 'sub _mm512_div_round_ps {
	    my($A, $B, $C) = @_;
    	    eval q(( &__m512) &__builtin_ia32_divps512_mask($A, $B, ( &__v16sf) &_mm512_undefined_ps(), -1, $C));
	}' unless defined(&_mm512_div_round_ps);
	eval 'sub _mm512_mask_div_round_ps {
	    my($W, $U, $A, $B, $C) = @_;
    	    eval q(( &__m512) &__builtin_ia32_divps512_mask($A, $B, $W, $U, $C));
	}' unless defined(&_mm512_mask_div_round_ps);
	eval 'sub _mm512_maskz_div_round_ps {
	    my($U, $A, $B, $C) = @_;
    	    eval q(( &__m512) &__builtin_ia32_divps512_mask($A, $B, ( &__v16sf) &_mm512_setzero_ps(), $U, $C));
	}' unless defined(&_mm512_maskz_div_round_ps);
	eval 'sub _mm_mul_round_sd {
	    my($A, $B, $C) = @_;
    	    eval q(( &__m128d) &__builtin_ia32_mulsd_round($A, $B, $C));
	}' unless defined(&_mm_mul_round_sd);
	eval 'sub _mm_mul_round_ss {
	    my($A, $B, $C) = @_;
    	    eval q(( &__m128) &__builtin_ia32_mulss_round($A, $B, $C));
	}' unless defined(&_mm_mul_round_ss);
	eval 'sub _mm_div_round_sd {
	    my($A, $B, $C) = @_;
    	    eval q(( &__m128d) &__builtin_ia32_divsd_round($A, $B, $C));
	}' unless defined(&_mm_div_round_sd);
	eval 'sub _mm_div_round_ss {
	    my($A, $B, $C) = @_;
    	    eval q(( &__m128) &__builtin_ia32_divss_round($A, $B, $C));
	}' unless defined(&_mm_div_round_ss);
    }
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_max_round_pd ( &__m512d  &__A,  &__m512d  &__B,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_maxpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &_mm512_undefined_pd (), ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_max_round_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_maxpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__W, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_max_round_pd ( &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_maxpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_max_round_ps ( &__m512  &__A,  &__m512  &__B,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_maxps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &_mm512_undefined_ps (), ( &__mmask16) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_max_round_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_maxps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__W, ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_max_round_ps ( &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_maxps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_min_round_pd ( &__m512d  &__A,  &__m512d  &__B,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_minpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &_mm512_undefined_pd (), ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_min_round_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_minpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__W, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_min_round_pd ( &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_minpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_min_round_ps ( &__m512  &__A,  &__m512  &__B,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_minps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &_mm512_undefined_ps (), ( &__mmask16) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_min_round_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_minps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__W, ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_min_round_ps ( &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_minps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm512_max_round_pd {
	    my($A, $B,  $R) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_maxpd512_mask($A, $B, ( &__v8df) &_mm512_undefined_pd(), -1, $R));
	}' unless defined(&_mm512_max_round_pd);
	eval 'sub _mm512_mask_max_round_pd {
	    my($W, $U,  $A, $B, $R) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_maxpd512_mask($A, $B, $W, $U, $R));
	}' unless defined(&_mm512_mask_max_round_pd);
	eval 'sub _mm512_maskz_max_round_pd {
	    my($U, $A,  $B, $R) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_maxpd512_mask($A, $B, ( &__v8df) &_mm512_setzero_pd(), $U, $R));
	}' unless defined(&_mm512_maskz_max_round_pd);
	eval 'sub _mm512_max_round_ps {
	    my($A, $B,  $R) = @_;
    	    eval q(( &__m512) &__builtin_ia32_maxps512_mask($A, $B, ( &__v16sf) &_mm512_undefined_pd(), -1, $R));
	}' unless defined(&_mm512_max_round_ps);
	eval 'sub _mm512_mask_max_round_ps {
	    my($W, $U,  $A, $B, $R) = @_;
    	    eval q(( &__m512) &__builtin_ia32_maxps512_mask($A, $B, $W, $U, $R));
	}' unless defined(&_mm512_mask_max_round_ps);
	eval 'sub _mm512_maskz_max_round_ps {
	    my($U, $A,  $B, $R) = @_;
    	    eval q(( &__m512) &__builtin_ia32_maxps512_mask($A, $B, ( &__v16sf) &_mm512_setzero_ps(), $U, $R));
	}' unless defined(&_mm512_maskz_max_round_ps);
	eval 'sub _mm512_min_round_pd {
	    my($A, $B,  $R) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_minpd512_mask($A, $B, ( &__v8df) &_mm512_undefined_pd(), -1, $R));
	}' unless defined(&_mm512_min_round_pd);
	eval 'sub _mm512_mask_min_round_pd {
	    my($W, $U,  $A, $B, $R) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_minpd512_mask($A, $B, $W, $U, $R));
	}' unless defined(&_mm512_mask_min_round_pd);
	eval 'sub _mm512_maskz_min_round_pd {
	    my($U, $A,  $B, $R) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_minpd512_mask($A, $B, ( &__v8df) &_mm512_setzero_pd(), $U, $R));
	}' unless defined(&_mm512_maskz_min_round_pd);
	eval 'sub _mm512_min_round_ps {
	    my($A, $B, $R) = @_;
    	    eval q(( &__m512) &__builtin_ia32_minps512_mask($A, $B, ( &__v16sf) &_mm512_undefined_ps(), -1, $R));
	}' unless defined(&_mm512_min_round_ps);
	eval 'sub _mm512_mask_min_round_ps {
	    my($W, $U,  $A, $B, $R) = @_;
    	    eval q(( &__m512) &__builtin_ia32_minps512_mask($A, $B, $W, $U, $R));
	}' unless defined(&_mm512_mask_min_round_ps);
	eval 'sub _mm512_maskz_min_round_ps {
	    my($U, $A,  $B, $R) = @_;
    	    eval q(( &__m512) &__builtin_ia32_minps512_mask($A, $B, ( &__v16sf) &_mm512_setzero_ps(), $U, $R));
	}' unless defined(&_mm512_maskz_min_round_ps);
    }
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_scalef_round_pd ( &__m512d  &__A,  &__m512d  &__B,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_scalefpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &_mm512_undefined_pd (), ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_scalef_round_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_scalefpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__W, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_scalef_round_pd ( &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_scalefpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_scalef_round_ps ( &__m512  &__A,  &__m512  &__B,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_scalefps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &_mm512_undefined_ps (), ( &__mmask16) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_scalef_round_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_scalefps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__W, ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_scalef_round_ps ( &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_scalefps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_scalef_round_sd ( &__m128d  &__A,  &__m128d  &__B,  &const \'int\'  &__R) { ( &__m128d)  &__builtin_ia32_scalefsd_round (( &__v2df)  &__A, ( &__v2df)  &__B,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_scalef_round_ss ( &__m128  &__A,  &__m128  &__B,  &const \'int\'  &__R) { ( &__m128)  &__builtin_ia32_scalefss_round (( &__v4sf)  &__A, ( &__v4sf)  &__B,  &__R); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm512_scalef_round_pd {
	    my($A, $B, $C) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_scalefpd512_mask($A, $B, ( &__v8df) &_mm512_undefined_pd(), -1, $C));
	}' unless defined(&_mm512_scalef_round_pd);
	eval 'sub _mm512_mask_scalef_round_pd {
	    my($W, $U, $A, $B, $C) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_scalefpd512_mask($A, $B, $W, $U, $C));
	}' unless defined(&_mm512_mask_scalef_round_pd);
	eval 'sub _mm512_maskz_scalef_round_pd {
	    my($U, $A, $B, $C) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_scalefpd512_mask($A, $B, ( &__v8df) &_mm512_setzero_pd(), $U, $C));
	}' unless defined(&_mm512_maskz_scalef_round_pd);
	eval 'sub _mm512_scalef_round_ps {
	    my($A, $B, $C) = @_;
    	    eval q(( &__m512) &__builtin_ia32_scalefps512_mask($A, $B, ( &__v16sf) &_mm512_undefined_ps(), -1, $C));
	}' unless defined(&_mm512_scalef_round_ps);
	eval 'sub _mm512_mask_scalef_round_ps {
	    my($W, $U, $A, $B, $C) = @_;
    	    eval q(( &__m512) &__builtin_ia32_scalefps512_mask($A, $B, $W, $U, $C));
	}' unless defined(&_mm512_mask_scalef_round_ps);
	eval 'sub _mm512_maskz_scalef_round_ps {
	    my($U, $A, $B, $C) = @_;
    	    eval q(( &__m512) &__builtin_ia32_scalefps512_mask($A, $B, ( &__v16sf) &_mm512_setzero_ps(), $U, $C));
	}' unless defined(&_mm512_maskz_scalef_round_ps);
	eval 'sub _mm_scalef_round_sd {
	    my($A, $B, $C) = @_;
    	    eval q(( &__m128d) &__builtin_ia32_scalefsd_round($A, $B, $C));
	}' unless defined(&_mm_scalef_round_sd);
	eval 'sub _mm_scalef_round_ss {
	    my($A, $B, $C) = @_;
    	    eval q(( &__m128) &__builtin_ia32_scalefss_round($A, $B, $C));
	}' unless defined(&_mm_scalef_round_ss);
    }
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_fmadd_round_pd ( &__m512d  &__A,  &__m512d  &__B,  &__m512d  &__C,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_vfmaddpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__C, ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_fmadd_round_pd ( &__m512d  &__A,  &__mmask8  &__U,  &__m512d  &__B,  &__m512d  &__C,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_vfmaddpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__C, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask3_fmadd_round_pd ( &__m512d  &__A,  &__m512d  &__B,  &__m512d  &__C,  &__mmask8  &__U,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_vfmaddpd512_mask3 (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__C, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_fmadd_round_pd ( &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B,  &__m512d  &__C,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_vfmaddpd512_maskz (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__C, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_fmadd_round_ps ( &__m512  &__A,  &__m512  &__B,  &__m512  &__C,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_vfmaddps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__C, ( &__mmask16) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_fmadd_round_ps ( &__m512  &__A,  &__mmask16  &__U,  &__m512  &__B,  &__m512  &__C,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_vfmaddps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__C, ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask3_fmadd_round_ps ( &__m512  &__A,  &__m512  &__B,  &__m512  &__C,  &__mmask16  &__U,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_vfmaddps512_mask3 (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__C, ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_fmadd_round_ps ( &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B,  &__m512  &__C,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_vfmaddps512_maskz (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__C, ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_fmsub_round_pd ( &__m512d  &__A,  &__m512d  &__B,  &__m512d  &__C,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_vfmaddpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, -( &__v8df)  &__C, ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_fmsub_round_pd ( &__m512d  &__A,  &__mmask8  &__U,  &__m512d  &__B,  &__m512d  &__C,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_vfmaddpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, -( &__v8df)  &__C, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask3_fmsub_round_pd ( &__m512d  &__A,  &__m512d  &__B,  &__m512d  &__C,  &__mmask8  &__U,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_vfmsubpd512_mask3 (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__C, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_fmsub_round_pd ( &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B,  &__m512d  &__C,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_vfmaddpd512_maskz (( &__v8df)  &__A, ( &__v8df)  &__B, -( &__v8df)  &__C, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_fmsub_round_ps ( &__m512  &__A,  &__m512  &__B,  &__m512  &__C,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_vfmaddps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, -( &__v16sf)  &__C, ( &__mmask16) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_fmsub_round_ps ( &__m512  &__A,  &__mmask16  &__U,  &__m512  &__B,  &__m512  &__C,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_vfmaddps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, -( &__v16sf)  &__C, ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask3_fmsub_round_ps ( &__m512  &__A,  &__m512  &__B,  &__m512  &__C,  &__mmask16  &__U,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_vfmsubps512_mask3 (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__C, ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_fmsub_round_ps ( &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B,  &__m512  &__C,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_vfmaddps512_maskz (( &__v16sf)  &__A, ( &__v16sf)  &__B, -( &__v16sf)  &__C, ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_fmaddsub_round_pd ( &__m512d  &__A,  &__m512d  &__B,  &__m512d  &__C,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_vfmaddsubpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__C, ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_fmaddsub_round_pd ( &__m512d  &__A,  &__mmask8  &__U,  &__m512d  &__B,  &__m512d  &__C,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_vfmaddsubpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__C, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask3_fmaddsub_round_pd ( &__m512d  &__A,  &__m512d  &__B,  &__m512d  &__C,  &__mmask8  &__U,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_vfmaddsubpd512_mask3 (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__C, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_fmaddsub_round_pd ( &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B,  &__m512d  &__C,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_vfmaddsubpd512_maskz (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__C, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_fmaddsub_round_ps ( &__m512  &__A,  &__m512  &__B,  &__m512  &__C,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_vfmaddsubps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__C, ( &__mmask16) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_fmaddsub_round_ps ( &__m512  &__A,  &__mmask16  &__U,  &__m512  &__B,  &__m512  &__C,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_vfmaddsubps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__C, ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask3_fmaddsub_round_ps ( &__m512  &__A,  &__m512  &__B,  &__m512  &__C,  &__mmask16  &__U,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_vfmaddsubps512_mask3 (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__C, ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_fmaddsub_round_ps ( &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B,  &__m512  &__C,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_vfmaddsubps512_maskz (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__C, ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_fmsubadd_round_pd ( &__m512d  &__A,  &__m512d  &__B,  &__m512d  &__C,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_vfmaddsubpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, -( &__v8df)  &__C, ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_fmsubadd_round_pd ( &__m512d  &__A,  &__mmask8  &__U,  &__m512d  &__B,  &__m512d  &__C,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_vfmaddsubpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, -( &__v8df)  &__C, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask3_fmsubadd_round_pd ( &__m512d  &__A,  &__m512d  &__B,  &__m512d  &__C,  &__mmask8  &__U,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_vfmsubaddpd512_mask3 (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__C, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_fmsubadd_round_pd ( &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B,  &__m512d  &__C,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_vfmaddsubpd512_maskz (( &__v8df)  &__A, ( &__v8df)  &__B, -( &__v8df)  &__C, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_fmsubadd_round_ps ( &__m512  &__A,  &__m512  &__B,  &__m512  &__C,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_vfmaddsubps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, -( &__v16sf)  &__C, ( &__mmask16) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_fmsubadd_round_ps ( &__m512  &__A,  &__mmask16  &__U,  &__m512  &__B,  &__m512  &__C,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_vfmaddsubps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, -( &__v16sf)  &__C, ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask3_fmsubadd_round_ps ( &__m512  &__A,  &__m512  &__B,  &__m512  &__C,  &__mmask16  &__U,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_vfmsubaddps512_mask3 (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__C, ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_fmsubadd_round_ps ( &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B,  &__m512  &__C,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_vfmaddsubps512_maskz (( &__v16sf)  &__A, ( &__v16sf)  &__B, -( &__v16sf)  &__C, ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_fnmadd_round_pd ( &__m512d  &__A,  &__m512d  &__B,  &__m512d  &__C,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_vfmaddpd512_mask (-( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__C, ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_fnmadd_round_pd ( &__m512d  &__A,  &__mmask8  &__U,  &__m512d  &__B,  &__m512d  &__C,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_vfnmaddpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__C, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask3_fnmadd_round_pd ( &__m512d  &__A,  &__m512d  &__B,  &__m512d  &__C,  &__mmask8  &__U,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_vfmaddpd512_mask3 (-( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__C, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_fnmadd_round_pd ( &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B,  &__m512d  &__C,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_vfmaddpd512_maskz (-( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__C, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_fnmadd_round_ps ( &__m512  &__A,  &__m512  &__B,  &__m512  &__C,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_vfmaddps512_mask (-( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__C, ( &__mmask16) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_fnmadd_round_ps ( &__m512  &__A,  &__mmask16  &__U,  &__m512  &__B,  &__m512  &__C,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_vfnmaddps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__C, ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask3_fnmadd_round_ps ( &__m512  &__A,  &__m512  &__B,  &__m512  &__C,  &__mmask16  &__U,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_vfmaddps512_mask3 (-( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__C, ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_fnmadd_round_ps ( &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B,  &__m512  &__C,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_vfmaddps512_maskz (-( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__C, ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_fnmsub_round_pd ( &__m512d  &__A,  &__m512d  &__B,  &__m512d  &__C,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_vfmaddpd512_mask (-( &__v8df)  &__A, ( &__v8df)  &__B, -( &__v8df)  &__C, ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_fnmsub_round_pd ( &__m512d  &__A,  &__mmask8  &__U,  &__m512d  &__B,  &__m512d  &__C,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_vfnmsubpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__C, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask3_fnmsub_round_pd ( &__m512d  &__A,  &__m512d  &__B,  &__m512d  &__C,  &__mmask8  &__U,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_vfnmsubpd512_mask3 (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__C, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_fnmsub_round_pd ( &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B,  &__m512d  &__C,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_vfmaddpd512_maskz (-( &__v8df)  &__A, ( &__v8df)  &__B, -( &__v8df)  &__C, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_fnmsub_round_ps ( &__m512  &__A,  &__m512  &__B,  &__m512  &__C,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_vfmaddps512_mask (-( &__v16sf)  &__A, ( &__v16sf)  &__B, -( &__v16sf)  &__C, ( &__mmask16) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_fnmsub_round_ps ( &__m512  &__A,  &__mmask16  &__U,  &__m512  &__B,  &__m512  &__C,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_vfnmsubps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__C, ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask3_fnmsub_round_ps ( &__m512  &__A,  &__m512  &__B,  &__m512  &__C,  &__mmask16  &__U,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_vfnmsubps512_mask3 (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__C, ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_fnmsub_round_ps ( &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B,  &__m512  &__C,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_vfmaddps512_maskz (-( &__v16sf)  &__A, ( &__v16sf)  &__B, -( &__v16sf)  &__C, ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm512_fmadd_round_pd {
	    my($A, $B, $C, $R) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_vfmaddpd512_mask($A, $B, $C, -1, $R));
	}' unless defined(&_mm512_fmadd_round_pd);
	eval 'sub _mm512_mask_fmadd_round_pd {
	    my($A, $U, $B, $C, $R) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_vfmaddpd512_mask($A, $B, $C, $U, $R));
	}' unless defined(&_mm512_mask_fmadd_round_pd);
	eval 'sub _mm512_mask3_fmadd_round_pd {
	    my($A, $B, $C, $U, $R) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_vfmaddpd512_mask3($A, $B, $C, $U, $R));
	}' unless defined(&_mm512_mask3_fmadd_round_pd);
	eval 'sub _mm512_maskz_fmadd_round_pd {
	    my($U, $A, $B, $C, $R) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_vfmaddpd512_maskz($A, $B, $C, $U, $R));
	}' unless defined(&_mm512_maskz_fmadd_round_pd);
	eval 'sub _mm512_fmadd_round_ps {
	    my($A, $B, $C, $R) = @_;
    	    eval q(( &__m512) &__builtin_ia32_vfmaddps512_mask($A, $B, $C, -1, $R));
	}' unless defined(&_mm512_fmadd_round_ps);
	eval 'sub _mm512_mask_fmadd_round_ps {
	    my($A, $U, $B, $C, $R) = @_;
    	    eval q(( &__m512) &__builtin_ia32_vfmaddps512_mask($A, $B, $C, $U, $R));
	}' unless defined(&_mm512_mask_fmadd_round_ps);
	eval 'sub _mm512_mask3_fmadd_round_ps {
	    my($A, $B, $C, $U, $R) = @_;
    	    eval q(( &__m512) &__builtin_ia32_vfmaddps512_mask3($A, $B, $C, $U, $R));
	}' unless defined(&_mm512_mask3_fmadd_round_ps);
	eval 'sub _mm512_maskz_fmadd_round_ps {
	    my($U, $A, $B, $C, $R) = @_;
    	    eval q(( &__m512) &__builtin_ia32_vfmaddps512_maskz($A, $B, $C, $U, $R));
	}' unless defined(&_mm512_maskz_fmadd_round_ps);
	eval 'sub _mm512_fmsub_round_pd {
	    my($A, $B, $C, $R) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_vfmaddpd512_mask($A, $B, -($C), -1, $R));
	}' unless defined(&_mm512_fmsub_round_pd);
	eval 'sub _mm512_mask_fmsub_round_pd {
	    my($A, $U, $B, $C, $R) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_vfmaddpd512_mask($A, $B, -($C), $U, $R));
	}' unless defined(&_mm512_mask_fmsub_round_pd);
	eval 'sub _mm512_mask3_fmsub_round_pd {
	    my($A, $B, $C, $U, $R) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_vfmsubpd512_mask3($A, $B, $C, $U, $R));
	}' unless defined(&_mm512_mask3_fmsub_round_pd);
	eval 'sub _mm512_maskz_fmsub_round_pd {
	    my($U, $A, $B, $C, $R) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_vfmaddpd512_maskz($A, $B, -($C), $U, $R));
	}' unless defined(&_mm512_maskz_fmsub_round_pd);
	eval 'sub _mm512_fmsub_round_ps {
	    my($A, $B, $C, $R) = @_;
    	    eval q(( &__m512) &__builtin_ia32_vfmaddps512_mask($A, $B, -($C), -1, $R));
	}' unless defined(&_mm512_fmsub_round_ps);
	eval 'sub _mm512_mask_fmsub_round_ps {
	    my($A, $U, $B, $C, $R) = @_;
    	    eval q(( &__m512) &__builtin_ia32_vfmaddps512_mask($A, $B, -($C), $U, $R));
	}' unless defined(&_mm512_mask_fmsub_round_ps);
	eval 'sub _mm512_mask3_fmsub_round_ps {
	    my($A, $B, $C, $U, $R) = @_;
    	    eval q(( &__m512) &__builtin_ia32_vfmsubps512_mask3($A, $B, $C, $U, $R));
	}' unless defined(&_mm512_mask3_fmsub_round_ps);
	eval 'sub _mm512_maskz_fmsub_round_ps {
	    my($U, $A, $B, $C, $R) = @_;
    	    eval q(( &__m512) &__builtin_ia32_vfmaddps512_maskz($A, $B, -($C), $U, $R));
	}' unless defined(&_mm512_maskz_fmsub_round_ps);
	eval 'sub _mm512_fmaddsub_round_pd {
	    my($A, $B, $C, $R) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_vfmaddsubpd512_mask($A, $B, $C, -1, $R));
	}' unless defined(&_mm512_fmaddsub_round_pd);
	eval 'sub _mm512_mask_fmaddsub_round_pd {
	    my($A, $U, $B, $C, $R) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_vfmaddsubpd512_mask($A, $B, $C, $U, $R));
	}' unless defined(&_mm512_mask_fmaddsub_round_pd);
	eval 'sub _mm512_mask3_fmaddsub_round_pd {
	    my($A, $B, $C, $U, $R) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_vfmaddsubpd512_mask3($A, $B, $C, $U, $R));
	}' unless defined(&_mm512_mask3_fmaddsub_round_pd);
	eval 'sub _mm512_maskz_fmaddsub_round_pd {
	    my($U, $A, $B, $C, $R) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_vfmaddsubpd512_maskz($A, $B, $C, $U, $R));
	}' unless defined(&_mm512_maskz_fmaddsub_round_pd);
	eval 'sub _mm512_fmaddsub_round_ps {
	    my($A, $B, $C, $R) = @_;
    	    eval q(( &__m512) &__builtin_ia32_vfmaddsubps512_mask($A, $B, $C, -1, $R));
	}' unless defined(&_mm512_fmaddsub_round_ps);
	eval 'sub _mm512_mask_fmaddsub_round_ps {
	    my($A, $U, $B, $C, $R) = @_;
    	    eval q(( &__m512) &__builtin_ia32_vfmaddsubps512_mask($A, $B, $C, $U, $R));
	}' unless defined(&_mm512_mask_fmaddsub_round_ps);
	eval 'sub _mm512_mask3_fmaddsub_round_ps {
	    my($A, $B, $C, $U, $R) = @_;
    	    eval q(( &__m512) &__builtin_ia32_vfmaddsubps512_mask3($A, $B, $C, $U, $R));
	}' unless defined(&_mm512_mask3_fmaddsub_round_ps);
	eval 'sub _mm512_maskz_fmaddsub_round_ps {
	    my($U, $A, $B, $C, $R) = @_;
    	    eval q(( &__m512) &__builtin_ia32_vfmaddsubps512_maskz($A, $B, $C, $U, $R));
	}' unless defined(&_mm512_maskz_fmaddsub_round_ps);
	eval 'sub _mm512_fmsubadd_round_pd {
	    my($A, $B, $C, $R) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_vfmaddsubpd512_mask($A, $B, -($C), -1, $R));
	}' unless defined(&_mm512_fmsubadd_round_pd);
	eval 'sub _mm512_mask_fmsubadd_round_pd {
	    my($A, $U, $B, $C, $R) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_vfmaddsubpd512_mask($A, $B, -($C), $U, $R));
	}' unless defined(&_mm512_mask_fmsubadd_round_pd);
	eval 'sub _mm512_mask3_fmsubadd_round_pd {
	    my($A, $B, $C, $U, $R) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_vfmsubaddpd512_mask3($A, $B, $C, $U, $R));
	}' unless defined(&_mm512_mask3_fmsubadd_round_pd);
	eval 'sub _mm512_maskz_fmsubadd_round_pd {
	    my($U, $A, $B, $C, $R) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_vfmaddsubpd512_maskz($A, $B, -($C), $U, $R));
	}' unless defined(&_mm512_maskz_fmsubadd_round_pd);
	eval 'sub _mm512_fmsubadd_round_ps {
	    my($A, $B, $C, $R) = @_;
    	    eval q(( &__m512) &__builtin_ia32_vfmaddsubps512_mask($A, $B, -($C), -1, $R));
	}' unless defined(&_mm512_fmsubadd_round_ps);
	eval 'sub _mm512_mask_fmsubadd_round_ps {
	    my($A, $U, $B, $C, $R) = @_;
    	    eval q(( &__m512) &__builtin_ia32_vfmaddsubps512_mask($A, $B, -($C), $U, $R));
	}' unless defined(&_mm512_mask_fmsubadd_round_ps);
	eval 'sub _mm512_mask3_fmsubadd_round_ps {
	    my($A, $B, $C, $U, $R) = @_;
    	    eval q(( &__m512) &__builtin_ia32_vfmsubaddps512_mask3($A, $B, $C, $U, $R));
	}' unless defined(&_mm512_mask3_fmsubadd_round_ps);
	eval 'sub _mm512_maskz_fmsubadd_round_ps {
	    my($U, $A, $B, $C, $R) = @_;
    	    eval q(( &__m512) &__builtin_ia32_vfmaddsubps512_maskz($A, $B, -($C), $U, $R));
	}' unless defined(&_mm512_maskz_fmsubadd_round_ps);
	eval 'sub _mm512_fnmadd_round_pd {
	    my($A, $B, $C, $R) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_vfmaddpd512_mask(-($A), $B, $C, -1, $R));
	}' unless defined(&_mm512_fnmadd_round_pd);
	eval 'sub _mm512_mask_fnmadd_round_pd {
	    my($A, $U, $B, $C, $R) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_vfnmaddpd512_mask(-($A), $B, $C, $U, $R));
	}' unless defined(&_mm512_mask_fnmadd_round_pd);
	eval 'sub _mm512_mask3_fnmadd_round_pd {
	    my($A, $B, $C, $U, $R) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_vfmaddpd512_mask3(-($A), $B, $C, $U, $R));
	}' unless defined(&_mm512_mask3_fnmadd_round_pd);
	eval 'sub _mm512_maskz_fnmadd_round_pd {
	    my($U, $A, $B, $C, $R) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_vfmaddpd512_maskz(-($A), $B, $C, $U, $R));
	}' unless defined(&_mm512_maskz_fnmadd_round_pd);
	eval 'sub _mm512_fnmadd_round_ps {
	    my($A, $B, $C, $R) = @_;
    	    eval q(( &__m512) &__builtin_ia32_vfmaddps512_mask(-($A), $B, $C, -1, $R));
	}' unless defined(&_mm512_fnmadd_round_ps);
	eval 'sub _mm512_mask_fnmadd_round_ps {
	    my($A, $U, $B, $C, $R) = @_;
    	    eval q(( &__m512) &__builtin_ia32_vfnmaddps512_mask(-($A), $B, $C, $U, $R));
	}' unless defined(&_mm512_mask_fnmadd_round_ps);
	eval 'sub _mm512_mask3_fnmadd_round_ps {
	    my($A, $B, $C, $U, $R) = @_;
    	    eval q(( &__m512) &__builtin_ia32_vfmaddps512_mask3(-($A), $B, $C, $U, $R));
	}' unless defined(&_mm512_mask3_fnmadd_round_ps);
	eval 'sub _mm512_maskz_fnmadd_round_ps {
	    my($U, $A, $B, $C, $R) = @_;
    	    eval q(( &__m512) &__builtin_ia32_vfmaddps512_maskz(-($A), $B, $C, $U, $R));
	}' unless defined(&_mm512_maskz_fnmadd_round_ps);
	eval 'sub _mm512_fnmsub_round_pd {
	    my($A, $B, $C, $R) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_vfmaddpd512_mask(-($A), $B, -($C), -1, $R));
	}' unless defined(&_mm512_fnmsub_round_pd);
	eval 'sub _mm512_mask_fnmsub_round_pd {
	    my($A, $U, $B, $C, $R) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_vfnmsubpd512_mask($A, $B, $C, $U, $R));
	}' unless defined(&_mm512_mask_fnmsub_round_pd);
	eval 'sub _mm512_mask3_fnmsub_round_pd {
	    my($A, $B, $C, $U, $R) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_vfnmsubpd512_mask3($A, $B, $C, $U, $R));
	}' unless defined(&_mm512_mask3_fnmsub_round_pd);
	eval 'sub _mm512_maskz_fnmsub_round_pd {
	    my($U, $A, $B, $C, $R) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_vfmaddpd512_maskz(-($A), $B, -($C), $U, $R));
	}' unless defined(&_mm512_maskz_fnmsub_round_pd);
	eval 'sub _mm512_fnmsub_round_ps {
	    my($A, $B, $C, $R) = @_;
    	    eval q(( &__m512) &__builtin_ia32_vfmaddps512_mask(-($A), $B, -($C), -1, $R));
	}' unless defined(&_mm512_fnmsub_round_ps);
	eval 'sub _mm512_mask_fnmsub_round_ps {
	    my($A, $U, $B, $C, $R) = @_;
    	    eval q(( &__m512) &__builtin_ia32_vfnmsubps512_mask($A, $B, $C, $U, $R));
	}' unless defined(&_mm512_mask_fnmsub_round_ps);
	eval 'sub _mm512_mask3_fnmsub_round_ps {
	    my($A, $B, $C, $U, $R) = @_;
    	    eval q(( &__m512) &__builtin_ia32_vfnmsubps512_mask3($A, $B, $C, $U, $R));
	}' unless defined(&_mm512_mask3_fnmsub_round_ps);
	eval 'sub _mm512_maskz_fnmsub_round_ps {
	    my($U, $A, $B, $C, $R) = @_;
    	    eval q(( &__m512) &__builtin_ia32_vfmaddps512_maskz(-($A), $B, -($C), $U, $R));
	}' unless defined(&_mm512_maskz_fnmsub_round_ps);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_abs_epi64 ( &__m512i  &__A) { ( &__m512i)  &__builtin_ia32_pabsq512_mask (( &__v8di)  &__A, ( &__v8di)  &_mm512_undefined_epi32 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_abs_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m512i  &__A) { ( &__m512i)  &__builtin_ia32_pabsq512_mask (( &__v8di)  &__A, ( &__v8di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_abs_epi64 ( &__mmask8  &__U,  &__m512i  &__A) { ( &__m512i)  &__builtin_ia32_pabsq512_mask (( &__v8di)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_abs_epi32 ( &__m512i  &__A) { ( &__m512i)  &__builtin_ia32_pabsd512_mask (( &__v16si)  &__A, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_abs_epi32 ( &__m512i  &__W,  &__mmask16  &__U,  &__m512i  &__A) { ( &__m512i)  &__builtin_ia32_pabsd512_mask (( &__v16si)  &__A, ( &__v16si)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_abs_epi32 ( &__mmask16  &__U,  &__m512i  &__A) { ( &__m512i)  &__builtin_ia32_pabsd512_mask (( &__v16si)  &__A, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_broadcastss_ps ( &__m128  &__A) { ( &__m512)  &__builtin_ia32_broadcastss512 (( &__v4sf)  &__A, ( &__v16sf)  &_mm512_undefined_ps (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_broadcastss_ps ( &__m512  &__O,  &__mmask16  &__M,  &__m128  &__A) { ( &__m512)  &__builtin_ia32_broadcastss512 (( &__v4sf)  &__A, ( &__v16sf)  &__O,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_broadcastss_ps ( &__mmask16  &__M,  &__m128  &__A) { ( &__m512)  &__builtin_ia32_broadcastss512 (( &__v4sf)  &__A, ( &__v16sf)  &_mm512_setzero_ps (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_broadcastsd_pd ( &__m128d  &__A) { ( &__m512d)  &__builtin_ia32_broadcastsd512 (( &__v2df)  &__A, ( &__v8df)  &_mm512_undefined_pd (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_broadcastsd_pd ( &__m512d  &__O,  &__mmask8  &__M,  &__m128d  &__A) { ( &__m512d)  &__builtin_ia32_broadcastsd512 (( &__v2df)  &__A, ( &__v8df)  &__O,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_broadcastsd_pd ( &__mmask8  &__M,  &__m128d  &__A) { ( &__m512d)  &__builtin_ia32_broadcastsd512 (( &__v2df)  &__A, ( &__v8df)  &_mm512_setzero_pd (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_broadcastd_epi32 ( &__m128i  &__A) { ( &__m512i)  &__builtin_ia32_pbroadcastd512 (( &__v4si)  &__A, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_broadcastd_epi32 ( &__m512i  &__O,  &__mmask16  &__M,  &__m128i  &__A) { ( &__m512i)  &__builtin_ia32_pbroadcastd512 (( &__v4si)  &__A, ( &__v16si)  &__O,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_broadcastd_epi32 ( &__mmask16  &__M,  &__m128i  &__A) { ( &__m512i)  &__builtin_ia32_pbroadcastd512 (( &__v4si)  &__A, ( &__v16si)  &_mm512_setzero_si512 (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_set1_epi32 (\'int\'  &__A) { ( &__m512i)  &__builtin_ia32_pbroadcastd512_gpr_mask ( &__A, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16)(-1)); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_set1_epi32 ( &__m512i  &__O,  &__mmask16  &__M, \'int\'  &__A) { ( &__m512i)  &__builtin_ia32_pbroadcastd512_gpr_mask ( &__A, ( &__v16si)  &__O,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_set1_epi32 ( &__mmask16  &__M, \'int\'  &__A) { ( &__m512i)  &__builtin_ia32_pbroadcastd512_gpr_mask ( &__A, ( &__v16si)  &_mm512_setzero_si512 (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_broadcastq_epi64 ( &__m128i  &__A) { ( &__m512i)  &__builtin_ia32_pbroadcastq512 (( &__v2di)  &__A, ( &__v8di)  &_mm512_undefined_epi32 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_broadcastq_epi64 ( &__m512i  &__O,  &__mmask8  &__M,  &__m128i  &__A) { ( &__m512i)  &__builtin_ia32_pbroadcastq512 (( &__v2di)  &__A, ( &__v8di)  &__O,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_broadcastq_epi64 ( &__mmask8  &__M,  &__m128i  &__A) { ( &__m512i)  &__builtin_ia32_pbroadcastq512 (( &__v2di)  &__A, ( &__v8di)  &_mm512_setzero_si512 (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_set1_epi64  { ( &__m512i)  &__builtin_ia32_pbroadcastq512_gpr_mask ( &__A, ( &__v8di)  &_mm512_undefined_epi32 (), ( &__mmask8)(-1)); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_set1_epi64 ( &__m512i  &__O,  &__mmask8  &__M, my $__A) { ( &__m512i)  &__builtin_ia32_pbroadcastq512_gpr_mask ( $__A, ( &__v8di)  &__O,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_set1_epi64 ( &__mmask8  &__M, my $__A) { ( &__m512i)  &__builtin_ia32_pbroadcastq512_gpr_mask ( $__A, ( &__v8di)  &_mm512_setzero_si512 (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_broadcast_f32x4 ( &__m128  &__A) { ( &__m512)  &__builtin_ia32_broadcastf32x4_512 (( &__v4sf)  &__A, ( &__v16sf)  &_mm512_undefined_ps (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_broadcast_f32x4 ( &__m512  &__O,  &__mmask16  &__M,  &__m128  &__A) { ( &__m512)  &__builtin_ia32_broadcastf32x4_512 (( &__v4sf)  &__A, ( &__v16sf)  &__O,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_broadcast_f32x4 ( &__mmask16  &__M,  &__m128  &__A) { ( &__m512)  &__builtin_ia32_broadcastf32x4_512 (( &__v4sf)  &__A, ( &__v16sf)  &_mm512_setzero_ps (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_broadcast_i32x4 ( &__m128i  &__A) { ( &__m512i)  &__builtin_ia32_broadcasti32x4_512 (( &__v4si)  &__A, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_broadcast_i32x4 ( &__m512i  &__O,  &__mmask16  &__M,  &__m128i  &__A) { ( &__m512i)  &__builtin_ia32_broadcasti32x4_512 (( &__v4si)  &__A, ( &__v16si)  &__O,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_broadcast_i32x4 ( &__mmask16  &__M,  &__m128i  &__A) { ( &__m512i)  &__builtin_ia32_broadcasti32x4_512 (( &__v4si)  &__A, ( &__v16si)  &_mm512_setzero_si512 (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_broadcast_f64x4 ( &__m256d  &__A) { ( &__m512d)  &__builtin_ia32_broadcastf64x4_512 (( &__v4df)  &__A, ( &__v8df)  &_mm512_undefined_pd (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_broadcast_f64x4 ( &__m512d  &__O,  &__mmask8  &__M,  &__m256d  &__A) { ( &__m512d)  &__builtin_ia32_broadcastf64x4_512 (( &__v4df)  &__A, ( &__v8df)  &__O,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_broadcast_f64x4 ( &__mmask8  &__M,  &__m256d  &__A) { ( &__m512d)  &__builtin_ia32_broadcastf64x4_512 (( &__v4df)  &__A, ( &__v8df)  &_mm512_setzero_pd (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_broadcast_i64x4 ( &__m256i  &__A) { ( &__m512i)  &__builtin_ia32_broadcasti64x4_512 (( &__v4di)  &__A, ( &__v8di)  &_mm512_undefined_epi32 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_broadcast_i64x4 ( &__m512i  &__O,  &__mmask8  &__M,  &__m256i  &__A) { ( &__m512i)  &__builtin_ia32_broadcasti64x4_512 (( &__v4di)  &__A, ( &__v8di)  &__O,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_broadcast_i64x4 ( &__mmask8  &__M,  &__m256i  &__A) { ( &__m512i)  &__builtin_ia32_broadcasti64x4_512 (( &__v4di)  &__A, ( &__v8di)  &_mm512_setzero_si512 (),  &__M); });
    }' unless defined(&__attribute__);
    eval("sub _MM_PERM_AAAA () { 0x00; }") unless defined(&_MM_PERM_AAAA);
    eval("sub _MM_PERM_AAAB () { 0x01; }") unless defined(&_MM_PERM_AAAB);
    eval("sub _MM_PERM_AAAC () { 0x02; }") unless defined(&_MM_PERM_AAAC);
    eval("sub _MM_PERM_AAAD () { 0x03; }") unless defined(&_MM_PERM_AAAD);
    eval("sub _MM_PERM_AABA () { 0x04; }") unless defined(&_MM_PERM_AABA);
    eval("sub _MM_PERM_AABB () { 0x05; }") unless defined(&_MM_PERM_AABB);
    eval("sub _MM_PERM_AABC () { 0x06; }") unless defined(&_MM_PERM_AABC);
    eval("sub _MM_PERM_AABD () { 0x07; }") unless defined(&_MM_PERM_AABD);
    eval("sub _MM_PERM_AACA () { 0x08; }") unless defined(&_MM_PERM_AACA);
    eval("sub _MM_PERM_AACB () { 0x09; }") unless defined(&_MM_PERM_AACB);
    eval("sub _MM_PERM_AACC () { 0x0A; }") unless defined(&_MM_PERM_AACC);
    eval("sub _MM_PERM_AACD () { 0x0B; }") unless defined(&_MM_PERM_AACD);
    eval("sub _MM_PERM_AADA () { 0x0C; }") unless defined(&_MM_PERM_AADA);
    eval("sub _MM_PERM_AADB () { 0x0D; }") unless defined(&_MM_PERM_AADB);
    eval("sub _MM_PERM_AADC () { 0x0E; }") unless defined(&_MM_PERM_AADC);
    eval("sub _MM_PERM_AADD () { 0x0F; }") unless defined(&_MM_PERM_AADD);
    eval("sub _MM_PERM_ABAA () { 0x10; }") unless defined(&_MM_PERM_ABAA);
    eval("sub _MM_PERM_ABAB () { 0x11; }") unless defined(&_MM_PERM_ABAB);
    eval("sub _MM_PERM_ABAC () { 0x12; }") unless defined(&_MM_PERM_ABAC);
    eval("sub _MM_PERM_ABAD () { 0x13; }") unless defined(&_MM_PERM_ABAD);
    eval("sub _MM_PERM_ABBA () { 0x14; }") unless defined(&_MM_PERM_ABBA);
    eval("sub _MM_PERM_ABBB () { 0x15; }") unless defined(&_MM_PERM_ABBB);
    eval("sub _MM_PERM_ABBC () { 0x16; }") unless defined(&_MM_PERM_ABBC);
    eval("sub _MM_PERM_ABBD () { 0x17; }") unless defined(&_MM_PERM_ABBD);
    eval("sub _MM_PERM_ABCA () { 0x18; }") unless defined(&_MM_PERM_ABCA);
    eval("sub _MM_PERM_ABCB () { 0x19; }") unless defined(&_MM_PERM_ABCB);
    eval("sub _MM_PERM_ABCC () { 0x1A; }") unless defined(&_MM_PERM_ABCC);
    eval("sub _MM_PERM_ABCD () { 0x1B; }") unless defined(&_MM_PERM_ABCD);
    eval("sub _MM_PERM_ABDA () { 0x1C; }") unless defined(&_MM_PERM_ABDA);
    eval("sub _MM_PERM_ABDB () { 0x1D; }") unless defined(&_MM_PERM_ABDB);
    eval("sub _MM_PERM_ABDC () { 0x1E; }") unless defined(&_MM_PERM_ABDC);
    eval("sub _MM_PERM_ABDD () { 0x1F; }") unless defined(&_MM_PERM_ABDD);
    eval("sub _MM_PERM_ACAA () { 0x20; }") unless defined(&_MM_PERM_ACAA);
    eval("sub _MM_PERM_ACAB () { 0x21; }") unless defined(&_MM_PERM_ACAB);
    eval("sub _MM_PERM_ACAC () { 0x22; }") unless defined(&_MM_PERM_ACAC);
    eval("sub _MM_PERM_ACAD () { 0x23; }") unless defined(&_MM_PERM_ACAD);
    eval("sub _MM_PERM_ACBA () { 0x24; }") unless defined(&_MM_PERM_ACBA);
    eval("sub _MM_PERM_ACBB () { 0x25; }") unless defined(&_MM_PERM_ACBB);
    eval("sub _MM_PERM_ACBC () { 0x26; }") unless defined(&_MM_PERM_ACBC);
    eval("sub _MM_PERM_ACBD () { 0x27; }") unless defined(&_MM_PERM_ACBD);
    eval("sub _MM_PERM_ACCA () { 0x28; }") unless defined(&_MM_PERM_ACCA);
    eval("sub _MM_PERM_ACCB () { 0x29; }") unless defined(&_MM_PERM_ACCB);
    eval("sub _MM_PERM_ACCC () { 0x2A; }") unless defined(&_MM_PERM_ACCC);
    eval("sub _MM_PERM_ACCD () { 0x2B; }") unless defined(&_MM_PERM_ACCD);
    eval("sub _MM_PERM_ACDA () { 0x2C; }") unless defined(&_MM_PERM_ACDA);
    eval("sub _MM_PERM_ACDB () { 0x2D; }") unless defined(&_MM_PERM_ACDB);
    eval("sub _MM_PERM_ACDC () { 0x2E; }") unless defined(&_MM_PERM_ACDC);
    eval("sub _MM_PERM_ACDD () { 0x2F; }") unless defined(&_MM_PERM_ACDD);
    eval("sub _MM_PERM_ADAA () { 0x30; }") unless defined(&_MM_PERM_ADAA);
    eval("sub _MM_PERM_ADAB () { 0x31; }") unless defined(&_MM_PERM_ADAB);
    eval("sub _MM_PERM_ADAC () { 0x32; }") unless defined(&_MM_PERM_ADAC);
    eval("sub _MM_PERM_ADAD () { 0x33; }") unless defined(&_MM_PERM_ADAD);
    eval("sub _MM_PERM_ADBA () { 0x34; }") unless defined(&_MM_PERM_ADBA);
    eval("sub _MM_PERM_ADBB () { 0x35; }") unless defined(&_MM_PERM_ADBB);
    eval("sub _MM_PERM_ADBC () { 0x36; }") unless defined(&_MM_PERM_ADBC);
    eval("sub _MM_PERM_ADBD () { 0x37; }") unless defined(&_MM_PERM_ADBD);
    eval("sub _MM_PERM_ADCA () { 0x38; }") unless defined(&_MM_PERM_ADCA);
    eval("sub _MM_PERM_ADCB () { 0x39; }") unless defined(&_MM_PERM_ADCB);
    eval("sub _MM_PERM_ADCC () { 0x3A; }") unless defined(&_MM_PERM_ADCC);
    eval("sub _MM_PERM_ADCD () { 0x3B; }") unless defined(&_MM_PERM_ADCD);
    eval("sub _MM_PERM_ADDA () { 0x3C; }") unless defined(&_MM_PERM_ADDA);
    eval("sub _MM_PERM_ADDB () { 0x3D; }") unless defined(&_MM_PERM_ADDB);
    eval("sub _MM_PERM_ADDC () { 0x3E; }") unless defined(&_MM_PERM_ADDC);
    eval("sub _MM_PERM_ADDD () { 0x3F; }") unless defined(&_MM_PERM_ADDD);
    eval("sub _MM_PERM_BAAA () { 0x40; }") unless defined(&_MM_PERM_BAAA);
    eval("sub _MM_PERM_BAAB () { 0x41; }") unless defined(&_MM_PERM_BAAB);
    eval("sub _MM_PERM_BAAC () { 0x42; }") unless defined(&_MM_PERM_BAAC);
    eval("sub _MM_PERM_BAAD () { 0x43; }") unless defined(&_MM_PERM_BAAD);
    eval("sub _MM_PERM_BABA () { 0x44; }") unless defined(&_MM_PERM_BABA);
    eval("sub _MM_PERM_BABB () { 0x45; }") unless defined(&_MM_PERM_BABB);
    eval("sub _MM_PERM_BABC () { 0x46; }") unless defined(&_MM_PERM_BABC);
    eval("sub _MM_PERM_BABD () { 0x47; }") unless defined(&_MM_PERM_BABD);
    eval("sub _MM_PERM_BACA () { 0x48; }") unless defined(&_MM_PERM_BACA);
    eval("sub _MM_PERM_BACB () { 0x49; }") unless defined(&_MM_PERM_BACB);
    eval("sub _MM_PERM_BACC () { 0x4A; }") unless defined(&_MM_PERM_BACC);
    eval("sub _MM_PERM_BACD () { 0x4B; }") unless defined(&_MM_PERM_BACD);
    eval("sub _MM_PERM_BADA () { 0x4C; }") unless defined(&_MM_PERM_BADA);
    eval("sub _MM_PERM_BADB () { 0x4D; }") unless defined(&_MM_PERM_BADB);
    eval("sub _MM_PERM_BADC () { 0x4E; }") unless defined(&_MM_PERM_BADC);
    eval("sub _MM_PERM_BADD () { 0x4F; }") unless defined(&_MM_PERM_BADD);
    eval("sub _MM_PERM_BBAA () { 0x50; }") unless defined(&_MM_PERM_BBAA);
    eval("sub _MM_PERM_BBAB () { 0x51; }") unless defined(&_MM_PERM_BBAB);
    eval("sub _MM_PERM_BBAC () { 0x52; }") unless defined(&_MM_PERM_BBAC);
    eval("sub _MM_PERM_BBAD () { 0x53; }") unless defined(&_MM_PERM_BBAD);
    eval("sub _MM_PERM_BBBA () { 0x54; }") unless defined(&_MM_PERM_BBBA);
    eval("sub _MM_PERM_BBBB () { 0x55; }") unless defined(&_MM_PERM_BBBB);
    eval("sub _MM_PERM_BBBC () { 0x56; }") unless defined(&_MM_PERM_BBBC);
    eval("sub _MM_PERM_BBBD () { 0x57; }") unless defined(&_MM_PERM_BBBD);
    eval("sub _MM_PERM_BBCA () { 0x58; }") unless defined(&_MM_PERM_BBCA);
    eval("sub _MM_PERM_BBCB () { 0x59; }") unless defined(&_MM_PERM_BBCB);
    eval("sub _MM_PERM_BBCC () { 0x5A; }") unless defined(&_MM_PERM_BBCC);
    eval("sub _MM_PERM_BBCD () { 0x5B; }") unless defined(&_MM_PERM_BBCD);
    eval("sub _MM_PERM_BBDA () { 0x5C; }") unless defined(&_MM_PERM_BBDA);
    eval("sub _MM_PERM_BBDB () { 0x5D; }") unless defined(&_MM_PERM_BBDB);
    eval("sub _MM_PERM_BBDC () { 0x5E; }") unless defined(&_MM_PERM_BBDC);
    eval("sub _MM_PERM_BBDD () { 0x5F; }") unless defined(&_MM_PERM_BBDD);
    eval("sub _MM_PERM_BCAA () { 0x60; }") unless defined(&_MM_PERM_BCAA);
    eval("sub _MM_PERM_BCAB () { 0x61; }") unless defined(&_MM_PERM_BCAB);
    eval("sub _MM_PERM_BCAC () { 0x62; }") unless defined(&_MM_PERM_BCAC);
    eval("sub _MM_PERM_BCAD () { 0x63; }") unless defined(&_MM_PERM_BCAD);
    eval("sub _MM_PERM_BCBA () { 0x64; }") unless defined(&_MM_PERM_BCBA);
    eval("sub _MM_PERM_BCBB () { 0x65; }") unless defined(&_MM_PERM_BCBB);
    eval("sub _MM_PERM_BCBC () { 0x66; }") unless defined(&_MM_PERM_BCBC);
    eval("sub _MM_PERM_BCBD () { 0x67; }") unless defined(&_MM_PERM_BCBD);
    eval("sub _MM_PERM_BCCA () { 0x68; }") unless defined(&_MM_PERM_BCCA);
    eval("sub _MM_PERM_BCCB () { 0x69; }") unless defined(&_MM_PERM_BCCB);
    eval("sub _MM_PERM_BCCC () { 0x6A; }") unless defined(&_MM_PERM_BCCC);
    eval("sub _MM_PERM_BCCD () { 0x6B; }") unless defined(&_MM_PERM_BCCD);
    eval("sub _MM_PERM_BCDA () { 0x6C; }") unless defined(&_MM_PERM_BCDA);
    eval("sub _MM_PERM_BCDB () { 0x6D; }") unless defined(&_MM_PERM_BCDB);
    eval("sub _MM_PERM_BCDC () { 0x6E; }") unless defined(&_MM_PERM_BCDC);
    eval("sub _MM_PERM_BCDD () { 0x6F; }") unless defined(&_MM_PERM_BCDD);
    eval("sub _MM_PERM_BDAA () { 0x70; }") unless defined(&_MM_PERM_BDAA);
    eval("sub _MM_PERM_BDAB () { 0x71; }") unless defined(&_MM_PERM_BDAB);
    eval("sub _MM_PERM_BDAC () { 0x72; }") unless defined(&_MM_PERM_BDAC);
    eval("sub _MM_PERM_BDAD () { 0x73; }") unless defined(&_MM_PERM_BDAD);
    eval("sub _MM_PERM_BDBA () { 0x74; }") unless defined(&_MM_PERM_BDBA);
    eval("sub _MM_PERM_BDBB () { 0x75; }") unless defined(&_MM_PERM_BDBB);
    eval("sub _MM_PERM_BDBC () { 0x76; }") unless defined(&_MM_PERM_BDBC);
    eval("sub _MM_PERM_BDBD () { 0x77; }") unless defined(&_MM_PERM_BDBD);
    eval("sub _MM_PERM_BDCA () { 0x78; }") unless defined(&_MM_PERM_BDCA);
    eval("sub _MM_PERM_BDCB () { 0x79; }") unless defined(&_MM_PERM_BDCB);
    eval("sub _MM_PERM_BDCC () { 0x7A; }") unless defined(&_MM_PERM_BDCC);
    eval("sub _MM_PERM_BDCD () { 0x7B; }") unless defined(&_MM_PERM_BDCD);
    eval("sub _MM_PERM_BDDA () { 0x7C; }") unless defined(&_MM_PERM_BDDA);
    eval("sub _MM_PERM_BDDB () { 0x7D; }") unless defined(&_MM_PERM_BDDB);
    eval("sub _MM_PERM_BDDC () { 0x7E; }") unless defined(&_MM_PERM_BDDC);
    eval("sub _MM_PERM_BDDD () { 0x7F; }") unless defined(&_MM_PERM_BDDD);
    eval("sub _MM_PERM_CAAA () { 0x80; }") unless defined(&_MM_PERM_CAAA);
    eval("sub _MM_PERM_CAAB () { 0x81; }") unless defined(&_MM_PERM_CAAB);
    eval("sub _MM_PERM_CAAC () { 0x82; }") unless defined(&_MM_PERM_CAAC);
    eval("sub _MM_PERM_CAAD () { 0x83; }") unless defined(&_MM_PERM_CAAD);
    eval("sub _MM_PERM_CABA () { 0x84; }") unless defined(&_MM_PERM_CABA);
    eval("sub _MM_PERM_CABB () { 0x85; }") unless defined(&_MM_PERM_CABB);
    eval("sub _MM_PERM_CABC () { 0x86; }") unless defined(&_MM_PERM_CABC);
    eval("sub _MM_PERM_CABD () { 0x87; }") unless defined(&_MM_PERM_CABD);
    eval("sub _MM_PERM_CACA () { 0x88; }") unless defined(&_MM_PERM_CACA);
    eval("sub _MM_PERM_CACB () { 0x89; }") unless defined(&_MM_PERM_CACB);
    eval("sub _MM_PERM_CACC () { 0x8A; }") unless defined(&_MM_PERM_CACC);
    eval("sub _MM_PERM_CACD () { 0x8B; }") unless defined(&_MM_PERM_CACD);
    eval("sub _MM_PERM_CADA () { 0x8C; }") unless defined(&_MM_PERM_CADA);
    eval("sub _MM_PERM_CADB () { 0x8D; }") unless defined(&_MM_PERM_CADB);
    eval("sub _MM_PERM_CADC () { 0x8E; }") unless defined(&_MM_PERM_CADC);
    eval("sub _MM_PERM_CADD () { 0x8F; }") unless defined(&_MM_PERM_CADD);
    eval("sub _MM_PERM_CBAA () { 0x90; }") unless defined(&_MM_PERM_CBAA);
    eval("sub _MM_PERM_CBAB () { 0x91; }") unless defined(&_MM_PERM_CBAB);
    eval("sub _MM_PERM_CBAC () { 0x92; }") unless defined(&_MM_PERM_CBAC);
    eval("sub _MM_PERM_CBAD () { 0x93; }") unless defined(&_MM_PERM_CBAD);
    eval("sub _MM_PERM_CBBA () { 0x94; }") unless defined(&_MM_PERM_CBBA);
    eval("sub _MM_PERM_CBBB () { 0x95; }") unless defined(&_MM_PERM_CBBB);
    eval("sub _MM_PERM_CBBC () { 0x96; }") unless defined(&_MM_PERM_CBBC);
    eval("sub _MM_PERM_CBBD () { 0x97; }") unless defined(&_MM_PERM_CBBD);
    eval("sub _MM_PERM_CBCA () { 0x98; }") unless defined(&_MM_PERM_CBCA);
    eval("sub _MM_PERM_CBCB () { 0x99; }") unless defined(&_MM_PERM_CBCB);
    eval("sub _MM_PERM_CBCC () { 0x9A; }") unless defined(&_MM_PERM_CBCC);
    eval("sub _MM_PERM_CBCD () { 0x9B; }") unless defined(&_MM_PERM_CBCD);
    eval("sub _MM_PERM_CBDA () { 0x9C; }") unless defined(&_MM_PERM_CBDA);
    eval("sub _MM_PERM_CBDB () { 0x9D; }") unless defined(&_MM_PERM_CBDB);
    eval("sub _MM_PERM_CBDC () { 0x9E; }") unless defined(&_MM_PERM_CBDC);
    eval("sub _MM_PERM_CBDD () { 0x9F; }") unless defined(&_MM_PERM_CBDD);
    eval("sub _MM_PERM_CCAA () { 0xA0; }") unless defined(&_MM_PERM_CCAA);
    eval("sub _MM_PERM_CCAB () { 0xA1; }") unless defined(&_MM_PERM_CCAB);
    eval("sub _MM_PERM_CCAC () { 0xA2; }") unless defined(&_MM_PERM_CCAC);
    eval("sub _MM_PERM_CCAD () { 0xA3; }") unless defined(&_MM_PERM_CCAD);
    eval("sub _MM_PERM_CCBA () { 0xA4; }") unless defined(&_MM_PERM_CCBA);
    eval("sub _MM_PERM_CCBB () { 0xA5; }") unless defined(&_MM_PERM_CCBB);
    eval("sub _MM_PERM_CCBC () { 0xA6; }") unless defined(&_MM_PERM_CCBC);
    eval("sub _MM_PERM_CCBD () { 0xA7; }") unless defined(&_MM_PERM_CCBD);
    eval("sub _MM_PERM_CCCA () { 0xA8; }") unless defined(&_MM_PERM_CCCA);
    eval("sub _MM_PERM_CCCB () { 0xA9; }") unless defined(&_MM_PERM_CCCB);
    eval("sub _MM_PERM_CCCC () { 0xAA; }") unless defined(&_MM_PERM_CCCC);
    eval("sub _MM_PERM_CCCD () { 0xAB; }") unless defined(&_MM_PERM_CCCD);
    eval("sub _MM_PERM_CCDA () { 0xAC; }") unless defined(&_MM_PERM_CCDA);
    eval("sub _MM_PERM_CCDB () { 0xAD; }") unless defined(&_MM_PERM_CCDB);
    eval("sub _MM_PERM_CCDC () { 0xAE; }") unless defined(&_MM_PERM_CCDC);
    eval("sub _MM_PERM_CCDD () { 0xAF; }") unless defined(&_MM_PERM_CCDD);
    eval("sub _MM_PERM_CDAA () { 0xB0; }") unless defined(&_MM_PERM_CDAA);
    eval("sub _MM_PERM_CDAB () { 0xB1; }") unless defined(&_MM_PERM_CDAB);
    eval("sub _MM_PERM_CDAC () { 0xB2; }") unless defined(&_MM_PERM_CDAC);
    eval("sub _MM_PERM_CDAD () { 0xB3; }") unless defined(&_MM_PERM_CDAD);
    eval("sub _MM_PERM_CDBA () { 0xB4; }") unless defined(&_MM_PERM_CDBA);
    eval("sub _MM_PERM_CDBB () { 0xB5; }") unless defined(&_MM_PERM_CDBB);
    eval("sub _MM_PERM_CDBC () { 0xB6; }") unless defined(&_MM_PERM_CDBC);
    eval("sub _MM_PERM_CDBD () { 0xB7; }") unless defined(&_MM_PERM_CDBD);
    eval("sub _MM_PERM_CDCA () { 0xB8; }") unless defined(&_MM_PERM_CDCA);
    eval("sub _MM_PERM_CDCB () { 0xB9; }") unless defined(&_MM_PERM_CDCB);
    eval("sub _MM_PERM_CDCC () { 0xBA; }") unless defined(&_MM_PERM_CDCC);
    eval("sub _MM_PERM_CDCD () { 0xBB; }") unless defined(&_MM_PERM_CDCD);
    eval("sub _MM_PERM_CDDA () { 0xBC; }") unless defined(&_MM_PERM_CDDA);
    eval("sub _MM_PERM_CDDB () { 0xBD; }") unless defined(&_MM_PERM_CDDB);
    eval("sub _MM_PERM_CDDC () { 0xBE; }") unless defined(&_MM_PERM_CDDC);
    eval("sub _MM_PERM_CDDD () { 0xBF; }") unless defined(&_MM_PERM_CDDD);
    eval("sub _MM_PERM_DAAA () { 0xC0; }") unless defined(&_MM_PERM_DAAA);
    eval("sub _MM_PERM_DAAB () { 0xC1; }") unless defined(&_MM_PERM_DAAB);
    eval("sub _MM_PERM_DAAC () { 0xC2; }") unless defined(&_MM_PERM_DAAC);
    eval("sub _MM_PERM_DAAD () { 0xC3; }") unless defined(&_MM_PERM_DAAD);
    eval("sub _MM_PERM_DABA () { 0xC4; }") unless defined(&_MM_PERM_DABA);
    eval("sub _MM_PERM_DABB () { 0xC5; }") unless defined(&_MM_PERM_DABB);
    eval("sub _MM_PERM_DABC () { 0xC6; }") unless defined(&_MM_PERM_DABC);
    eval("sub _MM_PERM_DABD () { 0xC7; }") unless defined(&_MM_PERM_DABD);
    eval("sub _MM_PERM_DACA () { 0xC8; }") unless defined(&_MM_PERM_DACA);
    eval("sub _MM_PERM_DACB () { 0xC9; }") unless defined(&_MM_PERM_DACB);
    eval("sub _MM_PERM_DACC () { 0xCA; }") unless defined(&_MM_PERM_DACC);
    eval("sub _MM_PERM_DACD () { 0xCB; }") unless defined(&_MM_PERM_DACD);
    eval("sub _MM_PERM_DADA () { 0xCC; }") unless defined(&_MM_PERM_DADA);
    eval("sub _MM_PERM_DADB () { 0xCD; }") unless defined(&_MM_PERM_DADB);
    eval("sub _MM_PERM_DADC () { 0xCE; }") unless defined(&_MM_PERM_DADC);
    eval("sub _MM_PERM_DADD () { 0xCF; }") unless defined(&_MM_PERM_DADD);
    eval("sub _MM_PERM_DBAA () { 0xD0; }") unless defined(&_MM_PERM_DBAA);
    eval("sub _MM_PERM_DBAB () { 0xD1; }") unless defined(&_MM_PERM_DBAB);
    eval("sub _MM_PERM_DBAC () { 0xD2; }") unless defined(&_MM_PERM_DBAC);
    eval("sub _MM_PERM_DBAD () { 0xD3; }") unless defined(&_MM_PERM_DBAD);
    eval("sub _MM_PERM_DBBA () { 0xD4; }") unless defined(&_MM_PERM_DBBA);
    eval("sub _MM_PERM_DBBB () { 0xD5; }") unless defined(&_MM_PERM_DBBB);
    eval("sub _MM_PERM_DBBC () { 0xD6; }") unless defined(&_MM_PERM_DBBC);
    eval("sub _MM_PERM_DBBD () { 0xD7; }") unless defined(&_MM_PERM_DBBD);
    eval("sub _MM_PERM_DBCA () { 0xD8; }") unless defined(&_MM_PERM_DBCA);
    eval("sub _MM_PERM_DBCB () { 0xD9; }") unless defined(&_MM_PERM_DBCB);
    eval("sub _MM_PERM_DBCC () { 0xDA; }") unless defined(&_MM_PERM_DBCC);
    eval("sub _MM_PERM_DBCD () { 0xDB; }") unless defined(&_MM_PERM_DBCD);
    eval("sub _MM_PERM_DBDA () { 0xDC; }") unless defined(&_MM_PERM_DBDA);
    eval("sub _MM_PERM_DBDB () { 0xDD; }") unless defined(&_MM_PERM_DBDB);
    eval("sub _MM_PERM_DBDC () { 0xDE; }") unless defined(&_MM_PERM_DBDC);
    eval("sub _MM_PERM_DBDD () { 0xDF; }") unless defined(&_MM_PERM_DBDD);
    eval("sub _MM_PERM_DCAA () { 0xE0; }") unless defined(&_MM_PERM_DCAA);
    eval("sub _MM_PERM_DCAB () { 0xE1; }") unless defined(&_MM_PERM_DCAB);
    eval("sub _MM_PERM_DCAC () { 0xE2; }") unless defined(&_MM_PERM_DCAC);
    eval("sub _MM_PERM_DCAD () { 0xE3; }") unless defined(&_MM_PERM_DCAD);
    eval("sub _MM_PERM_DCBA () { 0xE4; }") unless defined(&_MM_PERM_DCBA);
    eval("sub _MM_PERM_DCBB () { 0xE5; }") unless defined(&_MM_PERM_DCBB);
    eval("sub _MM_PERM_DCBC () { 0xE6; }") unless defined(&_MM_PERM_DCBC);
    eval("sub _MM_PERM_DCBD () { 0xE7; }") unless defined(&_MM_PERM_DCBD);
    eval("sub _MM_PERM_DCCA () { 0xE8; }") unless defined(&_MM_PERM_DCCA);
    eval("sub _MM_PERM_DCCB () { 0xE9; }") unless defined(&_MM_PERM_DCCB);
    eval("sub _MM_PERM_DCCC () { 0xEA; }") unless defined(&_MM_PERM_DCCC);
    eval("sub _MM_PERM_DCCD () { 0xEB; }") unless defined(&_MM_PERM_DCCD);
    eval("sub _MM_PERM_DCDA () { 0xEC; }") unless defined(&_MM_PERM_DCDA);
    eval("sub _MM_PERM_DCDB () { 0xED; }") unless defined(&_MM_PERM_DCDB);
    eval("sub _MM_PERM_DCDC () { 0xEE; }") unless defined(&_MM_PERM_DCDC);
    eval("sub _MM_PERM_DCDD () { 0xEF; }") unless defined(&_MM_PERM_DCDD);
    eval("sub _MM_PERM_DDAA () { 0xF0; }") unless defined(&_MM_PERM_DDAA);
    eval("sub _MM_PERM_DDAB () { 0xF1; }") unless defined(&_MM_PERM_DDAB);
    eval("sub _MM_PERM_DDAC () { 0xF2; }") unless defined(&_MM_PERM_DDAC);
    eval("sub _MM_PERM_DDAD () { 0xF3; }") unless defined(&_MM_PERM_DDAD);
    eval("sub _MM_PERM_DDBA () { 0xF4; }") unless defined(&_MM_PERM_DDBA);
    eval("sub _MM_PERM_DDBB () { 0xF5; }") unless defined(&_MM_PERM_DDBB);
    eval("sub _MM_PERM_DDBC () { 0xF6; }") unless defined(&_MM_PERM_DDBC);
    eval("sub _MM_PERM_DDBD () { 0xF7; }") unless defined(&_MM_PERM_DDBD);
    eval("sub _MM_PERM_DDCA () { 0xF8; }") unless defined(&_MM_PERM_DDCA);
    eval("sub _MM_PERM_DDCB () { 0xF9; }") unless defined(&_MM_PERM_DDCB);
    eval("sub _MM_PERM_DDCC () { 0xFA; }") unless defined(&_MM_PERM_DDCC);
    eval("sub _MM_PERM_DDCD () { 0xFB; }") unless defined(&_MM_PERM_DDCD);
    eval("sub _MM_PERM_DDDA () { 0xFC; }") unless defined(&_MM_PERM_DDDA);
    eval("sub _MM_PERM_DDDB () { 0xFD; }") unless defined(&_MM_PERM_DDDB);
    eval("sub _MM_PERM_DDDC () { 0xFE; }") unless defined(&_MM_PERM_DDDC);
    eval("sub _MM_PERM_DDDD () { 0xFF; }") unless defined(&_MM_PERM_DDDD);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_shuffle_epi32 ( &__m512i  &__A,  &_MM_PERM_ENUM  &__mask) { ( &__m512i)  &__builtin_ia32_pshufd512_mask (( &__v16si)  &__A,  &__mask, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_shuffle_epi32 ( &__m512i  &__W,  &__mmask16  &__U,  &__m512i  &__A,  &_MM_PERM_ENUM  &__mask) { ( &__m512i)  &__builtin_ia32_pshufd512_mask (( &__v16si)  &__A,  &__mask, ( &__v16si)  &__W, ( &__mmask16)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_shuffle_epi32 ( &__mmask16  &__U,  &__m512i  &__A,  &_MM_PERM_ENUM  &__mask) { ( &__m512i)  &__builtin_ia32_pshufd512_mask (( &__v16si)  &__A,  &__mask, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_shuffle_i64x2 ( &__m512i  &__A,  &__m512i  &__B,  &const \'int\'  &__imm) { ( &__m512i)  &__builtin_ia32_shuf_i64x2_mask (( &__v8di)  &__A, ( &__v8di)  &__B,  &__imm, ( &__v8di)  &_mm512_undefined_epi32 (), ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_shuffle_i64x2 ( &__m512i  &__W,  &__mmask8  &__U,  &__m512i  &__A,  &__m512i  &__B,  &const \'int\'  &__imm) { ( &__m512i)  &__builtin_ia32_shuf_i64x2_mask (( &__v8di)  &__A, ( &__v8di)  &__B,  &__imm, ( &__v8di)  &__W, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_shuffle_i64x2 ( &__mmask8  &__U,  &__m512i  &__A,  &__m512i  &__B,  &const \'int\'  &__imm) { ( &__m512i)  &__builtin_ia32_shuf_i64x2_mask (( &__v8di)  &__A, ( &__v8di)  &__B,  &__imm, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_shuffle_i32x4 ( &__m512i  &__A,  &__m512i  &__B,  &const \'int\'  &__imm) { ( &__m512i)  &__builtin_ia32_shuf_i32x4_mask (( &__v16si)  &__A, ( &__v16si)  &__B,  &__imm, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_shuffle_i32x4 ( &__m512i  &__W,  &__mmask16  &__U,  &__m512i  &__A,  &__m512i  &__B,  &const \'int\'  &__imm) { ( &__m512i)  &__builtin_ia32_shuf_i32x4_mask (( &__v16si)  &__A, ( &__v16si)  &__B,  &__imm, ( &__v16si)  &__W, ( &__mmask16)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_shuffle_i32x4 ( &__mmask16  &__U,  &__m512i  &__A,  &__m512i  &__B,  &const \'int\'  &__imm) { ( &__m512i)  &__builtin_ia32_shuf_i32x4_mask (( &__v16si)  &__A, ( &__v16si)  &__B,  &__imm, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_shuffle_f64x2 ( &__m512d  &__A,  &__m512d  &__B,  &const \'int\'  &__imm) { ( &__m512d)  &__builtin_ia32_shuf_f64x2_mask (( &__v8df)  &__A, ( &__v8df)  &__B,  &__imm, ( &__v8df)  &_mm512_undefined_pd (), ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_shuffle_f64x2 ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B,  &const \'int\'  &__imm) { ( &__m512d)  &__builtin_ia32_shuf_f64x2_mask (( &__v8df)  &__A, ( &__v8df)  &__B,  &__imm, ( &__v8df)  &__W, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_shuffle_f64x2 ( &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B,  &const \'int\'  &__imm) { ( &__m512d)  &__builtin_ia32_shuf_f64x2_mask (( &__v8df)  &__A, ( &__v8df)  &__B,  &__imm, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_shuffle_f32x4 ( &__m512  &__A,  &__m512  &__B,  &const \'int\'  &__imm) { ( &__m512)  &__builtin_ia32_shuf_f32x4_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B,  &__imm, ( &__v16sf)  &_mm512_undefined_ps (), ( &__mmask16) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_shuffle_f32x4 ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B,  &const \'int\'  &__imm) { ( &__m512)  &__builtin_ia32_shuf_f32x4_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B,  &__imm, ( &__v16sf)  &__W, ( &__mmask16)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_shuffle_f32x4 ( &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B,  &const \'int\'  &__imm) { ( &__m512)  &__builtin_ia32_shuf_f32x4_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B,  &__imm, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm512_shuffle_epi32 {
	    my($X, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_pshufd512_mask (( &__v16si)( &__m512i), ($C), ( &__v16si)( &__m512i) &_mm512_undefined_epi32 (), ( &__mmask16)-1)));
	}' unless defined(&_mm512_shuffle_epi32);
	eval 'sub _mm512_mask_shuffle_epi32 {
	    my($W, $U, $X, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_pshufd512_mask (( &__v16si)( &__m512i), ($C), ( &__v16si)( &__m512i)($W), ( &__mmask16)($U))));
	}' unless defined(&_mm512_mask_shuffle_epi32);
	eval 'sub _mm512_maskz_shuffle_epi32 {
	    my($U, $X, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_pshufd512_mask (( &__v16si)( &__m512i), ($C), ( &__v16si)( &__m512i) &_mm512_setzero_si512 (), ( &__mmask16)($U))));
	}' unless defined(&_mm512_maskz_shuffle_epi32);
	eval 'sub _mm512_shuffle_i64x2 {
	    my($X, $Y, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_shuf_i64x2_mask (( &__v8di)( &__m512i)($X), ( &__v8di)( &__m512i), ($C), ( &__v8di)( &__m512i) &_mm512_undefined_epi32 (), ( &__mmask8)-1)));
	}' unless defined(&_mm512_shuffle_i64x2);
	eval 'sub _mm512_mask_shuffle_i64x2 {
	    my($W, $U, $X, $Y, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_shuf_i64x2_mask (( &__v8di)( &__m512i)($X), ( &__v8di)( &__m512i), ($C), ( &__v8di)( &__m512i)($W), ( &__mmask8)($U))));
	}' unless defined(&_mm512_mask_shuffle_i64x2);
	eval 'sub _mm512_maskz_shuffle_i64x2 {
	    my($U, $X, $Y, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_shuf_i64x2_mask (( &__v8di)( &__m512i)($X), ( &__v8di)( &__m512i), ($C), ( &__v8di)( &__m512i) &_mm512_setzero_si512 (), ( &__mmask8)($U))));
	}' unless defined(&_mm512_maskz_shuffle_i64x2);
	eval 'sub _mm512_shuffle_i32x4 {
	    my($X, $Y, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_shuf_i32x4_mask (( &__v16si)( &__m512i)($X), ( &__v16si)( &__m512i), ($C), ( &__v16si)( &__m512i) &_mm512_undefined_epi32 (), ( &__mmask16)-1)));
	}' unless defined(&_mm512_shuffle_i32x4);
	eval 'sub _mm512_mask_shuffle_i32x4 {
	    my($W, $U, $X, $Y, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_shuf_i32x4_mask (( &__v16si)( &__m512i)($X), ( &__v16si)( &__m512i), ($C), ( &__v16si)( &__m512i)($W), ( &__mmask16)($U))));
	}' unless defined(&_mm512_mask_shuffle_i32x4);
	eval 'sub _mm512_maskz_shuffle_i32x4 {
	    my($U, $X, $Y, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_shuf_i32x4_mask (( &__v16si)( &__m512i)($X), ( &__v16si)( &__m512i), ($C), ( &__v16si)( &__m512i) &_mm512_setzero_si512 (), ( &__mmask16)($U))));
	}' unless defined(&_mm512_maskz_shuffle_i32x4);
	eval 'sub _mm512_shuffle_f64x2 {
	    my($X, $Y, $C) = @_;
    	    eval q((( &__m512d)  &__builtin_ia32_shuf_f64x2_mask (( &__v8df)( &__m512d)($X), ( &__v8df)( &__m512d), ($C), ( &__v8df)( &__m512d) &_mm512_undefined_pd(), ( &__mmask8)-1)));
	}' unless defined(&_mm512_shuffle_f64x2);
	eval 'sub _mm512_mask_shuffle_f64x2 {
	    my($W, $U, $X, $Y, $C) = @_;
    	    eval q((( &__m512d)  &__builtin_ia32_shuf_f64x2_mask (( &__v8df)( &__m512d)($X), ( &__v8df)( &__m512d), ($C), ( &__v8df)( &__m512d)($W), ( &__mmask8)($U))));
	}' unless defined(&_mm512_mask_shuffle_f64x2);
	eval 'sub _mm512_maskz_shuffle_f64x2 {
	    my($U, $X, $Y, $C) = @_;
    	    eval q((( &__m512d)  &__builtin_ia32_shuf_f64x2_mask (( &__v8df)( &__m512d)($X), ( &__v8df)( &__m512d), ($C), ( &__v8df)( &__m512d) &_mm512_setzero_pd(), ( &__mmask8)($U))));
	}' unless defined(&_mm512_maskz_shuffle_f64x2);
	eval 'sub _mm512_shuffle_f32x4 {
	    my($X, $Y, $C) = @_;
    	    eval q((( &__m512)  &__builtin_ia32_shuf_f32x4_mask (( &__v16sf)( &__m512)($X), ( &__v16sf)( &__m512), ($C), ( &__v16sf)( &__m512) &_mm512_undefined_ps(), ( &__mmask16)-1)));
	}' unless defined(&_mm512_shuffle_f32x4);
	eval 'sub _mm512_mask_shuffle_f32x4 {
	    my($W, $U, $X, $Y, $C) = @_;
    	    eval q((( &__m512)  &__builtin_ia32_shuf_f32x4_mask (( &__v16sf)( &__m512)($X), ( &__v16sf)( &__m512), ($C), ( &__v16sf)( &__m512)($W), ( &__mmask16)($U))));
	}' unless defined(&_mm512_mask_shuffle_f32x4);
	eval 'sub _mm512_maskz_shuffle_f32x4 {
	    my($U, $X, $Y, $C) = @_;
    	    eval q((( &__m512)  &__builtin_ia32_shuf_f32x4_mask (( &__v16sf)( &__m512)($X), ( &__v16sf)( &__m512), ($C), ( &__v16sf)( &__m512) &_mm512_setzero_ps(), ( &__mmask16)($U))));
	}' unless defined(&_mm512_maskz_shuffle_f32x4);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_rolv_epi32 ( &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_prolvd512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_rolv_epi32 ( &__m512i  &__W,  &__mmask16  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_prolvd512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_rolv_epi32 ( &__mmask16  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_prolvd512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_rorv_epi32 ( &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_prorvd512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_rorv_epi32 ( &__m512i  &__W,  &__mmask16  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_prorvd512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_rorv_epi32 ( &__mmask16  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_prorvd512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_rolv_epi64 ( &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_prolvq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &_mm512_undefined_epi32 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_rolv_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_prolvq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_rolv_epi64 ( &__mmask8  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_prolvq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_rorv_epi64 ( &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_prorvq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &_mm512_undefined_epi32 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_rorv_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_prorvq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_rorv_epi64 ( &__mmask8  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_prorvq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtt_roundpd_epi32 ( &__m512d  &__A,  &const \'int\'  &__R) { ( &__m256i)  &__builtin_ia32_cvttpd2dq512_mask (( &__v8df)  &__A, ( &__v8si)  &_mm256_undefined_si256 (), ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtt_roundpd_epi32 ( &__m256i  &__W,  &__mmask8  &__U,  &__m512d  &__A,  &const \'int\'  &__R) { ( &__m256i)  &__builtin_ia32_cvttpd2dq512_mask (( &__v8df)  &__A, ( &__v8si)  &__W, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtt_roundpd_epi32 ( &__mmask8  &__U,  &__m512d  &__A,  &const \'int\'  &__R) { ( &__m256i)  &__builtin_ia32_cvttpd2dq512_mask (( &__v8df)  &__A, ( &__v8si)  &_mm256_setzero_si256 (), ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtt_roundpd_epu32 ( &__m512d  &__A,  &const \'int\'  &__R) { ( &__m256i)  &__builtin_ia32_cvttpd2udq512_mask (( &__v8df)  &__A, ( &__v8si)  &_mm256_undefined_si256 (), ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtt_roundpd_epu32 ( &__m256i  &__W,  &__mmask8  &__U,  &__m512d  &__A,  &const \'int\'  &__R) { ( &__m256i)  &__builtin_ia32_cvttpd2udq512_mask (( &__v8df)  &__A, ( &__v8si)  &__W, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtt_roundpd_epu32 ( &__mmask8  &__U,  &__m512d  &__A,  &const \'int\'  &__R) { ( &__m256i)  &__builtin_ia32_cvttpd2udq512_mask (( &__v8df)  &__A, ( &__v8si)  &_mm256_setzero_si256 (), ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm512_cvtt_roundpd_epi32 {
	    my($A, $B) = @_;
    	    eval q((( &__m256i) &__builtin_ia32_cvttpd2dq512_mask($A, ( &__v8si) &_mm256_undefined_si256(), -1, $B)));
	}' unless defined(&_mm512_cvtt_roundpd_epi32);
	eval 'sub _mm512_mask_cvtt_roundpd_epi32 {
	    my($W, $U, $A, $B) = @_;
    	    eval q((( &__m256i) &__builtin_ia32_cvttpd2dq512_mask($A, ( &__v8si)($W), $U, $B)));
	}' unless defined(&_mm512_mask_cvtt_roundpd_epi32);
	eval 'sub _mm512_maskz_cvtt_roundpd_epi32 {
	    my($U, $A, $B) = @_;
    	    eval q((( &__m256i) &__builtin_ia32_cvttpd2dq512_mask($A, ( &__v8si) &_mm256_setzero_si256(), $U, $B)));
	}' unless defined(&_mm512_maskz_cvtt_roundpd_epi32);
	eval 'sub _mm512_cvtt_roundpd_epu32 {
	    my($A, $B) = @_;
    	    eval q((( &__m256i) &__builtin_ia32_cvttpd2udq512_mask($A, ( &__v8si) &_mm256_undefined_si256(), -1, $B)));
	}' unless defined(&_mm512_cvtt_roundpd_epu32);
	eval 'sub _mm512_mask_cvtt_roundpd_epu32 {
	    my($W, $U, $A, $B) = @_;
    	    eval q((( &__m256i) &__builtin_ia32_cvttpd2udq512_mask($A, ( &__v8si)($W), $U, $B)));
	}' unless defined(&_mm512_mask_cvtt_roundpd_epu32);
	eval 'sub _mm512_maskz_cvtt_roundpd_epu32 {
	    my($U, $A, $B) = @_;
    	    eval q((( &__m256i) &__builtin_ia32_cvttpd2udq512_mask($A, ( &__v8si) &_mm256_setzero_si256(), $U, $B)));
	}' unless defined(&_mm512_maskz_cvtt_roundpd_epu32);
    }
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvt_roundpd_epi32 ( &__m512d  &__A,  &const \'int\'  &__R) { ( &__m256i)  &__builtin_ia32_cvtpd2dq512_mask (( &__v8df)  &__A, ( &__v8si)  &_mm256_undefined_si256 (), ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvt_roundpd_epi32 ( &__m256i  &__W,  &__mmask8  &__U,  &__m512d  &__A,  &const \'int\'  &__R) { ( &__m256i)  &__builtin_ia32_cvtpd2dq512_mask (( &__v8df)  &__A, ( &__v8si)  &__W, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvt_roundpd_epi32 ( &__mmask8  &__U,  &__m512d  &__A,  &const \'int\'  &__R) { ( &__m256i)  &__builtin_ia32_cvtpd2dq512_mask (( &__v8df)  &__A, ( &__v8si)  &_mm256_setzero_si256 (), ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvt_roundpd_epu32 ( &__m512d  &__A,  &const \'int\'  &__R) { ( &__m256i)  &__builtin_ia32_cvtpd2udq512_mask (( &__v8df)  &__A, ( &__v8si)  &_mm256_undefined_si256 (), ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvt_roundpd_epu32 ( &__m256i  &__W,  &__mmask8  &__U,  &__m512d  &__A,  &const \'int\'  &__R) { ( &__m256i)  &__builtin_ia32_cvtpd2udq512_mask (( &__v8df)  &__A, ( &__v8si)  &__W, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvt_roundpd_epu32 ( &__mmask8  &__U,  &__m512d  &__A,  &const \'int\'  &__R) { ( &__m256i)  &__builtin_ia32_cvtpd2udq512_mask (( &__v8df)  &__A, ( &__v8si)  &_mm256_setzero_si256 (), ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm512_cvt_roundpd_epi32 {
	    my($A, $B) = @_;
    	    eval q((( &__m256i) &__builtin_ia32_cvtpd2dq512_mask($A, ( &__v8si) &_mm256_undefined_si256(), -1, $B)));
	}' unless defined(&_mm512_cvt_roundpd_epi32);
	eval 'sub _mm512_mask_cvt_roundpd_epi32 {
	    my($W, $U, $A, $B) = @_;
    	    eval q((( &__m256i) &__builtin_ia32_cvtpd2dq512_mask($A, ( &__v8si)($W), $U, $B)));
	}' unless defined(&_mm512_mask_cvt_roundpd_epi32);
	eval 'sub _mm512_maskz_cvt_roundpd_epi32 {
	    my($U, $A, $B) = @_;
    	    eval q((( &__m256i) &__builtin_ia32_cvtpd2dq512_mask($A, ( &__v8si) &_mm256_setzero_si256(), $U, $B)));
	}' unless defined(&_mm512_maskz_cvt_roundpd_epi32);
	eval 'sub _mm512_cvt_roundpd_epu32 {
	    my($A, $B) = @_;
    	    eval q((( &__m256i) &__builtin_ia32_cvtpd2udq512_mask($A, ( &__v8si) &_mm256_undefined_si256(), -1, $B)));
	}' unless defined(&_mm512_cvt_roundpd_epu32);
	eval 'sub _mm512_mask_cvt_roundpd_epu32 {
	    my($W, $U, $A, $B) = @_;
    	    eval q((( &__m256i) &__builtin_ia32_cvtpd2udq512_mask($A, ( &__v8si)($W), $U, $B)));
	}' unless defined(&_mm512_mask_cvt_roundpd_epu32);
	eval 'sub _mm512_maskz_cvt_roundpd_epu32 {
	    my($U, $A, $B) = @_;
    	    eval q((( &__m256i) &__builtin_ia32_cvtpd2udq512_mask($A, ( &__v8si) &_mm256_setzero_si256(), $U, $B)));
	}' unless defined(&_mm512_maskz_cvt_roundpd_epu32);
    }
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtt_roundps_epi32 ( &__m512  &__A,  &const \'int\'  &__R) { ( &__m512i)  &__builtin_ia32_cvttps2dq512_mask (( &__v16sf)  &__A, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtt_roundps_epi32 ( &__m512i  &__W,  &__mmask16  &__U,  &__m512  &__A,  &const \'int\'  &__R) { ( &__m512i)  &__builtin_ia32_cvttps2dq512_mask (( &__v16sf)  &__A, ( &__v16si)  &__W, ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtt_roundps_epi32 ( &__mmask16  &__U,  &__m512  &__A,  &const \'int\'  &__R) { ( &__m512i)  &__builtin_ia32_cvttps2dq512_mask (( &__v16sf)  &__A, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtt_roundps_epu32 ( &__m512  &__A,  &const \'int\'  &__R) { ( &__m512i)  &__builtin_ia32_cvttps2udq512_mask (( &__v16sf)  &__A, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtt_roundps_epu32 ( &__m512i  &__W,  &__mmask16  &__U,  &__m512  &__A,  &const \'int\'  &__R) { ( &__m512i)  &__builtin_ia32_cvttps2udq512_mask (( &__v16sf)  &__A, ( &__v16si)  &__W, ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtt_roundps_epu32 ( &__mmask16  &__U,  &__m512  &__A,  &const \'int\'  &__R) { ( &__m512i)  &__builtin_ia32_cvttps2udq512_mask (( &__v16sf)  &__A, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm512_cvtt_roundps_epi32 {
	    my($A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_cvttps2dq512_mask($A, ( &__v16si) &_mm512_undefined_epi32 (), -1, $B)));
	}' unless defined(&_mm512_cvtt_roundps_epi32);
	eval 'sub _mm512_mask_cvtt_roundps_epi32 {
	    my($W, $U, $A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_cvttps2dq512_mask($A, ( &__v16si)($W), $U, $B)));
	}' unless defined(&_mm512_mask_cvtt_roundps_epi32);
	eval 'sub _mm512_maskz_cvtt_roundps_epi32 {
	    my($U, $A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_cvttps2dq512_mask($A, ( &__v16si) &_mm512_setzero_si512 (), $U, $B)));
	}' unless defined(&_mm512_maskz_cvtt_roundps_epi32);
	eval 'sub _mm512_cvtt_roundps_epu32 {
	    my($A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_cvttps2udq512_mask($A, ( &__v16si) &_mm512_undefined_epi32 (), -1, $B)));
	}' unless defined(&_mm512_cvtt_roundps_epu32);
	eval 'sub _mm512_mask_cvtt_roundps_epu32 {
	    my($W, $U, $A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_cvttps2udq512_mask($A, ( &__v16si)($W), $U, $B)));
	}' unless defined(&_mm512_mask_cvtt_roundps_epu32);
	eval 'sub _mm512_maskz_cvtt_roundps_epu32 {
	    my($U, $A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_cvttps2udq512_mask($A, ( &__v16si) &_mm512_setzero_si512 (), $U, $B)));
	}' unless defined(&_mm512_maskz_cvtt_roundps_epu32);
    }
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvt_roundps_epi32 ( &__m512  &__A,  &const \'int\'  &__R) { ( &__m512i)  &__builtin_ia32_cvtps2dq512_mask (( &__v16sf)  &__A, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvt_roundps_epi32 ( &__m512i  &__W,  &__mmask16  &__U,  &__m512  &__A,  &const \'int\'  &__R) { ( &__m512i)  &__builtin_ia32_cvtps2dq512_mask (( &__v16sf)  &__A, ( &__v16si)  &__W, ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvt_roundps_epi32 ( &__mmask16  &__U,  &__m512  &__A,  &const \'int\'  &__R) { ( &__m512i)  &__builtin_ia32_cvtps2dq512_mask (( &__v16sf)  &__A, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvt_roundps_epu32 ( &__m512  &__A,  &const \'int\'  &__R) { ( &__m512i)  &__builtin_ia32_cvtps2udq512_mask (( &__v16sf)  &__A, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvt_roundps_epu32 ( &__m512i  &__W,  &__mmask16  &__U,  &__m512  &__A,  &const \'int\'  &__R) { ( &__m512i)  &__builtin_ia32_cvtps2udq512_mask (( &__v16sf)  &__A, ( &__v16si)  &__W, ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvt_roundps_epu32 ( &__mmask16  &__U,  &__m512  &__A,  &const \'int\'  &__R) { ( &__m512i)  &__builtin_ia32_cvtps2udq512_mask (( &__v16sf)  &__A, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm512_cvt_roundps_epi32 {
	    my($A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_cvtps2dq512_mask($A, ( &__v16si) &_mm512_undefined_epi32 (), -1, $B)));
	}' unless defined(&_mm512_cvt_roundps_epi32);
	eval 'sub _mm512_mask_cvt_roundps_epi32 {
	    my($W, $U, $A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_cvtps2dq512_mask($A, ( &__v16si)($W), $U, $B)));
	}' unless defined(&_mm512_mask_cvt_roundps_epi32);
	eval 'sub _mm512_maskz_cvt_roundps_epi32 {
	    my($U, $A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_cvtps2dq512_mask($A, ( &__v16si) &_mm512_setzero_si512 (), $U, $B)));
	}' unless defined(&_mm512_maskz_cvt_roundps_epi32);
	eval 'sub _mm512_cvt_roundps_epu32 {
	    my($A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_cvtps2udq512_mask($A, ( &__v16si) &_mm512_undefined_epi32 (), -1, $B)));
	}' unless defined(&_mm512_cvt_roundps_epu32);
	eval 'sub _mm512_mask_cvt_roundps_epu32 {
	    my($W, $U, $A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_cvtps2udq512_mask($A, ( &__v16si)($W), $U, $B)));
	}' unless defined(&_mm512_mask_cvt_roundps_epu32);
	eval 'sub _mm512_maskz_cvt_roundps_epu32 {
	    my($U, $A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_cvtps2udq512_mask($A, ( &__v16si) &_mm512_setzero_si512 (), $U, $B)));
	}' unless defined(&_mm512_maskz_cvt_roundps_epu32);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtu32_sd ( &__m128d  &__A, my $__B) { ( &__m128d)  &__builtin_ia32_cvtusi2sd32 (( &__v2df)  &__A,  $__B); });
    }' unless defined(&__attribute__);
    if(defined(&__x86_64__)) {
	if(defined(&__OPTIMIZE__)) {
	    eval 'sub __attribute__ () {
	        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvt_roundu64_sd ( &__m128d  &__A, my $__B,  &const \'int\'  &__R) { ( &__m128d)  &__builtin_ia32_cvtusi2sd64 (( &__v2df)  &__A,  $__B,  &__R); });
	    }' unless defined(&__attribute__);
	    eval 'sub __attribute__ () {
	        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvt_roundi64_sd ( &__m128d  &__A, my $__B,  &const \'int\'  &__R) { ( &__m128d)  &__builtin_ia32_cvtsi2sd64 (( &__v2df)  &__A,  $__B,  &__R); });
	    }' unless defined(&__attribute__);
	    eval 'sub __attribute__ () {
	        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvt_roundsi64_sd ( &__m128d  &__A, my $__B,  &const \'int\'  &__R) { ( &__m128d)  &__builtin_ia32_cvtsi2sd64 (( &__v2df)  &__A,  $__B,  &__R); });
	    }' unless defined(&__attribute__);
	} else {
	    eval 'sub _mm_cvt_roundu64_sd {
	        my($A, $B, $C) = @_;
    		eval q(( &__m128d) &__builtin_ia32_cvtusi2sd64($A, $B, $C));
	    }' unless defined(&_mm_cvt_roundu64_sd);
	    eval 'sub _mm_cvt_roundi64_sd {
	        my($A, $B, $C) = @_;
    		eval q(( &__m128d) &__builtin_ia32_cvtsi2sd64($A, $B, $C));
	    }' unless defined(&_mm_cvt_roundi64_sd);
	    eval 'sub _mm_cvt_roundsi64_sd {
	        my($A, $B, $C) = @_;
    		eval q(( &__m128d) &__builtin_ia32_cvtsi2sd64($A, $B, $C));
	    }' unless defined(&_mm_cvt_roundsi64_sd);
	}
    }
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvt_roundu32_ss ( &__m128  &__A, my $__B,  &const \'int\'  &__R) { ( &__m128)  &__builtin_ia32_cvtusi2ss32 (( &__v4sf)  &__A,  $__B,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvt_roundsi32_ss ( &__m128  &__A, \'int\'  &__B,  &const \'int\'  &__R) { ( &__m128)  &__builtin_ia32_cvtsi2ss32 (( &__v4sf)  &__A,  &__B,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvt_roundi32_ss ( &__m128  &__A, \'int\'  &__B,  &const \'int\'  &__R) { ( &__m128)  &__builtin_ia32_cvtsi2ss32 (( &__v4sf)  &__A,  &__B,  &__R); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm_cvt_roundu32_ss {
	    my($A, $B, $C) = @_;
    	    eval q(( &__m128) &__builtin_ia32_cvtusi2ss32($A, $B, $C));
	}' unless defined(&_mm_cvt_roundu32_ss);
	eval 'sub _mm_cvt_roundi32_ss {
	    my($A, $B, $C) = @_;
    	    eval q(( &__m128) &__builtin_ia32_cvtsi2ss32($A, $B, $C));
	}' unless defined(&_mm_cvt_roundi32_ss);
	eval 'sub _mm_cvt_roundsi32_ss {
	    my($A, $B, $C) = @_;
    	    eval q(( &__m128) &__builtin_ia32_cvtsi2ss32($A, $B, $C));
	}' unless defined(&_mm_cvt_roundsi32_ss);
    }
    if(defined(&__x86_64__)) {
	if(defined(&__OPTIMIZE__)) {
	    eval 'sub __attribute__ () {
	        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvt_roundu64_ss ( &__m128  &__A, my $__B,  &const \'int\'  &__R) { ( &__m128)  &__builtin_ia32_cvtusi2ss64 (( &__v4sf)  &__A,  $__B,  &__R); });
	    }' unless defined(&__attribute__);
	    eval 'sub __attribute__ () {
	        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvt_roundsi64_ss ( &__m128  &__A, my $__B,  &const \'int\'  &__R) { ( &__m128)  &__builtin_ia32_cvtsi2ss64 (( &__v4sf)  &__A,  $__B,  &__R); });
	    }' unless defined(&__attribute__);
	    eval 'sub __attribute__ () {
	        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvt_roundi64_ss ( &__m128  &__A, my $__B,  &const \'int\'  &__R) { ( &__m128)  &__builtin_ia32_cvtsi2ss64 (( &__v4sf)  &__A,  $__B,  &__R); });
	    }' unless defined(&__attribute__);
	} else {
	    eval 'sub _mm_cvt_roundu64_ss {
	        my($A, $B, $C) = @_;
    		eval q(( &__m128) &__builtin_ia32_cvtusi2ss64($A, $B, $C));
	    }' unless defined(&_mm_cvt_roundu64_ss);
	    eval 'sub _mm_cvt_roundi64_ss {
	        my($A, $B, $C) = @_;
    		eval q(( &__m128) &__builtin_ia32_cvtsi2ss64($A, $B, $C));
	    }' unless defined(&_mm_cvt_roundi64_ss);
	    eval 'sub _mm_cvt_roundsi64_ss {
	        my($A, $B, $C) = @_;
    		eval q(( &__m128) &__builtin_ia32_cvtsi2ss64($A, $B, $C));
	    }' unless defined(&_mm_cvt_roundsi64_ss);
	}
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtepi32_epi8 ( &__m512i  &__A) { ( &__m128i)  &__builtin_ia32_pmovdb512_mask (( &__v16si)  &__A, ( &__v16qi)  &_mm_undefined_si128 (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtepi32_storeu_epi8 ( &void *  &__P,  &__mmask16  &__M,  &__m512i  &__A) {  &__builtin_ia32_pmovdb512mem_mask (( &__v16qi *)  &__P, ( &__v16si)  &__A,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtepi32_epi8 ( &__m128i  &__O,  &__mmask16  &__M,  &__m512i  &__A) { ( &__m128i)  &__builtin_ia32_pmovdb512_mask (( &__v16si)  &__A, ( &__v16qi)  &__O,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtepi32_epi8 ( &__mmask16  &__M,  &__m512i  &__A) { ( &__m128i)  &__builtin_ia32_pmovdb512_mask (( &__v16si)  &__A, ( &__v16qi)  &_mm_setzero_si128 (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtsepi32_epi8 ( &__m512i  &__A) { ( &__m128i)  &__builtin_ia32_pmovsdb512_mask (( &__v16si)  &__A, ( &__v16qi)  &_mm_undefined_si128 (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtsepi32_storeu_epi8 ( &void *  &__P,  &__mmask16  &__M,  &__m512i  &__A) {  &__builtin_ia32_pmovsdb512mem_mask (( &__v16qi *)  &__P, ( &__v16si)  &__A,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtsepi32_epi8 ( &__m128i  &__O,  &__mmask16  &__M,  &__m512i  &__A) { ( &__m128i)  &__builtin_ia32_pmovsdb512_mask (( &__v16si)  &__A, ( &__v16qi)  &__O,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtsepi32_epi8 ( &__mmask16  &__M,  &__m512i  &__A) { ( &__m128i)  &__builtin_ia32_pmovsdb512_mask (( &__v16si)  &__A, ( &__v16qi)  &_mm_setzero_si128 (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtusepi32_epi8 ( &__m512i  &__A) { ( &__m128i)  &__builtin_ia32_pmovusdb512_mask (( &__v16si)  &__A, ( &__v16qi)  &_mm_undefined_si128 (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtusepi32_storeu_epi8 ( &void *  &__P,  &__mmask16  &__M,  &__m512i  &__A) {  &__builtin_ia32_pmovusdb512mem_mask (( &__v16qi *)  &__P, ( &__v16si)  &__A,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtusepi32_epi8 ( &__m128i  &__O,  &__mmask16  &__M,  &__m512i  &__A) { ( &__m128i)  &__builtin_ia32_pmovusdb512_mask (( &__v16si)  &__A, ( &__v16qi)  &__O,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtusepi32_epi8 ( &__mmask16  &__M,  &__m512i  &__A) { ( &__m128i)  &__builtin_ia32_pmovusdb512_mask (( &__v16si)  &__A, ( &__v16qi)  &_mm_setzero_si128 (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtepi32_epi16 ( &__m512i  &__A) { ( &__m256i)  &__builtin_ia32_pmovdw512_mask (( &__v16si)  &__A, ( &__v16hi)  &_mm256_undefined_si256 (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtepi32_storeu_epi16 ( &void *  &__P,  &__mmask16  &__M,  &__m512i  &__A) {  &__builtin_ia32_pmovdw512mem_mask (( &__v16hi *)  &__P, ( &__v16si)  &__A,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtepi32_epi16 ( &__m256i  &__O,  &__mmask16  &__M,  &__m512i  &__A) { ( &__m256i)  &__builtin_ia32_pmovdw512_mask (( &__v16si)  &__A, ( &__v16hi)  &__O,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtepi32_epi16 ( &__mmask16  &__M,  &__m512i  &__A) { ( &__m256i)  &__builtin_ia32_pmovdw512_mask (( &__v16si)  &__A, ( &__v16hi)  &_mm256_setzero_si256 (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtsepi32_epi16 ( &__m512i  &__A) { ( &__m256i)  &__builtin_ia32_pmovsdw512_mask (( &__v16si)  &__A, ( &__v16hi)  &_mm256_undefined_si256 (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtsepi32_storeu_epi16 ( &void * &__P,  &__mmask16  &__M,  &__m512i  &__A) {  &__builtin_ia32_pmovsdw512mem_mask (( &__v16hi*)  &__P, ( &__v16si)  &__A,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtsepi32_epi16 ( &__m256i  &__O,  &__mmask16  &__M,  &__m512i  &__A) { ( &__m256i)  &__builtin_ia32_pmovsdw512_mask (( &__v16si)  &__A, ( &__v16hi)  &__O,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtsepi32_epi16 ( &__mmask16  &__M,  &__m512i  &__A) { ( &__m256i)  &__builtin_ia32_pmovsdw512_mask (( &__v16si)  &__A, ( &__v16hi)  &_mm256_setzero_si256 (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtusepi32_epi16 ( &__m512i  &__A) { ( &__m256i)  &__builtin_ia32_pmovusdw512_mask (( &__v16si)  &__A, ( &__v16hi)  &_mm256_undefined_si256 (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtusepi32_storeu_epi16 ( &void * &__P,  &__mmask16  &__M,  &__m512i  &__A) {  &__builtin_ia32_pmovusdw512mem_mask (( &__v16hi*)  &__P, ( &__v16si)  &__A,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtusepi32_epi16 ( &__m256i  &__O,  &__mmask16  &__M,  &__m512i  &__A) { ( &__m256i)  &__builtin_ia32_pmovusdw512_mask (( &__v16si)  &__A, ( &__v16hi)  &__O,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtusepi32_epi16 ( &__mmask16  &__M,  &__m512i  &__A) { ( &__m256i)  &__builtin_ia32_pmovusdw512_mask (( &__v16si)  &__A, ( &__v16hi)  &_mm256_setzero_si256 (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtepi64_epi32 ( &__m512i  &__A) { ( &__m256i)  &__builtin_ia32_pmovqd512_mask (( &__v8di)  &__A, ( &__v8si)  &_mm256_undefined_si256 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtepi64_storeu_epi32 ( &void*  &__P,  &__mmask8  &__M,  &__m512i  &__A) {  &__builtin_ia32_pmovqd512mem_mask (( &__v8si *)  &__P, ( &__v8di)  &__A,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtepi64_epi32 ( &__m256i  &__O,  &__mmask8  &__M,  &__m512i  &__A) { ( &__m256i)  &__builtin_ia32_pmovqd512_mask (( &__v8di)  &__A, ( &__v8si)  &__O,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtepi64_epi32 ( &__mmask8  &__M,  &__m512i  &__A) { ( &__m256i)  &__builtin_ia32_pmovqd512_mask (( &__v8di)  &__A, ( &__v8si)  &_mm256_setzero_si256 (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtsepi64_epi32 ( &__m512i  &__A) { ( &__m256i)  &__builtin_ia32_pmovsqd512_mask (( &__v8di)  &__A, ( &__v8si)  &_mm256_undefined_si256 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtsepi64_storeu_epi32 ( &void * &__P,  &__mmask8  &__M,  &__m512i  &__A) {  &__builtin_ia32_pmovsqd512mem_mask (( &__v8si *)  &__P, ( &__v8di)  &__A,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtsepi64_epi32 ( &__m256i  &__O,  &__mmask8  &__M,  &__m512i  &__A) { ( &__m256i)  &__builtin_ia32_pmovsqd512_mask (( &__v8di)  &__A, ( &__v8si)  &__O,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtsepi64_epi32 ( &__mmask8  &__M,  &__m512i  &__A) { ( &__m256i)  &__builtin_ia32_pmovsqd512_mask (( &__v8di)  &__A, ( &__v8si)  &_mm256_setzero_si256 (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtusepi64_epi32 ( &__m512i  &__A) { ( &__m256i)  &__builtin_ia32_pmovusqd512_mask (( &__v8di)  &__A, ( &__v8si)  &_mm256_undefined_si256 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtusepi64_storeu_epi32 ( &void*  &__P,  &__mmask8  &__M,  &__m512i  &__A) {  &__builtin_ia32_pmovusqd512mem_mask (( &__v8si*)  &__P, ( &__v8di)  &__A,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtusepi64_epi32 ( &__m256i  &__O,  &__mmask8  &__M,  &__m512i  &__A) { ( &__m256i)  &__builtin_ia32_pmovusqd512_mask (( &__v8di)  &__A, ( &__v8si)  &__O,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtusepi64_epi32 ( &__mmask8  &__M,  &__m512i  &__A) { ( &__m256i)  &__builtin_ia32_pmovusqd512_mask (( &__v8di)  &__A, ( &__v8si)  &_mm256_setzero_si256 (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtepi64_epi16 ( &__m512i  &__A) { ( &__m128i)  &__builtin_ia32_pmovqw512_mask (( &__v8di)  &__A, ( &__v8hi)  &_mm_undefined_si128 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtepi64_storeu_epi16 ( &void * &__P,  &__mmask8  &__M,  &__m512i  &__A) {  &__builtin_ia32_pmovqw512mem_mask (( &__v8hi *)  &__P, ( &__v8di)  &__A,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtepi64_epi16 ( &__m128i  &__O,  &__mmask8  &__M,  &__m512i  &__A) { ( &__m128i)  &__builtin_ia32_pmovqw512_mask (( &__v8di)  &__A, ( &__v8hi)  &__O,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtepi64_epi16 ( &__mmask8  &__M,  &__m512i  &__A) { ( &__m128i)  &__builtin_ia32_pmovqw512_mask (( &__v8di)  &__A, ( &__v8hi)  &_mm_setzero_si128 (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtsepi64_epi16 ( &__m512i  &__A) { ( &__m128i)  &__builtin_ia32_pmovsqw512_mask (( &__v8di)  &__A, ( &__v8hi)  &_mm_undefined_si128 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtsepi64_storeu_epi16 ( &void *  &__P,  &__mmask8  &__M,  &__m512i  &__A) {  &__builtin_ia32_pmovsqw512mem_mask (( &__v8hi *)  &__P, ( &__v8di)  &__A,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtsepi64_epi16 ( &__m128i  &__O,  &__mmask8  &__M,  &__m512i  &__A) { ( &__m128i)  &__builtin_ia32_pmovsqw512_mask (( &__v8di)  &__A, ( &__v8hi)  &__O,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtsepi64_epi16 ( &__mmask8  &__M,  &__m512i  &__A) { ( &__m128i)  &__builtin_ia32_pmovsqw512_mask (( &__v8di)  &__A, ( &__v8hi)  &_mm_setzero_si128 (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtusepi64_epi16 ( &__m512i  &__A) { ( &__m128i)  &__builtin_ia32_pmovusqw512_mask (( &__v8di)  &__A, ( &__v8hi)  &_mm_undefined_si128 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtusepi64_storeu_epi16 ( &void * &__P,  &__mmask8  &__M,  &__m512i  &__A) {  &__builtin_ia32_pmovusqw512mem_mask (( &__v8hi*)  &__P, ( &__v8di)  &__A,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtusepi64_epi16 ( &__m128i  &__O,  &__mmask8  &__M,  &__m512i  &__A) { ( &__m128i)  &__builtin_ia32_pmovusqw512_mask (( &__v8di)  &__A, ( &__v8hi)  &__O,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtusepi64_epi16 ( &__mmask8  &__M,  &__m512i  &__A) { ( &__m128i)  &__builtin_ia32_pmovusqw512_mask (( &__v8di)  &__A, ( &__v8hi)  &_mm_setzero_si128 (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtepi64_epi8 ( &__m512i  &__A) { ( &__m128i)  &__builtin_ia32_pmovqb512_mask (( &__v8di)  &__A, ( &__v16qi)  &_mm_undefined_si128 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtepi64_storeu_epi8 ( &void *  &__P,  &__mmask8  &__M,  &__m512i  &__A) {  &__builtin_ia32_pmovqb512mem_mask (( &__v16qi *)  &__P, ( &__v8di)  &__A,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtepi64_epi8 ( &__m128i  &__O,  &__mmask8  &__M,  &__m512i  &__A) { ( &__m128i)  &__builtin_ia32_pmovqb512_mask (( &__v8di)  &__A, ( &__v16qi)  &__O,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtepi64_epi8 ( &__mmask8  &__M,  &__m512i  &__A) { ( &__m128i)  &__builtin_ia32_pmovqb512_mask (( &__v8di)  &__A, ( &__v16qi)  &_mm_setzero_si128 (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtsepi64_epi8 ( &__m512i  &__A) { ( &__m128i)  &__builtin_ia32_pmovsqb512_mask (( &__v8di)  &__A, ( &__v16qi)  &_mm_undefined_si128 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtsepi64_storeu_epi8 ( &void *  &__P,  &__mmask8  &__M,  &__m512i  &__A) {  &__builtin_ia32_pmovsqb512mem_mask (( &__v16qi *)  &__P, ( &__v8di)  &__A,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtsepi64_epi8 ( &__m128i  &__O,  &__mmask8  &__M,  &__m512i  &__A) { ( &__m128i)  &__builtin_ia32_pmovsqb512_mask (( &__v8di)  &__A, ( &__v16qi)  &__O,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtsepi64_epi8 ( &__mmask8  &__M,  &__m512i  &__A) { ( &__m128i)  &__builtin_ia32_pmovsqb512_mask (( &__v8di)  &__A, ( &__v16qi)  &_mm_setzero_si128 (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtusepi64_epi8 ( &__m512i  &__A) { ( &__m128i)  &__builtin_ia32_pmovusqb512_mask (( &__v8di)  &__A, ( &__v16qi)  &_mm_undefined_si128 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtusepi64_storeu_epi8 ( &void *  &__P,  &__mmask8  &__M,  &__m512i  &__A) {  &__builtin_ia32_pmovusqb512mem_mask (( &__v16qi *)  &__P, ( &__v8di)  &__A,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtusepi64_epi8 ( &__m128i  &__O,  &__mmask8  &__M,  &__m512i  &__A) { ( &__m128i)  &__builtin_ia32_pmovusqb512_mask (( &__v8di)  &__A, ( &__v16qi)  &__O,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtusepi64_epi8 ( &__mmask8  &__M,  &__m512i  &__A) { ( &__m128i)  &__builtin_ia32_pmovusqb512_mask (( &__v8di)  &__A, ( &__v16qi)  &_mm_setzero_si128 (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtepi32_pd ( &__m256i  &__A) { ( &__m512d)  &__builtin_ia32_cvtdq2pd512_mask (( &__v8si)  &__A, ( &__v8df)  &_mm512_undefined_pd (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtepi32_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m256i  &__A) { ( &__m512d)  &__builtin_ia32_cvtdq2pd512_mask (( &__v8si)  &__A, ( &__v8df)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtepi32_pd ( &__mmask8  &__U,  &__m256i  &__A) { ( &__m512d)  &__builtin_ia32_cvtdq2pd512_mask (( &__v8si)  &__A, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtepu32_pd ( &__m256i  &__A) { ( &__m512d)  &__builtin_ia32_cvtudq2pd512_mask (( &__v8si)  &__A, ( &__v8df)  &_mm512_undefined_pd (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtepu32_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m256i  &__A) { ( &__m512d)  &__builtin_ia32_cvtudq2pd512_mask (( &__v8si)  &__A, ( &__v8df)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtepu32_pd ( &__mmask8  &__U,  &__m256i  &__A) { ( &__m512d)  &__builtin_ia32_cvtudq2pd512_mask (( &__v8si)  &__A, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvt_roundepi32_ps ( &__m512i  &__A,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_cvtdq2ps512_mask (( &__v16si)  &__A, ( &__v16sf)  &_mm512_undefined_ps (), ( &__mmask16) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvt_roundepi32_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512i  &__A,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_cvtdq2ps512_mask (( &__v16si)  &__A, ( &__v16sf)  &__W, ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvt_roundepi32_ps ( &__mmask16  &__U,  &__m512i  &__A,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_cvtdq2ps512_mask (( &__v16si)  &__A, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvt_roundepu32_ps ( &__m512i  &__A,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_cvtudq2ps512_mask (( &__v16si)  &__A, ( &__v16sf)  &_mm512_undefined_ps (), ( &__mmask16) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvt_roundepu32_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512i  &__A,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_cvtudq2ps512_mask (( &__v16si)  &__A, ( &__v16sf)  &__W, ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvt_roundepu32_ps ( &__mmask16  &__U,  &__m512i  &__A,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_cvtudq2ps512_mask (( &__v16si)  &__A, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm512_cvt_roundepi32_ps {
	    my($A, $B) = @_;
    	    eval q(( &__m512) &__builtin_ia32_cvtdq2ps512_mask(( &__v16si)($A), ( &__v16sf) &_mm512_undefined_ps(), -1, $B));
	}' unless defined(&_mm512_cvt_roundepi32_ps);
	eval 'sub _mm512_mask_cvt_roundepi32_ps {
	    my($W, $U, $A, $B) = @_;
    	    eval q(( &__m512) &__builtin_ia32_cvtdq2ps512_mask(( &__v16si)($A), $W, $U, $B));
	}' unless defined(&_mm512_mask_cvt_roundepi32_ps);
	eval 'sub _mm512_maskz_cvt_roundepi32_ps {
	    my($U, $A, $B) = @_;
    	    eval q(( &__m512) &__builtin_ia32_cvtdq2ps512_mask(( &__v16si)($A), ( &__v16sf) &_mm512_setzero_ps(), $U, $B));
	}' unless defined(&_mm512_maskz_cvt_roundepi32_ps);
	eval 'sub _mm512_cvt_roundepu32_ps {
	    my($A, $B) = @_;
    	    eval q(( &__m512) &__builtin_ia32_cvtudq2ps512_mask(( &__v16si)($A), ( &__v16sf) &_mm512_undefined_ps(), -1, $B));
	}' unless defined(&_mm512_cvt_roundepu32_ps);
	eval 'sub _mm512_mask_cvt_roundepu32_ps {
	    my($W, $U, $A, $B) = @_;
    	    eval q(( &__m512) &__builtin_ia32_cvtudq2ps512_mask(( &__v16si)($A), $W, $U, $B));
	}' unless defined(&_mm512_mask_cvt_roundepu32_ps);
	eval 'sub _mm512_maskz_cvt_roundepu32_ps {
	    my($U, $A, $B) = @_;
    	    eval q(( &__m512) &__builtin_ia32_cvtudq2ps512_mask(( &__v16si)($A), ( &__v16sf) &_mm512_setzero_ps(), $U, $B));
	}' unless defined(&_mm512_maskz_cvt_roundepu32_ps);
    }
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_extractf64x4_pd ( &__m512d  &__A,  &const \'int\'  &__imm) { ( &__m256d)  &__builtin_ia32_extractf64x4_mask (( &__v8df)  &__A,  &__imm, ( &__v4df)  &_mm256_undefined_pd (), ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_extractf64x4_pd ( &__m256d  &__W,  &__mmask8  &__U,  &__m512d  &__A,  &const \'int\'  &__imm) { ( &__m256d)  &__builtin_ia32_extractf64x4_mask (( &__v8df)  &__A,  &__imm, ( &__v4df)  &__W, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_extractf64x4_pd ( &__mmask8  &__U,  &__m512d  &__A,  &const \'int\'  &__imm) { ( &__m256d)  &__builtin_ia32_extractf64x4_mask (( &__v8df)  &__A,  &__imm, ( &__v4df)  &_mm256_setzero_pd (), ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_extractf32x4_ps ( &__m512  &__A,  &const \'int\'  &__imm) { ( &__m128)  &__builtin_ia32_extractf32x4_mask (( &__v16sf)  &__A,  &__imm, ( &__v4sf)  &_mm_undefined_ps (), ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_extractf32x4_ps ( &__m128  &__W,  &__mmask8  &__U,  &__m512  &__A,  &const \'int\'  &__imm) { ( &__m128)  &__builtin_ia32_extractf32x4_mask (( &__v16sf)  &__A,  &__imm, ( &__v4sf)  &__W, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_extractf32x4_ps ( &__mmask8  &__U,  &__m512  &__A,  &const \'int\'  &__imm) { ( &__m128)  &__builtin_ia32_extractf32x4_mask (( &__v16sf)  &__A,  &__imm, ( &__v4sf)  &_mm_setzero_ps (), ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_extracti64x4_epi64 ( &__m512i  &__A,  &const \'int\'  &__imm) { ( &__m256i)  &__builtin_ia32_extracti64x4_mask (( &__v8di)  &__A,  &__imm, ( &__v4di)  &_mm256_undefined_si256 (), ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_extracti64x4_epi64 ( &__m256i  &__W,  &__mmask8  &__U,  &__m512i  &__A,  &const \'int\'  &__imm) { ( &__m256i)  &__builtin_ia32_extracti64x4_mask (( &__v8di)  &__A,  &__imm, ( &__v4di)  &__W, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_extracti64x4_epi64 ( &__mmask8  &__U,  &__m512i  &__A,  &const \'int\'  &__imm) { ( &__m256i)  &__builtin_ia32_extracti64x4_mask (( &__v8di)  &__A,  &__imm, ( &__v4di)  &_mm256_setzero_si256 (), ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_extracti32x4_epi32 ( &__m512i  &__A,  &const \'int\'  &__imm) { ( &__m128i)  &__builtin_ia32_extracti32x4_mask (( &__v16si)  &__A,  &__imm, ( &__v4si)  &_mm_undefined_si128 (), ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_extracti32x4_epi32 ( &__m128i  &__W,  &__mmask8  &__U,  &__m512i  &__A,  &const \'int\'  &__imm) { ( &__m128i)  &__builtin_ia32_extracti32x4_mask (( &__v16si)  &__A,  &__imm, ( &__v4si)  &__W, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_extracti32x4_epi32 ( &__mmask8  &__U,  &__m512i  &__A,  &const \'int\'  &__imm) { ( &__m128i)  &__builtin_ia32_extracti32x4_mask (( &__v16si)  &__A,  &__imm, ( &__v4si)  &_mm_setzero_si128 (), ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm512_extractf64x4_pd {
	    my($X, $C) = @_;
    	    eval q((( &__m256d)  &__builtin_ia32_extractf64x4_mask (( &__v8df)( &__m512d) , ($C), ( &__v4df)( &__m256d) &_mm256_undefined_pd(), ( &__mmask8)-1)));
	}' unless defined(&_mm512_extractf64x4_pd);
	eval 'sub _mm512_mask_extractf64x4_pd {
	    my($W, $U, $X, $C) = @_;
    	    eval q((( &__m256d)  &__builtin_ia32_extractf64x4_mask (( &__v8df)( &__m512d) , ($C), ( &__v4df)( &__m256d)($W), ( &__mmask8)($U))));
	}' unless defined(&_mm512_mask_extractf64x4_pd);
	eval 'sub _mm512_maskz_extractf64x4_pd {
	    my($U, $X, $C) = @_;
    	    eval q((( &__m256d)  &__builtin_ia32_extractf64x4_mask (( &__v8df)( &__m512d) , ($C), ( &__v4df)( &__m256d) &_mm256_setzero_pd(), ( &__mmask8)($U))));
	}' unless defined(&_mm512_maskz_extractf64x4_pd);
	eval 'sub _mm512_extractf32x4_ps {
	    my($X, $C) = @_;
    	    eval q((( &__m128)  &__builtin_ia32_extractf32x4_mask (( &__v16sf)( &__m512) , ($C), ( &__v4sf)( &__m128) &_mm_undefined_ps(), ( &__mmask8)-1)));
	}' unless defined(&_mm512_extractf32x4_ps);
	eval 'sub _mm512_mask_extractf32x4_ps {
	    my($W, $U, $X, $C) = @_;
    	    eval q((( &__m128)  &__builtin_ia32_extractf32x4_mask (( &__v16sf)( &__m512) , ($C), ( &__v4sf)( &__m128)($W), ( &__mmask8)($U))));
	}' unless defined(&_mm512_mask_extractf32x4_ps);
	eval 'sub _mm512_maskz_extractf32x4_ps {
	    my($U, $X, $C) = @_;
    	    eval q((( &__m128)  &__builtin_ia32_extractf32x4_mask (( &__v16sf)( &__m512) , ($C), ( &__v4sf)( &__m128) &_mm_setzero_ps(), ( &__mmask8)($U))));
	}' unless defined(&_mm512_maskz_extractf32x4_ps);
	eval 'sub _mm512_extracti64x4_epi64 {
	    my($X, $C) = @_;
    	    eval q((( &__m256i)  &__builtin_ia32_extracti64x4_mask (( &__v8di)( &__m512i) , ($C), ( &__v4di)( &__m256i) &_mm256_undefined_si256 (), ( &__mmask8)-1)));
	}' unless defined(&_mm512_extracti64x4_epi64);
	eval 'sub _mm512_mask_extracti64x4_epi64 {
	    my($W, $U, $X, $C) = @_;
    	    eval q((( &__m256i)  &__builtin_ia32_extracti64x4_mask (( &__v8di)( &__m512i) , ($C), ( &__v4di)( &__m256i)($W), ( &__mmask8)($U))));
	}' unless defined(&_mm512_mask_extracti64x4_epi64);
	eval 'sub _mm512_maskz_extracti64x4_epi64 {
	    my($U, $X, $C) = @_;
    	    eval q((( &__m256i)  &__builtin_ia32_extracti64x4_mask (( &__v8di)( &__m512i) , ($C), ( &__v4di)( &__m256i) &_mm256_setzero_si256 (), ( &__mmask8)($U))));
	}' unless defined(&_mm512_maskz_extracti64x4_epi64);
	eval 'sub _mm512_extracti32x4_epi32 {
	    my($X, $C) = @_;
    	    eval q((( &__m128i)  &__builtin_ia32_extracti32x4_mask (( &__v16si)( &__m512i) , ($C), ( &__v4si)( &__m128i) &_mm_undefined_si128 (), ( &__mmask8)-1)));
	}' unless defined(&_mm512_extracti32x4_epi32);
	eval 'sub _mm512_mask_extracti32x4_epi32 {
	    my($W, $U, $X, $C) = @_;
    	    eval q((( &__m128i)  &__builtin_ia32_extracti32x4_mask (( &__v16si)( &__m512i) , ($C), ( &__v4si)( &__m128i)($W), ( &__mmask8)($U))));
	}' unless defined(&_mm512_mask_extracti32x4_epi32);
	eval 'sub _mm512_maskz_extracti32x4_epi32 {
	    my($U, $X, $C) = @_;
    	    eval q((( &__m128i)  &__builtin_ia32_extracti32x4_mask (( &__v16si)( &__m512i) , ($C), ( &__v4si)( &__m128i) &_mm_setzero_si128 (), ( &__mmask8)($U))));
	}' unless defined(&_mm512_maskz_extracti32x4_epi32);
    }
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_inserti32x4 ( &__m512i  &__A,  &__m128i  &__B,  &const \'int\'  &__imm) { ( &__m512i)  &__builtin_ia32_inserti32x4_mask (( &__v16si)  &__A, ( &__v4si)  &__B,  &__imm, ( &__v16si)  &__A, -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_insertf32x4 ( &__m512  &__A,  &__m128  &__B,  &const \'int\'  &__imm) { ( &__m512)  &__builtin_ia32_insertf32x4_mask (( &__v16sf)  &__A, ( &__v4sf)  &__B,  &__imm, ( &__v16sf)  &__A, -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_inserti64x4 ( &__m512i  &__A,  &__m256i  &__B,  &const \'int\'  &__imm) { ( &__m512i)  &__builtin_ia32_inserti64x4_mask (( &__v8di)  &__A, ( &__v4di)  &__B,  &__imm, ( &__v8di)  &_mm512_undefined_epi32 (), ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_inserti64x4 ( &__m512i  &__W,  &__mmask8  &__U,  &__m512i  &__A,  &__m256i  &__B,  &const \'int\'  &__imm) { ( &__m512i)  &__builtin_ia32_inserti64x4_mask (( &__v8di)  &__A, ( &__v4di)  &__B,  &__imm, ( &__v8di)  &__W, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_inserti64x4 ( &__mmask8  &__U,  &__m512i  &__A,  &__m256i  &__B,  &const \'int\'  &__imm) { ( &__m512i)  &__builtin_ia32_inserti64x4_mask (( &__v8di)  &__A, ( &__v4di)  &__B,  &__imm, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_insertf64x4 ( &__m512d  &__A,  &__m256d  &__B,  &const \'int\'  &__imm) { ( &__m512d)  &__builtin_ia32_insertf64x4_mask (( &__v8df)  &__A, ( &__v4df)  &__B,  &__imm, ( &__v8df)  &_mm512_undefined_pd (), ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_insertf64x4 ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A,  &__m256d  &__B,  &const \'int\'  &__imm) { ( &__m512d)  &__builtin_ia32_insertf64x4_mask (( &__v8df)  &__A, ( &__v4df)  &__B,  &__imm, ( &__v8df)  &__W, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_insertf64x4 ( &__mmask8  &__U,  &__m512d  &__A,  &__m256d  &__B,  &const \'int\'  &__imm) { ( &__m512d)  &__builtin_ia32_insertf64x4_mask (( &__v8df)  &__A, ( &__v4df)  &__B,  &__imm, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm512_insertf32x4 {
	    my($X, $Y, $C) = @_;
    	    eval q((( &__m512)  &__builtin_ia32_insertf32x4_mask (( &__v16sf)( &__m512) ($X), ( &__v4sf)( &__m128) , ($C), ( &__v16sf)( &__m512) ($X), ( &__mmask16)(-1))));
	}' unless defined(&_mm512_insertf32x4);
	eval 'sub _mm512_inserti32x4 {
	    my($X, $Y, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_inserti32x4_mask (( &__v16si)( &__m512i) ($X), ( &__v4si)( &__m128i) , ($C), ( &__v16si)( &__m512i) ($X), ( &__mmask16)(-1))));
	}' unless defined(&_mm512_inserti32x4);
	eval 'sub _mm512_insertf64x4 {
	    my($X, $Y, $C) = @_;
    	    eval q((( &__m512d)  &__builtin_ia32_insertf64x4_mask (( &__v8df)( &__m512d) ($X), ( &__v4df)( &__m256d) , ($C), ( &__v8df)( &__m512d) &_mm512_undefined_pd(), ( &__mmask8)-1)));
	}' unless defined(&_mm512_insertf64x4);
	eval 'sub _mm512_mask_insertf64x4 {
	    my($W, $U, $X, $Y, $C) = @_;
    	    eval q((( &__m512d)  &__builtin_ia32_insertf64x4_mask (( &__v8df)( &__m512d) ($X), ( &__v4df)( &__m256d) , ($C), ( &__v8df)( &__m512d)($W), ( &__mmask8)($U))));
	}' unless defined(&_mm512_mask_insertf64x4);
	eval 'sub _mm512_maskz_insertf64x4 {
	    my($U, $X, $Y, $C) = @_;
    	    eval q((( &__m512d)  &__builtin_ia32_insertf64x4_mask (( &__v8df)( &__m512d) ($X), ( &__v4df)( &__m256d) , ($C), ( &__v8df)( &__m512d) &_mm512_setzero_pd(), ( &__mmask8)($U))));
	}' unless defined(&_mm512_maskz_insertf64x4);
	eval 'sub _mm512_inserti64x4 {
	    my($X, $Y, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_inserti64x4_mask (( &__v8di)( &__m512i) ($X), ( &__v4di)( &__m256i) , ($C), ( &__v8di)( &__m512i) &_mm512_undefined_epi32 (), ( &__mmask8)-1)));
	}' unless defined(&_mm512_inserti64x4);
	eval 'sub _mm512_mask_inserti64x4 {
	    my($W, $U, $X, $Y, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_inserti64x4_mask (( &__v8di)( &__m512i) ($X), ( &__v4di)( &__m256i) , ($C), ( &__v8di)( &__m512i)($W), ( &__mmask8)($U))));
	}' unless defined(&_mm512_mask_inserti64x4);
	eval 'sub _mm512_maskz_inserti64x4 {
	    my($U, $X, $Y, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_inserti64x4_mask (( &__v8di)( &__m512i) ($X), ( &__v4di)( &__m256i) , ($C), ( &__v8di)( &__m512i) &_mm512_setzero_si512 (), ( &__mmask8)($U))));
	}' unless defined(&_mm512_maskz_inserti64x4);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_loadu_pd ( &void  &const * &__P) { *( &__m512d_u *) &__P; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_loadu_pd ( &__m512d  &__W,  &__mmask8  &__U,  &void  &const * &__P) { ( &__m512d)  &__builtin_ia32_loadupd512_mask (( &const \'double\' *)  &__P, ( &__v8df)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_loadu_pd ( &__mmask8  &__U,  &void  &const * &__P) { ( &__m512d)  &__builtin_ia32_loadupd512_mask (( &const \'double\' *)  &__P, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_storeu_pd ( &void * &__P,  &__m512d  &__A) { *( &__m512d_u *) &__P =  &__A; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_storeu_pd ( &void * &__P,  &__mmask8  &__U,  &__m512d  &__A) {  &__builtin_ia32_storeupd512_mask (  &__P, ( &__v8df)  &__A, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_loadu_ps ( &void  &const * &__P) { *( &__m512_u *) &__P; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_loadu_ps ( &__m512  &__W,  &__mmask16  &__U,  &void  &const * &__P) { ( &__m512)  &__builtin_ia32_loadups512_mask (( &const \'float\' *)  &__P, ( &__v16sf)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_loadu_ps ( &__mmask16  &__U,  &void  &const * &__P) { ( &__m512)  &__builtin_ia32_loadups512_mask (( &const \'float\' *)  &__P, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_storeu_ps ( &void * &__P,  &__m512  &__A) { *( &__m512_u *) &__P =  &__A; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_storeu_ps ( &void * &__P,  &__mmask16  &__U,  &__m512  &__A) {  &__builtin_ia32_storeups512_mask (  &__P, ( &__v16sf)  &__A, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_loadu_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &void  &const * &__P) { ( &__m512i)  &__builtin_ia32_loaddqudi512_mask (( &const my $long *)  &__P, ( &__v8di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_loadu_epi64 ( &__mmask8  &__U,  &void  &const * &__P) { ( &__m512i)  &__builtin_ia32_loaddqudi512_mask (( &const my $long *)  &__P, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_storeu_epi64 ( &void * &__P,  &__mmask8  &__U,  &__m512i  &__A) {  &__builtin_ia32_storedqudi512_mask (  &__P, ( &__v8di)  &__A, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_loadu_si512 ( &void  &const * &__P) { *( &__m512i_u *) &__P; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_loadu_epi32 ( &__m512i  &__W,  &__mmask16  &__U,  &void  &const * &__P) { ( &__m512i)  &__builtin_ia32_loaddqusi512_mask (( &const \'int\' *)  &__P, ( &__v16si)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_loadu_epi32 ( &__mmask16  &__U,  &void  &const * &__P) { ( &__m512i)  &__builtin_ia32_loaddqusi512_mask (( &const \'int\' *)  &__P, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_storeu_si512 ( &void * &__P,  &__m512i  &__A) { *( &__m512i_u *) &__P =  &__A; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_storeu_epi32 ( &void * &__P,  &__mmask16  &__U,  &__m512i  &__A) {  &__builtin_ia32_storedqusi512_mask (  &__P, ( &__v16si)  &__A, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_permutevar_pd ( &__m512d  &__A,  &__m512i  &__C) { ( &__m512d)  &__builtin_ia32_vpermilvarpd512_mask (( &__v8df)  &__A, ( &__v8di)  &__C, ( &__v8df)  &_mm512_undefined_pd (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_permutevar_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A,  &__m512i  &__C) { ( &__m512d)  &__builtin_ia32_vpermilvarpd512_mask (( &__v8df)  &__A, ( &__v8di)  &__C, ( &__v8df)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_permutevar_pd ( &__mmask8  &__U,  &__m512d  &__A,  &__m512i  &__C) { ( &__m512d)  &__builtin_ia32_vpermilvarpd512_mask (( &__v8df)  &__A, ( &__v8di)  &__C, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_permutevar_ps ( &__m512  &__A,  &__m512i  &__C) { ( &__m512)  &__builtin_ia32_vpermilvarps512_mask (( &__v16sf)  &__A, ( &__v16si)  &__C, ( &__v16sf)  &_mm512_undefined_ps (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_permutevar_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A,  &__m512i  &__C) { ( &__m512)  &__builtin_ia32_vpermilvarps512_mask (( &__v16sf)  &__A, ( &__v16si)  &__C, ( &__v16sf)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_permutevar_ps ( &__mmask16  &__U,  &__m512  &__A,  &__m512i  &__C) { ( &__m512)  &__builtin_ia32_vpermilvarps512_mask (( &__v16sf)  &__A, ( &__v16si)  &__C, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_permutex2var_epi64 ( &__m512i  &__A,  &__m512i  &__I,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_vpermt2varq512_mask (( &__v8di)  &__I , ( &__v8di)  &__A, ( &__v8di)  &__B, ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_permutex2var_epi64 ( &__m512i  &__A,  &__mmask8  &__U,  &__m512i  &__I,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_vpermt2varq512_mask (( &__v8di)  &__I , ( &__v8di)  &__A, ( &__v8di)  &__B, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask2_permutex2var_epi64 ( &__m512i  &__A,  &__m512i  &__I,  &__mmask8  &__U,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_vpermi2varq512_mask (( &__v8di)  &__A, ( &__v8di)  &__I , ( &__v8di)  &__B, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_permutex2var_epi64 ( &__mmask8  &__U,  &__m512i  &__A,  &__m512i  &__I,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_vpermt2varq512_maskz (( &__v8di)  &__I , ( &__v8di)  &__A, ( &__v8di)  &__B, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_permutex2var_epi32 ( &__m512i  &__A,  &__m512i  &__I,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_vpermt2vard512_mask (( &__v16si)  &__I , ( &__v16si)  &__A, ( &__v16si)  &__B, ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_permutex2var_epi32 ( &__m512i  &__A,  &__mmask16  &__U,  &__m512i  &__I,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_vpermt2vard512_mask (( &__v16si)  &__I , ( &__v16si)  &__A, ( &__v16si)  &__B, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask2_permutex2var_epi32 ( &__m512i  &__A,  &__m512i  &__I,  &__mmask16  &__U,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_vpermi2vard512_mask (( &__v16si)  &__A, ( &__v16si)  &__I , ( &__v16si)  &__B, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_permutex2var_epi32 ( &__mmask16  &__U,  &__m512i  &__A,  &__m512i  &__I,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_vpermt2vard512_maskz (( &__v16si)  &__I , ( &__v16si)  &__A, ( &__v16si)  &__B, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_permutex2var_pd ( &__m512d  &__A,  &__m512i  &__I,  &__m512d  &__B) { ( &__m512d)  &__builtin_ia32_vpermt2varpd512_mask (( &__v8di)  &__I , ( &__v8df)  &__A, ( &__v8df)  &__B, ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_permutex2var_pd ( &__m512d  &__A,  &__mmask8  &__U,  &__m512i  &__I,  &__m512d  &__B) { ( &__m512d)  &__builtin_ia32_vpermt2varpd512_mask (( &__v8di)  &__I , ( &__v8df)  &__A, ( &__v8df)  &__B, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask2_permutex2var_pd ( &__m512d  &__A,  &__m512i  &__I,  &__mmask8  &__U,  &__m512d  &__B) { ( &__m512d)  &__builtin_ia32_vpermi2varpd512_mask (( &__v8df)  &__A, ( &__v8di)  &__I , ( &__v8df)  &__B, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_permutex2var_pd ( &__mmask8  &__U,  &__m512d  &__A,  &__m512i  &__I,  &__m512d  &__B) { ( &__m512d)  &__builtin_ia32_vpermt2varpd512_maskz (( &__v8di)  &__I , ( &__v8df)  &__A, ( &__v8df)  &__B, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_permutex2var_ps ( &__m512  &__A,  &__m512i  &__I,  &__m512  &__B) { ( &__m512)  &__builtin_ia32_vpermt2varps512_mask (( &__v16si)  &__I , ( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_permutex2var_ps ( &__m512  &__A,  &__mmask16  &__U,  &__m512i  &__I,  &__m512  &__B) { ( &__m512)  &__builtin_ia32_vpermt2varps512_mask (( &__v16si)  &__I , ( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask2_permutex2var_ps ( &__m512  &__A,  &__m512i  &__I,  &__mmask16  &__U,  &__m512  &__B) { ( &__m512)  &__builtin_ia32_vpermi2varps512_mask (( &__v16sf)  &__A, ( &__v16si)  &__I , ( &__v16sf)  &__B, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_permutex2var_ps ( &__mmask16  &__U,  &__m512  &__A,  &__m512i  &__I,  &__m512  &__B) { ( &__m512)  &__builtin_ia32_vpermt2varps512_maskz (( &__v16si)  &__I , ( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_permute_pd ( &__m512d  &__X,  &const \'int\'  &__C) { ( &__m512d)  &__builtin_ia32_vpermilpd512_mask (( &__v8df)  &__X,  &__C, ( &__v8df)  &_mm512_undefined_pd (), ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_permute_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__X,  &const \'int\'  &__C) { ( &__m512d)  &__builtin_ia32_vpermilpd512_mask (( &__v8df)  &__X,  &__C, ( &__v8df)  &__W, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_permute_pd ( &__mmask8  &__U,  &__m512d  &__X,  &const \'int\'  &__C) { ( &__m512d)  &__builtin_ia32_vpermilpd512_mask (( &__v8df)  &__X,  &__C, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_permute_ps ( &__m512  &__X,  &const \'int\'  &__C) { ( &__m512)  &__builtin_ia32_vpermilps512_mask (( &__v16sf)  &__X,  &__C, ( &__v16sf)  &_mm512_undefined_ps (), ( &__mmask16) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_permute_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__X,  &const \'int\'  &__C) { ( &__m512)  &__builtin_ia32_vpermilps512_mask (( &__v16sf)  &__X,  &__C, ( &__v16sf)  &__W, ( &__mmask16)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_permute_ps ( &__mmask16  &__U,  &__m512  &__X,  &const \'int\'  &__C) { ( &__m512)  &__builtin_ia32_vpermilps512_mask (( &__v16sf)  &__X,  &__C, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm512_permute_pd {
	    my($X, $C) = @_;
    	    eval q((( &__m512d)  &__builtin_ia32_vpermilpd512_mask (( &__v8df)( &__m512d), ($C), ( &__v8df)( &__m512d) &_mm512_undefined_pd(), ( &__mmask8)(-1))));
	}' unless defined(&_mm512_permute_pd);
	eval 'sub _mm512_mask_permute_pd {
	    my($W, $U, $X, $C) = @_;
    	    eval q((( &__m512d)  &__builtin_ia32_vpermilpd512_mask (( &__v8df)( &__m512d), ($C), ( &__v8df)( &__m512d)($W), ( &__mmask8)($U))));
	}' unless defined(&_mm512_mask_permute_pd);
	eval 'sub _mm512_maskz_permute_pd {
	    my($U, $X, $C) = @_;
    	    eval q((( &__m512d)  &__builtin_ia32_vpermilpd512_mask (( &__v8df)( &__m512d), ($C), ( &__v8df)( &__m512d) &_mm512_setzero_pd(), ( &__mmask8)($U))));
	}' unless defined(&_mm512_maskz_permute_pd);
	eval 'sub _mm512_permute_ps {
	    my($X, $C) = @_;
    	    eval q((( &__m512)  &__builtin_ia32_vpermilps512_mask (( &__v16sf)( &__m512), ($C), ( &__v16sf)( &__m512) &_mm512_undefined_ps(), ( &__mmask16)(-1))));
	}' unless defined(&_mm512_permute_ps);
	eval 'sub _mm512_mask_permute_ps {
	    my($W, $U, $X, $C) = @_;
    	    eval q((( &__m512)  &__builtin_ia32_vpermilps512_mask (( &__v16sf)( &__m512), ($C), ( &__v16sf)( &__m512)($W), ( &__mmask16)($U))));
	}' unless defined(&_mm512_mask_permute_ps);
	eval 'sub _mm512_maskz_permute_ps {
	    my($U, $X, $C) = @_;
    	    eval q((( &__m512)  &__builtin_ia32_vpermilps512_mask (( &__v16sf)( &__m512), ($C), ( &__v16sf)( &__m512) &_mm512_setzero_ps(), ( &__mmask16)($U))));
	}' unless defined(&_mm512_maskz_permute_ps);
    }
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_permutex_epi64 ( &__m512i  &__X,  &const \'int\'  &__I) { ( &__m512i)  &__builtin_ia32_permdi512_mask (( &__v8di)  &__X,  &__I, ( &__v8di)  &_mm512_undefined_epi32 (), ( &__mmask8) (-1)); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_permutex_epi64 ( &__m512i  &__W,  &__mmask8  &__M,  &__m512i  &__X,  &const \'int\'  &__I) { ( &__m512i)  &__builtin_ia32_permdi512_mask (( &__v8di)  &__X,  &__I, ( &__v8di)  &__W, ( &__mmask8)  &__M); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_permutex_epi64 ( &__mmask8  &__M,  &__m512i  &__X,  &const \'int\'  &__I) { ( &__m512i)  &__builtin_ia32_permdi512_mask (( &__v8di)  &__X,  &__I, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__M); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_permutex_pd ( &__m512d  &__X,  &const \'int\'  &__M) { ( &__m512d)  &__builtin_ia32_permdf512_mask (( &__v8df)  &__X,  &__M, ( &__v8df)  &_mm512_undefined_pd (), ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_permutex_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__X,  &const \'int\'  &__M) { ( &__m512d)  &__builtin_ia32_permdf512_mask (( &__v8df)  &__X,  &__M, ( &__v8df)  &__W, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_permutex_pd ( &__mmask8  &__U,  &__m512d  &__X,  &const \'int\'  &__M) { ( &__m512d)  &__builtin_ia32_permdf512_mask (( &__v8df)  &__X,  &__M, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm512_permutex_pd {
	    my($X, $M) = @_;
    	    eval q((( &__m512d)  &__builtin_ia32_permdf512_mask (( &__v8df)( &__m512d), ($M), ( &__v8df)( &__m512d) &_mm512_undefined_pd(), ( &__mmask8)-1)));
	}' unless defined(&_mm512_permutex_pd);
	eval 'sub _mm512_mask_permutex_pd {
	    my($W, $U, $X, $M) = @_;
    	    eval q((( &__m512d)  &__builtin_ia32_permdf512_mask (( &__v8df)( &__m512d), ($M), ( &__v8df)( &__m512d)($W), ( &__mmask8)($U))));
	}' unless defined(&_mm512_mask_permutex_pd);
	eval 'sub _mm512_maskz_permutex_pd {
	    my($U, $X, $M) = @_;
    	    eval q((( &__m512d)  &__builtin_ia32_permdf512_mask (( &__v8df)( &__m512d), ($M), ( &__v8df)( &__m512d) &_mm512_setzero_pd(), ( &__mmask8)($U))));
	}' unless defined(&_mm512_maskz_permutex_pd);
	eval 'sub _mm512_permutex_epi64 {
	    my($X, $I) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_permdi512_mask (( &__v8di)( &__m512i), ($I), ( &__v8di)( &__m512i) ( &_mm512_undefined_epi32 ()), ( &__mmask8)(-1))));
	}' unless defined(&_mm512_permutex_epi64);
	eval 'sub _mm512_maskz_permutex_epi64 {
	    my($M, $X, $I) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_permdi512_mask (( &__v8di)( &__m512i), ($I), ( &__v8di)( &__m512i) ( &_mm512_setzero_si512 ()), ( &__mmask8)($M))));
	}' unless defined(&_mm512_maskz_permutex_epi64);
	eval 'sub _mm512_mask_permutex_epi64 {
	    my($W, $M, $X, $I) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_permdi512_mask (( &__v8di)( &__m512i), ($I), ( &__v8di)( &__m512i)($W), ( &__mmask8)($M))));
	}' unless defined(&_mm512_mask_permutex_epi64);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_permutexvar_epi64 ( &__mmask8  &__M,  &__m512i  &__X,  &__m512i  &__Y) { ( &__m512i)  &__builtin_ia32_permvardi512_mask (( &__v8di)  &__Y, ( &__v8di)  &__X, ( &__v8di)  &_mm512_setzero_si512 (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_permutexvar_epi64 ( &__m512i  &__X,  &__m512i  &__Y) { ( &__m512i)  &__builtin_ia32_permvardi512_mask (( &__v8di)  &__Y, ( &__v8di)  &__X, ( &__v8di)  &_mm512_undefined_epi32 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_permutexvar_epi64 ( &__m512i  &__W,  &__mmask8  &__M,  &__m512i  &__X,  &__m512i  &__Y) { ( &__m512i)  &__builtin_ia32_permvardi512_mask (( &__v8di)  &__Y, ( &__v8di)  &__X, ( &__v8di)  &__W,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_permutexvar_epi32 ( &__mmask16  &__M,  &__m512i  &__X,  &__m512i  &__Y) { ( &__m512i)  &__builtin_ia32_permvarsi512_mask (( &__v16si)  &__Y, ( &__v16si)  &__X, ( &__v16si)  &_mm512_setzero_si512 (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_permutexvar_epi32 ( &__m512i  &__X,  &__m512i  &__Y) { ( &__m512i)  &__builtin_ia32_permvarsi512_mask (( &__v16si)  &__Y, ( &__v16si)  &__X, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_permutexvar_epi32 ( &__m512i  &__W,  &__mmask16  &__M,  &__m512i  &__X,  &__m512i  &__Y) { ( &__m512i)  &__builtin_ia32_permvarsi512_mask (( &__v16si)  &__Y, ( &__v16si)  &__X, ( &__v16si)  &__W,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_permutexvar_pd ( &__m512i  &__X,  &__m512d  &__Y) { ( &__m512d)  &__builtin_ia32_permvardf512_mask (( &__v8df)  &__Y, ( &__v8di)  &__X, ( &__v8df)  &_mm512_undefined_pd (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_permutexvar_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512i  &__X,  &__m512d  &__Y) { ( &__m512d)  &__builtin_ia32_permvardf512_mask (( &__v8df)  &__Y, ( &__v8di)  &__X, ( &__v8df)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_permutexvar_pd ( &__mmask8  &__U,  &__m512i  &__X,  &__m512d  &__Y) { ( &__m512d)  &__builtin_ia32_permvardf512_mask (( &__v8df)  &__Y, ( &__v8di)  &__X, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_permutexvar_ps ( &__m512i  &__X,  &__m512  &__Y) { ( &__m512)  &__builtin_ia32_permvarsf512_mask (( &__v16sf)  &__Y, ( &__v16si)  &__X, ( &__v16sf)  &_mm512_undefined_ps (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_permutexvar_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512i  &__X,  &__m512  &__Y) { ( &__m512)  &__builtin_ia32_permvarsf512_mask (( &__v16sf)  &__Y, ( &__v16si)  &__X, ( &__v16sf)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_permutexvar_ps ( &__mmask16  &__U,  &__m512i  &__X,  &__m512  &__Y) { ( &__m512)  &__builtin_ia32_permvarsf512_mask (( &__v16sf)  &__Y, ( &__v16si)  &__X, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_shuffle_ps ( &__m512  &__M,  &__m512  &__V,  &const \'int\'  &__imm) { ( &__m512)  &__builtin_ia32_shufps512_mask (( &__v16sf)  &__M, ( &__v16sf)  &__V,  &__imm, ( &__v16sf)  &_mm512_undefined_ps (), ( &__mmask16) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_shuffle_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__M,  &__m512  &__V,  &const \'int\'  &__imm) { ( &__m512)  &__builtin_ia32_shufps512_mask (( &__v16sf)  &__M, ( &__v16sf)  &__V,  &__imm, ( &__v16sf)  &__W, ( &__mmask16)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_shuffle_ps ( &__mmask16  &__U,  &__m512  &__M,  &__m512  &__V,  &const \'int\'  &__imm) { ( &__m512)  &__builtin_ia32_shufps512_mask (( &__v16sf)  &__M, ( &__v16sf)  &__V,  &__imm, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_shuffle_pd ( &__m512d  &__M,  &__m512d  &__V,  &const \'int\'  &__imm) { ( &__m512d)  &__builtin_ia32_shufpd512_mask (( &__v8df)  &__M, ( &__v8df)  &__V,  &__imm, ( &__v8df)  &_mm512_undefined_pd (), ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_shuffle_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__M,  &__m512d  &__V,  &const \'int\'  &__imm) { ( &__m512d)  &__builtin_ia32_shufpd512_mask (( &__v8df)  &__M, ( &__v8df)  &__V,  &__imm, ( &__v8df)  &__W, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_shuffle_pd ( &__mmask8  &__U,  &__m512d  &__M,  &__m512d  &__V,  &const \'int\'  &__imm) { ( &__m512d)  &__builtin_ia32_shufpd512_mask (( &__v8df)  &__M, ( &__v8df)  &__V,  &__imm, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_fixupimm_round_pd ( &__m512d  &__A,  &__m512d  &__B,  &__m512i  &__C,  &const \'int\'  &__imm,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_fixupimmpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8di)  &__C,  &__imm, ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_fixupimm_round_pd ( &__m512d  &__A,  &__mmask8  &__U,  &__m512d  &__B,  &__m512i  &__C,  &const \'int\'  &__imm,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_fixupimmpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8di)  &__C,  &__imm, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_fixupimm_round_pd ( &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B,  &__m512i  &__C,  &const \'int\'  &__imm,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_fixupimmpd512_maskz (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8di)  &__C,  &__imm, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_fixupimm_round_ps ( &__m512  &__A,  &__m512  &__B,  &__m512i  &__C,  &const \'int\'  &__imm,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_fixupimmps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16si)  &__C,  &__imm, ( &__mmask16) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_fixupimm_round_ps ( &__m512  &__A,  &__mmask16  &__U,  &__m512  &__B,  &__m512i  &__C,  &const \'int\'  &__imm,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_fixupimmps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16si)  &__C,  &__imm, ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_fixupimm_round_ps ( &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B,  &__m512i  &__C,  &const \'int\'  &__imm,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_fixupimmps512_maskz (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16si)  &__C,  &__imm, ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_fixupimm_round_sd ( &__m128d  &__A,  &__m128d  &__B,  &__m128i  &__C,  &const \'int\'  &__imm,  &const \'int\'  &__R) { ( &__m128d)  &__builtin_ia32_fixupimmsd_mask (( &__v2df)  &__A, ( &__v2df)  &__B, ( &__v2di)  &__C,  &__imm, ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_fixupimm_round_sd ( &__m128d  &__A,  &__mmask8  &__U,  &__m128d  &__B,  &__m128i  &__C,  &const \'int\'  &__imm,  &const \'int\'  &__R) { ( &__m128d)  &__builtin_ia32_fixupimmsd_mask (( &__v2df)  &__A, ( &__v2df)  &__B, ( &__v2di)  &__C,  &__imm, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_fixupimm_round_sd ( &__mmask8  &__U,  &__m128d  &__A,  &__m128d  &__B,  &__m128i  &__C,  &const \'int\'  &__imm,  &const \'int\'  &__R) { ( &__m128d)  &__builtin_ia32_fixupimmsd_maskz (( &__v2df)  &__A, ( &__v2df)  &__B, ( &__v2di)  &__C,  &__imm, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_fixupimm_round_ss ( &__m128  &__A,  &__m128  &__B,  &__m128i  &__C,  &const \'int\'  &__imm,  &const \'int\'  &__R) { ( &__m128)  &__builtin_ia32_fixupimmss_mask (( &__v4sf)  &__A, ( &__v4sf)  &__B, ( &__v4si)  &__C,  &__imm, ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_fixupimm_round_ss ( &__m128  &__A,  &__mmask8  &__U,  &__m128  &__B,  &__m128i  &__C,  &const \'int\'  &__imm,  &const \'int\'  &__R) { ( &__m128)  &__builtin_ia32_fixupimmss_mask (( &__v4sf)  &__A, ( &__v4sf)  &__B, ( &__v4si)  &__C,  &__imm, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_fixupimm_round_ss ( &__mmask8  &__U,  &__m128  &__A,  &__m128  &__B,  &__m128i  &__C,  &const \'int\'  &__imm,  &const \'int\'  &__R) { ( &__m128)  &__builtin_ia32_fixupimmss_maskz (( &__v4sf)  &__A, ( &__v4sf)  &__B, ( &__v4si)  &__C,  &__imm, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm512_shuffle_pd {
	    my($X, $Y, $C) = @_;
    	    eval q((( &__m512d) &__builtin_ia32_shufpd512_mask (( &__v8df)( &__m512d)($X), ( &__v8df)( &__m512d), ($C), ( &__v8df)( &__m512d) &_mm512_undefined_pd(), ( &__mmask8)-1)));
	}' unless defined(&_mm512_shuffle_pd);
	eval 'sub _mm512_mask_shuffle_pd {
	    my($W, $U, $X, $Y, $C) = @_;
    	    eval q((( &__m512d) &__builtin_ia32_shufpd512_mask (( &__v8df)( &__m512d)($X), ( &__v8df)( &__m512d), ($C), ( &__v8df)( &__m512d)($W), ( &__mmask8)($U))));
	}' unless defined(&_mm512_mask_shuffle_pd);
	eval 'sub _mm512_maskz_shuffle_pd {
	    my($U, $X, $Y, $C) = @_;
    	    eval q((( &__m512d) &__builtin_ia32_shufpd512_mask (( &__v8df)( &__m512d)($X), ( &__v8df)( &__m512d), ($C), ( &__v8df)( &__m512d) &_mm512_setzero_pd(), ( &__mmask8)($U))));
	}' unless defined(&_mm512_maskz_shuffle_pd);
	eval 'sub _mm512_shuffle_ps {
	    my($X, $Y, $C) = @_;
    	    eval q((( &__m512) &__builtin_ia32_shufps512_mask (( &__v16sf)( &__m512)($X), ( &__v16sf)( &__m512), ($C), ( &__v16sf)( &__m512) &_mm512_undefined_ps(), ( &__mmask16)-1)));
	}' unless defined(&_mm512_shuffle_ps);
	eval 'sub _mm512_mask_shuffle_ps {
	    my($W, $U, $X, $Y, $C) = @_;
    	    eval q((( &__m512) &__builtin_ia32_shufps512_mask (( &__v16sf)( &__m512)($X), ( &__v16sf)( &__m512), ($C), ( &__v16sf)( &__m512)($W), ( &__mmask16)($U))));
	}' unless defined(&_mm512_mask_shuffle_ps);
	eval 'sub _mm512_maskz_shuffle_ps {
	    my($U, $X, $Y, $C) = @_;
    	    eval q((( &__m512) &__builtin_ia32_shufps512_mask (( &__v16sf)( &__m512)($X), ( &__v16sf)( &__m512), ($C), ( &__v16sf)( &__m512) &_mm512_setzero_ps(), ( &__mmask16)($U))));
	}' unless defined(&_mm512_maskz_shuffle_ps);
	eval 'sub _mm512_fixupimm_round_pd {
	    my($X, $Y, $Z, $C, $R) = @_;
    	    eval q((( &__m512d) &__builtin_ia32_fixupimmpd512_mask (( &__v8df)( &__m512d)($X), ( &__v8df)( &__m512d)($Y), ( &__v8di)( &__m512i), ($C), ( &__mmask8)(-1), ($R))));
	}' unless defined(&_mm512_fixupimm_round_pd);
	eval 'sub _mm512_mask_fixupimm_round_pd {
	    my($X, $U, $Y, $Z, $C, $R) = @_;
    	    eval q((( &__m512d) &__builtin_ia32_fixupimmpd512_mask (( &__v8df)( &__m512d)($X), ( &__v8df)( &__m512d)($Y), ( &__v8di)( &__m512i), ($C), ( &__mmask8)($U), ($R))));
	}' unless defined(&_mm512_mask_fixupimm_round_pd);
	eval 'sub _mm512_maskz_fixupimm_round_pd {
	    my($U, $X, $Y, $Z, $C, $R) = @_;
    	    eval q((( &__m512d) &__builtin_ia32_fixupimmpd512_maskz (( &__v8df)( &__m512d)($X), ( &__v8df)( &__m512d)($Y), ( &__v8di)( &__m512i), ($C), ( &__mmask8)($U), ($R))));
	}' unless defined(&_mm512_maskz_fixupimm_round_pd);
	eval 'sub _mm512_fixupimm_round_ps {
	    my($X, $Y, $Z, $C, $R) = @_;
    	    eval q((( &__m512) &__builtin_ia32_fixupimmps512_mask (( &__v16sf)( &__m512)($X), ( &__v16sf)( &__m512)($Y), ( &__v16si)( &__m512i), ($C), ( &__mmask16)(-1), ($R))));
	}' unless defined(&_mm512_fixupimm_round_ps);
	eval 'sub _mm512_mask_fixupimm_round_ps {
	    my($X, $U, $Y, $Z, $C, $R) = @_;
    	    eval q((( &__m512) &__builtin_ia32_fixupimmps512_mask (( &__v16sf)( &__m512)($X), ( &__v16sf)( &__m512)($Y), ( &__v16si)( &__m512i), ($C), ( &__mmask16)($U), ($R))));
	}' unless defined(&_mm512_mask_fixupimm_round_ps);
	eval 'sub _mm512_maskz_fixupimm_round_ps {
	    my($U, $X, $Y, $Z, $C, $R) = @_;
    	    eval q((( &__m512) &__builtin_ia32_fixupimmps512_maskz (( &__v16sf)( &__m512)($X), ( &__v16sf)( &__m512)($Y), ( &__v16si)( &__m512i), ($C), ( &__mmask16)($U), ($R))));
	}' unless defined(&_mm512_maskz_fixupimm_round_ps);
	eval 'sub _mm_fixupimm_round_sd {
	    my($X, $Y, $Z, $C, $R) = @_;
    	    eval q((( &__m128d) &__builtin_ia32_fixupimmsd_mask (( &__v2df)( &__m128d)($X), ( &__v2df)( &__m128d)($Y), ( &__v2di)( &__m128i), ($C), ( &__mmask8)(-1), ($R))));
	}' unless defined(&_mm_fixupimm_round_sd);
	eval 'sub _mm_mask_fixupimm_round_sd {
	    my($X, $U, $Y, $Z, $C, $R) = @_;
    	    eval q((( &__m128d) &__builtin_ia32_fixupimmsd_mask (( &__v2df)( &__m128d)($X), ( &__v2df)( &__m128d)($Y), ( &__v2di)( &__m128i), ($C), ( &__mmask8)($U), ($R))));
	}' unless defined(&_mm_mask_fixupimm_round_sd);
	eval 'sub _mm_maskz_fixupimm_round_sd {
	    my($U, $X, $Y, $Z, $C, $R) = @_;
    	    eval q((( &__m128d) &__builtin_ia32_fixupimmsd_maskz (( &__v2df)( &__m128d)($X), ( &__v2df)( &__m128d)($Y), ( &__v2di)( &__m128i), ($C), ( &__mmask8)($U), ($R))));
	}' unless defined(&_mm_maskz_fixupimm_round_sd);
	eval 'sub _mm_fixupimm_round_ss {
	    my($X, $Y, $Z, $C, $R) = @_;
    	    eval q((( &__m128) &__builtin_ia32_fixupimmss_mask (( &__v4sf)( &__m128)($X), ( &__v4sf)( &__m128)($Y), ( &__v4si)( &__m128i), ($C), ( &__mmask8)(-1), ($R))));
	}' unless defined(&_mm_fixupimm_round_ss);
	eval 'sub _mm_mask_fixupimm_round_ss {
	    my($X, $U, $Y, $Z, $C, $R) = @_;
    	    eval q((( &__m128) &__builtin_ia32_fixupimmss_mask (( &__v4sf)( &__m128)($X), ( &__v4sf)( &__m128)($Y), ( &__v4si)( &__m128i), ($C), ( &__mmask8)($U), ($R))));
	}' unless defined(&_mm_mask_fixupimm_round_ss);
	eval 'sub _mm_maskz_fixupimm_round_ss {
	    my($U, $X, $Y, $Z, $C, $R) = @_;
    	    eval q((( &__m128) &__builtin_ia32_fixupimmss_maskz (( &__v4sf)( &__m128)($X), ( &__v4sf)( &__m128)($Y), ( &__v4si)( &__m128i), ($C), ( &__mmask8)($U), ($R))));
	}' unless defined(&_mm_maskz_fixupimm_round_ss);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_movehdup_ps ( &__m512  &__A) { ( &__m512)  &__builtin_ia32_movshdup512_mask (( &__v16sf)  &__A, ( &__v16sf)  &_mm512_undefined_ps (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_movehdup_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A) { ( &__m512)  &__builtin_ia32_movshdup512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_movehdup_ps ( &__mmask16  &__U,  &__m512  &__A) { ( &__m512)  &__builtin_ia32_movshdup512_mask (( &__v16sf)  &__A, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_moveldup_ps ( &__m512  &__A) { ( &__m512)  &__builtin_ia32_movsldup512_mask (( &__v16sf)  &__A, ( &__v16sf)  &_mm512_undefined_ps (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_moveldup_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A) { ( &__m512)  &__builtin_ia32_movsldup512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_moveldup_ps ( &__mmask16  &__U,  &__m512  &__A) { ( &__m512)  &__builtin_ia32_movsldup512_mask (( &__v16sf)  &__A, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_or_si512 ( &__m512i  &__A,  &__m512i  &__B) { ( &__m512i) (( &__v16su)  &__A | ( &__v16su)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_or_epi32 ( &__m512i  &__A,  &__m512i  &__B) { ( &__m512i) (( &__v16su)  &__A | ( &__v16su)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_or_epi32 ( &__m512i  &__W,  &__mmask16  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pord512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_or_epi32 ( &__mmask16  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pord512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_or_epi64 ( &__m512i  &__A,  &__m512i  &__B) { ( &__m512i) (( &__v8du)  &__A | ( &__v8du)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_or_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_porq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_or_epi64 ( &__mmask8  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_porq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_xor_si512 ( &__m512i  &__A,  &__m512i  &__B) { ( &__m512i) (( &__v16su)  &__A ^ ( &__v16su)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_xor_epi32 ( &__m512i  &__A,  &__m512i  &__B) { ( &__m512i) (( &__v16su)  &__A ^ ( &__v16su)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_xor_epi32 ( &__m512i  &__W,  &__mmask16  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pxord512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_xor_epi32 ( &__mmask16  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pxord512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_xor_epi64 ( &__m512i  &__A,  &__m512i  &__B) { ( &__m512i) (( &__v8du)  &__A ^ ( &__v8du)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_xor_epi64 ( &__m512i  &__W,  &__mmask16  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pxorq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_xor_epi64 ( &__mmask16  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pxorq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_rol_epi32 ( &__m512i  &__A,  &const \'int\'  &__B) { ( &__m512i)  &__builtin_ia32_prold512_mask (( &__v16si)  &__A,  &__B, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_rol_epi32 ( &__m512i  &__W,  &__mmask16  &__U,  &__m512i  &__A,  &const \'int\'  &__B) { ( &__m512i)  &__builtin_ia32_prold512_mask (( &__v16si)  &__A,  &__B, ( &__v16si)  &__W, ( &__mmask16)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_rol_epi32 ( &__mmask16  &__U,  &__m512i  &__A,  &const \'int\'  &__B) { ( &__m512i)  &__builtin_ia32_prold512_mask (( &__v16si)  &__A,  &__B, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_ror_epi32 ( &__m512i  &__A, \'int\'  &__B) { ( &__m512i)  &__builtin_ia32_prord512_mask (( &__v16si)  &__A,  &__B, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_ror_epi32 ( &__m512i  &__W,  &__mmask16  &__U,  &__m512i  &__A, \'int\'  &__B) { ( &__m512i)  &__builtin_ia32_prord512_mask (( &__v16si)  &__A,  &__B, ( &__v16si)  &__W, ( &__mmask16)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_ror_epi32 ( &__mmask16  &__U,  &__m512i  &__A, \'int\'  &__B) { ( &__m512i)  &__builtin_ia32_prord512_mask (( &__v16si)  &__A,  &__B, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_rol_epi64 ( &__m512i  &__A,  &const \'int\'  &__B) { ( &__m512i)  &__builtin_ia32_prolq512_mask (( &__v8di)  &__A,  &__B, ( &__v8di)  &_mm512_undefined_epi32 (), ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_rol_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m512i  &__A,  &const \'int\'  &__B) { ( &__m512i)  &__builtin_ia32_prolq512_mask (( &__v8di)  &__A,  &__B, ( &__v8di)  &__W, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_rol_epi64 ( &__mmask8  &__U,  &__m512i  &__A,  &const \'int\'  &__B) { ( &__m512i)  &__builtin_ia32_prolq512_mask (( &__v8di)  &__A,  &__B, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_ror_epi64 ( &__m512i  &__A, \'int\'  &__B) { ( &__m512i)  &__builtin_ia32_prorq512_mask (( &__v8di)  &__A,  &__B, ( &__v8di)  &_mm512_undefined_epi32 (), ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_ror_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m512i  &__A, \'int\'  &__B) { ( &__m512i)  &__builtin_ia32_prorq512_mask (( &__v8di)  &__A,  &__B, ( &__v8di)  &__W, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_ror_epi64 ( &__mmask8  &__U,  &__m512i  &__A, \'int\'  &__B) { ( &__m512i)  &__builtin_ia32_prorq512_mask (( &__v8di)  &__A,  &__B, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm512_rol_epi32 {
	    my($A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_prold512_mask (( &__v16si)( &__m512i), ($B), ( &__v16si) &_mm512_undefined_epi32 (), ( &__mmask16)(-1))));
	}' unless defined(&_mm512_rol_epi32);
	eval 'sub _mm512_mask_rol_epi32 {
	    my($W, $U, $A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_prold512_mask (( &__v16si)( &__m512i), ($B), ( &__v16si)( &__m512i)($W), ( &__mmask16)($U))));
	}' unless defined(&_mm512_mask_rol_epi32);
	eval 'sub _mm512_maskz_rol_epi32 {
	    my($U, $A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_prold512_mask (( &__v16si)( &__m512i), ($B), ( &__v16si) &_mm512_setzero_si512 (), ( &__mmask16)($U))));
	}' unless defined(&_mm512_maskz_rol_epi32);
	eval 'sub _mm512_ror_epi32 {
	    my($A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_prord512_mask (( &__v16si)( &__m512i), ($B), ( &__v16si) &_mm512_undefined_epi32 (), ( &__mmask16)(-1))));
	}' unless defined(&_mm512_ror_epi32);
	eval 'sub _mm512_mask_ror_epi32 {
	    my($W, $U, $A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_prord512_mask (( &__v16si)( &__m512i), ($B), ( &__v16si)( &__m512i)($W), ( &__mmask16)($U))));
	}' unless defined(&_mm512_mask_ror_epi32);
	eval 'sub _mm512_maskz_ror_epi32 {
	    my($U, $A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_prord512_mask (( &__v16si)( &__m512i), ($B), ( &__v16si) &_mm512_setzero_si512 (), ( &__mmask16)($U))));
	}' unless defined(&_mm512_maskz_ror_epi32);
	eval 'sub _mm512_rol_epi64 {
	    my($A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_prolq512_mask (( &__v8di)( &__m512i), ($B), ( &__v8di) &_mm512_undefined_epi32 (), ( &__mmask8)(-1))));
	}' unless defined(&_mm512_rol_epi64);
	eval 'sub _mm512_mask_rol_epi64 {
	    my($W, $U, $A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_prolq512_mask (( &__v8di)( &__m512i), ($B), ( &__v8di)( &__m512i)($W), ( &__mmask8)($U))));
	}' unless defined(&_mm512_mask_rol_epi64);
	eval 'sub _mm512_maskz_rol_epi64 {
	    my($U, $A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_prolq512_mask (( &__v8di)( &__m512i), ($B), ( &__v8di) &_mm512_setzero_si512 (), ( &__mmask8)($U))));
	}' unless defined(&_mm512_maskz_rol_epi64);
	eval 'sub _mm512_ror_epi64 {
	    my($A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_prorq512_mask (( &__v8di)( &__m512i), ($B), ( &__v8di) &_mm512_undefined_epi32 (), ( &__mmask8)(-1))));
	}' unless defined(&_mm512_ror_epi64);
	eval 'sub _mm512_mask_ror_epi64 {
	    my($W, $U, $A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_prorq512_mask (( &__v8di)( &__m512i), ($B), ( &__v8di)( &__m512i)($W), ( &__mmask8)($U))));
	}' unless defined(&_mm512_mask_ror_epi64);
	eval 'sub _mm512_maskz_ror_epi64 {
	    my($U, $A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_prorq512_mask (( &__v8di)( &__m512i), ($B), ( &__v8di) &_mm512_setzero_si512 (), ( &__mmask8)($U))));
	}' unless defined(&_mm512_maskz_ror_epi64);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_and_si512 ( &__m512i  &__A,  &__m512i  &__B) { ( &__m512i) (( &__v16su)  &__A & ( &__v16su)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_and_epi32 ( &__m512i  &__A,  &__m512i  &__B) { ( &__m512i) (( &__v16su)  &__A & ( &__v16su)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_and_epi32 ( &__m512i  &__W,  &__mmask16  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pandd512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_and_epi32 ( &__mmask16  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pandd512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_and_epi64 ( &__m512i  &__A,  &__m512i  &__B) { ( &__m512i) (( &__v8du)  &__A & ( &__v8du)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_and_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pandq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &__W,  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_and_epi64 ( &__mmask8  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pandq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &_mm512_setzero_pd (),  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_andnot_si512 ( &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pandnd512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_andnot_epi32 ( &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pandnd512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_andnot_epi32 ( &__m512i  &__W,  &__mmask16  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pandnd512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_andnot_epi32 ( &__mmask16  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pandnd512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_andnot_epi64 ( &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pandnq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &_mm512_undefined_epi32 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_andnot_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pandnq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &__W,  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_andnot_epi64 ( &__mmask8  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pandnq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &_mm512_setzero_pd (),  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_test_epi32_mask ( &__m512i  &__A,  &__m512i  &__B) { ( &__mmask16)  &__builtin_ia32_ptestmd512 (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_test_epi32_mask ( &__mmask16  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__mmask16)  &__builtin_ia32_ptestmd512 (( &__v16si)  &__A, ( &__v16si)  &__B,  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_test_epi64_mask ( &__m512i  &__A,  &__m512i  &__B) { ( &__mmask8)  &__builtin_ia32_ptestmq512 (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_test_epi64_mask ( &__mmask8  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__mmask8)  &__builtin_ia32_ptestmq512 (( &__v8di)  &__A, ( &__v8di)  &__B,  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_testn_epi32_mask ( &__m512i  &__A,  &__m512i  &__B) { ( &__mmask16)  &__builtin_ia32_ptestnmd512 (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_testn_epi32_mask ( &__mmask16  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__mmask16)  &__builtin_ia32_ptestnmd512 (( &__v16si)  &__A, ( &__v16si)  &__B,  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_testn_epi64_mask ( &__m512i  &__A,  &__m512i  &__B) { ( &__mmask8)  &__builtin_ia32_ptestnmq512 (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_testn_epi64_mask ( &__mmask8  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__mmask8)  &__builtin_ia32_ptestnmq512 (( &__v8di)  &__A, ( &__v8di)  &__B,  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_abs_ps ( &__m512  &__A) { ( &__m512)  &_mm512_and_epi32 (( &__m512i)  &__A,  &_mm512_set1_epi32 (0x7fffffff)); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_abs_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A) { ( &__m512)  &_mm512_mask_and_epi32 (( &__m512i)  &__W,  &__U, ( &__m512i)  &__A,  &_mm512_set1_epi32 (0x7fffffff)); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_abs_pd ( &__m512d  &__A) { ( &__m512d)  &_mm512_and_epi64 (( &__m512i)  &__A,  &_mm512_set1_epi64 (9.22337203685478e+18)); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_abs_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A) { ( &__m512d)  &_mm512_mask_and_epi64 (( &__m512i)  &__W,  &__U, ( &__m512i)  &__A,  &_mm512_set1_epi64 (9.22337203685478e+18)); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_unpackhi_epi32 ( &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_punpckhdq512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_unpackhi_epi32 ( &__m512i  &__W,  &__mmask16  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_punpckhdq512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_unpackhi_epi32 ( &__mmask16  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_punpckhdq512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_unpackhi_epi64 ( &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_punpckhqdq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &_mm512_undefined_epi32 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_unpackhi_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_punpckhqdq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_unpackhi_epi64 ( &__mmask8  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_punpckhqdq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_unpacklo_epi32 ( &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_punpckldq512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_unpacklo_epi32 ( &__m512i  &__W,  &__mmask16  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_punpckldq512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_unpacklo_epi32 ( &__mmask16  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_punpckldq512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_unpacklo_epi64 ( &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_punpcklqdq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &_mm512_undefined_epi32 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_unpacklo_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_punpcklqdq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_unpacklo_epi64 ( &__mmask8  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_punpcklqdq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    if(defined(&__x86_64__)) {
	if(defined(&__OPTIMIZE__)) {
	    eval 'sub __attribute__ () {
	        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvt_roundss_u64 ( &__m128  &__A,  &const \'int\'  &__R) {  &__builtin_ia32_vcvtss2usi64 (( &__v4sf)  &__A,  &__R); });
	    }' unless defined(&__attribute__);
	    eval 'sub __attribute__ () {
	        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvt_roundss_si64 ( &__m128  &__A,  &const \'int\'  &__R) {  &__builtin_ia32_vcvtss2si64 (( &__v4sf)  &__A,  &__R); });
	    }' unless defined(&__attribute__);
	    eval 'sub __attribute__ () {
	        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvt_roundss_i64 ( &__m128  &__A,  &const \'int\'  &__R) {  &__builtin_ia32_vcvtss2si64 (( &__v4sf)  &__A,  &__R); });
	    }' unless defined(&__attribute__);
	    eval 'sub __attribute__ () {
	        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtt_roundss_u64 ( &__m128  &__A,  &const \'int\'  &__R) {  &__builtin_ia32_vcvttss2usi64 (( &__v4sf)  &__A,  &__R); });
	    }' unless defined(&__attribute__);
	    eval 'sub __attribute__ () {
	        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtt_roundss_i64 ( &__m128  &__A,  &const \'int\'  &__R) {  &__builtin_ia32_vcvttss2si64 (( &__v4sf)  &__A,  &__R); });
	    }' unless defined(&__attribute__);
	    eval 'sub __attribute__ () {
	        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtt_roundss_si64 ( &__m128  &__A,  &const \'int\'  &__R) {  &__builtin_ia32_vcvttss2si64 (( &__v4sf)  &__A,  &__R); });
	    }' unless defined(&__attribute__);
	} else {
	    eval 'sub _mm_cvt_roundss_u64 {
	        my($A, $B) = @_;
    		eval q(( &__builtin_ia32_vcvtss2usi64($A, $B)));
	    }' unless defined(&_mm_cvt_roundss_u64);
	    eval 'sub _mm_cvt_roundss_si64 {
	        my($A, $B) = @_;
    		eval q(( &__builtin_ia32_vcvtss2si64($A, $B)));
	    }' unless defined(&_mm_cvt_roundss_si64);
	    eval 'sub _mm_cvt_roundss_i64 {
	        my($A, $B) = @_;
    		eval q(( &__builtin_ia32_vcvtss2si64($A, $B)));
	    }' unless defined(&_mm_cvt_roundss_i64);
	    eval 'sub _mm_cvtt_roundss_u64 {
	        my($A, $B) = @_;
    		eval q(( &__builtin_ia32_vcvttss2usi64($A, $B)));
	    }' unless defined(&_mm_cvtt_roundss_u64);
	    eval 'sub _mm_cvtt_roundss_i64 {
	        my($A, $B) = @_;
    		eval q(( &__builtin_ia32_vcvttss2si64($A, $B)));
	    }' unless defined(&_mm_cvtt_roundss_i64);
	    eval 'sub _mm_cvtt_roundss_si64 {
	        my($A, $B) = @_;
    		eval q(( &__builtin_ia32_vcvttss2si64($A, $B)));
	    }' unless defined(&_mm_cvtt_roundss_si64);
	}
    }
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvt_roundss_u32 ( &__m128  &__A,  &const \'int\'  &__R) {  &__builtin_ia32_vcvtss2usi32 (( &__v4sf)  &__A,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvt_roundss_si32 ( &__m128  &__A,  &const \'int\'  &__R) {  &__builtin_ia32_vcvtss2si32 (( &__v4sf)  &__A,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvt_roundss_i32 ( &__m128  &__A,  &const \'int\'  &__R) {  &__builtin_ia32_vcvtss2si32 (( &__v4sf)  &__A,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtt_roundss_u32 ( &__m128  &__A,  &const \'int\'  &__R) {  &__builtin_ia32_vcvttss2usi32 (( &__v4sf)  &__A,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtt_roundss_i32 ( &__m128  &__A,  &const \'int\'  &__R) {  &__builtin_ia32_vcvttss2si32 (( &__v4sf)  &__A,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtt_roundss_si32 ( &__m128  &__A,  &const \'int\'  &__R) {  &__builtin_ia32_vcvttss2si32 (( &__v4sf)  &__A,  &__R); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm_cvt_roundss_u32 {
	    my($A, $B) = @_;
    	    eval q(( &__builtin_ia32_vcvtss2usi32($A, $B)));
	}' unless defined(&_mm_cvt_roundss_u32);
	eval 'sub _mm_cvt_roundss_si32 {
	    my($A, $B) = @_;
    	    eval q(( &__builtin_ia32_vcvtss2si32($A, $B)));
	}' unless defined(&_mm_cvt_roundss_si32);
	eval 'sub _mm_cvt_roundss_i32 {
	    my($A, $B) = @_;
    	    eval q(( &__builtin_ia32_vcvtss2si32($A, $B)));
	}' unless defined(&_mm_cvt_roundss_i32);
	eval 'sub _mm_cvtt_roundss_u32 {
	    my($A, $B) = @_;
    	    eval q(( &__builtin_ia32_vcvttss2usi32($A, $B)));
	}' unless defined(&_mm_cvtt_roundss_u32);
	eval 'sub _mm_cvtt_roundss_si32 {
	    my($A, $B) = @_;
    	    eval q(( &__builtin_ia32_vcvttss2si32($A, $B)));
	}' unless defined(&_mm_cvtt_roundss_si32);
	eval 'sub _mm_cvtt_roundss_i32 {
	    my($A, $B) = @_;
    	    eval q(( &__builtin_ia32_vcvttss2si32($A, $B)));
	}' unless defined(&_mm_cvtt_roundss_i32);
    }
    if(defined(&__x86_64__)) {
	if(defined(&__OPTIMIZE__)) {
	    eval 'sub __attribute__ () {
	        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvt_roundsd_u64 ( &__m128d  &__A,  &const \'int\'  &__R) {  &__builtin_ia32_vcvtsd2usi64 (( &__v2df)  &__A,  &__R); });
	    }' unless defined(&__attribute__);
	    eval 'sub __attribute__ () {
	        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvt_roundsd_si64 ( &__m128d  &__A,  &const \'int\'  &__R) {  &__builtin_ia32_vcvtsd2si64 (( &__v2df)  &__A,  &__R); });
	    }' unless defined(&__attribute__);
	    eval 'sub __attribute__ () {
	        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvt_roundsd_i64 ( &__m128d  &__A,  &const \'int\'  &__R) {  &__builtin_ia32_vcvtsd2si64 (( &__v2df)  &__A,  &__R); });
	    }' unless defined(&__attribute__);
	    eval 'sub __attribute__ () {
	        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtt_roundsd_u64 ( &__m128d  &__A,  &const \'int\'  &__R) {  &__builtin_ia32_vcvttsd2usi64 (( &__v2df)  &__A,  &__R); });
	    }' unless defined(&__attribute__);
	    eval 'sub __attribute__ () {
	        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtt_roundsd_si64 ( &__m128d  &__A,  &const \'int\'  &__R) {  &__builtin_ia32_vcvttsd2si64 (( &__v2df)  &__A,  &__R); });
	    }' unless defined(&__attribute__);
	    eval 'sub __attribute__ () {
	        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtt_roundsd_i64 ( &__m128d  &__A,  &const \'int\'  &__R) {  &__builtin_ia32_vcvttsd2si64 (( &__v2df)  &__A,  &__R); });
	    }' unless defined(&__attribute__);
	} else {
	    eval 'sub _mm_cvt_roundsd_u64 {
	        my($A, $B) = @_;
    		eval q(( &__builtin_ia32_vcvtsd2usi64($A, $B)));
	    }' unless defined(&_mm_cvt_roundsd_u64);
	    eval 'sub _mm_cvt_roundsd_si64 {
	        my($A, $B) = @_;
    		eval q(( &__builtin_ia32_vcvtsd2si64($A, $B)));
	    }' unless defined(&_mm_cvt_roundsd_si64);
	    eval 'sub _mm_cvt_roundsd_i64 {
	        my($A, $B) = @_;
    		eval q(( &__builtin_ia32_vcvtsd2si64($A, $B)));
	    }' unless defined(&_mm_cvt_roundsd_i64);
	    eval 'sub _mm_cvtt_roundsd_u64 {
	        my($A, $B) = @_;
    		eval q(( &__builtin_ia32_vcvttsd2usi64($A, $B)));
	    }' unless defined(&_mm_cvtt_roundsd_u64);
	    eval 'sub _mm_cvtt_roundsd_si64 {
	        my($A, $B) = @_;
    		eval q(( &__builtin_ia32_vcvttsd2si64($A, $B)));
	    }' unless defined(&_mm_cvtt_roundsd_si64);
	    eval 'sub _mm_cvtt_roundsd_i64 {
	        my($A, $B) = @_;
    		eval q(( &__builtin_ia32_vcvttsd2si64($A, $B)));
	    }' unless defined(&_mm_cvtt_roundsd_i64);
	}
    }
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvt_roundsd_u32 ( &__m128d  &__A,  &const \'int\'  &__R) {  &__builtin_ia32_vcvtsd2usi32 (( &__v2df)  &__A,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvt_roundsd_si32 ( &__m128d  &__A,  &const \'int\'  &__R) {  &__builtin_ia32_vcvtsd2si32 (( &__v2df)  &__A,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvt_roundsd_i32 ( &__m128d  &__A,  &const \'int\'  &__R) {  &__builtin_ia32_vcvtsd2si32 (( &__v2df)  &__A,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtt_roundsd_u32 ( &__m128d  &__A,  &const \'int\'  &__R) {  &__builtin_ia32_vcvttsd2usi32 (( &__v2df)  &__A,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtt_roundsd_i32 ( &__m128d  &__A,  &const \'int\'  &__R) {  &__builtin_ia32_vcvttsd2si32 (( &__v2df)  &__A,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtt_roundsd_si32 ( &__m128d  &__A,  &const \'int\'  &__R) {  &__builtin_ia32_vcvttsd2si32 (( &__v2df)  &__A,  &__R); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm_cvt_roundsd_u32 {
	    my($A, $B) = @_;
    	    eval q(( &__builtin_ia32_vcvtsd2usi32($A, $B)));
	}' unless defined(&_mm_cvt_roundsd_u32);
	eval 'sub _mm_cvt_roundsd_si32 {
	    my($A, $B) = @_;
    	    eval q(( &__builtin_ia32_vcvtsd2si32($A, $B)));
	}' unless defined(&_mm_cvt_roundsd_si32);
	eval 'sub _mm_cvt_roundsd_i32 {
	    my($A, $B) = @_;
    	    eval q(( &__builtin_ia32_vcvtsd2si32($A, $B)));
	}' unless defined(&_mm_cvt_roundsd_i32);
	eval 'sub _mm_cvtt_roundsd_u32 {
	    my($A, $B) = @_;
    	    eval q(( &__builtin_ia32_vcvttsd2usi32($A, $B)));
	}' unless defined(&_mm_cvtt_roundsd_u32);
	eval 'sub _mm_cvtt_roundsd_si32 {
	    my($A, $B) = @_;
    	    eval q(( &__builtin_ia32_vcvttsd2si32($A, $B)));
	}' unless defined(&_mm_cvtt_roundsd_si32);
	eval 'sub _mm_cvtt_roundsd_i32 {
	    my($A, $B) = @_;
    	    eval q(( &__builtin_ia32_vcvttsd2si32($A, $B)));
	}' unless defined(&_mm_cvtt_roundsd_i32);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_movedup_pd ( &__m512d  &__A) { ( &__m512d)  &__builtin_ia32_movddup512_mask (( &__v8df)  &__A, ( &__v8df)  &_mm512_undefined_pd (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_movedup_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A) { ( &__m512d)  &__builtin_ia32_movddup512_mask (( &__v8df)  &__A, ( &__v8df)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_movedup_pd ( &__mmask8  &__U,  &__m512d  &__A) { ( &__m512d)  &__builtin_ia32_movddup512_mask (( &__v8df)  &__A, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_unpacklo_pd ( &__m512d  &__A,  &__m512d  &__B) { ( &__m512d)  &__builtin_ia32_unpcklpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &_mm512_undefined_pd (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_unpacklo_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B) { ( &__m512d)  &__builtin_ia32_unpcklpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_unpacklo_pd ( &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B) { ( &__m512d)  &__builtin_ia32_unpcklpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_unpackhi_pd ( &__m512d  &__A,  &__m512d  &__B) { ( &__m512d)  &__builtin_ia32_unpckhpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &_mm512_undefined_pd (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_unpackhi_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B) { ( &__m512d)  &__builtin_ia32_unpckhpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_unpackhi_pd ( &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B) { ( &__m512d)  &__builtin_ia32_unpckhpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_unpackhi_ps ( &__m512  &__A,  &__m512  &__B) { ( &__m512)  &__builtin_ia32_unpckhps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &_mm512_undefined_ps (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_unpackhi_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B) { ( &__m512)  &__builtin_ia32_unpckhps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_unpackhi_ps ( &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B) { ( &__m512)  &__builtin_ia32_unpckhps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvt_roundps_pd ( &__m256  &__A,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_cvtps2pd512_mask (( &__v8sf)  &__A, ( &__v8df)  &_mm512_undefined_pd (), ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvt_roundps_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m256  &__A,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_cvtps2pd512_mask (( &__v8sf)  &__A, ( &__v8df)  &__W, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvt_roundps_pd ( &__mmask8  &__U,  &__m256  &__A,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_cvtps2pd512_mask (( &__v8sf)  &__A, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvt_roundph_ps ( &__m256i  &__A,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_vcvtph2ps512_mask (( &__v16hi)  &__A, ( &__v16sf)  &_mm512_undefined_ps (), ( &__mmask16) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvt_roundph_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m256i  &__A,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_vcvtph2ps512_mask (( &__v16hi)  &__A, ( &__v16sf)  &__W, ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvt_roundph_ps ( &__mmask16  &__U,  &__m256i  &__A,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_vcvtph2ps512_mask (( &__v16hi)  &__A, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvt_roundps_ph ( &__m512  &__A,  &const \'int\'  &__I) { ( &__m256i)  &__builtin_ia32_vcvtps2ph512_mask (( &__v16sf)  &__A,  &__I, ( &__v16hi)  &_mm256_undefined_si256 (), -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtps_ph ( &__m512  &__A,  &const \'int\'  &__I) { ( &__m256i)  &__builtin_ia32_vcvtps2ph512_mask (( &__v16sf)  &__A,  &__I, ( &__v16hi)  &_mm256_undefined_si256 (), -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvt_roundps_ph ( &__m256i  &__U,  &__mmask16  &__W,  &__m512  &__A,  &const \'int\'  &__I) { ( &__m256i)  &__builtin_ia32_vcvtps2ph512_mask (( &__v16sf)  &__A,  &__I, ( &__v16hi)  &__U, ( &__mmask16)  &__W); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtps_ph ( &__m256i  &__U,  &__mmask16  &__W,  &__m512  &__A,  &const \'int\'  &__I) { ( &__m256i)  &__builtin_ia32_vcvtps2ph512_mask (( &__v16sf)  &__A,  &__I, ( &__v16hi)  &__U, ( &__mmask16)  &__W); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvt_roundps_ph ( &__mmask16  &__W,  &__m512  &__A,  &const \'int\'  &__I) { ( &__m256i)  &__builtin_ia32_vcvtps2ph512_mask (( &__v16sf)  &__A,  &__I, ( &__v16hi)  &_mm256_setzero_si256 (), ( &__mmask16)  &__W); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtps_ph ( &__mmask16  &__W,  &__m512  &__A,  &const \'int\'  &__I) { ( &__m256i)  &__builtin_ia32_vcvtps2ph512_mask (( &__v16sf)  &__A,  &__I, ( &__v16hi)  &_mm256_setzero_si256 (), ( &__mmask16)  &__W); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm512_cvt_roundps_pd {
	    my($A, $B) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_cvtps2pd512_mask($A, ( &__v8df) &_mm512_undefined_pd(), -1, $B));
	}' unless defined(&_mm512_cvt_roundps_pd);
	eval 'sub _mm512_mask_cvt_roundps_pd {
	    my($W, $U, $A, $B) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_cvtps2pd512_mask($A, ( &__v8df)($W), $U, $B));
	}' unless defined(&_mm512_mask_cvt_roundps_pd);
	eval 'sub _mm512_maskz_cvt_roundps_pd {
	    my($U, $A, $B) = @_;
    	    eval q(( &__m512d) &__builtin_ia32_cvtps2pd512_mask($A, ( &__v8df) &_mm512_setzero_pd(), $U, $B));
	}' unless defined(&_mm512_maskz_cvt_roundps_pd);
	eval 'sub _mm512_cvt_roundph_ps {
	    my($A, $B) = @_;
    	    eval q(( &__m512) &__builtin_ia32_vcvtph2ps512_mask(( &__v16hi)($A), ( &__v16sf) &_mm512_undefined_ps(), -1, $B));
	}' unless defined(&_mm512_cvt_roundph_ps);
	eval 'sub _mm512_mask_cvt_roundph_ps {
	    my($W, $U, $A, $B) = @_;
    	    eval q(( &__m512) &__builtin_ia32_vcvtph2ps512_mask(( &__v16hi)($A), ( &__v16sf)($W), $U, $B));
	}' unless defined(&_mm512_mask_cvt_roundph_ps);
	eval 'sub _mm512_maskz_cvt_roundph_ps {
	    my($U, $A, $B) = @_;
    	    eval q(( &__m512) &__builtin_ia32_vcvtph2ps512_mask(( &__v16hi)($A), ( &__v16sf) &_mm512_setzero_ps(), $U, $B));
	}' unless defined(&_mm512_maskz_cvt_roundph_ps);
	eval 'sub _mm512_cvt_roundps_ph {
	    my($A, $I) = @_;
    	    eval q((( &__m256i)  &__builtin_ia32_vcvtps2ph512_mask (( &__v16sf)( &__m512) $A, ($I), ( &__v16hi) &_mm256_undefined_si256 (), -1)));
	}' unless defined(&_mm512_cvt_roundps_ph);
	eval 'sub _mm512_cvtps_ph {
	    my($A, $I) = @_;
    	    eval q((( &__m256i)  &__builtin_ia32_vcvtps2ph512_mask (( &__v16sf)( &__m512) $A, ($I), ( &__v16hi) &_mm256_undefined_si256 (), -1)));
	}' unless defined(&_mm512_cvtps_ph);
	eval 'sub _mm512_mask_cvt_roundps_ph {
	    my($U, $W, $A, $I) = @_;
    	    eval q((( &__m256i)  &__builtin_ia32_vcvtps2ph512_mask (( &__v16sf)( &__m512) $A, ($I), ( &__v16hi)( &__m256i)($U), ( &__mmask16) ($W))));
	}' unless defined(&_mm512_mask_cvt_roundps_ph);
	eval 'sub _mm512_mask_cvtps_ph {
	    my($U, $W, $A, $I) = @_;
    	    eval q((( &__m256i)  &__builtin_ia32_vcvtps2ph512_mask (( &__v16sf)( &__m512) $A, ($I), ( &__v16hi)( &__m256i)($U), ( &__mmask16) ($W))));
	}' unless defined(&_mm512_mask_cvtps_ph);
	eval 'sub _mm512_maskz_cvt_roundps_ph {
	    my($W, $A, $I) = @_;
    	    eval q((( &__m256i)  &__builtin_ia32_vcvtps2ph512_mask (( &__v16sf)( &__m512) $A, ($I), ( &__v16hi) &_mm256_setzero_si256 (), ( &__mmask16) ($W))));
	}' unless defined(&_mm512_maskz_cvt_roundps_ph);
	eval 'sub _mm512_maskz_cvtps_ph {
	    my($W, $A, $I) = @_;
    	    eval q((( &__m256i)  &__builtin_ia32_vcvtps2ph512_mask (( &__v16sf)( &__m512) $A, ($I), ( &__v16hi) &_mm256_setzero_si256 (), ( &__mmask16) ($W))));
	}' unless defined(&_mm512_maskz_cvtps_ph);
    }
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvt_roundpd_ps ( &__m512d  &__A,  &const \'int\'  &__R) { ( &__m256)  &__builtin_ia32_cvtpd2ps512_mask (( &__v8df)  &__A, ( &__v8sf)  &_mm256_undefined_ps (), ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvt_roundpd_ps ( &__m256  &__W,  &__mmask8  &__U,  &__m512d  &__A,  &const \'int\'  &__R) { ( &__m256)  &__builtin_ia32_cvtpd2ps512_mask (( &__v8df)  &__A, ( &__v8sf)  &__W, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvt_roundpd_ps ( &__mmask8  &__U,  &__m512d  &__A,  &const \'int\'  &__R) { ( &__m256)  &__builtin_ia32_cvtpd2ps512_mask (( &__v8df)  &__A, ( &__v8sf)  &_mm256_setzero_ps (), ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvt_roundsd_ss ( &__m128  &__A,  &__m128d  &__B,  &const \'int\'  &__R) { ( &__m128)  &__builtin_ia32_cvtsd2ss_round (( &__v4sf)  &__A, ( &__v2df)  &__B,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvt_roundss_sd ( &__m128d  &__A,  &__m128  &__B,  &const \'int\'  &__R) { ( &__m128d)  &__builtin_ia32_cvtss2sd_round (( &__v2df)  &__A, ( &__v4sf)  &__B,  &__R); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm512_cvt_roundpd_ps {
	    my($A, $B) = @_;
    	    eval q(( &__m256) &__builtin_ia32_cvtpd2ps512_mask($A, ( &__v8sf) &_mm256_undefined_ps(), -1, $B));
	}' unless defined(&_mm512_cvt_roundpd_ps);
	eval 'sub _mm512_mask_cvt_roundpd_ps {
	    my($W, $U, $A, $B) = @_;
    	    eval q(( &__m256) &__builtin_ia32_cvtpd2ps512_mask($A, ( &__v8sf)($W), $U, $B));
	}' unless defined(&_mm512_mask_cvt_roundpd_ps);
	eval 'sub _mm512_maskz_cvt_roundpd_ps {
	    my($U, $A, $B) = @_;
    	    eval q(( &__m256) &__builtin_ia32_cvtpd2ps512_mask($A, ( &__v8sf) &_mm256_setzero_ps(), $U, $B));
	}' unless defined(&_mm512_maskz_cvt_roundpd_ps);
	eval 'sub _mm_cvt_roundsd_ss {
	    my($A, $B, $C) = @_;
    	    eval q(( &__m128) &__builtin_ia32_cvtsd2ss_round($A, $B, $C));
	}' unless defined(&_mm_cvt_roundsd_ss);
	eval 'sub _mm_cvt_roundss_sd {
	    my($A, $B, $C) = @_;
    	    eval q(( &__m128d) &__builtin_ia32_cvtss2sd_round($A, $B, $C));
	}' unless defined(&_mm_cvt_roundss_sd);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_stream_si512 ( &__m512i *  &__P,  &__m512i  &__A) {  &__builtin_ia32_movntdq512 (( &__v8di *)  &__P, ( &__v8di)  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_stream_ps (\'float\' * &__P,  &__m512  &__A) {  &__builtin_ia32_movntps512 ( &__P, ( &__v16sf)  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_stream_pd (\'double\' * &__P,  &__m512d  &__A) {  &__builtin_ia32_movntpd512 ( &__P, ( &__v8df)  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_stream_load_si512 ( &void * &__P) {  &__builtin_ia32_movntdqa512 (( &__v8di *) &__P); });
    }' unless defined(&__attribute__);
    eval("sub _MM_MANT_NORM_1_2 () { 0; }") unless defined(&_MM_MANT_NORM_1_2);
    eval("sub _MM_MANT_NORM_p5_2 () { 1; }") unless defined(&_MM_MANT_NORM_p5_2);
    eval("sub _MM_MANT_NORM_p5_1 () { 2; }") unless defined(&_MM_MANT_NORM_p5_1);
    eval("sub _MM_MANT_NORM_p75_1p5 () { 3; }") unless defined(&_MM_MANT_NORM_p75_1p5);
    eval("sub _MM_MANT_SIGN_src () { 0; }") unless defined(&_MM_MANT_SIGN_src);
    eval("sub _MM_MANT_SIGN_zero () { 1; }") unless defined(&_MM_MANT_SIGN_zero);
    eval("sub _MM_MANT_SIGN_nan () { 2; }") unless defined(&_MM_MANT_SIGN_nan);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_getexp_round_ss ( &__m128  &__A,  &__m128  &__B,  &const \'int\'  &__R) { ( &__m128)  &__builtin_ia32_getexpss128_round (( &__v4sf)  &__A, ( &__v4sf)  &__B,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_getexp_round_sd ( &__m128d  &__A,  &__m128d  &__B,  &const \'int\'  &__R) { ( &__m128d)  &__builtin_ia32_getexpsd128_round (( &__v2df)  &__A, ( &__v2df)  &__B,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_getexp_round_ps ( &__m512  &__A,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_getexpps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &_mm512_undefined_ps (), ( &__mmask16) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_getexp_round_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_getexpps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__W, ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_getexp_round_ps ( &__mmask16  &__U,  &__m512  &__A,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_getexpps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_getexp_round_pd ( &__m512d  &__A,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_getexppd512_mask (( &__v8df)  &__A, ( &__v8df)  &_mm512_undefined_pd (), ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_getexp_round_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_getexppd512_mask (( &__v8df)  &__A, ( &__v8df)  &__W, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_getexp_round_pd ( &__mmask8  &__U,  &__m512d  &__A,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_getexppd512_mask (( &__v8df)  &__A, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_getmant_round_pd ( &__m512d  &__A,  &_MM_MANTISSA_NORM_ENUM  &__B,  &_MM_MANTISSA_SIGN_ENUM  &__C,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_getmantpd512_mask (( &__v8df)  &__A, ( &__C << 2) |  &__B,  &_mm512_undefined_pd (), ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_getmant_round_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A,  &_MM_MANTISSA_NORM_ENUM  &__B,  &_MM_MANTISSA_SIGN_ENUM  &__C,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_getmantpd512_mask (( &__v8df)  &__A, ( &__C << 2) |  &__B, ( &__v8df)  &__W,  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_getmant_round_pd ( &__mmask8  &__U,  &__m512d  &__A,  &_MM_MANTISSA_NORM_ENUM  &__B,  &_MM_MANTISSA_SIGN_ENUM  &__C,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_getmantpd512_mask (( &__v8df)  &__A, ( &__C << 2) |  &__B, ( &__v8df)  &_mm512_setzero_pd (),  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_getmant_round_ps ( &__m512  &__A,  &_MM_MANTISSA_NORM_ENUM  &__B,  &_MM_MANTISSA_SIGN_ENUM  &__C,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_getmantps512_mask (( &__v16sf)  &__A, ( &__C << 2) |  &__B,  &_mm512_undefined_ps (), ( &__mmask16) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_getmant_round_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A,  &_MM_MANTISSA_NORM_ENUM  &__B,  &_MM_MANTISSA_SIGN_ENUM  &__C,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_getmantps512_mask (( &__v16sf)  &__A, ( &__C << 2) |  &__B, ( &__v16sf)  &__W,  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_getmant_round_ps ( &__mmask16  &__U,  &__m512  &__A,  &_MM_MANTISSA_NORM_ENUM  &__B,  &_MM_MANTISSA_SIGN_ENUM  &__C,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_getmantps512_mask (( &__v16sf)  &__A, ( &__C << 2) |  &__B, ( &__v16sf)  &_mm512_setzero_ps (),  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_getmant_round_sd ( &__m128d  &__A,  &__m128d  &__B,  &_MM_MANTISSA_NORM_ENUM  &__C,  &_MM_MANTISSA_SIGN_ENUM  &__D,  &const \'int\'  &__R) { ( &__m128d)  &__builtin_ia32_getmantsd_round (( &__v2df)  &__A, ( &__v2df)  &__B, ( &__D << 2) |  &__C,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_getmant_round_ss ( &__m128  &__A,  &__m128  &__B,  &_MM_MANTISSA_NORM_ENUM  &__C,  &_MM_MANTISSA_SIGN_ENUM  &__D,  &const \'int\'  &__R) { ( &__m128)  &__builtin_ia32_getmantss_round (( &__v4sf)  &__A, ( &__v4sf)  &__B, ( &__D << 2) |  &__C,  &__R); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm512_getmant_round_pd {
	    my($X, $B, $C, $R) = @_;
    	    eval q((( &__m512d) &__builtin_ia32_getmantpd512_mask (( &__v8df)( &__m512d), ((($C)<<2) | ($B)), ( &__v8df)( &__m512d) &_mm512_undefined_pd(), ( &__mmask8)-1, ($R))));
	}' unless defined(&_mm512_getmant_round_pd);
	eval 'sub _mm512_mask_getmant_round_pd {
	    my($W, $U, $X, $B, $C, $R) = @_;
    	    eval q((( &__m512d) &__builtin_ia32_getmantpd512_mask (( &__v8df)( &__m512d), ((($C)<<2) | ($B)), ( &__v8df)( &__m512d)($W), ( &__mmask8)($U), ($R))));
	}' unless defined(&_mm512_mask_getmant_round_pd);
	eval 'sub _mm512_maskz_getmant_round_pd {
	    my($U, $X, $B, $C, $R) = @_;
    	    eval q((( &__m512d) &__builtin_ia32_getmantpd512_mask (( &__v8df)( &__m512d), ((($C)<<2) | ($B)), ( &__v8df)( &__m512d) &_mm512_setzero_pd(), ( &__mmask8)($U), ($R))));
	}' unless defined(&_mm512_maskz_getmant_round_pd);
	eval 'sub _mm512_getmant_round_ps {
	    my($X, $B, $C, $R) = @_;
    	    eval q((( &__m512) &__builtin_ia32_getmantps512_mask (( &__v16sf)( &__m512), ((($C)<<2) | ($B)), ( &__v16sf)( &__m512) &_mm512_undefined_ps(), ( &__mmask16)-1, ($R))));
	}' unless defined(&_mm512_getmant_round_ps);
	eval 'sub _mm512_mask_getmant_round_ps {
	    my($W, $U, $X, $B, $C, $R) = @_;
    	    eval q((( &__m512) &__builtin_ia32_getmantps512_mask (( &__v16sf)( &__m512), ((($C)<<2) | ($B)), ( &__v16sf)( &__m512)($W), ( &__mmask16)($U), ($R))));
	}' unless defined(&_mm512_mask_getmant_round_ps);
	eval 'sub _mm512_maskz_getmant_round_ps {
	    my($U, $X, $B, $C, $R) = @_;
    	    eval q((( &__m512) &__builtin_ia32_getmantps512_mask (( &__v16sf)( &__m512), ((($C)<<2) | ($B)), ( &__v16sf)( &__m512) &_mm512_setzero_ps(), ( &__mmask16)($U), ($R))));
	}' unless defined(&_mm512_maskz_getmant_round_ps);
	eval 'sub _mm_getmant_round_sd {
	    my($X, $Y, $C, $D, $R) = @_;
    	    eval q((( &__m128d) &__builtin_ia32_getmantsd_round (( &__v2df)( &__m128d)($X), ( &__v2df)( &__m128d), ((($D)<<2) | ($C)), ($R))));
	}' unless defined(&_mm_getmant_round_sd);
	eval 'sub _mm_getmant_round_ss {
	    my($X, $Y, $C, $D, $R) = @_;
    	    eval q((( &__m128) &__builtin_ia32_getmantss_round (( &__v4sf)( &__m128)($X), ( &__v4sf)( &__m128), ((($D)<<2) | ($C)), ($R))));
	}' unless defined(&_mm_getmant_round_ss);
	eval 'sub _mm_getexp_round_ss {
	    my($A, $B, $R) = @_;
    	    eval q((( &__m128) &__builtin_ia32_getexpss128_round(( &__v4sf)( &__m128)($A), ( &__v4sf)( &__m128)($B), $R)));
	}' unless defined(&_mm_getexp_round_ss);
	eval 'sub _mm_getexp_round_sd {
	    my($A, $B, $R) = @_;
    	    eval q((( &__m128d) &__builtin_ia32_getexpsd128_round(( &__v2df)( &__m128d)($A), ( &__v2df)( &__m128d)($B), $R)));
	}' unless defined(&_mm_getexp_round_sd);
	eval 'sub _mm512_getexp_round_ps {
	    my($A, $R) = @_;
    	    eval q((( &__m512) &__builtin_ia32_getexpps512_mask(( &__v16sf)( &__m512)($A), ( &__v16sf) &_mm512_undefined_ps(), ( &__mmask16)-1, $R)));
	}' unless defined(&_mm512_getexp_round_ps);
	eval 'sub _mm512_mask_getexp_round_ps {
	    my($W, $U, $A, $R) = @_;
    	    eval q((( &__m512) &__builtin_ia32_getexpps512_mask(( &__v16sf)( &__m512)($A), ( &__v16sf)( &__m512)($W), ( &__mmask16)($U), $R)));
	}' unless defined(&_mm512_mask_getexp_round_ps);
	eval 'sub _mm512_maskz_getexp_round_ps {
	    my($U, $A, $R) = @_;
    	    eval q((( &__m512) &__builtin_ia32_getexpps512_mask(( &__v16sf)( &__m512)($A), ( &__v16sf) &_mm512_setzero_ps(), ( &__mmask16)($U), $R)));
	}' unless defined(&_mm512_maskz_getexp_round_ps);
	eval 'sub _mm512_getexp_round_pd {
	    my($A, $R) = @_;
    	    eval q((( &__m512d) &__builtin_ia32_getexppd512_mask(( &__v8df)( &__m512d)($A), ( &__v8df) &_mm512_undefined_pd(), ( &__mmask8)-1, $R)));
	}' unless defined(&_mm512_getexp_round_pd);
	eval 'sub _mm512_mask_getexp_round_pd {
	    my($W, $U, $A, $R) = @_;
    	    eval q((( &__m512d) &__builtin_ia32_getexppd512_mask(( &__v8df)( &__m512d)($A), ( &__v8df)( &__m512d)($W), ( &__mmask8)($U), $R)));
	}' unless defined(&_mm512_mask_getexp_round_pd);
	eval 'sub _mm512_maskz_getexp_round_pd {
	    my($U, $A, $R) = @_;
    	    eval q((( &__m512d) &__builtin_ia32_getexppd512_mask(( &__v8df)( &__m512d)($A), ( &__v8df) &_mm512_setzero_pd(), ( &__mmask8)($U), $R)));
	}' unless defined(&_mm512_maskz_getexp_round_pd);
    }
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_roundscale_round_ps ( &__m512  &__A,  &const \'int\'  &__imm,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_rndscaleps_mask (( &__v16sf)  &__A,  &__imm, ( &__v16sf)  &_mm512_undefined_ps (), -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_roundscale_round_ps ( &__m512  &__A,  &__mmask16  &__B,  &__m512  &__C,  &const \'int\'  &__imm,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_rndscaleps_mask (( &__v16sf)  &__C,  &__imm, ( &__v16sf)  &__A, ( &__mmask16)  &__B,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_roundscale_round_ps ( &__mmask16  &__A,  &__m512  &__B,  &const \'int\'  &__imm,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_rndscaleps_mask (( &__v16sf)  &__B,  &__imm, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__A,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_roundscale_round_pd ( &__m512d  &__A,  &const \'int\'  &__imm,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_rndscalepd_mask (( &__v8df)  &__A,  &__imm, ( &__v8df)  &_mm512_undefined_pd (), -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_roundscale_round_pd ( &__m512d  &__A,  &__mmask8  &__B,  &__m512d  &__C,  &const \'int\'  &__imm,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_rndscalepd_mask (( &__v8df)  &__C,  &__imm, ( &__v8df)  &__A, ( &__mmask8)  &__B,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_roundscale_round_pd ( &__mmask8  &__A,  &__m512d  &__B,  &const \'int\'  &__imm,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_rndscalepd_mask (( &__v8df)  &__B,  &__imm, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__A,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_roundscale_round_ss ( &__m128  &__A,  &__m128  &__B,  &const \'int\'  &__imm,  &const \'int\'  &__R) { ( &__m128)  &__builtin_ia32_rndscaless_round (( &__v4sf)  &__A, ( &__v4sf)  &__B,  &__imm,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_roundscale_round_sd ( &__m128d  &__A,  &__m128d  &__B,  &const \'int\'  &__imm,  &const \'int\'  &__R) { ( &__m128d)  &__builtin_ia32_rndscalesd_round (( &__v2df)  &__A, ( &__v2df)  &__B,  &__imm,  &__R); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm512_roundscale_round_ps {
	    my($A, $B, $R) = @_;
    	    eval q((( &__m512)  &__builtin_ia32_rndscaleps_mask (( &__v16sf)( &__m512), ($B), ( &__v16sf) &_mm512_undefined_ps(), ( &__mmask16)(-1), $R)));
	}' unless defined(&_mm512_roundscale_round_ps);
	eval 'sub _mm512_mask_roundscale_round_ps {
	    my($A, $B, $C, $D, $R) = @_;
    	    eval q((( &__m512)  &__builtin_ia32_rndscaleps_mask (( &__v16sf)( &__m512), ($D), ( &__v16sf)( &__m512)($A), ( &__mmask16)($B), $R)));
	}' unless defined(&_mm512_mask_roundscale_round_ps);
	eval 'sub _mm512_maskz_roundscale_round_ps {
	    my($A, $B, $C, $R) = @_;
    	    eval q((( &__m512)  &__builtin_ia32_rndscaleps_mask (( &__v16sf)( &__m512), ($C), ( &__v16sf) &_mm512_setzero_ps(), ( &__mmask16)($A), $R)));
	}' unless defined(&_mm512_maskz_roundscale_round_ps);
	eval 'sub _mm512_roundscale_round_pd {
	    my($A, $B, $R) = @_;
    	    eval q((( &__m512d)  &__builtin_ia32_rndscalepd_mask (( &__v8df)( &__m512d), ($B), ( &__v8df) &_mm512_undefined_pd(), ( &__mmask8)(-1), $R)));
	}' unless defined(&_mm512_roundscale_round_pd);
	eval 'sub _mm512_mask_roundscale_round_pd {
	    my($A, $B, $C, $D, $R) = @_;
    	    eval q((( &__m512d)  &__builtin_ia32_rndscalepd_mask (( &__v8df)( &__m512d), ($D), ( &__v8df)( &__m512d)($A), ( &__mmask8)($B), $R)));
	}' unless defined(&_mm512_mask_roundscale_round_pd);
	eval 'sub _mm512_maskz_roundscale_round_pd {
	    my($A, $B, $C, $R) = @_;
    	    eval q((( &__m512d)  &__builtin_ia32_rndscalepd_mask (( &__v8df)( &__m512d), ($C), ( &__v8df) &_mm512_setzero_pd(), ( &__mmask8)($A), $R)));
	}' unless defined(&_mm512_maskz_roundscale_round_pd);
	eval 'sub _mm_roundscale_round_ss {
	    my($A, $B, $C, $R) = @_;
    	    eval q((( &__m128)  &__builtin_ia32_rndscaless_round (( &__v4sf)( &__m128)($A), ( &__v4sf)( &__m128), ($C), $R)));
	}' unless defined(&_mm_roundscale_round_ss);
	eval 'sub _mm_roundscale_round_sd {
	    my($A, $B, $C, $R) = @_;
    	    eval q((( &__m128d)  &__builtin_ia32_rndscalesd_round (( &__v2df)( &__m128d)($A), ( &__v2df)( &__m128d), ($C), $R)));
	}' unless defined(&_mm_roundscale_round_sd);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_floor_ps ( &__m512  &__A) { ( &__m512)  &__builtin_ia32_rndscaleps_mask (( &__v16sf)  &__A,  &_MM_FROUND_FLOOR, ( &__v16sf)  &__A, -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_floor_pd ( &__m512d  &__A) { ( &__m512d)  &__builtin_ia32_rndscalepd_mask (( &__v8df)  &__A,  &_MM_FROUND_FLOOR, ( &__v8df)  &__A, -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_ceil_ps ( &__m512  &__A) { ( &__m512)  &__builtin_ia32_rndscaleps_mask (( &__v16sf)  &__A,  &_MM_FROUND_CEIL, ( &__v16sf)  &__A, -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_ceil_pd ( &__m512d  &__A) { ( &__m512d)  &__builtin_ia32_rndscalepd_mask (( &__v8df)  &__A,  &_MM_FROUND_CEIL, ( &__v8df)  &__A, -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_floor_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A) { ( &__m512)  &__builtin_ia32_rndscaleps_mask (( &__v16sf)  &__A,  &_MM_FROUND_FLOOR, ( &__v16sf)  &__W,  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_floor_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A) { ( &__m512d)  &__builtin_ia32_rndscalepd_mask (( &__v8df)  &__A,  &_MM_FROUND_FLOOR, ( &__v8df)  &__W,  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_ceil_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A) { ( &__m512)  &__builtin_ia32_rndscaleps_mask (( &__v16sf)  &__A,  &_MM_FROUND_CEIL, ( &__v16sf)  &__W,  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_ceil_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A) { ( &__m512d)  &__builtin_ia32_rndscalepd_mask (( &__v8df)  &__A,  &_MM_FROUND_CEIL, ( &__v8df)  &__W,  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_alignr_epi32 ( &__m512i  &__A,  &__m512i  &__B,  &const \'int\'  &__imm) { ( &__m512i)  &__builtin_ia32_alignd512_mask (( &__v16si)  &__A, ( &__v16si)  &__B,  &__imm, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_alignr_epi32 ( &__m512i  &__W,  &__mmask16  &__U,  &__m512i  &__A,  &__m512i  &__B,  &const \'int\'  &__imm) { ( &__m512i)  &__builtin_ia32_alignd512_mask (( &__v16si)  &__A, ( &__v16si)  &__B,  &__imm, ( &__v16si)  &__W, ( &__mmask16)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_alignr_epi32 ( &__mmask16  &__U,  &__m512i  &__A,  &__m512i  &__B,  &const \'int\'  &__imm) { ( &__m512i)  &__builtin_ia32_alignd512_mask (( &__v16si)  &__A, ( &__v16si)  &__B,  &__imm, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_alignr_epi64 ( &__m512i  &__A,  &__m512i  &__B,  &const \'int\'  &__imm) { ( &__m512i)  &__builtin_ia32_alignq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B,  &__imm, ( &__v8di)  &_mm512_undefined_epi32 (), ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_alignr_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m512i  &__A,  &__m512i  &__B,  &const \'int\'  &__imm) { ( &__m512i)  &__builtin_ia32_alignq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B,  &__imm, ( &__v8di)  &__W, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_alignr_epi64 ( &__mmask8  &__U,  &__m512i  &__A,  &__m512i  &__B,  &const \'int\'  &__imm) { ( &__m512i)  &__builtin_ia32_alignq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B,  &__imm, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm512_alignr_epi32 {
	    my($X, $Y, $C) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_alignd512_mask (( &__v16si)( &__m512i)($X), ( &__v16si)( &__m512i), ($C), ( &__v16si) &_mm512_undefined_epi32 (), ( &__mmask16)-1)));
	}' unless defined(&_mm512_alignr_epi32);
	eval 'sub _mm512_mask_alignr_epi32 {
	    my($W, $U, $X, $Y, $C) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_alignd512_mask (( &__v16si)( &__m512i)($X), ( &__v16si)( &__m512i), ($C), ( &__v16si)( &__m512i)($W), ( &__mmask16)($U))));
	}' unless defined(&_mm512_mask_alignr_epi32);
	eval 'sub _mm512_maskz_alignr_epi32 {
	    my($U, $X, $Y, $C) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_alignd512_mask (( &__v16si)( &__m512i)($X), ( &__v16si)( &__m512i), ($C), ( &__v16si) &_mm512_setzero_si512 (), ( &__mmask16)($U))));
	}' unless defined(&_mm512_maskz_alignr_epi32);
	eval 'sub _mm512_alignr_epi64 {
	    my($X, $Y, $C) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_alignq512_mask (( &__v8di)( &__m512i)($X), ( &__v8di)( &__m512i), ($C), ( &__v8di) &_mm512_undefined_epi32 (), ( &__mmask8)-1)));
	}' unless defined(&_mm512_alignr_epi64);
	eval 'sub _mm512_mask_alignr_epi64 {
	    my($W, $U, $X, $Y, $C) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_alignq512_mask (( &__v8di)( &__m512i)($X), ( &__v8di)( &__m512i), ($C), ( &__v8di)( &__m512i)($W), ( &__mmask8)($U))));
	}' unless defined(&_mm512_mask_alignr_epi64);
	eval 'sub _mm512_maskz_alignr_epi64 {
	    my($U, $X, $Y, $C) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_alignq512_mask (( &__v8di)( &__m512i)($X), ( &__v8di)( &__m512i), ($C), ( &__v8di) &_mm512_setzero_si512 (), ( &__mmask8)($U))));
	}' unless defined(&_mm512_maskz_alignr_epi64);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cmpeq_epi32_mask ( &__m512i  &__A,  &__m512i  &__B) { ( &__mmask16)  &__builtin_ia32_pcmpeqd512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cmpeq_epi32_mask ( &__mmask16  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__mmask16)  &__builtin_ia32_pcmpeqd512_mask (( &__v16si)  &__A, ( &__v16si)  &__B,  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cmpeq_epi64_mask ( &__mmask8  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__mmask8)  &__builtin_ia32_pcmpeqq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B,  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cmpeq_epi64_mask ( &__m512i  &__A,  &__m512i  &__B) { ( &__mmask8)  &__builtin_ia32_pcmpeqq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cmpgt_epi32_mask ( &__m512i  &__A,  &__m512i  &__B) { ( &__mmask16)  &__builtin_ia32_pcmpgtd512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cmpgt_epi32_mask ( &__mmask16  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__mmask16)  &__builtin_ia32_pcmpgtd512_mask (( &__v16si)  &__A, ( &__v16si)  &__B,  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cmpgt_epi64_mask ( &__mmask8  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__mmask8)  &__builtin_ia32_pcmpgtq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B,  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cmpgt_epi64_mask ( &__m512i  &__A,  &__m512i  &__B) { ( &__mmask8)  &__builtin_ia32_pcmpgtq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cmpge_epi32_mask ( &__m512i  &__X,  &__m512i  &__Y) { ( &__mmask16)  &__builtin_ia32_cmpd512_mask (( &__v16si)  &__X, ( &__v16si)  &__Y, 5, ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cmpge_epi32_mask ( &__mmask16  &__M,  &__m512i  &__X,  &__m512i  &__Y) { ( &__mmask16)  &__builtin_ia32_cmpd512_mask (( &__v16si)  &__X, ( &__v16si)  &__Y, 5, ( &__mmask16)  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cmpge_epu32_mask ( &__mmask16  &__M,  &__m512i  &__X,  &__m512i  &__Y) { ( &__mmask16)  &__builtin_ia32_ucmpd512_mask (( &__v16si)  &__X, ( &__v16si)  &__Y, 5, ( &__mmask16)  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cmpge_epu32_mask ( &__m512i  &__X,  &__m512i  &__Y) { ( &__mmask16)  &__builtin_ia32_ucmpd512_mask (( &__v16si)  &__X, ( &__v16si)  &__Y, 5, ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cmpge_epi64_mask ( &__mmask8  &__M,  &__m512i  &__X,  &__m512i  &__Y) { ( &__mmask8)  &__builtin_ia32_cmpq512_mask (( &__v8di)  &__X, ( &__v8di)  &__Y, 5, ( &__mmask8)  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cmpge_epi64_mask ( &__m512i  &__X,  &__m512i  &__Y) { ( &__mmask8)  &__builtin_ia32_cmpq512_mask (( &__v8di)  &__X, ( &__v8di)  &__Y, 5, ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cmpge_epu64_mask ( &__mmask8  &__M,  &__m512i  &__X,  &__m512i  &__Y) { ( &__mmask8)  &__builtin_ia32_ucmpq512_mask (( &__v8di)  &__X, ( &__v8di)  &__Y, 5, ( &__mmask8)  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cmpge_epu64_mask ( &__m512i  &__X,  &__m512i  &__Y) { ( &__mmask8)  &__builtin_ia32_ucmpq512_mask (( &__v8di)  &__X, ( &__v8di)  &__Y, 5, ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cmple_epi32_mask ( &__mmask16  &__M,  &__m512i  &__X,  &__m512i  &__Y) { ( &__mmask16)  &__builtin_ia32_cmpd512_mask (( &__v16si)  &__X, ( &__v16si)  &__Y, 2, ( &__mmask16)  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cmple_epi32_mask ( &__m512i  &__X,  &__m512i  &__Y) { ( &__mmask16)  &__builtin_ia32_cmpd512_mask (( &__v16si)  &__X, ( &__v16si)  &__Y, 2, ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cmple_epu32_mask ( &__mmask16  &__M,  &__m512i  &__X,  &__m512i  &__Y) { ( &__mmask16)  &__builtin_ia32_ucmpd512_mask (( &__v16si)  &__X, ( &__v16si)  &__Y, 2, ( &__mmask16)  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cmple_epu32_mask ( &__m512i  &__X,  &__m512i  &__Y) { ( &__mmask16)  &__builtin_ia32_ucmpd512_mask (( &__v16si)  &__X, ( &__v16si)  &__Y, 2, ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cmple_epi64_mask ( &__mmask8  &__M,  &__m512i  &__X,  &__m512i  &__Y) { ( &__mmask8)  &__builtin_ia32_cmpq512_mask (( &__v8di)  &__X, ( &__v8di)  &__Y, 2, ( &__mmask8)  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cmple_epi64_mask ( &__m512i  &__X,  &__m512i  &__Y) { ( &__mmask8)  &__builtin_ia32_cmpq512_mask (( &__v8di)  &__X, ( &__v8di)  &__Y, 2, ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cmple_epu64_mask ( &__mmask8  &__M,  &__m512i  &__X,  &__m512i  &__Y) { ( &__mmask8)  &__builtin_ia32_ucmpq512_mask (( &__v8di)  &__X, ( &__v8di)  &__Y, 2, ( &__mmask8)  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cmple_epu64_mask ( &__m512i  &__X,  &__m512i  &__Y) { ( &__mmask8)  &__builtin_ia32_ucmpq512_mask (( &__v8di)  &__X, ( &__v8di)  &__Y, 2, ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cmplt_epi32_mask ( &__mmask16  &__M,  &__m512i  &__X,  &__m512i  &__Y) { ( &__mmask16)  &__builtin_ia32_cmpd512_mask (( &__v16si)  &__X, ( &__v16si)  &__Y, 1, ( &__mmask16)  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cmplt_epi32_mask ( &__m512i  &__X,  &__m512i  &__Y) { ( &__mmask16)  &__builtin_ia32_cmpd512_mask (( &__v16si)  &__X, ( &__v16si)  &__Y, 1, ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cmplt_epu32_mask ( &__mmask16  &__M,  &__m512i  &__X,  &__m512i  &__Y) { ( &__mmask16)  &__builtin_ia32_ucmpd512_mask (( &__v16si)  &__X, ( &__v16si)  &__Y, 1, ( &__mmask16)  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cmplt_epu32_mask ( &__m512i  &__X,  &__m512i  &__Y) { ( &__mmask16)  &__builtin_ia32_ucmpd512_mask (( &__v16si)  &__X, ( &__v16si)  &__Y, 1, ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cmplt_epi64_mask ( &__mmask8  &__M,  &__m512i  &__X,  &__m512i  &__Y) { ( &__mmask8)  &__builtin_ia32_cmpq512_mask (( &__v8di)  &__X, ( &__v8di)  &__Y, 1, ( &__mmask8)  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cmplt_epi64_mask ( &__m512i  &__X,  &__m512i  &__Y) { ( &__mmask8)  &__builtin_ia32_cmpq512_mask (( &__v8di)  &__X, ( &__v8di)  &__Y, 1, ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cmplt_epu64_mask ( &__mmask8  &__M,  &__m512i  &__X,  &__m512i  &__Y) { ( &__mmask8)  &__builtin_ia32_ucmpq512_mask (( &__v8di)  &__X, ( &__v8di)  &__Y, 1, ( &__mmask8)  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cmplt_epu64_mask ( &__m512i  &__X,  &__m512i  &__Y) { ( &__mmask8)  &__builtin_ia32_ucmpq512_mask (( &__v8di)  &__X, ( &__v8di)  &__Y, 1, ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cmpneq_epi32_mask ( &__m512i  &__X,  &__m512i  &__Y) { ( &__mmask16)  &__builtin_ia32_cmpd512_mask (( &__v16si)  &__X, ( &__v16si)  &__Y, 4, ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cmpneq_epi32_mask ( &__mmask16  &__M,  &__m512i  &__X,  &__m512i  &__Y) { ( &__mmask16)  &__builtin_ia32_cmpd512_mask (( &__v16si)  &__X, ( &__v16si)  &__Y, 4, ( &__mmask16)  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cmpneq_epu32_mask ( &__mmask16  &__M,  &__m512i  &__X,  &__m512i  &__Y) { ( &__mmask16)  &__builtin_ia32_ucmpd512_mask (( &__v16si)  &__X, ( &__v16si)  &__Y, 4, ( &__mmask16)  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cmpneq_epu32_mask ( &__m512i  &__X,  &__m512i  &__Y) { ( &__mmask16)  &__builtin_ia32_ucmpd512_mask (( &__v16si)  &__X, ( &__v16si)  &__Y, 4, ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cmpneq_epi64_mask ( &__mmask16  &__M,  &__m512i  &__X,  &__m512i  &__Y) { ( &__mmask8)  &__builtin_ia32_cmpq512_mask (( &__v8di)  &__X, ( &__v8di)  &__Y, 4, ( &__mmask8)  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cmpneq_epi64_mask ( &__m512i  &__X,  &__m512i  &__Y) { ( &__mmask8)  &__builtin_ia32_cmpq512_mask (( &__v8di)  &__X, ( &__v8di)  &__Y, 4, ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cmpneq_epu64_mask ( &__mmask8  &__M,  &__m512i  &__X,  &__m512i  &__Y) { ( &__mmask8)  &__builtin_ia32_ucmpq512_mask (( &__v8di)  &__X, ( &__v8di)  &__Y, 4, ( &__mmask8)  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cmpneq_epu64_mask ( &__m512i  &__X,  &__m512i  &__Y) { ( &__mmask8)  &__builtin_ia32_ucmpq512_mask (( &__v8di)  &__X, ( &__v8di)  &__Y, 4, ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub _MM_CMPINT_EQ () {0x;}' unless defined(&_MM_CMPINT_EQ);
    eval 'sub _MM_CMPINT_LT () {0x1;}' unless defined(&_MM_CMPINT_LT);
    eval 'sub _MM_CMPINT_LE () {0x2;}' unless defined(&_MM_CMPINT_LE);
    eval 'sub _MM_CMPINT_UNUSED () {0x3;}' unless defined(&_MM_CMPINT_UNUSED);
    eval 'sub _MM_CMPINT_NE () {0x4;}' unless defined(&_MM_CMPINT_NE);
    eval 'sub _MM_CMPINT_NLT () {0x5;}' unless defined(&_MM_CMPINT_NLT);
    eval 'sub _MM_CMPINT_GE () {0x5;}' unless defined(&_MM_CMPINT_GE);
    eval 'sub _MM_CMPINT_NLE () {0x6;}' unless defined(&_MM_CMPINT_NLE);
    eval 'sub _MM_CMPINT_GT () {0x6;}' unless defined(&_MM_CMPINT_GT);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_kshiftli_mask16 ( &__mmask16  &__A, my $__B) { ( &__mmask16)  &__builtin_ia32_kshiftlihi (( &__mmask16)  &__A, ( &__mmask8)  $__B); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_kshiftri_mask16 ( &__mmask16  &__A, my $__B) { ( &__mmask16)  &__builtin_ia32_kshiftrihi (( &__mmask16)  &__A, ( &__mmask8)  $__B); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cmp_epi64_mask ( &__m512i  &__X,  &__m512i  &__Y,  &const \'int\'  &__P) { ( &__mmask8)  &__builtin_ia32_cmpq512_mask (( &__v8di)  &__X, ( &__v8di)  &__Y,  &__P, ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cmp_epi32_mask ( &__m512i  &__X,  &__m512i  &__Y,  &const \'int\'  &__P) { ( &__mmask16)  &__builtin_ia32_cmpd512_mask (( &__v16si)  &__X, ( &__v16si)  &__Y,  &__P, ( &__mmask16) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cmp_epu64_mask ( &__m512i  &__X,  &__m512i  &__Y,  &const \'int\'  &__P) { ( &__mmask8)  &__builtin_ia32_ucmpq512_mask (( &__v8di)  &__X, ( &__v8di)  &__Y,  &__P, ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cmp_epu32_mask ( &__m512i  &__X,  &__m512i  &__Y,  &const \'int\'  &__P) { ( &__mmask16)  &__builtin_ia32_ucmpd512_mask (( &__v16si)  &__X, ( &__v16si)  &__Y,  &__P, ( &__mmask16) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cmp_round_pd_mask ( &__m512d  &__X,  &__m512d  &__Y,  &const \'int\'  &__P,  &const \'int\'  &__R) { ( &__mmask8)  &__builtin_ia32_cmppd512_mask (( &__v8df)  &__X, ( &__v8df)  &__Y,  &__P, ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cmp_round_ps_mask ( &__m512  &__X,  &__m512  &__Y,  &const \'int\'  &__P,  &const \'int\'  &__R) { ( &__mmask16)  &__builtin_ia32_cmpps512_mask (( &__v16sf)  &__X, ( &__v16sf)  &__Y,  &__P, ( &__mmask16) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cmp_epi64_mask ( &__mmask8  &__U,  &__m512i  &__X,  &__m512i  &__Y,  &const \'int\'  &__P) { ( &__mmask8)  &__builtin_ia32_cmpq512_mask (( &__v8di)  &__X, ( &__v8di)  &__Y,  &__P, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cmp_epi32_mask ( &__mmask16  &__U,  &__m512i  &__X,  &__m512i  &__Y,  &const \'int\'  &__P) { ( &__mmask16)  &__builtin_ia32_cmpd512_mask (( &__v16si)  &__X, ( &__v16si)  &__Y,  &__P, ( &__mmask16)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cmp_epu64_mask ( &__mmask8  &__U,  &__m512i  &__X,  &__m512i  &__Y,  &const \'int\'  &__P) { ( &__mmask8)  &__builtin_ia32_ucmpq512_mask (( &__v8di)  &__X, ( &__v8di)  &__Y,  &__P, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cmp_epu32_mask ( &__mmask16  &__U,  &__m512i  &__X,  &__m512i  &__Y,  &const \'int\'  &__P) { ( &__mmask16)  &__builtin_ia32_ucmpd512_mask (( &__v16si)  &__X, ( &__v16si)  &__Y,  &__P, ( &__mmask16)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cmp_round_pd_mask ( &__mmask8  &__U,  &__m512d  &__X,  &__m512d  &__Y,  &const \'int\'  &__P,  &const \'int\'  &__R) { ( &__mmask8)  &__builtin_ia32_cmppd512_mask (( &__v8df)  &__X, ( &__v8df)  &__Y,  &__P, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cmp_round_ps_mask ( &__mmask16  &__U,  &__m512  &__X,  &__m512  &__Y,  &const \'int\'  &__P,  &const \'int\'  &__R) { ( &__mmask16)  &__builtin_ia32_cmpps512_mask (( &__v16sf)  &__X, ( &__v16sf)  &__Y,  &__P, ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cmp_round_sd_mask ( &__m128d  &__X,  &__m128d  &__Y,  &const \'int\'  &__P,  &const \'int\'  &__R) { ( &__mmask8)  &__builtin_ia32_cmpsd_mask (( &__v2df)  &__X, ( &__v2df)  &__Y,  &__P, ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_cmp_round_sd_mask ( &__mmask8  &__M,  &__m128d  &__X,  &__m128d  &__Y,  &const \'int\'  &__P,  &const \'int\'  &__R) { ( &__mmask8)  &__builtin_ia32_cmpsd_mask (( &__v2df)  &__X, ( &__v2df)  &__Y,  &__P, ( &__mmask8)  &__M,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cmp_round_ss_mask ( &__m128  &__X,  &__m128  &__Y,  &const \'int\'  &__P,  &const \'int\'  &__R) { ( &__mmask8)  &__builtin_ia32_cmpss_mask (( &__v4sf)  &__X, ( &__v4sf)  &__Y,  &__P, ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_cmp_round_ss_mask ( &__mmask8  &__M,  &__m128  &__X,  &__m128  &__Y,  &const \'int\'  &__P,  &const \'int\'  &__R) { ( &__mmask8)  &__builtin_ia32_cmpss_mask (( &__v4sf)  &__X, ( &__v4sf)  &__Y,  &__P, ( &__mmask8)  &__M,  &__R); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _kshiftli_mask16 {
	    my($X, $Y) = @_;
    	    eval q((( &__mmask16)  &__builtin_ia32_kshiftlihi (( &__mmask16)($X), ( &__mmask8)($Y))));
	}' unless defined(&_kshiftli_mask16);
	eval 'sub _kshiftri_mask16 {
	    my($X, $Y) = @_;
    	    eval q((( &__mmask16)  &__builtin_ia32_kshiftrihi (( &__mmask16)($X), ( &__mmask8)($Y))));
	}' unless defined(&_kshiftri_mask16);
	eval 'sub _mm512_cmp_epi64_mask {
	    my($X, $Y, $P) = @_;
    	    eval q((( &__mmask8)  &__builtin_ia32_cmpq512_mask (( &__v8di)( &__m512i)($X), ( &__v8di)( &__m512i), ($P), ( &__mmask8)-1)));
	}' unless defined(&_mm512_cmp_epi64_mask);
	eval 'sub _mm512_cmp_epi32_mask {
	    my($X, $Y, $P) = @_;
    	    eval q((( &__mmask16)  &__builtin_ia32_cmpd512_mask (( &__v16si)( &__m512i)($X), ( &__v16si)( &__m512i), ($P), ( &__mmask16)-1)));
	}' unless defined(&_mm512_cmp_epi32_mask);
	eval 'sub _mm512_cmp_epu64_mask {
	    my($X, $Y, $P) = @_;
    	    eval q((( &__mmask8)  &__builtin_ia32_ucmpq512_mask (( &__v8di)( &__m512i)($X), ( &__v8di)( &__m512i), ($P), ( &__mmask8)-1)));
	}' unless defined(&_mm512_cmp_epu64_mask);
	eval 'sub _mm512_cmp_epu32_mask {
	    my($X, $Y, $P) = @_;
    	    eval q((( &__mmask16)  &__builtin_ia32_ucmpd512_mask (( &__v16si)( &__m512i)($X), ( &__v16si)( &__m512i), ($P), ( &__mmask16)-1)));
	}' unless defined(&_mm512_cmp_epu32_mask);
	eval 'sub _mm512_cmp_round_pd_mask {
	    my($X, $Y, $P, $R) = @_;
    	    eval q((( &__mmask8)  &__builtin_ia32_cmppd512_mask (( &__v8df)( &__m512d)($X), ( &__v8df)( &__m512d), ($P), ( &__mmask8)-1, $R)));
	}' unless defined(&_mm512_cmp_round_pd_mask);
	eval 'sub _mm512_cmp_round_ps_mask {
	    my($X, $Y, $P, $R) = @_;
    	    eval q((( &__mmask16)  &__builtin_ia32_cmpps512_mask (( &__v16sf)( &__m512)($X), ( &__v16sf)( &__m512), ($P), ( &__mmask16)-1, $R)));
	}' unless defined(&_mm512_cmp_round_ps_mask);
	eval 'sub _mm512_mask_cmp_epi64_mask {
	    my($M, $X, $Y, $P) = @_;
    	    eval q((( &__mmask8)  &__builtin_ia32_cmpq512_mask (( &__v8di)( &__m512i)($X), ( &__v8di)( &__m512i), ($P), ( &__mmask8)$M)));
	}' unless defined(&_mm512_mask_cmp_epi64_mask);
	eval 'sub _mm512_mask_cmp_epi32_mask {
	    my($M, $X, $Y, $P) = @_;
    	    eval q((( &__mmask16)  &__builtin_ia32_cmpd512_mask (( &__v16si)( &__m512i)($X), ( &__v16si)( &__m512i), ($P), ( &__mmask16)$M)));
	}' unless defined(&_mm512_mask_cmp_epi32_mask);
	eval 'sub _mm512_mask_cmp_epu64_mask {
	    my($M, $X, $Y, $P) = @_;
    	    eval q((( &__mmask8)  &__builtin_ia32_ucmpq512_mask (( &__v8di)( &__m512i)($X), ( &__v8di)( &__m512i), ($P), ( &__mmask8)$M)));
	}' unless defined(&_mm512_mask_cmp_epu64_mask);
	eval 'sub _mm512_mask_cmp_epu32_mask {
	    my($M, $X, $Y, $P) = @_;
    	    eval q((( &__mmask16)  &__builtin_ia32_ucmpd512_mask (( &__v16si)( &__m512i)($X), ( &__v16si)( &__m512i), ($P), ( &__mmask16)$M)));
	}' unless defined(&_mm512_mask_cmp_epu32_mask);
	eval 'sub _mm512_mask_cmp_round_pd_mask {
	    my($M, $X, $Y, $P, $R) = @_;
    	    eval q((( &__mmask8)  &__builtin_ia32_cmppd512_mask (( &__v8df)( &__m512d)($X), ( &__v8df)( &__m512d), ($P), ( &__mmask8)$M, $R)));
	}' unless defined(&_mm512_mask_cmp_round_pd_mask);
	eval 'sub _mm512_mask_cmp_round_ps_mask {
	    my($M, $X, $Y, $P, $R) = @_;
    	    eval q((( &__mmask16)  &__builtin_ia32_cmpps512_mask (( &__v16sf)( &__m512)($X), ( &__v16sf)( &__m512), ($P), ( &__mmask16)$M, $R)));
	}' unless defined(&_mm512_mask_cmp_round_ps_mask);
	eval 'sub _mm_cmp_round_sd_mask {
	    my($X, $Y, $P, $R) = @_;
    	    eval q((( &__mmask8)  &__builtin_ia32_cmpsd_mask (( &__v2df)( &__m128d)($X), ( &__v2df)( &__m128d), ($P), ( &__mmask8)-1, $R)));
	}' unless defined(&_mm_cmp_round_sd_mask);
	eval 'sub _mm_mask_cmp_round_sd_mask {
	    my($M, $X, $Y, $P, $R) = @_;
    	    eval q((( &__mmask8)  &__builtin_ia32_cmpsd_mask (( &__v2df)( &__m128d)($X), ( &__v2df)( &__m128d), ($P), ($M), $R)));
	}' unless defined(&_mm_mask_cmp_round_sd_mask);
	eval 'sub _mm_cmp_round_ss_mask {
	    my($X, $Y, $P, $R) = @_;
    	    eval q((( &__mmask8)  &__builtin_ia32_cmpss_mask (( &__v4sf)( &__m128)($X), ( &__v4sf)( &__m128), ($P), ( &__mmask8)-1, $R)));
	}' unless defined(&_mm_cmp_round_ss_mask);
	eval 'sub _mm_mask_cmp_round_ss_mask {
	    my($M, $X, $Y, $P, $R) = @_;
    	    eval q((( &__mmask8)  &__builtin_ia32_cmpss_mask (( &__v4sf)( &__m128)($X), ( &__v4sf)( &__m128), ($P), ($M), $R)));
	}' unless defined(&_mm_mask_cmp_round_ss_mask);
    }
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_i32gather_ps ( &__m512i  &__index,  &void  &const * &__addr, \'int\'  &__scale) {  &__m512  &__v1_old =  &_mm512_undefined_ps ();  &__mmask16  &__mask = 0xffff; ( &__m512)  &__builtin_ia32_gathersiv16sf (( &__v16sf)  &__v1_old,  &__addr, ( &__v16si)  &__index,  &__mask,  &__scale); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_i32gather_ps ( &__m512  &__v1_old,  &__mmask16  &__mask,  &__m512i  &__index,  &void  &const * &__addr, \'int\'  &__scale) { ( &__m512)  &__builtin_ia32_gathersiv16sf (( &__v16sf)  &__v1_old,  &__addr, ( &__v16si)  &__index,  &__mask,  &__scale); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_i32gather_pd ( &__m256i  &__index,  &void  &const * &__addr, \'int\'  &__scale) {  &__m512d  &__v1_old =  &_mm512_undefined_pd ();  &__mmask8  &__mask = 0xff; ( &__m512d)  &__builtin_ia32_gathersiv8df (( &__v8df)  &__v1_old,  &__addr, ( &__v8si)  &__index,  &__mask,  &__scale); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_i32gather_pd ( &__m512d  &__v1_old,  &__mmask8  &__mask,  &__m256i  &__index,  &void  &const * &__addr, \'int\'  &__scale) { ( &__m512d)  &__builtin_ia32_gathersiv8df (( &__v8df)  &__v1_old,  &__addr, ( &__v8si)  &__index,  &__mask,  &__scale); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_i64gather_ps ( &__m512i  &__index,  &void  &const * &__addr, \'int\'  &__scale) {  &__m256  &__v1_old =  &_mm256_undefined_ps ();  &__mmask8  &__mask = 0xff; ( &__m256)  &__builtin_ia32_gatherdiv16sf (( &__v8sf)  &__v1_old,  &__addr, ( &__v8di)  &__index,  &__mask,  &__scale); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_i64gather_ps ( &__m256  &__v1_old,  &__mmask8  &__mask,  &__m512i  &__index,  &void  &const * &__addr, \'int\'  &__scale) { ( &__m256)  &__builtin_ia32_gatherdiv16sf (( &__v8sf)  &__v1_old,  &__addr, ( &__v8di)  &__index,  &__mask,  &__scale); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_i64gather_pd ( &__m512i  &__index,  &void  &const * &__addr, \'int\'  &__scale) {  &__m512d  &__v1_old =  &_mm512_undefined_pd ();  &__mmask8  &__mask = 0xff; ( &__m512d)  &__builtin_ia32_gatherdiv8df (( &__v8df)  &__v1_old,  &__addr, ( &__v8di)  &__index,  &__mask,  &__scale); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_i64gather_pd ( &__m512d  &__v1_old,  &__mmask8  &__mask,  &__m512i  &__index,  &void  &const * &__addr, \'int\'  &__scale) { ( &__m512d)  &__builtin_ia32_gatherdiv8df (( &__v8df)  &__v1_old,  &__addr, ( &__v8di)  &__index,  &__mask,  &__scale); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_i32gather_epi32 ( &__m512i  &__index,  &void  &const * &__addr, \'int\'  &__scale) {  &__m512i  &__v1_old =  &_mm512_undefined_epi32 ();  &__mmask16  &__mask = 0xffff; ( &__m512i)  &__builtin_ia32_gathersiv16si (( &__v16si)  &__v1_old,  &__addr, ( &__v16si)  &__index,  &__mask,  &__scale); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_i32gather_epi32 ( &__m512i  &__v1_old,  &__mmask16  &__mask,  &__m512i  &__index,  &void  &const * &__addr, \'int\'  &__scale) { ( &__m512i)  &__builtin_ia32_gathersiv16si (( &__v16si)  &__v1_old,  &__addr, ( &__v16si)  &__index,  &__mask,  &__scale); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_i32gather_epi64 ( &__m256i  &__index,  &void  &const * &__addr, \'int\'  &__scale) {  &__m512i  &__v1_old =  &_mm512_undefined_epi32 ();  &__mmask8  &__mask = 0xff; ( &__m512i)  &__builtin_ia32_gathersiv8di (( &__v8di)  &__v1_old,  &__addr, ( &__v8si)  &__index,  &__mask,  &__scale); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_i32gather_epi64 ( &__m512i  &__v1_old,  &__mmask8  &__mask,  &__m256i  &__index,  &void  &const * &__addr, \'int\'  &__scale) { ( &__m512i)  &__builtin_ia32_gathersiv8di (( &__v8di)  &__v1_old,  &__addr, ( &__v8si)  &__index,  &__mask,  &__scale); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_i64gather_epi32 ( &__m512i  &__index,  &void  &const * &__addr, \'int\'  &__scale) {  &__m256i  &__v1_old =  &_mm256_undefined_si256 ();  &__mmask8  &__mask = 0xff; ( &__m256i)  &__builtin_ia32_gatherdiv16si (( &__v8si)  &__v1_old,  &__addr, ( &__v8di)  &__index,  &__mask,  &__scale); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_i64gather_epi32 ( &__m256i  &__v1_old,  &__mmask8  &__mask,  &__m512i  &__index,  &void  &const * &__addr, \'int\'  &__scale) { ( &__m256i)  &__builtin_ia32_gatherdiv16si (( &__v8si)  &__v1_old,  &__addr, ( &__v8di)  &__index,  &__mask,  &__scale); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_i64gather_epi64 ( &__m512i  &__index,  &void  &const * &__addr, \'int\'  &__scale) {  &__m512i  &__v1_old =  &_mm512_undefined_epi32 ();  &__mmask8  &__mask = 0xff; ( &__m512i)  &__builtin_ia32_gatherdiv8di (( &__v8di)  &__v1_old,  &__addr, ( &__v8di)  &__index,  &__mask,  &__scale); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_i64gather_epi64 ( &__m512i  &__v1_old,  &__mmask8  &__mask,  &__m512i  &__index,  &void  &const * &__addr, \'int\'  &__scale) { ( &__m512i)  &__builtin_ia32_gatherdiv8di (( &__v8di)  &__v1_old,  &__addr, ( &__v8di)  &__index,  &__mask,  &__scale); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_i32scatter_ps ( &void * &__addr,  &__m512i  &__index,  &__m512  &__v1, \'int\'  &__scale) {  &__builtin_ia32_scattersiv16sf ( &__addr, ( &__mmask16) 0xffff, ( &__v16si)  &__index, ( &__v16sf)  &__v1,  &__scale); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_i32scatter_ps ( &void * &__addr,  &__mmask16  &__mask,  &__m512i  &__index,  &__m512  &__v1, \'int\'  &__scale) {  &__builtin_ia32_scattersiv16sf ( &__addr,  &__mask, ( &__v16si)  &__index, ( &__v16sf)  &__v1,  &__scale); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_i32scatter_pd ( &void * &__addr,  &__m256i  &__index,  &__m512d  &__v1, \'int\'  &__scale) {  &__builtin_ia32_scattersiv8df ( &__addr, ( &__mmask8) 0xff, ( &__v8si)  &__index, ( &__v8df)  &__v1,  &__scale); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_i32scatter_pd ( &void * &__addr,  &__mmask8  &__mask,  &__m256i  &__index,  &__m512d  &__v1, \'int\'  &__scale) {  &__builtin_ia32_scattersiv8df ( &__addr,  &__mask, ( &__v8si)  &__index, ( &__v8df)  &__v1,  &__scale); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_i64scatter_ps ( &void * &__addr,  &__m512i  &__index,  &__m256  &__v1, \'int\'  &__scale) {  &__builtin_ia32_scatterdiv16sf ( &__addr, ( &__mmask8) 0xff, ( &__v8di)  &__index, ( &__v8sf)  &__v1,  &__scale); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_i64scatter_ps ( &void * &__addr,  &__mmask8  &__mask,  &__m512i  &__index,  &__m256  &__v1, \'int\'  &__scale) {  &__builtin_ia32_scatterdiv16sf ( &__addr,  &__mask, ( &__v8di)  &__index, ( &__v8sf)  &__v1,  &__scale); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_i64scatter_pd ( &void * &__addr,  &__m512i  &__index,  &__m512d  &__v1, \'int\'  &__scale) {  &__builtin_ia32_scatterdiv8df ( &__addr, ( &__mmask8) 0xff, ( &__v8di)  &__index, ( &__v8df)  &__v1,  &__scale); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_i64scatter_pd ( &void * &__addr,  &__mmask8  &__mask,  &__m512i  &__index,  &__m512d  &__v1, \'int\'  &__scale) {  &__builtin_ia32_scatterdiv8df ( &__addr,  &__mask, ( &__v8di)  &__index, ( &__v8df)  &__v1,  &__scale); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_i32scatter_epi32 ( &void * &__addr,  &__m512i  &__index,  &__m512i  &__v1, \'int\'  &__scale) {  &__builtin_ia32_scattersiv16si ( &__addr, ( &__mmask16) 0xffff, ( &__v16si)  &__index, ( &__v16si)  &__v1,  &__scale); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_i32scatter_epi32 ( &void * &__addr,  &__mmask16  &__mask,  &__m512i  &__index,  &__m512i  &__v1, \'int\'  &__scale) {  &__builtin_ia32_scattersiv16si ( &__addr,  &__mask, ( &__v16si)  &__index, ( &__v16si)  &__v1,  &__scale); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_i32scatter_epi64 ( &void * &__addr,  &__m256i  &__index,  &__m512i  &__v1, \'int\'  &__scale) {  &__builtin_ia32_scattersiv8di ( &__addr, ( &__mmask8) 0xff, ( &__v8si)  &__index, ( &__v8di)  &__v1,  &__scale); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_i32scatter_epi64 ( &void * &__addr,  &__mmask8  &__mask,  &__m256i  &__index,  &__m512i  &__v1, \'int\'  &__scale) {  &__builtin_ia32_scattersiv8di ( &__addr,  &__mask, ( &__v8si)  &__index, ( &__v8di)  &__v1,  &__scale); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_i64scatter_epi32 ( &void * &__addr,  &__m512i  &__index,  &__m256i  &__v1, \'int\'  &__scale) {  &__builtin_ia32_scatterdiv16si ( &__addr, ( &__mmask8) 0xff, ( &__v8di)  &__index, ( &__v8si)  &__v1,  &__scale); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_i64scatter_epi32 ( &void * &__addr,  &__mmask8  &__mask,  &__m512i  &__index,  &__m256i  &__v1, \'int\'  &__scale) {  &__builtin_ia32_scatterdiv16si ( &__addr,  &__mask, ( &__v8di)  &__index, ( &__v8si)  &__v1,  &__scale); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_i64scatter_epi64 ( &void * &__addr,  &__m512i  &__index,  &__m512i  &__v1, \'int\'  &__scale) {  &__builtin_ia32_scatterdiv8di ( &__addr, ( &__mmask8) 0xff, ( &__v8di)  &__index, ( &__v8di)  &__v1,  &__scale); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_i64scatter_epi64 ( &void * &__addr,  &__mmask8  &__mask,  &__m512i  &__index,  &__m512i  &__v1, \'int\'  &__scale) {  &__builtin_ia32_scatterdiv8di ( &__addr,  &__mask, ( &__v8di)  &__index, ( &__v8di)  &__v1,  &__scale); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm512_i32gather_ps {
	    my($INDEX, $ADDR, $SCALE) = @_;
    	    eval q(( &__m512)  &__builtin_ia32_gathersiv16sf (( &__v16sf) &_mm512_undefined_ps(), ( &void  &const *)$ADDR, ( &__v16si)( &__m512i)$INDEX, ( &__mmask16)0xffff, $SCALE));
	}' unless defined(&_mm512_i32gather_ps);
	eval 'sub _mm512_mask_i32gather_ps {
	    my($V1OLD, $MASK, $INDEX, $ADDR, $SCALE) = @_;
    	    eval q(( &__m512)  &__builtin_ia32_gathersiv16sf (( &__v16sf)( &__m512)$V1OLD, ( &void  &const *)$ADDR, ( &__v16si)( &__m512i)$INDEX, ( &__mmask16)$MASK, $SCALE));
	}' unless defined(&_mm512_mask_i32gather_ps);
	eval 'sub _mm512_i32gather_pd {
	    my($INDEX, $ADDR, $SCALE) = @_;
    	    eval q(( &__m512d)  &__builtin_ia32_gathersiv8df (( &__v8df) &_mm512_undefined_pd(), ( &void  &const *)$ADDR, ( &__v8si)( &__m256i)$INDEX, ( &__mmask8)0xff, $SCALE));
	}' unless defined(&_mm512_i32gather_pd);
	eval 'sub _mm512_mask_i32gather_pd {
	    my($V1OLD, $MASK, $INDEX, $ADDR, $SCALE) = @_;
    	    eval q(( &__m512d)  &__builtin_ia32_gathersiv8df (( &__v8df)( &__m512d)$V1OLD, ( &void  &const *)$ADDR, ( &__v8si)( &__m256i)$INDEX, ( &__mmask8)$MASK, $SCALE));
	}' unless defined(&_mm512_mask_i32gather_pd);
	eval 'sub _mm512_i64gather_ps {
	    my($INDEX, $ADDR, $SCALE) = @_;
    	    eval q(( &__m256)  &__builtin_ia32_gatherdiv16sf (( &__v8sf) &_mm256_undefined_ps(), ( &void  &const *)$ADDR, ( &__v8di)( &__m512i)$INDEX, ( &__mmask8)0xff, $SCALE));
	}' unless defined(&_mm512_i64gather_ps);
	eval 'sub _mm512_mask_i64gather_ps {
	    my($V1OLD, $MASK, $INDEX, $ADDR, $SCALE) = @_;
    	    eval q(( &__m256)  &__builtin_ia32_gatherdiv16sf (( &__v8sf)( &__m256)$V1OLD, ( &void  &const *)$ADDR, ( &__v8di)( &__m512i)$INDEX, ( &__mmask8)$MASK, $SCALE));
	}' unless defined(&_mm512_mask_i64gather_ps);
	eval 'sub _mm512_i64gather_pd {
	    my($INDEX, $ADDR, $SCALE) = @_;
    	    eval q(( &__m512d)  &__builtin_ia32_gatherdiv8df (( &__v8df) &_mm512_undefined_pd(), ( &void  &const *)$ADDR, ( &__v8di)( &__m512i)$INDEX, ( &__mmask8)0xff, $SCALE));
	}' unless defined(&_mm512_i64gather_pd);
	eval 'sub _mm512_mask_i64gather_pd {
	    my($V1OLD, $MASK, $INDEX, $ADDR, $SCALE) = @_;
    	    eval q(( &__m512d)  &__builtin_ia32_gatherdiv8df (( &__v8df)( &__m512d)$V1OLD, ( &void  &const *)$ADDR, ( &__v8di)( &__m512i)$INDEX, ( &__mmask8)$MASK, $SCALE));
	}' unless defined(&_mm512_mask_i64gather_pd);
	eval 'sub _mm512_i32gather_epi32 {
	    my($INDEX, $ADDR, $SCALE) = @_;
    	    eval q(( &__m512i)  &__builtin_ia32_gathersiv16si (( &__v16si) &_mm512_undefined_epi32 (), ( &void  &const *)$ADDR, ( &__v16si)( &__m512i)$INDEX, ( &__mmask16)0xffff, $SCALE));
	}' unless defined(&_mm512_i32gather_epi32);
	eval 'sub _mm512_mask_i32gather_epi32 {
	    my($V1OLD, $MASK, $INDEX, $ADDR, $SCALE) = @_;
    	    eval q(( &__m512i)  &__builtin_ia32_gathersiv16si (( &__v16si)( &__m512i)$V1OLD, ( &void  &const *)$ADDR, ( &__v16si)( &__m512i)$INDEX, ( &__mmask16)$MASK, $SCALE));
	}' unless defined(&_mm512_mask_i32gather_epi32);
	eval 'sub _mm512_i32gather_epi64 {
	    my($INDEX, $ADDR, $SCALE) = @_;
    	    eval q(( &__m512i)  &__builtin_ia32_gathersiv8di (( &__v8di) &_mm512_undefined_epi32 (), ( &void  &const *)$ADDR, ( &__v8si)( &__m256i)$INDEX, ( &__mmask8)0xff, $SCALE));
	}' unless defined(&_mm512_i32gather_epi64);
	eval 'sub _mm512_mask_i32gather_epi64 {
	    my($V1OLD, $MASK, $INDEX, $ADDR, $SCALE) = @_;
    	    eval q(( &__m512i)  &__builtin_ia32_gathersiv8di (( &__v8di)( &__m512i)$V1OLD, ( &void  &const *)$ADDR, ( &__v8si)( &__m256i)$INDEX, ( &__mmask8)$MASK, $SCALE));
	}' unless defined(&_mm512_mask_i32gather_epi64);
	eval 'sub _mm512_i64gather_epi32 {
	    my($INDEX, $ADDR, $SCALE) = @_;
    	    eval q(( &__m256i)  &__builtin_ia32_gatherdiv16si (( &__v8si) &_mm256_undefined_si256(), ( &void  &const *)$ADDR, ( &__v8di)( &__m512i)$INDEX, ( &__mmask8)0xff, $SCALE));
	}' unless defined(&_mm512_i64gather_epi32);
	eval 'sub _mm512_mask_i64gather_epi32 {
	    my($V1OLD, $MASK, $INDEX, $ADDR, $SCALE) = @_;
    	    eval q(( &__m256i)  &__builtin_ia32_gatherdiv16si (( &__v8si)( &__m256i)$V1OLD, ( &void  &const *)$ADDR, ( &__v8di)( &__m512i)$INDEX, ( &__mmask8)$MASK, $SCALE));
	}' unless defined(&_mm512_mask_i64gather_epi32);
	eval 'sub _mm512_i64gather_epi64 {
	    my($INDEX, $ADDR, $SCALE) = @_;
    	    eval q(( &__m512i)  &__builtin_ia32_gatherdiv8di (( &__v8di) &_mm512_undefined_epi32 (), ( &void  &const *)$ADDR, ( &__v8di)( &__m512i)$INDEX, ( &__mmask8)0xff, $SCALE));
	}' unless defined(&_mm512_i64gather_epi64);
	eval 'sub _mm512_mask_i64gather_epi64 {
	    my($V1OLD, $MASK, $INDEX, $ADDR, $SCALE) = @_;
    	    eval q(( &__m512i)  &__builtin_ia32_gatherdiv8di (( &__v8di)( &__m512i)$V1OLD, ( &void  &const *)$ADDR, ( &__v8di)( &__m512i)$INDEX, ( &__mmask8)$MASK, $SCALE));
	}' unless defined(&_mm512_mask_i64gather_epi64);
	eval 'sub _mm512_i32scatter_ps {
	    my($ADDR, $INDEX, $V1, $SCALE) = @_;
    	    eval q( &__builtin_ia32_scattersiv16sf (( &void *)$ADDR, ( &__mmask16)0xffff, ( &__v16si)( &__m512i)$INDEX, ( &__v16sf)( &__m512)$V1, $SCALE));
	}' unless defined(&_mm512_i32scatter_ps);
	eval 'sub _mm512_mask_i32scatter_ps {
	    my($ADDR, $MASK, $INDEX, $V1, $SCALE) = @_;
    	    eval q( &__builtin_ia32_scattersiv16sf (( &void *)$ADDR, ( &__mmask16)$MASK, ( &__v16si)( &__m512i)$INDEX, ( &__v16sf)( &__m512)$V1, $SCALE));
	}' unless defined(&_mm512_mask_i32scatter_ps);
	eval 'sub _mm512_i32scatter_pd {
	    my($ADDR, $INDEX, $V1, $SCALE) = @_;
    	    eval q( &__builtin_ia32_scattersiv8df (( &void *)$ADDR, ( &__mmask8)0xff, ( &__v8si)( &__m256i)$INDEX, ( &__v8df)( &__m512d)$V1, $SCALE));
	}' unless defined(&_mm512_i32scatter_pd);
	eval 'sub _mm512_mask_i32scatter_pd {
	    my($ADDR, $MASK, $INDEX, $V1, $SCALE) = @_;
    	    eval q( &__builtin_ia32_scattersiv8df (( &void *)$ADDR, ( &__mmask8)$MASK, ( &__v8si)( &__m256i)$INDEX, ( &__v8df)( &__m512d)$V1, $SCALE));
	}' unless defined(&_mm512_mask_i32scatter_pd);
	eval 'sub _mm512_i64scatter_ps {
	    my($ADDR, $INDEX, $V1, $SCALE) = @_;
    	    eval q( &__builtin_ia32_scatterdiv16sf (( &void *)$ADDR, ( &__mmask8)0xff, ( &__v8di)( &__m512i)$INDEX, ( &__v8sf)( &__m256)$V1, $SCALE));
	}' unless defined(&_mm512_i64scatter_ps);
	eval 'sub _mm512_mask_i64scatter_ps {
	    my($ADDR, $MASK, $INDEX, $V1, $SCALE) = @_;
    	    eval q( &__builtin_ia32_scatterdiv16sf (( &void *)$ADDR, ( &__mmask16)$MASK, ( &__v8di)( &__m512i)$INDEX, ( &__v8sf)( &__m256)$V1, $SCALE));
	}' unless defined(&_mm512_mask_i64scatter_ps);
	eval 'sub _mm512_i64scatter_pd {
	    my($ADDR, $INDEX, $V1, $SCALE) = @_;
    	    eval q( &__builtin_ia32_scatterdiv8df (( &void *)$ADDR, ( &__mmask8)0xff, ( &__v8di)( &__m512i)$INDEX, ( &__v8df)( &__m512d)$V1, $SCALE));
	}' unless defined(&_mm512_i64scatter_pd);
	eval 'sub _mm512_mask_i64scatter_pd {
	    my($ADDR, $MASK, $INDEX, $V1, $SCALE) = @_;
    	    eval q( &__builtin_ia32_scatterdiv8df (( &void *)$ADDR, ( &__mmask8)$MASK, ( &__v8di)( &__m512i)$INDEX, ( &__v8df)( &__m512d)$V1, $SCALE));
	}' unless defined(&_mm512_mask_i64scatter_pd);
	eval 'sub _mm512_i32scatter_epi32 {
	    my($ADDR, $INDEX, $V1, $SCALE) = @_;
    	    eval q( &__builtin_ia32_scattersiv16si (( &void *)$ADDR, ( &__mmask16)0xffff, ( &__v16si)( &__m512i)$INDEX, ( &__v16si)( &__m512i)$V1, $SCALE));
	}' unless defined(&_mm512_i32scatter_epi32);
	eval 'sub _mm512_mask_i32scatter_epi32 {
	    my($ADDR, $MASK, $INDEX, $V1, $SCALE) = @_;
    	    eval q( &__builtin_ia32_scattersiv16si (( &void *)$ADDR, ( &__mmask16)$MASK, ( &__v16si)( &__m512i)$INDEX, ( &__v16si)( &__m512i)$V1, $SCALE));
	}' unless defined(&_mm512_mask_i32scatter_epi32);
	eval 'sub _mm512_i32scatter_epi64 {
	    my($ADDR, $INDEX, $V1, $SCALE) = @_;
    	    eval q( &__builtin_ia32_scattersiv8di (( &void *)$ADDR, ( &__mmask8)0xff, ( &__v8si)( &__m256i)$INDEX, ( &__v8di)( &__m512i)$V1, $SCALE));
	}' unless defined(&_mm512_i32scatter_epi64);
	eval 'sub _mm512_mask_i32scatter_epi64 {
	    my($ADDR, $MASK, $INDEX, $V1, $SCALE) = @_;
    	    eval q( &__builtin_ia32_scattersiv8di (( &void *)$ADDR, ( &__mmask8)$MASK, ( &__v8si)( &__m256i)$INDEX, ( &__v8di)( &__m512i)$V1, $SCALE));
	}' unless defined(&_mm512_mask_i32scatter_epi64);
	eval 'sub _mm512_i64scatter_epi32 {
	    my($ADDR, $INDEX, $V1, $SCALE) = @_;
    	    eval q( &__builtin_ia32_scatterdiv16si (( &void *)$ADDR, ( &__mmask8)0xff, ( &__v8di)( &__m512i)$INDEX, ( &__v8si)( &__m256i)$V1, $SCALE));
	}' unless defined(&_mm512_i64scatter_epi32);
	eval 'sub _mm512_mask_i64scatter_epi32 {
	    my($ADDR, $MASK, $INDEX, $V1, $SCALE) = @_;
    	    eval q( &__builtin_ia32_scatterdiv16si (( &void *)$ADDR, ( &__mmask8)$MASK, ( &__v8di)( &__m512i)$INDEX, ( &__v8si)( &__m256i)$V1, $SCALE));
	}' unless defined(&_mm512_mask_i64scatter_epi32);
	eval 'sub _mm512_i64scatter_epi64 {
	    my($ADDR, $INDEX, $V1, $SCALE) = @_;
    	    eval q( &__builtin_ia32_scatterdiv8di (( &void *)$ADDR, ( &__mmask8)0xff, ( &__v8di)( &__m512i)$INDEX, ( &__v8di)( &__m512i)$V1, $SCALE));
	}' unless defined(&_mm512_i64scatter_epi64);
	eval 'sub _mm512_mask_i64scatter_epi64 {
	    my($ADDR, $MASK, $INDEX, $V1, $SCALE) = @_;
    	    eval q( &__builtin_ia32_scatterdiv8di (( &void *)$ADDR, ( &__mmask8)$MASK, ( &__v8di)( &__m512i)$INDEX, ( &__v8di)( &__m512i)$V1, $SCALE));
	}' unless defined(&_mm512_mask_i64scatter_epi64);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_compress_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A) { ( &__m512d)  &__builtin_ia32_compressdf512_mask (( &__v8df)  &__A, ( &__v8df)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_compress_pd ( &__mmask8  &__U,  &__m512d  &__A) { ( &__m512d)  &__builtin_ia32_compressdf512_mask (( &__v8df)  &__A, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_compressstoreu_pd ( &void * &__P,  &__mmask8  &__U,  &__m512d  &__A) {  &__builtin_ia32_compressstoredf512_mask (( &__v8df *)  &__P, ( &__v8df)  &__A, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_compress_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A) { ( &__m512)  &__builtin_ia32_compresssf512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_compress_ps ( &__mmask16  &__U,  &__m512  &__A) { ( &__m512)  &__builtin_ia32_compresssf512_mask (( &__v16sf)  &__A, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_compressstoreu_ps ( &void * &__P,  &__mmask16  &__U,  &__m512  &__A) {  &__builtin_ia32_compressstoresf512_mask (( &__v16sf *)  &__P, ( &__v16sf)  &__A, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_compress_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m512i  &__A) { ( &__m512i)  &__builtin_ia32_compressdi512_mask (( &__v8di)  &__A, ( &__v8di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_compress_epi64 ( &__mmask8  &__U,  &__m512i  &__A) { ( &__m512i)  &__builtin_ia32_compressdi512_mask (( &__v8di)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_compressstoreu_epi64 ( &void * &__P,  &__mmask8  &__U,  &__m512i  &__A) {  &__builtin_ia32_compressstoredi512_mask (( &__v8di *)  &__P, ( &__v8di)  &__A, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_compress_epi32 ( &__m512i  &__W,  &__mmask16  &__U,  &__m512i  &__A) { ( &__m512i)  &__builtin_ia32_compresssi512_mask (( &__v16si)  &__A, ( &__v16si)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_compress_epi32 ( &__mmask16  &__U,  &__m512i  &__A) { ( &__m512i)  &__builtin_ia32_compresssi512_mask (( &__v16si)  &__A, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_compressstoreu_epi32 ( &void * &__P,  &__mmask16  &__U,  &__m512i  &__A) {  &__builtin_ia32_compressstoresi512_mask (( &__v16si *)  &__P, ( &__v16si)  &__A, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_expand_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A) { ( &__m512d)  &__builtin_ia32_expanddf512_mask (( &__v8df)  &__A, ( &__v8df)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_expand_pd ( &__mmask8  &__U,  &__m512d  &__A) { ( &__m512d)  &__builtin_ia32_expanddf512_maskz (( &__v8df)  &__A, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_expandloadu_pd ( &__m512d  &__W,  &__mmask8  &__U,  &void  &const * &__P) { ( &__m512d)  &__builtin_ia32_expandloaddf512_mask (( &const  &__v8df *)  &__P, ( &__v8df)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_expandloadu_pd ( &__mmask8  &__U,  &void  &const * &__P) { ( &__m512d)  &__builtin_ia32_expandloaddf512_maskz (( &const  &__v8df *)  &__P, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_expand_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A) { ( &__m512)  &__builtin_ia32_expandsf512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_expand_ps ( &__mmask16  &__U,  &__m512  &__A) { ( &__m512)  &__builtin_ia32_expandsf512_maskz (( &__v16sf)  &__A, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_expandloadu_ps ( &__m512  &__W,  &__mmask16  &__U,  &void  &const * &__P) { ( &__m512)  &__builtin_ia32_expandloadsf512_mask (( &const  &__v16sf *)  &__P, ( &__v16sf)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_expandloadu_ps ( &__mmask16  &__U,  &void  &const * &__P) { ( &__m512)  &__builtin_ia32_expandloadsf512_maskz (( &const  &__v16sf *)  &__P, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_expand_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m512i  &__A) { ( &__m512i)  &__builtin_ia32_expanddi512_mask (( &__v8di)  &__A, ( &__v8di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_expand_epi64 ( &__mmask8  &__U,  &__m512i  &__A) { ( &__m512i)  &__builtin_ia32_expanddi512_maskz (( &__v8di)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_expandloadu_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &void  &const * &__P) { ( &__m512i)  &__builtin_ia32_expandloaddi512_mask (( &const  &__v8di *)  &__P, ( &__v8di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_expandloadu_epi64 ( &__mmask8  &__U,  &void  &const * &__P) { ( &__m512i)  &__builtin_ia32_expandloaddi512_maskz (( &const  &__v8di *)  &__P, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_expand_epi32 ( &__m512i  &__W,  &__mmask16  &__U,  &__m512i  &__A) { ( &__m512i)  &__builtin_ia32_expandsi512_mask (( &__v16si)  &__A, ( &__v16si)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_expand_epi32 ( &__mmask16  &__U,  &__m512i  &__A) { ( &__m512i)  &__builtin_ia32_expandsi512_maskz (( &__v16si)  &__A, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_expandloadu_epi32 ( &__m512i  &__W,  &__mmask16  &__U,  &void  &const * &__P) { ( &__m512i)  &__builtin_ia32_expandloadsi512_mask (( &const  &__v16si *)  &__P, ( &__v16si)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_expandloadu_epi32 ( &__mmask16  &__U,  &void  &const * &__P) { ( &__m512i)  &__builtin_ia32_expandloadsi512_maskz (( &const  &__v16si *)  &__P, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub _kand_mask16 () { &_mm512_kand;}' unless defined(&_kand_mask16);
    eval 'sub _kandn_mask16 () { &_mm512_kandn;}' unless defined(&_kandn_mask16);
    eval 'sub _knot_mask16 () { &_mm512_knot;}' unless defined(&_knot_mask16);
    eval 'sub _kor_mask16 () { &_mm512_kor;}' unless defined(&_kor_mask16);
    eval 'sub _kxnor_mask16 () { &_mm512_kxnor;}' unless defined(&_kxnor_mask16);
    eval 'sub _kxor_mask16 () { &_mm512_kxor;}' unless defined(&_kxor_mask16);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_kortest_mask16_u8 ( &__mmask16  &__A,  &__mmask16  &__B, my $char * &__CF) { * &__CF =  &__builtin_ia32_kortestchi ( &__A,  &__B);  &__builtin_ia32_kortestzhi ( &__A,  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_kortestz_mask16_u8 ( &__mmask16  &__A,  &__mmask16  &__B) {  &__builtin_ia32_kortestzhi (( &__mmask16)  &__A, ( &__mmask16)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_kortestc_mask16_u8 ( &__mmask16  &__A,  &__mmask16  &__B) {  &__builtin_ia32_kortestchi (( &__mmask16)  &__A, ( &__mmask16)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_cvtmask16_u32 {  &__builtin_ia32_kmovw (( &__mmask16 )  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_cvtu32_mask16  { ( &__mmask16)  &__builtin_ia32_kmovw (( &__mmask16 )  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_load_mask16 ( &__mmask16 * &__A) { ( &__mmask16)  &__builtin_ia32_kmovw (*( &__mmask16 *)  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_store_mask16 ( &__mmask16 * &__A,  &__mmask16  &__B) { *( &__mmask16 *)  &__A =  &__builtin_ia32_kmovw ( &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_kand ( &__mmask16  &__A,  &__mmask16  &__B) { ( &__mmask16)  &__builtin_ia32_kandhi (( &__mmask16)  &__A, ( &__mmask16)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_kandn ( &__mmask16  &__A,  &__mmask16  &__B) { ( &__mmask16)  &__builtin_ia32_kandnhi (( &__mmask16)  &__A, ( &__mmask16)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_kor ( &__mmask16  &__A,  &__mmask16  &__B) { ( &__mmask16)  &__builtin_ia32_korhi (( &__mmask16)  &__A, ( &__mmask16)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_kortestz ( &__mmask16  &__A,  &__mmask16  &__B) { ( &__mmask16)  &__builtin_ia32_kortestzhi (( &__mmask16)  &__A, ( &__mmask16)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_kortestc ( &__mmask16  &__A,  &__mmask16  &__B) { ( &__mmask16)  &__builtin_ia32_kortestchi (( &__mmask16)  &__A, ( &__mmask16)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_kxnor ( &__mmask16  &__A,  &__mmask16  &__B) { ( &__mmask16)  &__builtin_ia32_kxnorhi (( &__mmask16)  &__A, ( &__mmask16)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_kxor ( &__mmask16  &__A,  &__mmask16  &__B) { ( &__mmask16)  &__builtin_ia32_kxorhi (( &__mmask16)  &__A, ( &__mmask16)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_knot ( &__mmask16  &__A) { ( &__mmask16)  &__builtin_ia32_knothi (( &__mmask16)  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_kunpackb ( &__mmask16  &__A,  &__mmask16  &__B) { ( &__mmask16)  &__builtin_ia32_kunpckhi (( &__mmask16)  &__A, ( &__mmask16)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_kunpackb_mask16 ( &__mmask8  &__A,  &__mmask8  &__B) { ( &__mmask16)  &__builtin_ia32_kunpckhi (( &__mmask16)  &__A, ( &__mmask16)  &__B); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_inserti32x4 ( &__mmask16  &__B,  &__m512i  &__C,  &__m128i  &__D,  &const \'int\'  &__imm) { ( &__m512i)  &__builtin_ia32_inserti32x4_mask (( &__v16si)  &__C, ( &__v4si)  &__D,  &__imm, ( &__v16si)  &_mm512_setzero_si512 (),  &__B); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_insertf32x4 ( &__mmask16  &__B,  &__m512  &__C,  &__m128  &__D,  &const \'int\'  &__imm) { ( &__m512)  &__builtin_ia32_insertf32x4_mask (( &__v16sf)  &__C, ( &__v4sf)  &__D,  &__imm, ( &__v16sf)  &_mm512_setzero_ps (),  &__B); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_inserti32x4 ( &__m512i  &__A,  &__mmask16  &__B,  &__m512i  &__C,  &__m128i  &__D,  &const \'int\'  &__imm) { ( &__m512i)  &__builtin_ia32_inserti32x4_mask (( &__v16si)  &__C, ( &__v4si)  &__D,  &__imm, ( &__v16si)  &__A,  &__B); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_insertf32x4 ( &__m512  &__A,  &__mmask16  &__B,  &__m512  &__C,  &__m128  &__D,  &const \'int\'  &__imm) { ( &__m512)  &__builtin_ia32_insertf32x4_mask (( &__v16sf)  &__C, ( &__v4sf)  &__D,  &__imm, ( &__v16sf)  &__A,  &__B); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm512_maskz_insertf32x4 {
	    my($A, $X, $Y, $C) = @_;
    	    eval q((( &__m512)  &__builtin_ia32_insertf32x4_mask (( &__v16sf)( &__m512) ($X), ( &__v4sf)( &__m128) , ($C), ( &__v16sf) &_mm512_setzero_ps(), ( &__mmask8)($A))));
	}' unless defined(&_mm512_maskz_insertf32x4);
	eval 'sub _mm512_maskz_inserti32x4 {
	    my($A, $X, $Y, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_inserti32x4_mask (( &__v16si)( &__m512i) ($X), ( &__v4si)( &__m128i) , ($C), ( &__v16si) &_mm512_setzero_si512 (), ( &__mmask8)($A))));
	}' unless defined(&_mm512_maskz_inserti32x4);
	eval 'sub _mm512_mask_insertf32x4 {
	    my($A, $B, $X, $Y, $C) = @_;
    	    eval q((( &__m512)  &__builtin_ia32_insertf32x4_mask (( &__v16sf)( &__m512) ($X), ( &__v4sf)( &__m128) , ($C), ( &__v16sf)( &__m512) ($A), ( &__mmask8)($B))));
	}' unless defined(&_mm512_mask_insertf32x4);
	eval 'sub _mm512_mask_inserti32x4 {
	    my($A, $B, $X, $Y, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_inserti32x4_mask (( &__v16si)( &__m512i) ($X), ( &__v4si)( &__m128i) , ($C), ( &__v16si)( &__m512i) ($A), ( &__mmask8)($B))));
	}' unless defined(&_mm512_mask_inserti32x4);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_max_epi64 ( &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pmaxsq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &_mm512_undefined_epi32 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_max_epi64 ( &__mmask8  &__M,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pmaxsq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &_mm512_setzero_si512 (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_max_epi64 ( &__m512i  &__W,  &__mmask8  &__M,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pmaxsq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &__W,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_min_epi64 ( &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pminsq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &_mm512_undefined_epi32 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_min_epi64 ( &__m512i  &__W,  &__mmask8  &__M,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pminsq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &__W,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_min_epi64 ( &__mmask8  &__M,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pminsq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &_mm512_setzero_si512 (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_max_epu64 ( &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pmaxuq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &_mm512_undefined_epi32 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_max_epu64 ( &__mmask8  &__M,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pmaxuq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &_mm512_setzero_si512 (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_max_epu64 ( &__m512i  &__W,  &__mmask8  &__M,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pmaxuq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &__W,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_min_epu64 ( &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pminuq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &_mm512_undefined_epi32 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_min_epu64 ( &__m512i  &__W,  &__mmask8  &__M,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pminuq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &__W,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_min_epu64 ( &__mmask8  &__M,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pminuq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &_mm512_setzero_si512 (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_max_epi32 ( &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pmaxsd512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_max_epi32 ( &__mmask16  &__M,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pmaxsd512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &_mm512_setzero_si512 (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_max_epi32 ( &__m512i  &__W,  &__mmask16  &__M,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pmaxsd512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &__W,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_min_epi32 ( &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pminsd512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_min_epi32 ( &__mmask16  &__M,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pminsd512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &_mm512_setzero_si512 (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_min_epi32 ( &__m512i  &__W,  &__mmask16  &__M,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pminsd512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &__W,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_max_epu32 ( &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pmaxud512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_max_epu32 ( &__mmask16  &__M,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pmaxud512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &_mm512_setzero_si512 (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_max_epu32 ( &__m512i  &__W,  &__mmask16  &__M,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pmaxud512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &__W,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_min_epu32 ( &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pminud512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_min_epu32 ( &__mmask16  &__M,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pminud512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &_mm512_setzero_si512 (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_min_epu32 ( &__m512i  &__W,  &__mmask16  &__M,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pminud512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__v16si)  &__W,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_unpacklo_ps ( &__m512  &__A,  &__m512  &__B) { ( &__m512)  &__builtin_ia32_unpcklps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &_mm512_undefined_ps (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_unpacklo_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B) { ( &__m512)  &__builtin_ia32_unpcklps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_unpacklo_ps ( &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B) { ( &__m512)  &__builtin_ia32_unpcklps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_max_round_sd ( &__m128d  &__A,  &__m128d  &__B,  &const \'int\'  &__R) { ( &__m128d)  &__builtin_ia32_maxsd_round (( &__v2df)  &__A, ( &__v2df)  &__B,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_max_round_ss ( &__m128  &__A,  &__m128  &__B,  &const \'int\'  &__R) { ( &__m128)  &__builtin_ia32_maxss_round (( &__v4sf)  &__A, ( &__v4sf)  &__B,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_min_round_sd ( &__m128d  &__A,  &__m128d  &__B,  &const \'int\'  &__R) { ( &__m128d)  &__builtin_ia32_minsd_round (( &__v2df)  &__A, ( &__v2df)  &__B,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_min_round_ss ( &__m128  &__A,  &__m128  &__B,  &const \'int\'  &__R) { ( &__m128)  &__builtin_ia32_minss_round (( &__v4sf)  &__A, ( &__v4sf)  &__B,  &__R); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm_max_round_sd {
	    my($A, $B, $C) = @_;
    	    eval q(( &__m128d) &__builtin_ia32_addsd_round($A, $B, $C));
	}' unless defined(&_mm_max_round_sd);
	eval 'sub _mm_max_round_ss {
	    my($A, $B, $C) = @_;
    	    eval q(( &__m128) &__builtin_ia32_addss_round($A, $B, $C));
	}' unless defined(&_mm_max_round_ss);
	eval 'sub _mm_min_round_sd {
	    my($A, $B, $C) = @_;
    	    eval q(( &__m128d) &__builtin_ia32_subsd_round($A, $B, $C));
	}' unless defined(&_mm_min_round_sd);
	eval 'sub _mm_min_round_ss {
	    my($A, $B, $C) = @_;
    	    eval q(( &__m128) &__builtin_ia32_subss_round($A, $B, $C));
	}' unless defined(&_mm_min_round_ss);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_blend_pd ( &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__W) { ( &__m512d)  &__builtin_ia32_blendmpd_512_mask (( &__v8df)  &__A, ( &__v8df)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_blend_ps ( &__mmask16  &__U,  &__m512  &__A,  &__m512  &__W) { ( &__m512)  &__builtin_ia32_blendmps_512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_blend_epi64 ( &__mmask8  &__U,  &__m512i  &__A,  &__m512i  &__W) { ( &__m512i)  &__builtin_ia32_blendmq_512_mask (( &__v8di)  &__A, ( &__v8di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_blend_epi32 ( &__mmask16  &__U,  &__m512i  &__A,  &__m512i  &__W) { ( &__m512i)  &__builtin_ia32_blendmd_512_mask (( &__v16si)  &__A, ( &__v16si)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_fmadd_round_sd ( &__m128d  &__W,  &__m128d  &__A,  &__m128d  &__B,  &const \'int\'  &__R) { ( &__m128d)  &__builtin_ia32_vfmaddsd3_round (( &__v2df)  &__W, ( &__v2df)  &__A, ( &__v2df)  &__B,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_fmadd_round_ss ( &__m128  &__W,  &__m128  &__A,  &__m128  &__B,  &const \'int\'  &__R) { ( &__m128)  &__builtin_ia32_vfmaddss3_round (( &__v4sf)  &__W, ( &__v4sf)  &__A, ( &__v4sf)  &__B,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_fmsub_round_sd ( &__m128d  &__W,  &__m128d  &__A,  &__m128d  &__B,  &const \'int\'  &__R) { ( &__m128d)  &__builtin_ia32_vfmaddsd3_round (( &__v2df)  &__W, ( &__v2df)  &__A, -( &__v2df)  &__B,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_fmsub_round_ss ( &__m128  &__W,  &__m128  &__A,  &__m128  &__B,  &const \'int\'  &__R) { ( &__m128)  &__builtin_ia32_vfmaddss3_round (( &__v4sf)  &__W, ( &__v4sf)  &__A, -( &__v4sf)  &__B,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_fnmadd_round_sd ( &__m128d  &__W,  &__m128d  &__A,  &__m128d  &__B,  &const \'int\'  &__R) { ( &__m128d)  &__builtin_ia32_vfmaddsd3_round (( &__v2df)  &__W, -( &__v2df)  &__A, ( &__v2df)  &__B,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_fnmadd_round_ss ( &__m128  &__W,  &__m128  &__A,  &__m128  &__B,  &const \'int\'  &__R) { ( &__m128)  &__builtin_ia32_vfmaddss3_round (( &__v4sf)  &__W, -( &__v4sf)  &__A, ( &__v4sf)  &__B,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_fnmsub_round_sd ( &__m128d  &__W,  &__m128d  &__A,  &__m128d  &__B,  &const \'int\'  &__R) { ( &__m128d)  &__builtin_ia32_vfmaddsd3_round (( &__v2df)  &__W, -( &__v2df)  &__A, -( &__v2df)  &__B,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_fnmsub_round_ss ( &__m128  &__W,  &__m128  &__A,  &__m128  &__B,  &const \'int\'  &__R) { ( &__m128)  &__builtin_ia32_vfmaddss3_round (( &__v4sf)  &__W, -( &__v4sf)  &__A, -( &__v4sf)  &__B,  &__R); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm_fmadd_round_sd {
	    my($A, $B, $C, $R) = @_;
    	    eval q(( &__m128d) &__builtin_ia32_vfmaddsd3_round($A, $B, $C, $R));
	}' unless defined(&_mm_fmadd_round_sd);
	eval 'sub _mm_fmadd_round_ss {
	    my($A, $B, $C, $R) = @_;
    	    eval q(( &__m128) &__builtin_ia32_vfmaddss3_round($A, $B, $C, $R));
	}' unless defined(&_mm_fmadd_round_ss);
	eval 'sub _mm_fmsub_round_sd {
	    my($A, $B, $C, $R) = @_;
    	    eval q(( &__m128d) &__builtin_ia32_vfmaddsd3_round($A, $B, -($C), $R));
	}' unless defined(&_mm_fmsub_round_sd);
	eval 'sub _mm_fmsub_round_ss {
	    my($A, $B, $C, $R) = @_;
    	    eval q(( &__m128) &__builtin_ia32_vfmaddss3_round($A, $B, -($C), $R));
	}' unless defined(&_mm_fmsub_round_ss);
	eval 'sub _mm_fnmadd_round_sd {
	    my($A, $B, $C, $R) = @_;
    	    eval q(( &__m128d) &__builtin_ia32_vfmaddsd3_round($A, -($B), $C, $R));
	}' unless defined(&_mm_fnmadd_round_sd);
	eval 'sub _mm_fnmadd_round_ss {
	    my($A, $B, $C, $R) = @_;
    	    eval q(( &__m128) &__builtin_ia32_vfmaddss3_round($A, -($B), $C, $R));
	}' unless defined(&_mm_fnmadd_round_ss);
	eval 'sub _mm_fnmsub_round_sd {
	    my($A, $B, $C, $R) = @_;
    	    eval q(( &__m128d) &__builtin_ia32_vfmaddsd3_round($A, -($B), -($C), $R));
	}' unless defined(&_mm_fnmsub_round_sd);
	eval 'sub _mm_fnmsub_round_ss {
	    my($A, $B, $C, $R) = @_;
    	    eval q(( &__m128) &__builtin_ia32_vfmaddss3_round($A, -($B), -($C), $R));
	}' unless defined(&_mm_fnmsub_round_ss);
    }
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_comi_round_ss ( &__m128  &__A,  &__m128  &__B,  &const \'int\'  &__P,  &const \'int\'  &__R) {  &__builtin_ia32_vcomiss (( &__v4sf)  &__A, ( &__v4sf)  &__B,  &__P,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_comi_round_sd ( &__m128d  &__A,  &__m128d  &__B,  &const \'int\'  &__P,  &const \'int\'  &__R) {  &__builtin_ia32_vcomisd (( &__v2df)  &__A, ( &__v2df)  &__B,  &__P,  &__R); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm_comi_round_ss {
	    my($A, $B, $C, $D) = @_;
    	    eval q( &__builtin_ia32_vcomiss($A, $B, $C, $D));
	}' unless defined(&_mm_comi_round_ss);
	eval 'sub _mm_comi_round_sd {
	    my($A, $B, $C, $D) = @_;
    	    eval q( &__builtin_ia32_vcomisd($A, $B, $C, $D));
	}' unless defined(&_mm_comi_round_sd);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_sqrt_pd ( &__m512d  &__A) { ( &__m512d)  &__builtin_ia32_sqrtpd512_mask (( &__v8df)  &__A, ( &__v8df)  &_mm512_undefined_pd (), ( &__mmask8) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_sqrt_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A) { ( &__m512d)  &__builtin_ia32_sqrtpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__W, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_sqrt_pd ( &__mmask8  &__U,  &__m512d  &__A) { ( &__m512d)  &__builtin_ia32_sqrtpd512_mask (( &__v8df)  &__A, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_sqrt_ps ( &__m512  &__A) { ( &__m512)  &__builtin_ia32_sqrtps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &_mm512_undefined_ps (), ( &__mmask16) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_sqrt_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A) { ( &__m512)  &__builtin_ia32_sqrtps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__W, ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_sqrt_ps ( &__mmask16  &__U,  &__m512  &__A) { ( &__m512)  &__builtin_ia32_sqrtps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_add_pd ( &__m512d  &__A,  &__m512d  &__B) { ( &__m512d) (( &__v8df) &__A + ( &__v8df) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_add_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B) { ( &__m512d)  &__builtin_ia32_addpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__W, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_add_pd ( &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B) { ( &__m512d)  &__builtin_ia32_addpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_add_ps ( &__m512  &__A,  &__m512  &__B) { ( &__m512) (( &__v16sf) &__A + ( &__v16sf) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_add_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B) { ( &__m512)  &__builtin_ia32_addps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__W, ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_add_ps ( &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B) { ( &__m512)  &__builtin_ia32_addps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_sub_pd ( &__m512d  &__A,  &__m512d  &__B) { ( &__m512d) (( &__v8df) &__A - ( &__v8df) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_sub_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B) { ( &__m512d)  &__builtin_ia32_subpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__W, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_sub_pd ( &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B) { ( &__m512d)  &__builtin_ia32_subpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_sub_ps ( &__m512  &__A,  &__m512  &__B) { ( &__m512) (( &__v16sf) &__A - ( &__v16sf) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_sub_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B) { ( &__m512)  &__builtin_ia32_subps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__W, ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_sub_ps ( &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B) { ( &__m512)  &__builtin_ia32_subps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mul_pd ( &__m512d  &__A,  &__m512d  &__B) { ( &__m512d) (( &__v8df) &__A * ( &__v8df) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_mul_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B) { ( &__m512d)  &__builtin_ia32_mulpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__W, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_mul_pd ( &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B) { ( &__m512d)  &__builtin_ia32_mulpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mul_ps ( &__m512  &__A,  &__m512  &__B) { ( &__m512) (( &__v16sf) &__A * ( &__v16sf) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_mul_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B) { ( &__m512)  &__builtin_ia32_mulps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__W, ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_mul_ps ( &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B) { ( &__m512)  &__builtin_ia32_mulps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_div_pd ( &__m512d  &__M,  &__m512d  &__V) { ( &__m512d) (( &__v8df) &__M / ( &__v8df) &__V); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_div_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__M,  &__m512d  &__V) { ( &__m512d)  &__builtin_ia32_divpd512_mask (( &__v8df)  &__M, ( &__v8df)  &__V, ( &__v8df)  &__W, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_div_pd ( &__mmask8  &__U,  &__m512d  &__M,  &__m512d  &__V) { ( &__m512d)  &__builtin_ia32_divpd512_mask (( &__v8df)  &__M, ( &__v8df)  &__V, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_div_ps ( &__m512  &__A,  &__m512  &__B) { ( &__m512) (( &__v16sf) &__A / ( &__v16sf) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_div_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B) { ( &__m512)  &__builtin_ia32_divps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__W, ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_div_ps ( &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B) { ( &__m512)  &__builtin_ia32_divps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_max_pd ( &__m512d  &__A,  &__m512d  &__B) { ( &__m512d)  &__builtin_ia32_maxpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &_mm512_undefined_pd (), ( &__mmask8) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_max_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B) { ( &__m512d)  &__builtin_ia32_maxpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__W, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_max_pd ( &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B) { ( &__m512d)  &__builtin_ia32_maxpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_max_ps ( &__m512  &__A,  &__m512  &__B) { ( &__m512)  &__builtin_ia32_maxps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &_mm512_undefined_ps (), ( &__mmask16) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_max_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B) { ( &__m512)  &__builtin_ia32_maxps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__W, ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_max_ps ( &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B) { ( &__m512)  &__builtin_ia32_maxps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_min_pd ( &__m512d  &__A,  &__m512d  &__B) { ( &__m512d)  &__builtin_ia32_minpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &_mm512_undefined_pd (), ( &__mmask8) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_min_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B) { ( &__m512d)  &__builtin_ia32_minpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__W, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_min_pd ( &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B) { ( &__m512d)  &__builtin_ia32_minpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_min_ps ( &__m512  &__A,  &__m512  &__B) { ( &__m512)  &__builtin_ia32_minps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &_mm512_undefined_ps (), ( &__mmask16) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_min_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B) { ( &__m512)  &__builtin_ia32_minps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__W, ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_min_ps ( &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B) { ( &__m512)  &__builtin_ia32_minps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_scalef_pd ( &__m512d  &__A,  &__m512d  &__B) { ( &__m512d)  &__builtin_ia32_scalefpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &_mm512_undefined_pd (), ( &__mmask8) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_scalef_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B) { ( &__m512d)  &__builtin_ia32_scalefpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__W, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_scalef_pd ( &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B) { ( &__m512d)  &__builtin_ia32_scalefpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_scalef_ps ( &__m512  &__A,  &__m512  &__B) { ( &__m512)  &__builtin_ia32_scalefps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &_mm512_undefined_ps (), ( &__mmask16) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_scalef_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B) { ( &__m512)  &__builtin_ia32_scalefps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__W, ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_scalef_ps ( &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B) { ( &__m512)  &__builtin_ia32_scalefps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_scalef_sd ( &__m128d  &__A,  &__m128d  &__B) { ( &__m128d)  &__builtin_ia32_scalefsd_round (( &__v2df)  &__A, ( &__v2df)  &__B,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_scalef_ss ( &__m128  &__A,  &__m128  &__B) { ( &__m128)  &__builtin_ia32_scalefss_round (( &__v4sf)  &__A, ( &__v4sf)  &__B,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_fmadd_pd ( &__m512d  &__A,  &__m512d  &__B,  &__m512d  &__C) { ( &__m512d)  &__builtin_ia32_vfmaddpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__C, ( &__mmask8) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_fmadd_pd ( &__m512d  &__A,  &__mmask8  &__U,  &__m512d  &__B,  &__m512d  &__C) { ( &__m512d)  &__builtin_ia32_vfmaddpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__C, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask3_fmadd_pd ( &__m512d  &__A,  &__m512d  &__B,  &__m512d  &__C,  &__mmask8  &__U) { ( &__m512d)  &__builtin_ia32_vfmaddpd512_mask3 (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__C, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_fmadd_pd ( &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B,  &__m512d  &__C) { ( &__m512d)  &__builtin_ia32_vfmaddpd512_maskz (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__C, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_fmadd_ps ( &__m512  &__A,  &__m512  &__B,  &__m512  &__C) { ( &__m512)  &__builtin_ia32_vfmaddps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__C, ( &__mmask16) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_fmadd_ps ( &__m512  &__A,  &__mmask16  &__U,  &__m512  &__B,  &__m512  &__C) { ( &__m512)  &__builtin_ia32_vfmaddps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__C, ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask3_fmadd_ps ( &__m512  &__A,  &__m512  &__B,  &__m512  &__C,  &__mmask16  &__U) { ( &__m512)  &__builtin_ia32_vfmaddps512_mask3 (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__C, ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_fmadd_ps ( &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B,  &__m512  &__C) { ( &__m512)  &__builtin_ia32_vfmaddps512_maskz (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__C, ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_fmsub_pd ( &__m512d  &__A,  &__m512d  &__B,  &__m512d  &__C) { ( &__m512d)  &__builtin_ia32_vfmaddpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, -( &__v8df)  &__C, ( &__mmask8) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_fmsub_pd ( &__m512d  &__A,  &__mmask8  &__U,  &__m512d  &__B,  &__m512d  &__C) { ( &__m512d)  &__builtin_ia32_vfmaddpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, -( &__v8df)  &__C, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask3_fmsub_pd ( &__m512d  &__A,  &__m512d  &__B,  &__m512d  &__C,  &__mmask8  &__U) { ( &__m512d)  &__builtin_ia32_vfmsubpd512_mask3 (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__C, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_fmsub_pd ( &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B,  &__m512d  &__C) { ( &__m512d)  &__builtin_ia32_vfmaddpd512_maskz (( &__v8df)  &__A, ( &__v8df)  &__B, -( &__v8df)  &__C, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_fmsub_ps ( &__m512  &__A,  &__m512  &__B,  &__m512  &__C) { ( &__m512)  &__builtin_ia32_vfmaddps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, -( &__v16sf)  &__C, ( &__mmask16) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_fmsub_ps ( &__m512  &__A,  &__mmask16  &__U,  &__m512  &__B,  &__m512  &__C) { ( &__m512)  &__builtin_ia32_vfmaddps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, -( &__v16sf)  &__C, ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask3_fmsub_ps ( &__m512  &__A,  &__m512  &__B,  &__m512  &__C,  &__mmask16  &__U) { ( &__m512)  &__builtin_ia32_vfmsubps512_mask3 (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__C, ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_fmsub_ps ( &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B,  &__m512  &__C) { ( &__m512)  &__builtin_ia32_vfmaddps512_maskz (( &__v16sf)  &__A, ( &__v16sf)  &__B, -( &__v16sf)  &__C, ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_fmaddsub_pd ( &__m512d  &__A,  &__m512d  &__B,  &__m512d  &__C) { ( &__m512d)  &__builtin_ia32_vfmaddsubpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__C, ( &__mmask8) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_fmaddsub_pd ( &__m512d  &__A,  &__mmask8  &__U,  &__m512d  &__B,  &__m512d  &__C) { ( &__m512d)  &__builtin_ia32_vfmaddsubpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__C, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask3_fmaddsub_pd ( &__m512d  &__A,  &__m512d  &__B,  &__m512d  &__C,  &__mmask8  &__U) { ( &__m512d)  &__builtin_ia32_vfmaddsubpd512_mask3 (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__C, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_fmaddsub_pd ( &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B,  &__m512d  &__C) { ( &__m512d)  &__builtin_ia32_vfmaddsubpd512_maskz (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__C, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_fmaddsub_ps ( &__m512  &__A,  &__m512  &__B,  &__m512  &__C) { ( &__m512)  &__builtin_ia32_vfmaddsubps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__C, ( &__mmask16) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_fmaddsub_ps ( &__m512  &__A,  &__mmask16  &__U,  &__m512  &__B,  &__m512  &__C) { ( &__m512)  &__builtin_ia32_vfmaddsubps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__C, ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask3_fmaddsub_ps ( &__m512  &__A,  &__m512  &__B,  &__m512  &__C,  &__mmask16  &__U) { ( &__m512)  &__builtin_ia32_vfmaddsubps512_mask3 (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__C, ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_fmaddsub_ps ( &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B,  &__m512  &__C) { ( &__m512)  &__builtin_ia32_vfmaddsubps512_maskz (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__C, ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_fmsubadd_pd ( &__m512d  &__A,  &__m512d  &__B,  &__m512d  &__C) { ( &__m512d)  &__builtin_ia32_vfmaddsubpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, -( &__v8df)  &__C, ( &__mmask8) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_fmsubadd_pd ( &__m512d  &__A,  &__mmask8  &__U,  &__m512d  &__B,  &__m512d  &__C) { ( &__m512d)  &__builtin_ia32_vfmaddsubpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, -( &__v8df)  &__C, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask3_fmsubadd_pd ( &__m512d  &__A,  &__m512d  &__B,  &__m512d  &__C,  &__mmask8  &__U) { ( &__m512d)  &__builtin_ia32_vfmsubaddpd512_mask3 (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__C, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_fmsubadd_pd ( &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B,  &__m512d  &__C) { ( &__m512d)  &__builtin_ia32_vfmaddsubpd512_maskz (( &__v8df)  &__A, ( &__v8df)  &__B, -( &__v8df)  &__C, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_fmsubadd_ps ( &__m512  &__A,  &__m512  &__B,  &__m512  &__C) { ( &__m512)  &__builtin_ia32_vfmaddsubps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, -( &__v16sf)  &__C, ( &__mmask16) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_fmsubadd_ps ( &__m512  &__A,  &__mmask16  &__U,  &__m512  &__B,  &__m512  &__C) { ( &__m512)  &__builtin_ia32_vfmaddsubps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, -( &__v16sf)  &__C, ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask3_fmsubadd_ps ( &__m512  &__A,  &__m512  &__B,  &__m512  &__C,  &__mmask16  &__U) { ( &__m512)  &__builtin_ia32_vfmsubaddps512_mask3 (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__C, ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_fmsubadd_ps ( &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B,  &__m512  &__C) { ( &__m512)  &__builtin_ia32_vfmaddsubps512_maskz (( &__v16sf)  &__A, ( &__v16sf)  &__B, -( &__v16sf)  &__C, ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_fnmadd_pd ( &__m512d  &__A,  &__m512d  &__B,  &__m512d  &__C) { ( &__m512d)  &__builtin_ia32_vfmaddpd512_mask (-( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__C, ( &__mmask8) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_fnmadd_pd ( &__m512d  &__A,  &__mmask8  &__U,  &__m512d  &__B,  &__m512d  &__C) { ( &__m512d)  &__builtin_ia32_vfnmaddpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__C, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask3_fnmadd_pd ( &__m512d  &__A,  &__m512d  &__B,  &__m512d  &__C,  &__mmask8  &__U) { ( &__m512d)  &__builtin_ia32_vfmaddpd512_mask3 (-( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__C, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_fnmadd_pd ( &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B,  &__m512d  &__C) { ( &__m512d)  &__builtin_ia32_vfmaddpd512_maskz (-( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__C, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_fnmadd_ps ( &__m512  &__A,  &__m512  &__B,  &__m512  &__C) { ( &__m512)  &__builtin_ia32_vfmaddps512_mask (-( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__C, ( &__mmask16) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_fnmadd_ps ( &__m512  &__A,  &__mmask16  &__U,  &__m512  &__B,  &__m512  &__C) { ( &__m512)  &__builtin_ia32_vfnmaddps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__C, ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask3_fnmadd_ps ( &__m512  &__A,  &__m512  &__B,  &__m512  &__C,  &__mmask16  &__U) { ( &__m512)  &__builtin_ia32_vfmaddps512_mask3 (-( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__C, ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_fnmadd_ps ( &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B,  &__m512  &__C) { ( &__m512)  &__builtin_ia32_vfmaddps512_maskz (-( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__C, ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_fnmsub_pd ( &__m512d  &__A,  &__m512d  &__B,  &__m512d  &__C) { ( &__m512d)  &__builtin_ia32_vfmaddpd512_mask (-( &__v8df)  &__A, ( &__v8df)  &__B, -( &__v8df)  &__C, ( &__mmask8) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_fnmsub_pd ( &__m512d  &__A,  &__mmask8  &__U,  &__m512d  &__B,  &__m512d  &__C) { ( &__m512d)  &__builtin_ia32_vfnmsubpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__C, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask3_fnmsub_pd ( &__m512d  &__A,  &__m512d  &__B,  &__m512d  &__C,  &__mmask8  &__U) { ( &__m512d)  &__builtin_ia32_vfnmsubpd512_mask3 (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__C, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_fnmsub_pd ( &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B,  &__m512d  &__C) { ( &__m512d)  &__builtin_ia32_vfmaddpd512_maskz (-( &__v8df)  &__A, ( &__v8df)  &__B, -( &__v8df)  &__C, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_fnmsub_ps ( &__m512  &__A,  &__m512  &__B,  &__m512  &__C) { ( &__m512)  &__builtin_ia32_vfmaddps512_mask (-( &__v16sf)  &__A, ( &__v16sf)  &__B, -( &__v16sf)  &__C, ( &__mmask16) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_fnmsub_ps ( &__m512  &__A,  &__mmask16  &__U,  &__m512  &__B,  &__m512  &__C) { ( &__m512)  &__builtin_ia32_vfnmsubps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__C, ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask3_fnmsub_ps ( &__m512  &__A,  &__m512  &__B,  &__m512  &__C,  &__mmask16  &__U) { ( &__m512)  &__builtin_ia32_vfnmsubps512_mask3 (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__C, ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_fnmsub_ps ( &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B,  &__m512  &__C) { ( &__m512)  &__builtin_ia32_vfmaddps512_maskz (-( &__v16sf)  &__A, ( &__v16sf)  &__B, -( &__v16sf)  &__C, ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvttpd_epi32 ( &__m512d  &__A) { ( &__m256i)  &__builtin_ia32_cvttpd2dq512_mask (( &__v8df)  &__A, ( &__v8si)  &_mm256_undefined_si256 (), ( &__mmask8) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvttpd_epi32 ( &__m256i  &__W,  &__mmask8  &__U,  &__m512d  &__A) { ( &__m256i)  &__builtin_ia32_cvttpd2dq512_mask (( &__v8df)  &__A, ( &__v8si)  &__W, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvttpd_epi32 ( &__mmask8  &__U,  &__m512d  &__A) { ( &__m256i)  &__builtin_ia32_cvttpd2dq512_mask (( &__v8df)  &__A, ( &__v8si)  &_mm256_setzero_si256 (), ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvttpd_epu32 ( &__m512d  &__A) { ( &__m256i)  &__builtin_ia32_cvttpd2udq512_mask (( &__v8df)  &__A, ( &__v8si)  &_mm256_undefined_si256 (), ( &__mmask8) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvttpd_epu32 ( &__m256i  &__W,  &__mmask8  &__U,  &__m512d  &__A) { ( &__m256i)  &__builtin_ia32_cvttpd2udq512_mask (( &__v8df)  &__A, ( &__v8si)  &__W, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvttpd_epu32 ( &__mmask8  &__U,  &__m512d  &__A) { ( &__m256i)  &__builtin_ia32_cvttpd2udq512_mask (( &__v8df)  &__A, ( &__v8si)  &_mm256_setzero_si256 (), ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtpd_epi32 ( &__m512d  &__A) { ( &__m256i)  &__builtin_ia32_cvtpd2dq512_mask (( &__v8df)  &__A, ( &__v8si)  &_mm256_undefined_si256 (), ( &__mmask8) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtpd_epi32 ( &__m256i  &__W,  &__mmask8  &__U,  &__m512d  &__A) { ( &__m256i)  &__builtin_ia32_cvtpd2dq512_mask (( &__v8df)  &__A, ( &__v8si)  &__W, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtpd_epi32 ( &__mmask8  &__U,  &__m512d  &__A) { ( &__m256i)  &__builtin_ia32_cvtpd2dq512_mask (( &__v8df)  &__A, ( &__v8si)  &_mm256_setzero_si256 (), ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtpd_epu32 ( &__m512d  &__A) { ( &__m256i)  &__builtin_ia32_cvtpd2udq512_mask (( &__v8df)  &__A, ( &__v8si)  &_mm256_undefined_si256 (), ( &__mmask8) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtpd_epu32 ( &__m256i  &__W,  &__mmask8  &__U,  &__m512d  &__A) { ( &__m256i)  &__builtin_ia32_cvtpd2udq512_mask (( &__v8df)  &__A, ( &__v8si)  &__W, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtpd_epu32 ( &__mmask8  &__U,  &__m512d  &__A) { ( &__m256i)  &__builtin_ia32_cvtpd2udq512_mask (( &__v8df)  &__A, ( &__v8si)  &_mm256_setzero_si256 (), ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvttps_epi32 ( &__m512  &__A) { ( &__m512i)  &__builtin_ia32_cvttps2dq512_mask (( &__v16sf)  &__A, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvttps_epi32 ( &__m512i  &__W,  &__mmask16  &__U,  &__m512  &__A) { ( &__m512i)  &__builtin_ia32_cvttps2dq512_mask (( &__v16sf)  &__A, ( &__v16si)  &__W, ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvttps_epi32 ( &__mmask16  &__U,  &__m512  &__A) { ( &__m512i)  &__builtin_ia32_cvttps2dq512_mask (( &__v16sf)  &__A, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvttps_epu32 ( &__m512  &__A) { ( &__m512i)  &__builtin_ia32_cvttps2udq512_mask (( &__v16sf)  &__A, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvttps_epu32 ( &__m512i  &__W,  &__mmask16  &__U,  &__m512  &__A) { ( &__m512i)  &__builtin_ia32_cvttps2udq512_mask (( &__v16sf)  &__A, ( &__v16si)  &__W, ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvttps_epu32 ( &__mmask16  &__U,  &__m512  &__A) { ( &__m512i)  &__builtin_ia32_cvttps2udq512_mask (( &__v16sf)  &__A, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtps_epi32 ( &__m512  &__A) { ( &__m512i)  &__builtin_ia32_cvtps2dq512_mask (( &__v16sf)  &__A, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtps_epi32 ( &__m512i  &__W,  &__mmask16  &__U,  &__m512  &__A) { ( &__m512i)  &__builtin_ia32_cvtps2dq512_mask (( &__v16sf)  &__A, ( &__v16si)  &__W, ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtps_epi32 ( &__mmask16  &__U,  &__m512  &__A) { ( &__m512i)  &__builtin_ia32_cvtps2dq512_mask (( &__v16sf)  &__A, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtps_epu32 ( &__m512  &__A) { ( &__m512i)  &__builtin_ia32_cvtps2udq512_mask (( &__v16sf)  &__A, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtps_epu32 ( &__m512i  &__W,  &__mmask16  &__U,  &__m512  &__A) { ( &__m512i)  &__builtin_ia32_cvtps2udq512_mask (( &__v16sf)  &__A, ( &__v16si)  &__W, ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtps_epu32 ( &__mmask16  &__U,  &__m512  &__A) { ( &__m512i)  &__builtin_ia32_cvtps2udq512_mask (( &__v16sf)  &__A, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtsd_f64 ( &__m512d  &__A) {  $__A[0]; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtss_f32 ( &__m512  &__A) {  $__A[0]; });
    }' unless defined(&__attribute__);
    if(defined(&__x86_64__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtu64_ss ( &__m128  &__A, my $__B) { ( &__m128)  &__builtin_ia32_cvtusi2ss64 (( &__v4sf)  &__A,  $__B,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtu64_sd ( &__m128d  &__A, my $__B) { ( &__m128d)  &__builtin_ia32_cvtusi2sd64 (( &__v2df)  &__A,  $__B,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtu32_ss ( &__m128  &__A, my $__B) { ( &__m128)  &__builtin_ia32_cvtusi2ss32 (( &__v4sf)  &__A,  $__B,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtepi32_ps ( &__m512i  &__A) { ( &__m512)  &__builtin_ia32_cvtdq2ps512_mask (( &__v16si)  &__A, ( &__v16sf)  &_mm512_undefined_ps (), ( &__mmask16) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtepi32_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512i  &__A) { ( &__m512)  &__builtin_ia32_cvtdq2ps512_mask (( &__v16si)  &__A, ( &__v16sf)  &__W, ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtepi32_ps ( &__mmask16  &__U,  &__m512i  &__A) { ( &__m512)  &__builtin_ia32_cvtdq2ps512_mask (( &__v16si)  &__A, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtepu32_ps ( &__m512i  &__A) { ( &__m512)  &__builtin_ia32_cvtudq2ps512_mask (( &__v16si)  &__A, ( &__v16sf)  &_mm512_undefined_ps (), ( &__mmask16) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtepu32_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512i  &__A) { ( &__m512)  &__builtin_ia32_cvtudq2ps512_mask (( &__v16si)  &__A, ( &__v16sf)  &__W, ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtepu32_ps ( &__mmask16  &__U,  &__m512i  &__A) { ( &__m512)  &__builtin_ia32_cvtudq2ps512_mask (( &__v16si)  &__A, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_fixupimm_pd ( &__m512d  &__A,  &__m512d  &__B,  &__m512i  &__C,  &const \'int\'  &__imm) { ( &__m512d)  &__builtin_ia32_fixupimmpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8di)  &__C,  &__imm, ( &__mmask8) -1,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_fixupimm_pd ( &__m512d  &__A,  &__mmask8  &__U,  &__m512d  &__B,  &__m512i  &__C,  &const \'int\'  &__imm) { ( &__m512d)  &__builtin_ia32_fixupimmpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8di)  &__C,  &__imm, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_fixupimm_pd ( &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B,  &__m512i  &__C,  &const \'int\'  &__imm) { ( &__m512d)  &__builtin_ia32_fixupimmpd512_maskz (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8di)  &__C,  &__imm, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_fixupimm_ps ( &__m512  &__A,  &__m512  &__B,  &__m512i  &__C,  &const \'int\'  &__imm) { ( &__m512)  &__builtin_ia32_fixupimmps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16si)  &__C,  &__imm, ( &__mmask16) -1,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_fixupimm_ps ( &__m512  &__A,  &__mmask16  &__U,  &__m512  &__B,  &__m512i  &__C,  &const \'int\'  &__imm) { ( &__m512)  &__builtin_ia32_fixupimmps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16si)  &__C,  &__imm, ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_fixupimm_ps ( &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B,  &__m512i  &__C,  &const \'int\'  &__imm) { ( &__m512)  &__builtin_ia32_fixupimmps512_maskz (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16si)  &__C,  &__imm, ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_fixupimm_sd ( &__m128d  &__A,  &__m128d  &__B,  &__m128i  &__C,  &const \'int\'  &__imm) { ( &__m128d)  &__builtin_ia32_fixupimmsd_mask (( &__v2df)  &__A, ( &__v2df)  &__B, ( &__v2di)  &__C,  &__imm, ( &__mmask8) -1,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_fixupimm_sd ( &__m128d  &__A,  &__mmask8  &__U,  &__m128d  &__B,  &__m128i  &__C,  &const \'int\'  &__imm) { ( &__m128d)  &__builtin_ia32_fixupimmsd_mask (( &__v2df)  &__A, ( &__v2df)  &__B, ( &__v2di)  &__C,  &__imm, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_fixupimm_sd ( &__mmask8  &__U,  &__m128d  &__A,  &__m128d  &__B,  &__m128i  &__C,  &const \'int\'  &__imm) { ( &__m128d)  &__builtin_ia32_fixupimmsd_maskz (( &__v2df)  &__A, ( &__v2df)  &__B, ( &__v2di)  &__C,  &__imm, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_fixupimm_ss ( &__m128  &__A,  &__m128  &__B,  &__m128i  &__C,  &const \'int\'  &__imm) { ( &__m128)  &__builtin_ia32_fixupimmss_mask (( &__v4sf)  &__A, ( &__v4sf)  &__B, ( &__v4si)  &__C,  &__imm, ( &__mmask8) -1,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_fixupimm_ss ( &__m128  &__A,  &__mmask8  &__U,  &__m128  &__B,  &__m128i  &__C,  &const \'int\'  &__imm) { ( &__m128)  &__builtin_ia32_fixupimmss_mask (( &__v4sf)  &__A, ( &__v4sf)  &__B, ( &__v4si)  &__C,  &__imm, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_fixupimm_ss ( &__mmask8  &__U,  &__m128  &__A,  &__m128  &__B,  &__m128i  &__C,  &const \'int\'  &__imm) { ( &__m128)  &__builtin_ia32_fixupimmss_maskz (( &__v4sf)  &__A, ( &__v4sf)  &__B, ( &__v4si)  &__C,  &__imm, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm512_fixupimm_pd {
	    my($X, $Y, $Z, $C) = @_;
    	    eval q((( &__m512d) &__builtin_ia32_fixupimmpd512_mask (( &__v8df)( &__m512d)($X), ( &__v8df)( &__m512d)($Y), ( &__v8di)( &__m512i), ($C), ( &__mmask8)(-1),  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm512_fixupimm_pd);
	eval 'sub _mm512_mask_fixupimm_pd {
	    my($X, $U, $Y, $Z, $C) = @_;
    	    eval q((( &__m512d) &__builtin_ia32_fixupimmpd512_mask (( &__v8df)( &__m512d)($X), ( &__v8df)( &__m512d)($Y), ( &__v8di)( &__m512i), ($C), ( &__mmask8)($U),  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm512_mask_fixupimm_pd);
	eval 'sub _mm512_maskz_fixupimm_pd {
	    my($U, $X, $Y, $Z, $C) = @_;
    	    eval q((( &__m512d) &__builtin_ia32_fixupimmpd512_maskz (( &__v8df)( &__m512d)($X), ( &__v8df)( &__m512d)($Y), ( &__v8di)( &__m512i), ($C), ( &__mmask8)($U),  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm512_maskz_fixupimm_pd);
	eval 'sub _mm512_fixupimm_ps {
	    my($X, $Y, $Z, $C) = @_;
    	    eval q((( &__m512) &__builtin_ia32_fixupimmps512_mask (( &__v16sf)( &__m512)($X), ( &__v16sf)( &__m512)($Y), ( &__v16si)( &__m512i), ($C), ( &__mmask16)(-1),  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm512_fixupimm_ps);
	eval 'sub _mm512_mask_fixupimm_ps {
	    my($X, $U, $Y, $Z, $C) = @_;
    	    eval q((( &__m512) &__builtin_ia32_fixupimmps512_mask (( &__v16sf)( &__m512)($X), ( &__v16sf)( &__m512)($Y), ( &__v16si)( &__m512i), ($C), ( &__mmask16)($U),  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm512_mask_fixupimm_ps);
	eval 'sub _mm512_maskz_fixupimm_ps {
	    my($U, $X, $Y, $Z, $C) = @_;
    	    eval q((( &__m512) &__builtin_ia32_fixupimmps512_maskz (( &__v16sf)( &__m512)($X), ( &__v16sf)( &__m512)($Y), ( &__v16si)( &__m512i), ($C), ( &__mmask16)($U),  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm512_maskz_fixupimm_ps);
	eval 'sub _mm_fixupimm_sd {
	    my($X, $Y, $Z, $C) = @_;
    	    eval q((( &__m128d) &__builtin_ia32_fixupimmsd_mask (( &__v2df)( &__m128d)($X), ( &__v2df)( &__m128d)($Y), ( &__v2di)( &__m128i), ($C), ( &__mmask8)(-1),  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm_fixupimm_sd);
	eval 'sub _mm_mask_fixupimm_sd {
	    my($X, $U, $Y, $Z, $C) = @_;
    	    eval q((( &__m128d) &__builtin_ia32_fixupimmsd_mask (( &__v2df)( &__m128d)($X), ( &__v2df)( &__m128d)($Y), ( &__v2di)( &__m128i), ($C), ( &__mmask8)($U),  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm_mask_fixupimm_sd);
	eval 'sub _mm_maskz_fixupimm_sd {
	    my($U, $X, $Y, $Z, $C) = @_;
    	    eval q((( &__m128d) &__builtin_ia32_fixupimmsd_maskz (( &__v2df)( &__m128d)($X), ( &__v2df)( &__m128d)($Y), ( &__v2di)( &__m128i), ($C), ( &__mmask8)($U),  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm_maskz_fixupimm_sd);
	eval 'sub _mm_fixupimm_ss {
	    my($X, $Y, $Z, $C) = @_;
    	    eval q((( &__m128) &__builtin_ia32_fixupimmss_mask (( &__v4sf)( &__m128)($X), ( &__v4sf)( &__m128)($Y), ( &__v4si)( &__m128i), ($C), ( &__mmask8)(-1),  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm_fixupimm_ss);
	eval 'sub _mm_mask_fixupimm_ss {
	    my($X, $U, $Y, $Z, $C) = @_;
    	    eval q((( &__m128) &__builtin_ia32_fixupimmss_mask (( &__v4sf)( &__m128)($X), ( &__v4sf)( &__m128)($Y), ( &__v4si)( &__m128i), ($C), ( &__mmask8)($U),  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm_mask_fixupimm_ss);
	eval 'sub _mm_maskz_fixupimm_ss {
	    my($U, $X, $Y, $Z, $C) = @_;
    	    eval q((( &__m128) &__builtin_ia32_fixupimmss_maskz (( &__v4sf)( &__m128)($X), ( &__v4sf)( &__m128)($Y), ( &__v4si)( &__m128i), ($C), ( &__mmask8)($U),  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm_maskz_fixupimm_ss);
    }
    if(defined(&__x86_64__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtss_u64 {  &__builtin_ia32_vcvtss2usi64 (( &__v4sf)  &__A,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvttss_u64 {  &__builtin_ia32_vcvttss2usi64 (( &__v4sf)  &__A,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvttss_i64 {  &__builtin_ia32_vcvttss2si64 (( &__v4sf)  &__A,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtss_u32 {  &__builtin_ia32_vcvtss2usi32 (( &__v4sf)  &__A,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvttss_u32 {  &__builtin_ia32_vcvttss2usi32 (( &__v4sf)  &__A,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvttss_i32 {  &__builtin_ia32_vcvttss2si32 (( &__v4sf)  &__A,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    if(defined(&__x86_64__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtsd_u64 {  &__builtin_ia32_vcvtsd2usi64 (( &__v2df)  &__A,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvttsd_u64 {  &__builtin_ia32_vcvttsd2usi64 (( &__v2df)  &__A,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvttsd_i64 {  &__builtin_ia32_vcvttsd2si64 (( &__v2df)  &__A,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtsd_u32 {  &__builtin_ia32_vcvtsd2usi32 (( &__v2df)  &__A,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvttsd_u32 {  &__builtin_ia32_vcvttsd2usi32 (( &__v2df)  &__A,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvttsd_i32 {  &__builtin_ia32_vcvttsd2si32 (( &__v2df)  &__A,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtps_pd ( &__m256  &__A) { ( &__m512d)  &__builtin_ia32_cvtps2pd512_mask (( &__v8sf)  &__A, ( &__v8df)  &_mm512_undefined_pd (), ( &__mmask8) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtps_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m256  &__A) { ( &__m512d)  &__builtin_ia32_cvtps2pd512_mask (( &__v8sf)  &__A, ( &__v8df)  &__W, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtps_pd ( &__mmask8  &__U,  &__m256  &__A) { ( &__m512d)  &__builtin_ia32_cvtps2pd512_mask (( &__v8sf)  &__A, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtph_ps ( &__m256i  &__A) { ( &__m512)  &__builtin_ia32_vcvtph2ps512_mask (( &__v16hi)  &__A, ( &__v16sf)  &_mm512_undefined_ps (), ( &__mmask16) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtph_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m256i  &__A) { ( &__m512)  &__builtin_ia32_vcvtph2ps512_mask (( &__v16hi)  &__A, ( &__v16sf)  &__W, ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtph_ps ( &__mmask16  &__U,  &__m256i  &__A) { ( &__m512)  &__builtin_ia32_vcvtph2ps512_mask (( &__v16hi)  &__A, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtpd_ps ( &__m512d  &__A) { ( &__m256)  &__builtin_ia32_cvtpd2ps512_mask (( &__v8df)  &__A, ( &__v8sf)  &_mm256_undefined_ps (), ( &__mmask8) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtpd_ps ( &__m256  &__W,  &__mmask8  &__U,  &__m512d  &__A) { ( &__m256)  &__builtin_ia32_cvtpd2ps512_mask (( &__v8df)  &__A, ( &__v8sf)  &__W, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtpd_ps ( &__mmask8  &__U,  &__m512d  &__A) { ( &__m256)  &__builtin_ia32_cvtpd2ps512_mask (( &__v8df)  &__A, ( &__v8sf)  &_mm256_setzero_ps (), ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_getexp_ps ( &__m512  &__A) { ( &__m512)  &__builtin_ia32_getexpps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &_mm512_undefined_ps (), ( &__mmask16) -1,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_getexp_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A) { ( &__m512)  &__builtin_ia32_getexpps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__W, ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_getexp_ps ( &__mmask16  &__U,  &__m512  &__A) { ( &__m512)  &__builtin_ia32_getexpps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_getexp_pd ( &__m512d  &__A) { ( &__m512d)  &__builtin_ia32_getexppd512_mask (( &__v8df)  &__A, ( &__v8df)  &_mm512_undefined_pd (), ( &__mmask8) -1,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_getexp_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A) { ( &__m512d)  &__builtin_ia32_getexppd512_mask (( &__v8df)  &__A, ( &__v8df)  &__W, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_getexp_pd ( &__mmask8  &__U,  &__m512d  &__A) { ( &__m512d)  &__builtin_ia32_getexppd512_mask (( &__v8df)  &__A, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_getexp_ss ( &__m128  &__A,  &__m128  &__B) { ( &__m128)  &__builtin_ia32_getexpss128_round (( &__v4sf)  &__A, ( &__v4sf)  &__B,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_getexp_sd ( &__m128d  &__A,  &__m128d  &__B) { ( &__m128d)  &__builtin_ia32_getexpsd128_round (( &__v2df)  &__A, ( &__v2df)  &__B,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_getmant_pd ( &__m512d  &__A,  &_MM_MANTISSA_NORM_ENUM  &__B,  &_MM_MANTISSA_SIGN_ENUM  &__C) { ( &__m512d)  &__builtin_ia32_getmantpd512_mask (( &__v8df)  &__A, ( &__C << 2) |  &__B,  &_mm512_undefined_pd (), ( &__mmask8) -1,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_getmant_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A,  &_MM_MANTISSA_NORM_ENUM  &__B,  &_MM_MANTISSA_SIGN_ENUM  &__C) { ( &__m512d)  &__builtin_ia32_getmantpd512_mask (( &__v8df)  &__A, ( &__C << 2) |  &__B, ( &__v8df)  &__W,  &__U,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_getmant_pd ( &__mmask8  &__U,  &__m512d  &__A,  &_MM_MANTISSA_NORM_ENUM  &__B,  &_MM_MANTISSA_SIGN_ENUM  &__C) { ( &__m512d)  &__builtin_ia32_getmantpd512_mask (( &__v8df)  &__A, ( &__C << 2) |  &__B, ( &__v8df)  &_mm512_setzero_pd (),  &__U,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_getmant_ps ( &__m512  &__A,  &_MM_MANTISSA_NORM_ENUM  &__B,  &_MM_MANTISSA_SIGN_ENUM  &__C) { ( &__m512)  &__builtin_ia32_getmantps512_mask (( &__v16sf)  &__A, ( &__C << 2) |  &__B,  &_mm512_undefined_ps (), ( &__mmask16) -1,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_getmant_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A,  &_MM_MANTISSA_NORM_ENUM  &__B,  &_MM_MANTISSA_SIGN_ENUM  &__C) { ( &__m512)  &__builtin_ia32_getmantps512_mask (( &__v16sf)  &__A, ( &__C << 2) |  &__B, ( &__v16sf)  &__W,  &__U,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_getmant_ps ( &__mmask16  &__U,  &__m512  &__A,  &_MM_MANTISSA_NORM_ENUM  &__B,  &_MM_MANTISSA_SIGN_ENUM  &__C) { ( &__m512)  &__builtin_ia32_getmantps512_mask (( &__v16sf)  &__A, ( &__C << 2) |  &__B, ( &__v16sf)  &_mm512_setzero_ps (),  &__U,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_getmant_sd ( &__m128d  &__A,  &__m128d  &__B,  &_MM_MANTISSA_NORM_ENUM  &__C,  &_MM_MANTISSA_SIGN_ENUM  &__D) { ( &__m128d)  &__builtin_ia32_getmantsd_round (( &__v2df)  &__A, ( &__v2df)  &__B, ( &__D << 2) |  &__C,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_getmant_ss ( &__m128  &__A,  &__m128  &__B,  &_MM_MANTISSA_NORM_ENUM  &__C,  &_MM_MANTISSA_SIGN_ENUM  &__D) { ( &__m128)  &__builtin_ia32_getmantss_round (( &__v4sf)  &__A, ( &__v4sf)  &__B, ( &__D << 2) |  &__C,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm512_getmant_pd {
	    my($X, $B, $C) = @_;
    	    eval q((( &__m512d) &__builtin_ia32_getmantpd512_mask (( &__v8df)( &__m512d), ((($C)<<2) | ($B)), ( &__v8df) &_mm512_undefined_pd(), ( &__mmask8)-1,  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm512_getmant_pd);
	eval 'sub _mm512_mask_getmant_pd {
	    my($W, $U, $X, $B, $C) = @_;
    	    eval q((( &__m512d) &__builtin_ia32_getmantpd512_mask (( &__v8df)( &__m512d), ((($C)<<2) | ($B)), ( &__v8df)( &__m512d)($W), ( &__mmask8)($U),  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm512_mask_getmant_pd);
	eval 'sub _mm512_maskz_getmant_pd {
	    my($U, $X, $B, $C) = @_;
    	    eval q((( &__m512d) &__builtin_ia32_getmantpd512_mask (( &__v8df)( &__m512d), ((($C)<<2) | ($B)), ( &__v8df) &_mm512_setzero_pd(), ( &__mmask8)($U),  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm512_maskz_getmant_pd);
	eval 'sub _mm512_getmant_ps {
	    my($X, $B, $C) = @_;
    	    eval q((( &__m512) &__builtin_ia32_getmantps512_mask (( &__v16sf)( &__m512), ((($C)<<2) | ($B)), ( &__v16sf) &_mm512_undefined_ps(), ( &__mmask16)-1,  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm512_getmant_ps);
	eval 'sub _mm512_mask_getmant_ps {
	    my($W, $U, $X, $B, $C) = @_;
    	    eval q((( &__m512) &__builtin_ia32_getmantps512_mask (( &__v16sf)( &__m512), ((($C)<<2) | ($B)), ( &__v16sf)( &__m512)($W), ( &__mmask16)($U),  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm512_mask_getmant_ps);
	eval 'sub _mm512_maskz_getmant_ps {
	    my($U, $X, $B, $C) = @_;
    	    eval q((( &__m512) &__builtin_ia32_getmantps512_mask (( &__v16sf)( &__m512), ((($C)<<2) | ($B)), ( &__v16sf) &_mm512_setzero_ps(), ( &__mmask16)($U),  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm512_maskz_getmant_ps);
	eval 'sub _mm_getmant_sd {
	    my($X, $Y, $C, $D) = @_;
    	    eval q((( &__m128d) &__builtin_ia32_getmantsd_round (( &__v2df)( &__m128d)($X), ( &__v2df)( &__m128d), ((($D)<<2) | ($C)),  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm_getmant_sd);
	eval 'sub _mm_getmant_ss {
	    my($X, $Y, $C, $D) = @_;
    	    eval q((( &__m128) &__builtin_ia32_getmantss_round (( &__v4sf)( &__m128)($X), ( &__v4sf)( &__m128), ((($D)<<2) | ($C)),  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm_getmant_ss);
	eval 'sub _mm_getexp_ss {
	    my($A, $B) = @_;
    	    eval q((( &__m128) &__builtin_ia32_getexpss128_mask(( &__v4sf)( &__m128)($A), ( &__v4sf)( &__m128)($B),  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm_getexp_ss);
	eval 'sub _mm_getexp_sd {
	    my($A, $B) = @_;
    	    eval q((( &__m128d) &__builtin_ia32_getexpsd128_mask(( &__v2df)( &__m128d)($A), ( &__v2df)( &__m128d)($B),  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm_getexp_sd);
	eval 'sub _mm512_getexp_ps {
	    my($A) = @_;
    	    eval q((( &__m512) &__builtin_ia32_getexpps512_mask(( &__v16sf)( &__m512)($A), ( &__v16sf) &_mm512_undefined_ps(), ( &__mmask16)-1,  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm512_getexp_ps);
	eval 'sub _mm512_mask_getexp_ps {
	    my($W, $U, $A) = @_;
    	    eval q((( &__m512) &__builtin_ia32_getexpps512_mask(( &__v16sf)( &__m512)($A), ( &__v16sf)( &__m512)($W), ( &__mmask16)($U),  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm512_mask_getexp_ps);
	eval 'sub _mm512_maskz_getexp_ps {
	    my($U, $A) = @_;
    	    eval q((( &__m512) &__builtin_ia32_getexpps512_mask(( &__v16sf)( &__m512)($A), ( &__v16sf) &_mm512_setzero_ps(), ( &__mmask16)($U),  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm512_maskz_getexp_ps);
	eval 'sub _mm512_getexp_pd {
	    my($A) = @_;
    	    eval q((( &__m512d) &__builtin_ia32_getexppd512_mask(( &__v8df)( &__m512d)($A), ( &__v8df) &_mm512_undefined_pd(), ( &__mmask8)-1,  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm512_getexp_pd);
	eval 'sub _mm512_mask_getexp_pd {
	    my($W, $U, $A) = @_;
    	    eval q((( &__m512d) &__builtin_ia32_getexppd512_mask(( &__v8df)( &__m512d)($A), ( &__v8df)( &__m512d)($W), ( &__mmask8)($U),  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm512_mask_getexp_pd);
	eval 'sub _mm512_maskz_getexp_pd {
	    my($U, $A) = @_;
    	    eval q((( &__m512d) &__builtin_ia32_getexppd512_mask(( &__v8df)( &__m512d)($A), ( &__v8df) &_mm512_setzero_pd(), ( &__mmask8)($U),  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm512_maskz_getexp_pd);
    }
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_roundscale_ps ( &__m512  &__A,  &const \'int\'  &__imm) { ( &__m512)  &__builtin_ia32_rndscaleps_mask (( &__v16sf)  &__A,  &__imm, ( &__v16sf)  &_mm512_undefined_ps (), -1,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_roundscale_ps ( &__m512  &__A,  &__mmask16  &__B,  &__m512  &__C,  &const \'int\'  &__imm) { ( &__m512)  &__builtin_ia32_rndscaleps_mask (( &__v16sf)  &__C,  &__imm, ( &__v16sf)  &__A, ( &__mmask16)  &__B,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_roundscale_ps ( &__mmask16  &__A,  &__m512  &__B,  &const \'int\'  &__imm) { ( &__m512)  &__builtin_ia32_rndscaleps_mask (( &__v16sf)  &__B,  &__imm, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__A,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_roundscale_pd ( &__m512d  &__A,  &const \'int\'  &__imm) { ( &__m512d)  &__builtin_ia32_rndscalepd_mask (( &__v8df)  &__A,  &__imm, ( &__v8df)  &_mm512_undefined_pd (), -1,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_roundscale_pd ( &__m512d  &__A,  &__mmask8  &__B,  &__m512d  &__C,  &const \'int\'  &__imm) { ( &__m512d)  &__builtin_ia32_rndscalepd_mask (( &__v8df)  &__C,  &__imm, ( &__v8df)  &__A, ( &__mmask8)  &__B,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_roundscale_pd ( &__mmask8  &__A,  &__m512d  &__B,  &const \'int\'  &__imm) { ( &__m512d)  &__builtin_ia32_rndscalepd_mask (( &__v8df)  &__B,  &__imm, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__A,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_roundscale_ss ( &__m128  &__A,  &__m128  &__B,  &const \'int\'  &__imm) { ( &__m128)  &__builtin_ia32_rndscaless_round (( &__v4sf)  &__A, ( &__v4sf)  &__B,  &__imm,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_roundscale_sd ( &__m128d  &__A,  &__m128d  &__B,  &const \'int\'  &__imm) { ( &__m128d)  &__builtin_ia32_rndscalesd_round (( &__v2df)  &__A, ( &__v2df)  &__B,  &__imm,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm512_roundscale_ps {
	    my($A, $B) = @_;
    	    eval q((( &__m512)  &__builtin_ia32_rndscaleps_mask (( &__v16sf)( &__m512), ($B), ( &__v16sf) &_mm512_undefined_ps(), ( &__mmask16)(-1),  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm512_roundscale_ps);
	eval 'sub _mm512_mask_roundscale_ps {
	    my($A, $B, $C, $D) = @_;
    	    eval q((( &__m512)  &__builtin_ia32_rndscaleps_mask (( &__v16sf)( &__m512), ($D), ( &__v16sf)( &__m512)($A), ( &__mmask16)($B),  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm512_mask_roundscale_ps);
	eval 'sub _mm512_maskz_roundscale_ps {
	    my($A, $B, $C) = @_;
    	    eval q((( &__m512)  &__builtin_ia32_rndscaleps_mask (( &__v16sf)( &__m512), ($C), ( &__v16sf) &_mm512_setzero_ps(), ( &__mmask16)($A),  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm512_maskz_roundscale_ps);
	eval 'sub _mm512_roundscale_pd {
	    my($A, $B) = @_;
    	    eval q((( &__m512d)  &__builtin_ia32_rndscalepd_mask (( &__v8df)( &__m512d), ($B), ( &__v8df) &_mm512_undefined_pd(), ( &__mmask8)(-1),  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm512_roundscale_pd);
	eval 'sub _mm512_mask_roundscale_pd {
	    my($A, $B, $C, $D) = @_;
    	    eval q((( &__m512d)  &__builtin_ia32_rndscalepd_mask (( &__v8df)( &__m512d), ($D), ( &__v8df)( &__m512d)($A), ( &__mmask8)($B),  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm512_mask_roundscale_pd);
	eval 'sub _mm512_maskz_roundscale_pd {
	    my($A, $B, $C) = @_;
    	    eval q((( &__m512d)  &__builtin_ia32_rndscalepd_mask (( &__v8df)( &__m512d), ($C), ( &__v8df) &_mm512_setzero_pd(), ( &__mmask8)($A),  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm512_maskz_roundscale_pd);
	eval 'sub _mm_roundscale_ss {
	    my($A, $B, $C) = @_;
    	    eval q((( &__m128)  &__builtin_ia32_rndscaless_round (( &__v4sf)( &__m128)($A), ( &__v4sf)( &__m128), ($C),  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm_roundscale_ss);
	eval 'sub _mm_roundscale_sd {
	    my($A, $B, $C) = @_;
    	    eval q((( &__m128d)  &__builtin_ia32_rndscalesd_round (( &__v2df)( &__m128d)($A), ( &__v2df)( &__m128d), ($C),  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm_roundscale_sd);
    }
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cmp_pd_mask ( &__m512d  &__X,  &__m512d  &__Y,  &const \'int\'  &__P) { ( &__mmask8)  &__builtin_ia32_cmppd512_mask (( &__v8df)  &__X, ( &__v8df)  &__Y,  &__P, ( &__mmask8) -1,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cmp_ps_mask ( &__m512  &__X,  &__m512  &__Y,  &const \'int\'  &__P) { ( &__mmask16)  &__builtin_ia32_cmpps512_mask (( &__v16sf)  &__X, ( &__v16sf)  &__Y,  &__P, ( &__mmask16) -1,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cmp_ps_mask ( &__mmask16  &__U,  &__m512  &__X,  &__m512  &__Y,  &const \'int\'  &__P) { ( &__mmask16)  &__builtin_ia32_cmpps512_mask (( &__v16sf)  &__X, ( &__v16sf)  &__Y,  &__P, ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cmp_pd_mask ( &__mmask8  &__U,  &__m512d  &__X,  &__m512d  &__Y,  &const \'int\'  &__P) { ( &__mmask8)  &__builtin_ia32_cmppd512_mask (( &__v8df)  &__X, ( &__v8df)  &__Y,  &__P, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cmp_sd_mask ( &__m128d  &__X,  &__m128d  &__Y,  &const \'int\'  &__P) { ( &__mmask8)  &__builtin_ia32_cmpsd_mask (( &__v2df)  &__X, ( &__v2df)  &__Y,  &__P, ( &__mmask8) -1,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_cmp_sd_mask ( &__mmask8  &__M,  &__m128d  &__X,  &__m128d  &__Y,  &const \'int\'  &__P) { ( &__mmask8)  &__builtin_ia32_cmpsd_mask (( &__v2df)  &__X, ( &__v2df)  &__Y,  &__P, ( &__mmask8)  &__M,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cmp_ss_mask ( &__m128  &__X,  &__m128  &__Y,  &const \'int\'  &__P) { ( &__mmask8)  &__builtin_ia32_cmpss_mask (( &__v4sf)  &__X, ( &__v4sf)  &__Y,  &__P, ( &__mmask8) -1,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_cmp_ss_mask ( &__mmask8  &__M,  &__m128  &__X,  &__m128  &__Y,  &const \'int\'  &__P) { ( &__mmask8)  &__builtin_ia32_cmpss_mask (( &__v4sf)  &__X, ( &__v4sf)  &__Y,  &__P, ( &__mmask8)  &__M,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm512_cmp_pd_mask {
	    my($X, $Y, $P) = @_;
    	    eval q((( &__mmask8)  &__builtin_ia32_cmppd512_mask (( &__v8df)( &__m512d)($X), ( &__v8df)( &__m512d), ($P), ( &__mmask8)-1, &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm512_cmp_pd_mask);
	eval 'sub _mm512_cmp_ps_mask {
	    my($X, $Y, $P) = @_;
    	    eval q((( &__mmask16)  &__builtin_ia32_cmpps512_mask (( &__v16sf)( &__m512)($X), ( &__v16sf)( &__m512), ($P), ( &__mmask16)-1, &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm512_cmp_ps_mask);
	eval 'sub _mm512_mask_cmp_pd_mask {
	    my($M, $X, $Y, $P) = @_;
    	    eval q((( &__mmask8)  &__builtin_ia32_cmppd512_mask (( &__v8df)( &__m512d)($X), ( &__v8df)( &__m512d), ($P), ( &__mmask8)$M,  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm512_mask_cmp_pd_mask);
	eval 'sub _mm512_mask_cmp_ps_mask {
	    my($M, $X, $Y, $P) = @_;
    	    eval q((( &__mmask16)  &__builtin_ia32_cmpps512_mask (( &__v16sf)( &__m512)($X), ( &__v16sf)( &__m512), ($P), ( &__mmask16)$M, &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm512_mask_cmp_ps_mask);
	eval 'sub _mm_cmp_sd_mask {
	    my($X, $Y, $P) = @_;
    	    eval q((( &__mmask8)  &__builtin_ia32_cmpsd_mask (( &__v2df)( &__m128d)($X), ( &__v2df)( &__m128d), ($P), ( &__mmask8)-1, &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm_cmp_sd_mask);
	eval 'sub _mm_mask_cmp_sd_mask {
	    my($M, $X, $Y, $P) = @_;
    	    eval q((( &__mmask8)  &__builtin_ia32_cmpsd_mask (( &__v2df)( &__m128d)($X), ( &__v2df)( &__m128d), ($P), $M, &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm_mask_cmp_sd_mask);
	eval 'sub _mm_cmp_ss_mask {
	    my($X, $Y, $P) = @_;
    	    eval q((( &__mmask8)  &__builtin_ia32_cmpss_mask (( &__v4sf)( &__m128)($X), ( &__v4sf)( &__m128), ($P), ( &__mmask8)-1, &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm_cmp_ss_mask);
	eval 'sub _mm_mask_cmp_ss_mask {
	    my($M, $X, $Y, $P) = @_;
    	    eval q((( &__mmask8)  &__builtin_ia32_cmpss_mask (( &__v4sf)( &__m128)($X), ( &__v4sf)( &__m128), ($P), $M, &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm_mask_cmp_ss_mask);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_kmov ( &__mmask16  &__A) {  &__builtin_ia32_kmovw ( &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_castpd_ps ( &__m512d  &__A) { ( &__m512) ( &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_castpd_si512 ( &__m512d  &__A) { ( &__m512i) ( &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_castps_pd ( &__m512  &__A) { ( &__m512d) ( &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_castps_si512 ( &__m512  &__A) { ( &__m512i) ( &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_castsi512_ps ( &__m512i  &__A) { ( &__m512) ( &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_castsi512_pd ( &__m512i  &__A) { ( &__m512d) ( &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_castpd512_pd128 ( &__m512d  &__A) { ( &__m128d) &_mm512_extractf32x4_ps(( &__m512) &__A, 0); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_castps512_ps128 ( &__m512  &__A) {  &_mm512_extractf32x4_ps( &__A, 0); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_castsi512_si128 ( &__m512i  &__A) { ( &__m128i) &_mm512_extracti32x4_epi32(( &__m512i) &__A, 0); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_castpd512_pd256 ( &__m512d  &__A) {  &_mm512_extractf64x4_pd( &__A, 0); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_castps512_ps256 ( &__m512  &__A) { ( &__m256) &_mm512_extractf64x4_pd(( &__m512d) &__A, 0); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_castsi512_si256 ( &__m512i  &__A) { ( &__m256i) &_mm512_extractf64x4_pd(( &__m512d) &__A, 0); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_castpd128_pd512 ( &__m128d  &__A) { ( &__m512d)  &__builtin_ia32_pd512_pd(( &__m128d) &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_castps128_ps512 ( &__m128  &__A) { ( &__m512)  &__builtin_ia32_ps512_ps(( &__m128) &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_castsi128_si512 ( &__m128i  &__A) { ( &__m512i)  &__builtin_ia32_si512_si(( &__v4si) &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_castpd256_pd512 ( &__m256d  &__A) {  &__builtin_ia32_pd512_256pd ( &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_castps256_ps512 ( &__m256  &__A) {  &__builtin_ia32_ps512_256ps ( &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_castsi256_si512 ( &__m256i  &__A) { ( &__m512i) &__builtin_ia32_si512_256si (( &__v8si) &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cmpeq_epu32_mask ( &__m512i  &__A,  &__m512i  &__B) { ( &__mmask16)  &__builtin_ia32_ucmpd512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, 0, ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cmpeq_epu32_mask ( &__mmask16  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__mmask16)  &__builtin_ia32_ucmpd512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, 0,  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cmpeq_epu64_mask ( &__mmask8  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__mmask8)  &__builtin_ia32_ucmpq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, 0,  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cmpeq_epu64_mask ( &__m512i  &__A,  &__m512i  &__B) { ( &__mmask8)  &__builtin_ia32_ucmpq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, 0, ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cmpgt_epu32_mask ( &__m512i  &__A,  &__m512i  &__B) { ( &__mmask16)  &__builtin_ia32_ucmpd512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, 6, ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cmpgt_epu32_mask ( &__mmask16  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__mmask16)  &__builtin_ia32_ucmpd512_mask (( &__v16si)  &__A, ( &__v16si)  &__B, 6,  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cmpgt_epu64_mask ( &__mmask8  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__mmask8)  &__builtin_ia32_ucmpq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, 6,  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cmpgt_epu64_mask ( &__m512i  &__A,  &__m512i  &__B) { ( &__mmask8)  &__builtin_ia32_ucmpq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, 6, ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    undef(&__MM512_REDUCE_OP) if defined(&__MM512_REDUCE_OP);
    eval 'sub __MM512_REDUCE_OP {
        my($op) = @_;
	    eval q( &__v8si  &__T1 = ( &__v8si)  &_mm512_extracti64x4_epi64 ( &__A, 1);  &__v8si  &__T2 = ( &__v8si)  &_mm512_extracti64x4_epi64 ( &__A, 0);  &__m256i  &__T3 = ( &__m256i) ( &__T1 $op  &__T2);  &__v4si  &__T4 = ( &__v4si)  &_mm256_extracti128_si256 ( &__T3, 1);  &__v4si  &__T5 = ( &__v4si)  &_mm256_extracti128_si256 ( &__T3, 0);  &__v4si  &__T6 =  &__T4 $op  &__T5;  &__v4si  &__T7 =  &__builtin_shuffle ( &__T6, ( &__v4si) { 2, 3, 0, 1});  &__v4si  &__T8 =  &__T6 $op  &__T7;  &return  $__T8[0] $op  $__T8[1]);
    }' unless defined(&__MM512_REDUCE_OP);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_reduce_add_epi32 ( &__m512i  &__A) {  &__MM512_REDUCE_OP (+); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_reduce_mul_epi32 ( &__m512i  &__A) {  &__MM512_REDUCE_OP (*); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_reduce_and_epi32 ( &__m512i  &__A) {  &__MM512_REDUCE_OP (); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_reduce_or_epi32 ( &__m512i  &__A) {  &__MM512_REDUCE_OP (|); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_reduce_add_epi32 ( &__mmask16  &__U,  &__m512i  &__A) {  &__A =  &_mm512_maskz_mov_epi32 ( &__U,  &__A);  &__MM512_REDUCE_OP (+); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_reduce_mul_epi32 ( &__mmask16  &__U,  &__m512i  &__A) {  &__A =  &_mm512_mask_mov_epi32 ( &_mm512_set1_epi32 (1),  &__U,  &__A);  &__MM512_REDUCE_OP (*); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_reduce_and_epi32 ( &__mmask16  &__U,  &__m512i  &__A) {  &__A =  &_mm512_mask_mov_epi32 ( &_mm512_set1_epi32 (~0),  &__U,  &__A);  &__MM512_REDUCE_OP (); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_reduce_or_epi32 ( &__mmask16  &__U,  &__m512i  &__A) {  &__A =  &_mm512_maskz_mov_epi32 ( &__U,  &__A);  &__MM512_REDUCE_OP (|); });
    }' unless defined(&__attribute__);
    undef(&__MM512_REDUCE_OP) if defined(&__MM512_REDUCE_OP);
    eval 'sub __MM512_REDUCE_OP {
        my($op) = @_;
	    eval q( &__m256i  &__T1 = ( &__m256i)  &_mm512_extracti64x4_epi64 ( &__A, 1);  &__m256i  &__T2 = ( &__m256i)  &_mm512_extracti64x4_epi64 ( &__A, 0);  &__m256i  &__T3 =  &_mm256_$op ( &__T1,  &__T2);  &__m128i  &__T4 = ( &__m128i)  &_mm256_extracti128_si256 ( &__T3, 1);  &__m128i  &__T5 = ( &__m128i)  &_mm256_extracti128_si256 ( &__T3, 0);  &__m128i  &__T6 =  &_mm_$op ( &__T4,  &__T5);  &__m128i  &__T7 = ( &__m128i)  &__builtin_shuffle (( &__v4si)  &__T6, ( &__v4si) { 2, 3, 0, 1});  &__m128i  &__T8 =  &_mm_$op ( &__T6,  &__T7);  &__m128i  &__T9 = ( &__m128i)  &__builtin_shuffle (( &__v4si)  &__T8, ( &__v4si) { 1, 0, 1, 0});  &__v4si  &__T10 = ( &__v4si)  &_mm_$op ( &__T8,  &__T9);  &return  $__T10[0]);
    }' unless defined(&__MM512_REDUCE_OP);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_reduce_min_epi32 ( &__m512i  &__A) {  &__MM512_REDUCE_OP ( &min_epi32); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_reduce_max_epi32 ( &__m512i  &__A) {  &__MM512_REDUCE_OP ( &max_epi32); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_reduce_min_epu32 ( &__m512i  &__A) {  &__MM512_REDUCE_OP ( &min_epu32); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_reduce_max_epu32 ( &__m512i  &__A) {  &__MM512_REDUCE_OP ( &max_epu32); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_reduce_min_epi32 ( &__mmask16  &__U,  &__m512i  &__A) {  &__A =  &_mm512_mask_mov_epi32 ( &_mm512_set1_epi32 ( &__INT_MAX__),  &__U,  &__A);  &__MM512_REDUCE_OP ( &min_epi32); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_reduce_max_epi32 ( &__mmask16  &__U,  &__m512i  &__A) {  &__A =  &_mm512_mask_mov_epi32 ( &_mm512_set1_epi32 (- &__INT_MAX__ - 1),  &__U,  &__A);  &__MM512_REDUCE_OP ( &max_epi32); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_reduce_min_epu32 ( &__mmask16  &__U,  &__m512i  &__A) {  &__A =  &_mm512_mask_mov_epi32 ( &_mm512_set1_epi32 (~0),  &__U,  &__A);  &__MM512_REDUCE_OP ( &min_epu32); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_reduce_max_epu32 ( &__mmask16  &__U,  &__m512i  &__A) {  &__A =  &_mm512_maskz_mov_epi32 ( &__U,  &__A);  &__MM512_REDUCE_OP ( &max_epu32); });
    }' unless defined(&__attribute__);
    undef(&__MM512_REDUCE_OP) if defined(&__MM512_REDUCE_OP);
    eval 'sub __MM512_REDUCE_OP {
        my($op) = @_;
	    eval q( &__m256  &__T1 = ( &__m256)  &_mm512_extractf64x4_pd (( &__m512d)  &__A, 1);  &__m256  &__T2 = ( &__m256)  &_mm512_extractf64x4_pd (( &__m512d)  &__A, 0);  &__m256  &__T3 =  &__T1 $op  &__T2;  &__m128  &__T4 =  &_mm256_extractf128_ps ( &__T3, 1);  &__m128  &__T5 =  &_mm256_extractf128_ps ( &__T3, 0);  &__m128  &__T6 =  &__T4 $op  &__T5;  &__m128  &__T7 =  &__builtin_shuffle ( &__T6, ( &__v4si) { 2, 3, 0, 1});  &__m128  &__T8 =  &__T6 $op  &__T7;  &return  $__T8[0] $op  $__T8[1]);
    }' unless defined(&__MM512_REDUCE_OP);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_reduce_add_ps ( &__m512  &__A) {  &__MM512_REDUCE_OP (+); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_reduce_mul_ps ( &__m512  &__A) {  &__MM512_REDUCE_OP (*); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_reduce_add_ps ( &__mmask16  &__U,  &__m512  &__A) {  &__A =  &_mm512_maskz_mov_ps ( &__U,  &__A);  &__MM512_REDUCE_OP (+); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_reduce_mul_ps ( &__mmask16  &__U,  &__m512  &__A) {  &__A =  &_mm512_mask_mov_ps ( &_mm512_set1_ps (1.0 &f),  &__U,  &__A);  &__MM512_REDUCE_OP (*); });
    }' unless defined(&__attribute__);
    undef(&__MM512_REDUCE_OP) if defined(&__MM512_REDUCE_OP);
    eval 'sub __MM512_REDUCE_OP {
        my($op) = @_;
	    eval q( &__m256  &__T1 = ( &__m256)  &_mm512_extractf64x4_pd (( &__m512d)  &__A, 1);  &__m256  &__T2 = ( &__m256)  &_mm512_extractf64x4_pd (( &__m512d)  &__A, 0);  &__m256  &__T3 =  &_mm256_$op ( &__T1,  &__T2);  &__m128  &__T4 =  &_mm256_extractf128_ps ( &__T3, 1);  &__m128  &__T5 =  &_mm256_extractf128_ps ( &__T3, 0);  &__m128  &__T6 =  &_mm_$op ( &__T4,  &__T5);  &__m128  &__T7 =  &__builtin_shuffle ( &__T6, ( &__v4si) { 2, 3, 0, 1});  &__m128  &__T8 =  &_mm_$op ( &__T6,  &__T7);  &__m128  &__T9 =  &__builtin_shuffle ( &__T8, ( &__v4si) { 1, 0, 1, 0});  &__m128  &__T10 =  &_mm_$op ( &__T8,  &__T9);  &return  $__T10[0]);
    }' unless defined(&__MM512_REDUCE_OP);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_reduce_min_ps ( &__m512  &__A) {  &__MM512_REDUCE_OP ( &min_ps); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_reduce_max_ps ( &__m512  &__A) {  &__MM512_REDUCE_OP ( &max_ps); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_reduce_min_ps ( &__mmask16  &__U,  &__m512  &__A) {  &__A =  &_mm512_mask_mov_ps ( &_mm512_set1_ps ( &__builtin_inff ()),  &__U,  &__A);  &__MM512_REDUCE_OP ( &min_ps); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_reduce_max_ps ( &__mmask16  &__U,  &__m512  &__A) {  &__A =  &_mm512_mask_mov_ps ( &_mm512_set1_ps (- &__builtin_inff ()),  &__U,  &__A);  &__MM512_REDUCE_OP ( &max_ps); });
    }' unless defined(&__attribute__);
    undef(&__MM512_REDUCE_OP) if defined(&__MM512_REDUCE_OP);
    eval 'sub __MM512_REDUCE_OP {
        my($op) = @_;
	    eval q( &__v4di  &__T1 = ( &__v4di)  &_mm512_extracti64x4_epi64 ( &__A, 1);  &__v4di  &__T2 = ( &__v4di)  &_mm512_extracti64x4_epi64 ( &__A, 0);  &__m256i  &__T3 = ( &__m256i) ( &__T1 $op  &__T2);  &__v2di  &__T4 = ( &__v2di)  &_mm256_extracti128_si256 ( &__T3, 1);  &__v2di  &__T5 = ( &__v2di)  &_mm256_extracti128_si256 ( &__T3, 0);  &__v2di  &__T6 =  &__T4 $op  &__T5;  &return  $__T6[0] $op  $__T6[1]);
    }' unless defined(&__MM512_REDUCE_OP);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_reduce_add_epi64 ( &__m512i  &__A) {  &__MM512_REDUCE_OP (+); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_reduce_mul_epi64 ( &__m512i  &__A) {  &__MM512_REDUCE_OP (*); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_reduce_and_epi64 ( &__m512i  &__A) {  &__MM512_REDUCE_OP (); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_reduce_or_epi64 ( &__m512i  &__A) {  &__MM512_REDUCE_OP (|); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_reduce_add_epi64 ( &__mmask8  &__U,  &__m512i  &__A) {  &__A =  &_mm512_maskz_mov_epi64 ( &__U,  &__A);  &__MM512_REDUCE_OP (+); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_reduce_mul_epi64 ( &__mmask8  &__U,  &__m512i  &__A) {  &__A =  &_mm512_mask_mov_epi64 ( &_mm512_set1_epi64 (1),  &__U,  &__A);  &__MM512_REDUCE_OP (*); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_reduce_and_epi64 ( &__mmask8  &__U,  &__m512i  &__A) {  &__A =  &_mm512_mask_mov_epi64 ( &_mm512_set1_epi64 (~0),  &__U,  &__A);  &__MM512_REDUCE_OP (); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_reduce_or_epi64 ( &__mmask8  &__U,  &__m512i  &__A) {  &__A =  &_mm512_maskz_mov_epi64 ( &__U,  &__A);  &__MM512_REDUCE_OP (|); });
    }' unless defined(&__attribute__);
    undef(&__MM512_REDUCE_OP) if defined(&__MM512_REDUCE_OP);
    eval 'sub __MM512_REDUCE_OP {
        my($op) = @_;
	    eval q( &__m512i  &__T1 =  &_mm512_shuffle_i64x2 ( &__A,  &__A, 0x4e);  &__m512i  &__T2 =  &_mm512_$op ( &__A,  &__T1);  &__m512i  &__T3 = ( &__m512i)  &__builtin_shuffle (( &__v8di)  &__T2, ( &__v8di) { 2, 3, 0, 1, 6, 7, 4, 5});  &__m512i  &__T4 =  &_mm512_$op ( &__T2,  &__T3);  &__m512i  &__T5 = ( &__m512i)  &__builtin_shuffle (( &__v8di)  &__T4, ( &__v8di) { 1, 0, 3, 2, 5, 4, 7, 6});  &__v8di  &__T6 = ( &__v8di)  &_mm512_$op ( &__T4,  &__T5);  &return  $__T6[0]);
    }' unless defined(&__MM512_REDUCE_OP);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_reduce_min_epi64 ( &__m512i  &__A) {  &__MM512_REDUCE_OP ( &min_epi64); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_reduce_max_epi64 ( &__m512i  &__A) {  &__MM512_REDUCE_OP ( &max_epi64); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_reduce_min_epi64 ( &__mmask8  &__U,  &__m512i  &__A) {  &__A =  &_mm512_mask_mov_epi64 ( &_mm512_set1_epi64 ( &__LONG_LONG_MAX__),  &__U,  &__A);  &__MM512_REDUCE_OP ( &min_epi64); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_reduce_max_epi64 ( &__mmask8  &__U,  &__m512i  &__A) {  &__A =  &_mm512_mask_mov_epi64 ( &_mm512_set1_epi64 (- &__LONG_LONG_MAX__ - 1),  &__U,  &__A);  &__MM512_REDUCE_OP ( &max_epi64); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_reduce_min_epu64 ( &__m512i  &__A) {  &__MM512_REDUCE_OP ( &min_epu64); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_reduce_max_epu64 ( &__m512i  &__A) {  &__MM512_REDUCE_OP ( &max_epu64); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_reduce_min_epu64 ( &__mmask8  &__U,  &__m512i  &__A) {  &__A =  &_mm512_mask_mov_epi64 ( &_mm512_set1_epi64 (~0),  &__U,  &__A);  &__MM512_REDUCE_OP ( &min_epu64); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_reduce_max_epu64 ( &__mmask8  &__U,  &__m512i  &__A) {  &__A =  &_mm512_maskz_mov_epi64 ( &__U,  &__A);  &__MM512_REDUCE_OP ( &max_epu64); });
    }' unless defined(&__attribute__);
    undef(&__MM512_REDUCE_OP) if defined(&__MM512_REDUCE_OP);
    eval 'sub __MM512_REDUCE_OP {
        my($op) = @_;
	    eval q( &__m256d  &__T1 = ( &__m256d)  &_mm512_extractf64x4_pd ( &__A, 1);  &__m256d  &__T2 = ( &__m256d)  &_mm512_extractf64x4_pd ( &__A, 0);  &__m256d  &__T3 =  &__T1 $op  &__T2;  &__m128d  &__T4 =  &_mm256_extractf128_pd ( &__T3, 1);  &__m128d  &__T5 =  &_mm256_extractf128_pd ( &__T3, 0);  &__m128d  &__T6 =  &__T4 $op  &__T5;  &return  $__T6[0] $op  $__T6[1]);
    }' unless defined(&__MM512_REDUCE_OP);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_reduce_add_pd ( &__m512d  &__A) {  &__MM512_REDUCE_OP (+); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_reduce_mul_pd ( &__m512d  &__A) {  &__MM512_REDUCE_OP (*); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_reduce_add_pd ( &__mmask8  &__U,  &__m512d  &__A) {  &__A =  &_mm512_maskz_mov_pd ( &__U,  &__A);  &__MM512_REDUCE_OP (+); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_reduce_mul_pd ( &__mmask8  &__U,  &__m512d  &__A) {  &__A =  &_mm512_mask_mov_pd ( &_mm512_set1_pd (1.0),  &__U,  &__A);  &__MM512_REDUCE_OP (*); });
    }' unless defined(&__attribute__);
    undef(&__MM512_REDUCE_OP) if defined(&__MM512_REDUCE_OP);
    eval 'sub __MM512_REDUCE_OP {
        my($op) = @_;
	    eval q( &__m256d  &__T1 = ( &__m256d)  &_mm512_extractf64x4_pd ( &__A, 1);  &__m256d  &__T2 = ( &__m256d)  &_mm512_extractf64x4_pd ( &__A, 0);  &__m256d  &__T3 =  &_mm256_$op ( &__T1,  &__T2);  &__m128d  &__T4 =  &_mm256_extractf128_pd ( &__T3, 1);  &__m128d  &__T5 =  &_mm256_extractf128_pd ( &__T3, 0);  &__m128d  &__T6 =  &_mm_$op ( &__T4,  &__T5);  &__m128d  &__T7 = ( &__m128d)  &__builtin_shuffle ( &__T6, ( &__v2di) { 1, 0});  &__m128d  &__T8 =  &_mm_$op ( &__T6,  &__T7);  &return  $__T8[0]);
    }' unless defined(&__MM512_REDUCE_OP);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_reduce_min_pd ( &__m512d  &__A) {  &__MM512_REDUCE_OP ( &min_pd); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_reduce_max_pd ( &__m512d  &__A) {  &__MM512_REDUCE_OP ( &max_pd); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_reduce_min_pd ( &__mmask8  &__U,  &__m512d  &__A) {  &__A =  &_mm512_mask_mov_pd ( &_mm512_set1_pd ( &__builtin_inf ()),  &__U,  &__A);  &__MM512_REDUCE_OP ( &min_pd); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_reduce_max_pd ( &__mmask8  &__U,  &__m512d  &__A) {  &__A =  &_mm512_mask_mov_pd ( &_mm512_set1_pd (- &__builtin_inf ()),  &__U,  &__A);  &__MM512_REDUCE_OP ( &max_pd); });
    }' unless defined(&__attribute__);
    undef(&__MM512_REDUCE_OP) if defined(&__MM512_REDUCE_OP);
    if(defined(&__DISABLE_AVX512F__)) {
	undef(&__DISABLE_AVX512F__) if defined(&__DISABLE_AVX512F__);
    }
}
1;
